package com.tofly.dyrqGps.controller;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.tofly.common.core.entity.ResultRespone;
import com.tofly.common.core.util.Date8Util;
import com.tofly.common.log.annotation.ToFlyAppLog;
import com.tofly.common.oauth.util.SecurityUtils;
import com.tofly.dyrqGps.entity.EsGpsStatus;
import com.tofly.dyrqGps.repository.GpsStatusRepository;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import lombok.AllArgsConstructor;
import org.elasticsearch.client.Client;
import org.elasticsearch.index.query.QueryBuilders;
import org.elasticsearch.index.query.RangeQueryBuilder;
import org.springframework.data.domain.PageRequest;
import org.springframework.data.domain.Sort;
import org.springframework.data.elasticsearch.core.ElasticsearchTemplate;
import org.springframework.data.elasticsearch.core.query.NativeSearchQueryBuilder;
import org.springframework.web.bind.annotation.*;

import java.util.ArrayList;
import java.util.List;

/**
 * @author tuonbed
 * @date 2020/5/6  15:38
 */
@RestController
@AllArgsConstructor
@RequestMapping("/esgps")
@Api(tags="ES存储GPS状态信息")
public class EsSaveGpsStatusController {

    private final GpsStatusRepository gpsStatusRepository;
    private final ElasticsearchTemplate elasticsearchTemplate;
    private final Client client;


//    @ToFlyAppLog(title="新增GPS状态表" )
//    @ApiOperation(value = "新增GPS状态表")
//    @PostMapping
//    public ResultRespone save(@RequestBody EsGpsStatus gpsStatus) {
//        gpsStatus.setUserId(SecurityUtils.getUserId());
//        gpsStatus.setUserIdName(SecurityUtils.getUser().getRealName());
//        gpsStatus.setRealname(SecurityUtils.getUser().getRealName());
//        gpsStatus.setSystemtime(Date8Util.getCurrentDate());
//        return ResultRespone.success(gpsStatusRepository.save(gpsStatus));
//    }
//
//
//    @ToFlyAppLog(title="修改GPS状态表" )
//    @ApiOperation(value = "修改GPS状态表")
//    @PutMapping
//    public ResultRespone update(@RequestBody EsGpsStatus gpsStatus) {
//        return null;
////        return ResultRespone.success(gpsStatusRepository.update(gpsStatus));
//    }
//
//    @ApiOperation(value = "获取GPS状态表")
//    @GetMapping("/get")
//    public List get(){
//        System.out.println(elasticsearchTemplate.indexExists("202005"));
//        Iterable<EsGpsStatus> all = gpsStatusRepository.findAll();
//        List list=new ArrayList();
//        all.forEach(k->{
//            list.add(k);
//        });
//        return list;
//    }
//
//    @ApiOperation(value = "根据ID获取GPS状态表")
//    @GetMapping("/findone")
//    public EsGpsStatus get(String id){
//        System.out.println(id);
//        return gpsStatusRepository.findById(id).get();
//    }
//
//
//
//
//    /**
//     * 通过id删除GPS信息表
//     * @param id id
//     * @return ResultRespone
//     */
//    @ToFlyAppLog(title="通过id删除GPS信息表" )
//    @ApiOperation(value = "通过id删除GPS信息表")
//    @ApiImplicitParams({
//            @ApiImplicitParam(name = "id", value = "ID", required = true, dataType = "String")
//    })
//    @DeleteMapping("/{id}" )
//    public ResultRespone removeById(@PathVariable String id) {
//        gpsStatusRepository.deleteById(id);
//        return ResultRespone.success(true);
//    }
//
//    @ApiOperation(value = "清理GPS状态表")
//    @GetMapping("/clear")
//    public String clear(){
//        gpsStatusRepository.deleteAll();
//        return "sucess";
//    }
//
//    @ApiOperation(value = "分页获取GPS状态表")
//    @GetMapping("/page")
//    public ResultRespone get(Page page, @ModelAttribute EsGpsStatus gpsStatus){
//
//        return ResultRespone.success(gpsStatusRepository.getPage(gpsStatus,page));
//    }
//
    @ApiOperation(value = "删除index")
    @GetMapping("/deleteIndex")
    public boolean deleteIndex(String index){

        return elasticsearchTemplate.deleteIndex(index);
    }
//
//    @ApiOperation(value = "获取所有index的GPS状态表")
//    @GetMapping("/getAll")
//    public ResultRespone getAll(Page page){
////        SearchQuery searchQuery = new NativeSearchQueryBuilder()
////                .withTypes("gpsstatus")
////                .build();
////        List<EsGpsStatus> esGpsStatuses = elasticsearchTemplate.queryForList(searchQuery, EsGpsStatus.class);
////        return esGpsStatuses;
////        MatchQueryBuilder queryBuilder = QueryBuilders.matchQuery("direction",123);
////        queryBuilder.minimumShouldMatch("100%");
////        //String[] indexs=new String[]{"dyrq","dyrq1"};
////        SearchResponse response = client.prepareSearch(index)
////                .setQuery(queryBuilder)
////                .get();
////        System.out.println("条数是："+response.getHits().totalHits);
////        SearchHit[] hits = response.getHits().getHits();
////        int hitslength=hits.length;
////        List<Map> reList=new ArrayList();
////        if (hitslength > 0) {
////            for(int i=0;i<hitslength;i++) {
////                reList.add(hits[i].getSourceAsMap());
////            }
////        }
//
//
//        Sort sort=new Sort(Sort.Direction.ASC,"systemtime");
////        FieldSortBuilder idSort = SortBuilders.fieldSort("systemtime").order(SortOrder.ASC).unmappedType("Date");
//        String[] indexs=new String[]{"dyrq","dyrq250","dyrq_1704","dyrq_1705","dyrq_1706"};
//        NativeSearchQueryBuilder nativeSearchQueryBuilder = new NativeSearchQueryBuilder();
//        RangeQueryBuilder rangeQueryBuilder= QueryBuilders.rangeQuery("systemtime");
//        rangeQueryBuilder.from("2020-05-12 17:05:00");
//        rangeQueryBuilder.to("2020-05-12 17:05:59");
//
//
//        nativeSearchQueryBuilder.withIndices(indexs).withTypes("gpsstatus").withQuery(rangeQueryBuilder)
//                .withPageable(PageRequest.of(0,500,sort));
//        List<EsGpsStatus> esGpsStatuses = elasticsearchTemplate.queryForList(nativeSearchQueryBuilder.build(), EsGpsStatus.class);
//
//        //        SearchRequestBuilder requestBuilder = client.prepareSearch(indexs).setTypes("gpsstatus");
////        MatchQueryBuilder queryBuilder = QueryBuilders.matchQuery("question", question);
//        //使粗排分数相同的项顺序相同,unmappedType可以理解为，如果不存在改字段，则识别为long的最大（最小）值，位置在最后，避免直接返回不存在错误
//
////
////        FieldSortBuilder idSort = SortBuilders.fieldSort("systemtime").order(SortOrder.ASC).unmappedType("long");
////        SearchResponse response = requestBuilder.addSort(idSort).setFrom(0).setSize(500).get();
////        System.out.println("条数是："+response.getHits().totalHits);
////        SearchHit[] hits = response.getHits().getHits();
////        int hitslength=hits.length;
////        List<Map> reList=new ArrayList();
////        if (hitslength > 0) {
////            for(int i=0;i<hitslength;i++) {
////                reList.add(hits[i].getSourceAsMap());
////            }
////        }
//        page.setRecords(esGpsStatuses);
//        return ResultRespone.success(page);
//
//    }

}
