package com.tofly.dyrqGps.controller;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.tofly.common.core.entity.ResultRespone;
import com.tofly.common.core.util.Date8Util;
import com.tofly.common.core.util.StringUtil;
import com.tofly.common.oauth.exception.ToflyDeniedException;
import com.tofly.dyrqGps.entity.GpsSectionSearch;
import com.tofly.dyrqGps.entity.UserGpsSearch;
import com.tofly.dyrqGps.service.GpsService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import lombok.AllArgsConstructor;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.ModelAttribute;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

/**
 *
 */

@RestController
@AllArgsConstructor
@RequestMapping("/usergps")
@Api(tags="巡检人员监控信息接口")
public class GpsController {
    GpsService gpsService;

    @GetMapping("/sectionGps")
    @ApiOperation(value = "获取巡检人员分段轨迹)")
    public ResultRespone getSectionGps(Page page, @ModelAttribute UserGpsSearch userGpsSearch) {
        if (userGpsSearch.getUserId() == null) {
            throw new ToflyDeniedException("用户id不能为空");
        }
        if (userGpsSearch.getStartDate() == null ) {
            userGpsSearch.setStartDate(Date8Util.getStartTime());
        }
        if (userGpsSearch.getEndDate() == null ) {
            userGpsSearch.setEndDate(Date8Util.getEndTime());
        }
        return ResultRespone.success(gpsService.getSectionGps(page,userGpsSearch));
    }

    @GetMapping("/section")
    @ApiOperation(value = "获取巡检人员分段")
    public ResultRespone getSection(@ModelAttribute GpsSectionSearch gpsSectionSearch) {
        if (gpsSectionSearch.getUserId() == null) {
            throw new ToflyDeniedException("用户id不能为空");
        }
        if (gpsSectionSearch.getStartDate() == null ) {
            gpsSectionSearch.setStartDate(Date8Util.getStartTime());
        }
        if (gpsSectionSearch.getEndDate() == null ) {
            gpsSectionSearch.setEndDate(Date8Util.getEndTime());
        }
        return ResultRespone.success(gpsService.getSection(gpsSectionSearch));
    }

}
