/*
 * Author: wangjian
 * 生成entity
 */
package com.tofly.dyrqGps.entity;

import com.baomidou.mybatisplus.annotation.FieldFill;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import org.springframework.data.annotation.Id;
import org.springframework.data.elasticsearch.annotations.Document;
import org.springframework.data.elasticsearch.annotations.Field;
import org.springframework.data.elasticsearch.annotations.FieldType;
import org.springframework.format.annotation.DateTimeFormat;

import java.io.Serializable;
import java.math.BigDecimal;
import java.util.Date;


/**
 * GPS状态表
 *
 * @author
 * @date Mon Apr 13 00:00:00 CST 2020
 */
@Data
@Document(indexName = "dyrq_"+"#{T(com.tofly.common.core.util.Date8Util).getSF()}", type = "gpsstatus")
public class EsGpsStatus  implements Serializable {
    private static final long serialVersionUID = 494073698339266200L;
    /**
     * 编号GUID
     */
    @TableId(value = "ID",type= IdType.INPUT)
    @ApiModelProperty(value = "编号GUID")
    @Id
    private String id;
    /**
     * GPS时间
     */
    @ApiModelProperty(value = "GPS时间")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss",timezone = "GMT+8")
    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm:ss")
    private Date gpstime;
    /**
     * 经度
     */
    @ApiModelProperty(value = "经度")
    private BigDecimal longitude;
    /**
     * 纬度
     */
    @ApiModelProperty(value = "纬度")
    private BigDecimal latitude;
    /**
     * 速度
     */
    @ApiModelProperty(value = "速度")
    private Float speed;
    /**
     * 方向
     */
    @ApiModelProperty(value = "方向")
    private Integer direction;
    /**
     * 位置描述
     */
    @ApiModelProperty(value = "位置描述")
    private String location;
    /**
     * 系统时间
     */
    @ApiModelProperty(value = "系统时间")
    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm:ss")
    @Field(type = FieldType.Date,fielddata=true)
    private Date systemtime;
    /**
     * 累计距离
     */
    @ApiModelProperty(value = "累计距离")
    private BigDecimal distance;
    /**
     * 定位模糊半径
     */
    @ApiModelProperty(value = "定位模糊半径")
    private Double radius;
    /**
     * 1：GPS定位；
     2：网络定位。

     */
    @ApiModelProperty(value = "1：GPS定位； 2：网络定位")
    private String locationType;
    @ApiModelProperty(hidden = true)
    private String locationTypeName;
    /**
     * 投影坐标x
     */
    @ApiModelProperty(value = "投影坐标x")
    private BigDecimal x;
    /**
     * 投影坐标y
     */
    @ApiModelProperty(value = "投影坐标y")
    private BigDecimal y;
    /**
     * 用户编号
     */
    @ApiModelProperty(value = "用户编号")
    @TableField(value = "USER_ID",fill = FieldFill.INSERT)
    private Long userId;
    @ApiModelProperty(hidden = true)
    private String userIdName;
    /**
     * 用户真实姓名
     */
    @ApiModelProperty(value = "用户真实姓名")
    private String realname;
    /**
     * $column.comments
     */
    @ApiModelProperty(value = "$column.comments")
    private String delFlag;
}
