package com.tofly.dyrqGps.service.impl;

import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.tofly.common.core.util.Date8Util;
import com.tofly.dyrqGps.entity.EsGpsUpload;
import com.tofly.dyrqGps.entity.GpsSectionSearch;
import com.tofly.dyrqGps.entity.Sign;
import com.tofly.dyrqGps.entity.UserGpsSearch;
import com.tofly.dyrqGps.repository.EsGpsUploadService;
import com.tofly.dyrqGps.service.GpsService;
import com.tofly.dyrqGps.service.SignService;
import com.tofly.dyrqGps.util.EsQueryUtil;
import com.tofly.dyrqGps.util.EsSaveInfoUtil;
import lombok.AllArgsConstructor;
import org.elasticsearch.index.query.QueryBuilder;
import org.springframework.data.elasticsearch.core.ElasticsearchTemplate;
import org.springframework.stereotype.Service;

import java.util.*;

@Service
@AllArgsConstructor
public class GpsServiceImpl implements GpsService {
    private final SignService signService;
    private final EsGpsUploadService esGpsUploadService;
    private final EsSaveInfoUtil esSaveInfoUtil;
    private final ElasticsearchTemplate elasticsearchTemplate;

    @Override
    public List<EsGpsUpload> getSectionGps(Page page, UserGpsSearch userGpsSearch) {
        EsGpsUpload esGpsUpload = null;
        if (Long.valueOf(10).equals(page.getSize())){
            page.setSize(new Long(1000));
        }
        QueryBuilder[] queryBuilders = EsQueryUtil.getGpsLst(page, userGpsSearch);
        List<EsGpsUpload> list = esGpsUploadService.getAll(esGpsUpload, page,
                esSaveInfoUtil.DyMonth(esGpsUploadService.getIndex()), elasticsearchTemplate, queryBuilders);
        return list;
    }

    @Override
    public List<Map> getSection(GpsSectionSearch gpsSectionSearch) {
        List<Sign> signList = signService.list(Wrappers.<Sign>lambdaQuery()
                .ge(Sign::getSignTime, gpsSectionSearch.getStartDate())
                .le(Sign::getSignTime, gpsSectionSearch.getEndDate())
                .eq(Sign::getUserid, gpsSectionSearch.getUserId())
                .orderByAsc(Sign::getSignTime));

        int k = 1;
        Date start = null;
        List<Map> list = new ArrayList<>();
        List<String> section = new ArrayList<>();
        for (int i = 0; i<signList.size();i++) {
            Map result = new HashMap();
            if ("1".equals(signList.get(i).getSignType())) {
                start= signList.get(i).getSignTime();
                if (signList.size() == (i+1)){
//                    section.add("第"+k+"段 "+Date8Util.format(start,"yyyy-MM-dd HH:mm:ss")+" - "+ Date8Util.format(Date8Util.getCurrentDate(),"yyyy-MM-dd HH:mm:ss"));
                    result.put("section",k);
                    result.put("startTime",start);
                    result.put("endTime",gpsSectionSearch.getEndDate().equals(Date8Util.getEndTime()) ? Date8Util.getCurrentDate() : gpsSectionSearch.getEndDate());
                    list.add(result);
                }
            }
            if ("2".equals(signList.get(i).getSignType())) {
//                section.add("第"+k+"段 "+Date8Util.format(start,"yyyy-MM-dd HH:mm:ss")+" - "+Date8Util.format(signList.get(i).getSignTime(),"yyyy-MM-dd HH:mm:ss"));
                result.put("section",k);
                result.put("startTime",start);
                result.put("endTime",signList.get(i).getSignTime());
                list.add(result);
                k++;
            }
        }

        return list;
    }
}
