package com.tofly.dyrqGps.util;

import com.baomidou.mybatisplus.core.metadata.OrderItem;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.tofly.common.core.util.StringUtil;
import com.tofly.dyrqGps.entity.EsCarGpsUploadQuery;
import com.tofly.dyrqGps.entity.EsQuery;
import com.tofly.dyrqGps.entity.UserGpsSearch;
import org.elasticsearch.index.query.*;

/**
 * @author tuonbed
 * @date 2020/5/18  9:51
 */
public class EsQueryUtil {

    public static QueryBuilder[] putQUery(Page page, EsQuery esQuery) {
        RangeQueryBuilder rangeQueryBuilder = QueryBuilders.rangeQuery("gpstime");
        if (esQuery.getUploadTimes() != null) {
            rangeQueryBuilder.from(esQuery.getUploadTimes().getTime());
        }
        if (esQuery.getUploadTimee() != null) {
            rangeQueryBuilder.to(esQuery.getUploadTimee().getTime());
        }
        BoolQueryBuilder qb = QueryBuilders.boolQuery();
        if (esQuery.getUserId() != null) {
            MatchQueryBuilder queryBuilder = QueryBuilders.matchQuery("userid", esQuery.getUserId());
            queryBuilder.minimumShouldMatch("100%");
            qb.filter(queryBuilder);
        }
        QueryBuilder[] queryBuilders = new QueryBuilder[2];
        queryBuilders[0] = rangeQueryBuilder;
        queryBuilders[1] = qb;

        OrderItem orderItem = new OrderItem();
        orderItem.setColumn("gpstime");
        orderItem.setAsc(false);
        if (esQuery.getIsAsc() != null){
            orderItem.setAsc(true);
        }
        page.addOrder(orderItem);
        return queryBuilders;
    }

    public static QueryBuilder[] deviceQuery(Page page, EsQuery esQuery) {
        RangeQueryBuilder rangeQueryBuilder = QueryBuilders.rangeQuery("uploadtime");
        if (esQuery.getUploadTimes() != null) {
            rangeQueryBuilder.from(esQuery.getUploadTimes().getTime());
        }
        if (esQuery.getUploadTimee() != null) {
            rangeQueryBuilder.to(esQuery.getUploadTimee().getTime());
        }
        BoolQueryBuilder qb = QueryBuilders.boolQuery();
        if (esQuery.getUserId() != null) {
            MatchQueryBuilder queryBuilder = QueryBuilders.matchQuery("userid", esQuery.getUserId());
            queryBuilder.minimumShouldMatch("100%");
            qb.filter(queryBuilder);
        }
        QueryBuilder[] queryBuilders = new QueryBuilder[2];
        queryBuilders[0] = rangeQueryBuilder;
        queryBuilders[1] = qb;

        OrderItem orderItem = new OrderItem();
        orderItem.setColumn("uploadtime");
        orderItem.setAsc(false);
        if (esQuery.getIsAsc() != null){
            orderItem.setAsc(true);
        }
        page.addOrder(orderItem);
        return queryBuilders;
    }

    public static QueryBuilder[] CarGpsUploadQuery(Page page, EsCarGpsUploadQuery esCarGpsUploadQuery) {
        RangeQueryBuilder rangeQueryBuilder = QueryBuilders.rangeQuery("gpstime");
        if (esCarGpsUploadQuery.getStartTime() != null) {
            rangeQueryBuilder.from(esCarGpsUploadQuery.getStartTime().getTime());
        }
        if (esCarGpsUploadQuery.getEndTime() != null) {
            rangeQueryBuilder.to(esCarGpsUploadQuery.getEndTime().getTime());
        }
        BoolQueryBuilder qb = QueryBuilders.boolQuery();
        if (esCarGpsUploadQuery.getCarId() != null) {
            MatchQueryBuilder queryBuilder = QueryBuilders.matchQuery("carid", esCarGpsUploadQuery.getCarId());
            queryBuilder.minimumShouldMatch("100%");
            qb.filter(queryBuilder);
        }
        if (esCarGpsUploadQuery.getGpsType() != null) {
            MatchQueryBuilder queryBuilder = QueryBuilders.matchQuery("gpsType", esCarGpsUploadQuery.getGpsType());
            queryBuilder.minimumShouldMatch("100%");
            qb.filter(queryBuilder);
        }
        QueryBuilder[] queryBuilders = new QueryBuilder[2];
        queryBuilders[0] = rangeQueryBuilder;
        queryBuilders[1] = qb;

        OrderItem orderItem = new OrderItem();
        orderItem.setColumn("gpstime");
        orderItem.setAsc(false);
        if (esCarGpsUploadQuery.getOrderAsc() != null && esCarGpsUploadQuery.getOrderAsc()){
            orderItem.setAsc(true);
        }
        page.addOrder(orderItem);
        return queryBuilders;
    }

    public static QueryBuilder[] getGpsLst(Page page, UserGpsSearch userGpsSearch) {
        RangeQueryBuilder rangeQueryBuilder = QueryBuilders.rangeQuery("gpstime");
        if (userGpsSearch.getStartDate() != null) {
            rangeQueryBuilder.from(userGpsSearch.getStartDate().getTime());
        }
        if (userGpsSearch.getEndDate() != null) {
            rangeQueryBuilder.to(userGpsSearch.getEndDate().getTime());
        }
        BoolQueryBuilder qb = QueryBuilders.boolQuery();
        if (userGpsSearch.getUserId() != null) {
            MatchQueryBuilder queryBuilder = QueryBuilders.matchQuery("userid", userGpsSearch.getUserId());
            queryBuilder.minimumShouldMatch("100%");
            qb.filter(queryBuilder);
        }
        if (StringUtil.isNotEmpty(userGpsSearch.getIsvalid())) {
            MatchQueryBuilder queryBuilder = QueryBuilders.matchQuery("isvalid", userGpsSearch.getIsvalid());
            qb.must(queryBuilder);
        }
        if (userGpsSearch.getSection() != null) {
            MatchQueryBuilder qbGpsSection = QueryBuilders.matchQuery("gpsSection", userGpsSearch.getSection().toString());
            qb.must(qbGpsSection);
        }
        QueryBuilder[] queryBuilders = new QueryBuilder[2];
        queryBuilders[0] = rangeQueryBuilder;
        queryBuilders[1] = qb;

        OrderItem orderItem = new OrderItem();
        orderItem.setColumn("gpstime");
        orderItem.setAsc(true);
        page.addOrder(orderItem);
        return queryBuilders;
    }
}
