package com.tofly.dyrqGps.util;

import com.tofly.common.core.util.Date8Util;
import com.tofly.common.core.util.StringUtil;
import com.tofly.dyrqGps.mapper.EsSaveInfoMapper;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import javax.annotation.PostConstruct;
import java.math.BigDecimal;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;

/**
 * @author tuonbed
 * @date 2020/5/15  15:48
 */
@Component
@Slf4j
public class EsSaveInfoUtil {
    @Autowired
    private EsSaveInfoMapper esSaveInfoMapper;

    private Map<String,String> esindexinfo=new HashMap();

    private volatile Map<String,Long> carGpsInfo=new HashMap<>();

    public void checkorinsertEsInfo(String index){
        if(isSave(index)){
            Map map =new HashMap();
            map.put("esindex",index);
            map.put("fristtime", Date8Util.getYearMonth());
            esSaveInfoMapper.insertEsInfo(map);
            esindexinfo.putAll(map);
        }
    }

    @PostConstruct
    public void getUsersRtInfo(){
        List<Map> list = esSaveInfoMapper.getUsersRtInfo();
        log.info("初始化加载es数据:{}",list);
        list.parallelStream().forEach(m->{
            esindexinfo.put((String)m.get("esindex"),(String)m.get("fristtime"));
        });
        List<Map> cargpsList=esSaveInfoMapper.getCarGpsInfo();
        carGpsInfo=cargpsList.stream().collect(Collectors.toMap(m->(String)m.get("meid"),n->((BigDecimal)n.get("carId")).longValue()));
    }

    private boolean isSave(String index){
        return !esindexinfo.containsKey(index);
    }

    public int DyMonth(String index){
        int t=Date8Util.between(esindexinfo.get(index));
        return Math.min(t,DyrqCommonRedis.SAVE_MAX_TIME);
    }

    public long getCarId(String meid){
        return StringUtil.isNotEmpty(meid) ? carGpsInfo.get(meid) : 0;
    }

    public void updateCarGpsInfo(){
        List<Map> cargpsList=esSaveInfoMapper.getCarGpsInfo();
        carGpsInfo=cargpsList.stream().collect(Collectors.toMap(m->(String)m.get("meid"),n->((BigDecimal)n.get("carId")).longValue()));
    }

}
