package com.tofly.dyrqGps.util;

/**
 * @author pra
 * @date 2021/1/7 17:10
 * @description
 */
public class GpsDistanceUtil {
    /**
     *
     * @param lng1 点1经度
     * @param lat1 点1纬度
     * @param lng2 点2经度
     * @param lat2 点2纬度
     * @return 两点距离，单位m
     */
    public static double getDistance(double lng1, double lat1, double lng2, double lat2) {
        Double EARTH_RADIUS = 6378.137; // 地球长半径  地球半径系数6370.996
        Double radLat1 = lat1 * Math.PI / 180.0;
        Double radLat2 = lat2 * Math.PI / 180.0;

        Double radLng1 = lng1 * Math.PI / 180.0;
        Double radLng2 = lng2 * Math.PI / 180.0;

        Double a = radLat1 - radLat2;
        Double b = radLng1 - radLng2;

        double s = 2 * Math.asin(Math.sqrt(Math.pow(Math.sin(a / 2), 2) + Math.cos(radLat1) * Math.cos(radLat2) * Math.pow(Math.sin(b / 2), 2)));
        s = s * EARTH_RADIUS * 1000;
        //s = Math.round(s * 10000) / 10000;
        return s;
    }
}
