package com.tofly.dyrqScada.Config;


import com.tofly.dyrqScada.service.RealdataService;
import lombok.AllArgsConstructor;
import lombok.SneakyThrows;
import lombok.extern.slf4j.Slf4j;
import org.springframework.scheduling.annotation.Async;
import org.springframework.scheduling.annotation.EnableAsync;
import org.springframework.scheduling.annotation.EnableScheduling;
import org.springframework.scheduling.annotation.Scheduled;
import org.springframework.stereotype.Service;

@EnableScheduling   // 1.开启定时任务
@EnableAsync        // 2.开启多线程
@Slf4j
@Service
@AllArgsConstructor
public class ScheduledTask {
    private final RealdataService realdataService;

    @Async
    @Scheduled(cron="0 0/1 * * * ?")  //
    @SneakyThrows
    public void uploadPlanState(){
        realdataService.sync();
    }
}
