/*
 * Author: wangjian
 * 生成controller
 */
package com.tofly.dyrqScada.controller;

import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.tofly.common.core.entity.ResultRespone;
import com.tofly.common.log.annotation.ToFlyAppLog;
import com.tofly.dyrqScada.entity.Realdata;
import com.tofly.dyrqScada.service.RealdataService;
import lombok.AllArgsConstructor;
import org.springframework.web.bind.annotation.*;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import org.springframework.web.bind.annotation.ModelAttribute;

import java.util.Arrays;
/**
 * 
 *
 * @author pra
 * @date Fri Nov 20 00:00:00 CST 2020
 */
@RestController
@AllArgsConstructor
@RequestMapping("/realdata")
@Api(tags="接口")
public class RealdataController {

    private final  RealdataService realdataService;

    /**
    * 分页查询
    * @param page 分页对象
    * @param realdata 
    * @return
    */
    @GetMapping("/page" )
    @ApiOperation(value = "分页查询")
    public ResultRespone getRealdataPage(Page page, @ModelAttribute Realdata realdata) {
      return ResultRespone.success(realdataService.page(page, Wrappers.query(realdata)));
    }


//    /**
//     * 通过id查询
//     * @param tag id
//     * @return ResultRespone
//     */
//    @GetMapping("/{tag}" )
//    @ApiOperation(value = "通过ID查询")
//    @ApiImplicitParams({
//            @ApiImplicitParam(name = "tag", value = "ID", required = true, dataType = "String")
//    })
//    public ResultRespone getById(@PathVariable("tag" ) String tag) {
//      return ResultRespone.success(realdataService.getById(tag));
//    }

    /**
     * 新增
     * @param realdata 
     * @return ResultRespone
     */
    @ToFlyAppLog(title="新增" )
    @ApiOperation(value = "新增")
    @PostMapping
    public ResultRespone save(@RequestBody Realdata realdata) {
      return ResultRespone.success(realdataService.save(realdata));
    }

    /**
     * 修改
     * @param realdata 
     * @return ResultRespone
     */
    @ToFlyAppLog(title="修改" )
    @ApiOperation(value = "修改")
    @PutMapping
    public ResultRespone updateById(@RequestBody Realdata realdata) {
      return ResultRespone.success(realdataService.updateById(realdata));
    }

    /**
     * scada数据同步接口
     * @return
     */
    @GetMapping("/sync" )
    @ApiOperation(value = "scada数据同步接口")
    public ResultRespone sync() {
        return ResultRespone.success(realdataService.sync());
    }

}
