/*
 * Author: wangjian
 * 生成entity
 */
package com.tofly.dyrqSchedule.entity;

import com.baomidou.mybatisplus.annotation.*;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;

import java.math.BigDecimal;
import java.util.Date;
import com.fasterxml.jackson.annotation.JsonFormat;
import org.springframework.format.annotation.DateTimeFormat;


/**
 * 工地监护工单表
 *
 * @author pra
 * @date Fri Aug 21 00:00:00 CST 2020
 */
@Data
@EqualsAndHashCode(callSuper = true)
@TableName(value="TF_CONSTRUCTION_SITE",resultMap = "constructionSiteMap")
@KeySequence("TF_CONSTRUCTION_SITE")
@ApiModel
public class ConstructionSite extends Model<ConstructionSite> {
    private static final long serialVersionUID = 1L;

        /**
     * 工地监护工单主键ID
     */
        @TableId(value = "ID",type= IdType.INPUT)
            @ApiModelProperty(value = "工地监护工单主键ID")
                private Long id;
                /**
     * 工地名称(地址+内容)
     */
            @ApiModelProperty(value = "工地名称(地址+内容)")
                private String siteName;
                /**
     * 工地类型  0:第三方施工 , 1:自建工程
     */
            @ApiModelProperty(value = "工地类型  0:第三方施工 , 1:自建工程")
                private String siteType;
        @ApiModelProperty(hidden = true)
    private String siteTypeName;
                /**
     * 施工单位
     */
            @ApiModelProperty(value = "施工单位")
                private String constructionUnit;
                /**
     * 工地负责人
     */
            @ApiModelProperty(value = "工地负责人")
                private String personInCharge;
                /**
     * 负责人电话
     */
            @ApiModelProperty(value = "负责人电话")
                private String personInChargePhone;
                /**
     * 主管单位
     */
            @ApiModelProperty(value = "主管单位")
                private String manageUnit;
                /**
     * 主管人
     */
            @ApiModelProperty(value = "主管人")
                private String manager;
                /**
     * 施工地点
     */
            @ApiModelProperty(value = "施工地点")
                private String constructionAddress;
                /**
     * 坐标X
     */
            @ApiModelProperty(value = "坐标X")
                private BigDecimal x;
                /**
     * 坐标Y
     */
            @ApiModelProperty(value = "坐标Y")
                private BigDecimal y;
                /**
     * 派工人ID
     */
            @ApiModelProperty(value = "派工人ID")
                private Long dispatchUserId;
                /**
     * 派工时间
     */
            @ApiModelProperty(value = "派工时间")
        @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss",timezone = "GMT+8")
    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm:ss")
                private Date dispatchDate;
                /**
     * 备注
     */
            @ApiModelProperty(value = "备注")
                private String note;
                /**
     * 删除标记
     */
            @TableLogic
        @ApiModelProperty(value = "删除标记")
                private String delFlag;
                /**
     * 工单状态  0:待派工 , 工单状态  0:待派工 , 1:派工未通过, 2:待处理 , 3:待审核 , 4:审核未通过, 5:归档
     */
            @ApiModelProperty(value = "工单状态  0:待派工 , 工单状态  0:待派工 , 1:派工未通过, 2:待处理 , 3:待审核 , 4:审核未通过, 5:归档")
                private String constructionState;
        @ApiModelProperty(hidden = true)
    private String constructionStateName;
                /**
     * 详情描述
     */
            @ApiModelProperty(value = "详情描述")
                private String description;
                /**
     * 工地监护人
     */
            @ApiModelProperty(value = "工地监护人")
                private Long constructionPerson;
                /**
     * 工单创建人
     */
            @ApiModelProperty(value = "工单创建人")
                private Long creatUser;
                /**
     * 工单创建时间
     */
            @ApiModelProperty(value = "工单创建时间")
        @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss",timezone = "GMT+8")
    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm:ss")
                private Date creatTime;
                /**
     * 工地监护人部门
     */
            @ApiModelProperty(value = "工地监护人部门")
                private Long department;
            
}
