/*
 * Author: wangjian
 * 生成entity
 */
package com.tofly.dyrqSchedule.entity;

import com.baomidou.mybatisplus.annotation.*;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;

import java.math.BigDecimal;
import java.util.Date;

import com.fasterxml.jackson.annotation.JsonFormat;
import org.springframework.format.annotation.DateTimeFormat;

import javax.persistence.Entity;
import javax.persistence.Id;


/**
 * 累计计算轨迹
 *
 * @author pra
 * @date Fri Aug 21 00:00:00 CST 2020
 */
@Data
@EqualsAndHashCode(callSuper = true)
@TableName(value = "TF_GPS_DAY_CALCULATE", resultMap = "gpsDayCalculateMap")
@KeySequence("TF_GPS_DAY_CALCULATE")
@ApiModel
@Entity(name = "TF_GPS_DAY_CALCULATE")
public class GpsDayCalculate extends Model<GpsDayCalculate> {
    private static final long serialVersionUID = 1L;

    /**
     * 删除标记
     */
    @TableLogic
    @ApiModelProperty(value = "删除标记")
    private String delFlag;
    /**
     * 累计计算估计唯一编码
     */
    @Id
    @TableId(value = "ID", type = IdType.INPUT)
    @ApiModelProperty(value = "累计计算估计唯一编码")
    private Long id;
    /**
     * 用户唯一编码
     */
    @ApiModelProperty(value = "用户唯一编码")
    private Long userid;
    /**
     * 公司唯一编码
     */
    @ApiModelProperty(value = "公司唯一编码")
    private Long companyid;
    /**
     * 巡检日期
     */
    @ApiModelProperty(value = "巡检日期")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date planDate;
    /**
     * 巡检里程
     */
    @ApiModelProperty(value = "巡检里程")
    private Double planTotalDistance;
    /**
     * 巡检时长,秒数
     */
    @ApiModelProperty(value = "巡检时长,秒数")
    private Double planTotalTime;
    /**
     * 巡检平均时速
     */
    @ApiModelProperty(value = "巡检平均时速")
    private Double planTotalAverage;
    /**
     * 车辆ID
     */
    @ApiModelProperty(value = "车辆ID")
    private Long carid;
    /**
     * 计划巡检点个数
     */
    @ApiModelProperty(value = "计划巡检点个数")
    private BigDecimal pointinplan;
    /**
     * 实际巡检点个数
     */
    @ApiModelProperty(value = "实际巡检点个数")
    private BigDecimal pointpatroled;
    /**
     * 计划巡检线长度
     */
    @ApiModelProperty(value = "计划巡检线长度")
    private BigDecimal pathinplan;
    /**
     * 实际巡检线长度
     */
    @ApiModelProperty(value = "实际巡检线长度")
    private BigDecimal pathpatroled;
    /**
     * 发现隐患数
     */
    @ApiModelProperty(value = "发现隐患数")
    private BigDecimal troublefinded;
    /**
     * 计划巡检设备个数
     */
    @ApiModelProperty(value = "计划巡检设备个数")
    private BigDecimal equipmentsinplan;
    /**
     * 实际巡检设备个数
     */
    @ApiModelProperty(value = "实际巡检设备个数")
    private BigDecimal equipmentspatroled;
    /**
     * 工地发现个数
     */
    @ApiModelProperty(value = "工地发现个数")
    private BigDecimal buildingsitefinded;
    /**
     * 工地监护个数
     */
    @ApiModelProperty(value = "工地监护个数")
    private BigDecimal buildingsitemonitor;
    /**
     * 车巡里程
     */
    @ApiModelProperty(value = "车巡里程")
    private Double carTotalDistance;
    /**
     * 车巡耗时
     */
    @ApiModelProperty(value = "车巡耗时")
    private Double carTotalTime;
    /**
     * 车巡平均时速
     */
    @ApiModelProperty(value = "车巡平均时速")
    private Double carTotalAverage;
    /**
     * 有效里程
     */
    @ApiModelProperty(value = "有效里程")
    private Double validDistance;
    /**
     * 有效耗时
     */
    @ApiModelProperty(value = "有效耗时")
    private Double validTime;
    /**
     * 有效时速
     */
    @ApiModelProperty(value = "有效时速")
    private Double validAverage;
    /**
     * 签到时间段
     */
    @ApiModelProperty(value = "签到时间段")
    private String signRange;
    /**
     * 计划巡检隐患个数
     */
    @ApiModelProperty(value = "计划巡检隐患个数")
    private BigDecimal troubleinplan;
    /**
     * 实际巡检隐患个数
     */
    @ApiModelProperty(value = "实际巡检隐患个数")
    private BigDecimal troubleipatroled;
    @ApiModelProperty(value = "计划巡检管线长度")
    private BigDecimal pipeinplan;
    @ApiModelProperty(value = "实际巡检管线长度")
    private BigDecimal pipepatroled;
    @ApiModelProperty(value = "抢维修发现数量")
    private BigDecimal rushRepairNum;

}
