/*
 * Author: wangjian
 * 生成entity
 */
package com.tofly.dyrqSchedule.entity;

import com.baomidou.mybatisplus.annotation.*;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;

import java.math.BigDecimal;
import java.util.Date;
import com.fasterxml.jackson.annotation.JsonFormat;
import org.springframework.format.annotation.DateTimeFormat;


/**
 * 调压站及楼栋调压箱巡护记录表
 *
 * @author pra
 * @date Fri Aug 21 00:00:00 CST 2020
 */
@Data
@EqualsAndHashCode(callSuper = true)
@TableName(value="TF_MAINTENANCE",resultMap = "maintenanceMap")
@KeySequence("TF_MAINTENANCE")
@ApiModel
public class Maintenance extends Model<Maintenance> {
    private static final long serialVersionUID = 1L;

        /**
     * $column.comments
     */
        @TableId(value = "DEL_FLAG",type= IdType.INPUT)
            @TableLogic
        @ApiModelProperty(value = "$column.comments")
                private String delFlag;
                /**
     * 巡检计划临时点(point_id)
     */
            @ApiModelProperty(value = "巡检计划临时点(point_id)")
                private Long planTempPointId;
                /**
     * 子计划ID
     */
            @ApiModelProperty(value = "子计划ID")
                private Long childPlanId;
                /**
     * 平面坐标X
     */
            @ApiModelProperty(value = "平面坐标X")
                private BigDecimal x;
                /**
     * 平面坐标Y
     */
            @ApiModelProperty(value = "平面坐标Y")
                private BigDecimal y;
                /**
     * 唯一编码
     */
            @ApiModelProperty(value = "唯一编码")
                private Long id;
                /**
     * 用气片区
     */
            @ApiModelProperty(value = "用气片区")
                private String region;
                /**
     * 设施编号
     */
            @ApiModelProperty(value = "设施编号")
                private Long deviceId;
                /**
     * 检查起始时间
     */
            @ApiModelProperty(value = "检查起始时间")
        @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss",timezone = "GMT+8")
    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm:ss")
                private Date checkBeginDate;
                /**
     * 检查结束时间
     */
            @ApiModelProperty(value = "检查结束时间")
        @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss",timezone = "GMT+8")
    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm:ss")
                private Date checkEndDate;
                /**
     * 地址
     */
            @ApiModelProperty(value = "地址")
                private String address;
                /**
     * 记录创建人
     */
            @ApiModelProperty(value = "记录创建人")
            @TableField(value = "CREATE_USER",fill = FieldFill.INSERT)
            private Long createUser;
            @ApiModelProperty(hidden = true)
    private String createUserName;
            /**
     * 创建时间
     */
            @ApiModelProperty(value = "创建时间")
        @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss",timezone = "GMT+8")
    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm:ss")
            @TableField(value = "CREATE_DATE",fill = FieldFill.INSERT)
            private Date createDate;
                /**
     * 巡检员
     */
            @ApiModelProperty(value = "巡检员")
                private Long userid;
                /**
     * 审核人
     */
            @ApiModelProperty(value = "审核人")
                private Long checkUser;
            
}
