/*
 * Author: wangjian
 * 生成entity
 */
package com.tofly.dyrqSchedule.entity;

import com.baomidou.mybatisplus.annotation.*;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;

import java.math.BigDecimal;
import java.util.Date;
import com.fasterxml.jackson.annotation.JsonFormat;
import org.springframework.format.annotation.DateTimeFormat;


/**
 * 设备设施运行维修保养登记表
 *
 * @author pra
 * @date Fri Aug 21 00:00:00 CST 2020
 */
@Data
@EqualsAndHashCode(callSuper = true)
@TableName(value="TF_MAINTENANCE_DEVICE",resultMap = "maintenanceDeviceMap")
@KeySequence("TF_MAINTENANCE_DEVICE")
@ApiModel
public class MaintenanceDevice extends Model<MaintenanceDevice> {
    private static final long serialVersionUID = 1L;

        /**
     * 唯一编码
     */
        @TableId(value = "ID",type= IdType.INPUT)
            @ApiModelProperty(value = "唯一编码")
                private Long id;
                /**
     * 设备编号
     */
            @ApiModelProperty(value = "设备编号")
                private Long deviceId;
                /**
     * 型号
     */
            @ApiModelProperty(value = "型号")
                private String type;
                /**
     * 主要技术参数
     */
            @ApiModelProperty(value = "主要技术参数")
                private String techParam;
                /**
     * 已使用年限
     */
            @ApiModelProperty(value = "已使用年限")
                private Short usedYears;
                /**
     * 日常安全管理 措施
     */
            @ApiModelProperty(value = "日常安全管理 措施")
                private String security;
                /**
     * 运行操作人
     */
            @ApiModelProperty(value = "运行操作人")
                private Long useUser;
                /**
     * 运行状况
     */
            @ApiModelProperty(value = "运行状况")
                private String useStatus;
                /**
     * 维修人
     */
            @ApiModelProperty(value = "维修人")
                private Long repairUser;
                /**
     * 验收人
     */
            @ApiModelProperty(value = "验收人")
                private Long checkUser;
                /**
     * 维修内容
     */
            @ApiModelProperty(value = "维修内容")
                private String repairContent;
                /**
     * 维修时间
     */
            @ApiModelProperty(value = "维修时间")
        @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss",timezone = "GMT+8")
    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm:ss")
                private Date repairDate;
                /**
     * 保养人
     */
            @ApiModelProperty(value = "保养人")
                private Long maintainUser;
                /**
     * 设备操作人
     */
            @ApiModelProperty(value = "设备操作人")
                private Long deviceUser;
                /**
     * 保养时间
     */
            @ApiModelProperty(value = "保养时间")
        @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss",timezone = "GMT+8")
    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm:ss")
                private Date maintainDate;
                /**
     * 创建人
     */
            @ApiModelProperty(value = "创建人")
            @TableField(value = "CREATE_USER",fill = FieldFill.INSERT)
            private Long createUser;
            @ApiModelProperty(hidden = true)
    private String createUserName;
            /**
     * 创建时间
     */
            @ApiModelProperty(value = "创建时间")
        @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss",timezone = "GMT+8")
    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm:ss")
            @TableField(value = "CREATE_DATE",fill = FieldFill.INSERT)
            private Date createDate;
                /**
     * $column.comments
     */
            @TableLogic
        @ApiModelProperty(value = "$column.comments")
                private String delFlag;
                /**
     * 巡检计划临时点(point_id)
     */
            @ApiModelProperty(value = "巡检计划临时点(point_id)")
                private Long planTempPointId;
                /**
     * 子计划ID
     */
            @ApiModelProperty(value = "子计划ID")
                private Long childPlanId;
                /**
     * 平面坐标X
     */
            @ApiModelProperty(value = "平面坐标X")
                private BigDecimal x;
                /**
     * 平面坐标Y
     */
            @ApiModelProperty(value = "平面坐标Y")
                private BigDecimal y;
            
}
