/*
 * Author: wangjian
 * 生成entity
 */
package com.tofly.dyrqSchedule.entity;

import com.baomidou.mybatisplus.annotation.*;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;

import java.util.Date;
import com.fasterxml.jackson.annotation.JsonFormat;
import org.springframework.format.annotation.DateTimeFormat;


/**
 * 消息推送表
 *
 * @author pra
 * @date Fri Aug 21 00:00:00 CST 2020
 */
@Data
@EqualsAndHashCode(callSuper = true)
@TableName(value="TF_MESSAGE",resultMap = "messageMap")
@KeySequence("TF_MESSAGE")
@ApiModel
public class Message extends Model<Message> {
    private static final long serialVersionUID = 1L;

        /**
     * 唯一编码
     */
        @TableId(value = "ID",type= IdType.INPUT)
            @ApiModelProperty(value = "唯一编码")
                private Long id;
                /**
     * 创建人
     */
            @ApiModelProperty(value = "创建人")
            @TableField(value = "CREATE_USER",fill = FieldFill.INSERT)
            private Long createUser;
            @ApiModelProperty(hidden = true)
    private String createUserName;
            /**
     * 创建时间
     */
            @ApiModelProperty(value = "创建时间")
        @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss",timezone = "GMT+8")
    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm:ss")
            @TableField(value = "CREATE_DATE",fill = FieldFill.INSERT)
            private Date createDate;
                /**
     * 消息主题
     */
            @ApiModelProperty(value = "消息主题")
                private String topic;
                /**
     * 消息详情
     */
            @ApiModelProperty(value = "消息详情")
                private String message;
                /**
     * $column.comments
     */
            @TableLogic
        @ApiModelProperty(value = "$column.comments")
                private String delFlag;
                /**
     * 回复的原消息ID
     */
            @ApiModelProperty(value = "回复的原消息ID")
                private Long replyId;
            
}
