/*
 * Author: wangjian
 * 生成entity
 */
package com.tofly.dyrqSchedule.entity;

import com.baomidou.mybatisplus.annotation.*;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;

import java.util.Date;
import com.fasterxml.jackson.annotation.JsonFormat;
import org.springframework.format.annotation.DateTimeFormat;


/**
 * 消息推送人员表
 *
 * @author pra
 * @date Fri Aug 21 00:00:00 CST 2020
 */
@Data
@EqualsAndHashCode(callSuper = true)
@TableName(value="TF_MESSAGE_RECIPIENT",resultMap = "messageRecipientMap")
@KeySequence("TF_MESSAGE_RECIPIENT")
@ApiModel
public class MessageRecipient extends Model<MessageRecipient> {
    private static final long serialVersionUID = 1L;

        /**
     * 唯一编码
     */
        @TableId(value = "ID",type= IdType.INPUT)
            @ApiModelProperty(value = "唯一编码")
                private Long id;
                /**
     * 消息表主键
     */
            @ApiModelProperty(value = "消息表主键")
                private Long messageId;
                /**
     * 消息接收人
     */
            @ApiModelProperty(value = "消息接收人")
                private Long recipient;
                /**
     * 消息是否接收，0：未接收，1：已接收
     */
            @ApiModelProperty(value = "消息是否接收，0：未接收，1：已接收")
                private String flag;
                /**
     * 消息接收时间
     */
            @ApiModelProperty(value = "消息接收时间")
        @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss",timezone = "GMT+8")
    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm:ss")
                private Date recipientTime;
                /**
     * $column.comments
     */
            @TableLogic
        @ApiModelProperty(value = "$column.comments")
                private String delFlag;
            
}
