/*
 * Author: wangjian
 * 生成entity
 */
package com.tofly.dyrqSchedule.entity;

import com.baomidou.mybatisplus.annotation.*;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;

import java.math.BigDecimal;
import java.util.Date;
import com.fasterxml.jackson.annotation.JsonFormat;
import org.springframework.format.annotation.DateTimeFormat;

import javax.persistence.Entity;
import javax.persistence.Id;


/**
 * 考勤签到表
 *
 * @author pra
 * @date Fri Aug 21 00:00:00 CST 2020
 */
@Data
@EqualsAndHashCode(callSuper = true)
@TableName(value="TF_PDA_SIGN",resultMap = "pdaSignMap")
@KeySequence("TF_PDA_SIGN")
@ApiModel
@Entity(name = "TF_PDA_SIGN")
public class PdaSign extends Model<PdaSign> {
    private static final long serialVersionUID = 1L;

        /**
     * 删除标记
     */
            @TableLogic
        @ApiModelProperty(value = "删除标记")
                private String delFlag;
                /**
     * 主键id
     */
                @Id
        @TableId(value = "ID",type= IdType.INPUT)
            @ApiModelProperty(value = "主键id")
                private Long id;
                /**
     * 自增序号
     */
            @ApiModelProperty(value = "自增序号")
                private BigDecimal sid;
                /**
     * 用户id
     */
            @ApiModelProperty(value = "用户id")
                private Long userid;
                /**
     * 移动设备id
     */
            @ApiModelProperty(value = "移动设备id")
                private Long padid;
                /**
     * 签到时间
     */
            @ApiModelProperty(value = "签到时间")
        @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss",timezone = "GMT+8")
    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm:ss")
                private Date signTime;
                /**
     * 签到地址
     */
            @ApiModelProperty(value = "签到地址")
                private String signAddress;
                /**
     * 签到类型 1：上班 2：下班
     */
            @ApiModelProperty(value = "签到类型 1：上班 2：下班")
                private String signType;
        @ApiModelProperty(hidden = true)
    private String signTypeName;
                /**
     * 转换位置x
     */
            @ApiModelProperty(value = "转换位置x")
                private BigDecimal locationX;
                /**
     * 转换位置y
     */
            @ApiModelProperty(value = "转换位置y")
                private BigDecimal locationY;
                /**
     * GPS经度
     */
            @ApiModelProperty(value = "GPS经度")
                private BigDecimal locationLongitude;
                /**
     * GPS纬度
     */
            @ApiModelProperty(value = "GPS纬度")
                private BigDecimal locationLatitude;
                /**
     * 所属公司
     */
            @ApiModelProperty(value = "所属公司")
                private Long companyid;
        @ApiModelProperty(hidden = true)
    private String deptName;
                /**
     * 签到备注
     */
            @ApiModelProperty(value = "签到备注")
                private String notes;
                /**
     * 签到位置是否正常 0:gps获取 1：手动获取
     */
            @ApiModelProperty(value = "签到位置是否正常 0:gps获取 1：手动获取")
                private String flag;
        @ApiModelProperty(hidden = true)
    private String flagName;
            
}
