/*
 * Author: wangjian
 * 生成entity
 */
package com.tofly.dyrqSchedule.entity;

import com.baomidou.mybatisplus.annotation.*;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;

import java.util.Date;

import com.fasterxml.jackson.annotation.JsonFormat;
import org.springframework.format.annotation.DateTimeFormat;

import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;


/**
 * 巡检人员与移动设备关联表
 *
 * @author pra
 * @date Fri Aug 21 00:00:00 CST 2020
 */
@Data
@EqualsAndHashCode(callSuper = true)
@TableName(value = "TF_PDA_USER_DEVICE", resultMap = "pdaUserDeviceMap")
@KeySequence("TF_PDA_USER_DEVICE")
@ApiModel
@Entity(name = "TF_PDA_USER_DEVICE")
public class PdaUserDevice extends Model<PdaUserDevice> {
    private static final long serialVersionUID = 1L;

    /**
     * 绑定用户id
     */
    @ApiModelProperty(value = "绑定用户id")
    @TableField(value = "USER_ID", fill = FieldFill.INSERT)
    private Long userId;
    @ApiModelProperty(hidden = true)
    private String userIdName;
    /**
     * 绑定移动设备id
     */
    @ApiModelProperty(value = "绑定移动设备id")
    private Long deviceId;
    /**
     * 巡检类型 0：人巡 1：车巡
     */
    @ApiModelProperty(value = "巡检类型 0：人巡 1：车巡")
    private String xjtype;
    /**
     * 创建时间
     */
    @ApiModelProperty(value = "创建时间")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    @TableField(value = "CREATE_TIME", fill = FieldFill.INSERT)
    private Date createTime;
    /**
     * 唯一标识id
     */
    @Id
    @TableId(value = "ID", type = IdType.INPUT)
    @ApiModelProperty(value = "唯一标识id")
    private Long id;
    /**
     * $column.comments
     */
    @TableLogic
    @ApiModelProperty(value = "$column.comments")
    private String delFlag;

}
