/*
 * Author: wangjian
 * 生成entity
 */
package com.tofly.dyrqSchedule.entity;

import com.baomidou.mybatisplus.annotation.*;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import javax.persistence.Entity;
import javax.persistence.Id;
import java.math.BigDecimal;
import java.util.Date;
import com.fasterxml.jackson.annotation.JsonFormat;
import org.springframework.format.annotation.DateTimeFormat;


/**
 * 一月一巡计划
 *
 * @author pra
 * @date Fri Aug 21 00:00:00 CST 2020
 */
@Data
@EqualsAndHashCode(callSuper = true)
@TableName(value="TF_PLAN_CHILD",resultMap = "planChildMap")
@KeySequence("TF_PLAN_CHILD")
@ApiModel
@Entity(name = "TF_PLAN_CHILD")
public class PlanChild extends Model<PlanChild> {
    private static final long serialVersionUID = 1L;

    /**
     * $column.comments
     */
    @ApiModelProperty(value = "$column.comments")
    @TableLogic
    private String delFlag;
    /**
     * 计划唯一编码
     */
    @Id
    @TableId(value = "ID",type= IdType.INPUT)
    @ApiModelProperty(value = "计划唯一编码")
    private Long id;
    /**
     * 主计划唯一编码
     */
    @ApiModelProperty(value = "主计划唯一编码")
    private Long mainPlanId;
    /**
     * 计划序号
     */
    @ApiModelProperty(value = "计划序号")
    private BigDecimal childNum;
    /**
     * 计划开始日期
     */
    @ApiModelProperty(value = "计划开始日期")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss",timezone = "GMT+8")
    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm:ss")
    private Date childBeginDate;
    /**
     * 计划结束日期
     */
    @ApiModelProperty(value = "计划结束日期")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss",timezone = "GMT+8")
    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm:ss")
    private Date childEndDate;
    /**
     * 巡检周期编码
     */
    @ApiModelProperty(value = "巡检周期编码")
    private Long periodId;
    @ApiModelProperty(hidden = true)
    @TableField(exist = false)
    private String preiodName;
    /**
     * 设备类型唯一编码
     */
    @ApiModelProperty(value = "设备类型唯一编码")
    private Long deviceTypeId;
    @ApiModelProperty(hidden = true)
    @TableField(exist = false)
    private String deviceTypeName;
    /**
     * 完成率
     */
    @ApiModelProperty(value = "完成率")
    private Double percent;
    /**
     * 最后一次修改日期
     */
    @ApiModelProperty(value = "最后一次修改日期")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss",timezone = "GMT+8")
    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm:ss")
    @TableField(value = "LAST_TIME",fill = FieldFill.INSERT_UPDATE)
    private Date lastTime;
    /**
     * 用户唯一编码
     */
    @ApiModelProperty(value = "用户唯一编码")
    @TableField(value = "USER_ID",fill = FieldFill.INSERT)
    private Long userId;
    @ApiModelProperty(hidden = true)
    @TableField(exist = false)
    private String userIdName;
    /**
     * 公司唯一编码
     */
    @ApiModelProperty(value = "公司唯一编码")
    private Long companyid;
    @ApiModelProperty(hidden = true)
    @TableField(exist = false)
    private String deptName;
    /**
     * 片区唯一编码
     */
    @ApiModelProperty(value = "片区唯一编码")
    private Long regionId;
    @ApiModelProperty(hidden = true)
    @TableField(exist = false)
    private String regionName;
    /**
     * 巡检状态 0：待审核，1：未开始，2：正在执行 3：已完成 4：超时未完成  5：申请转移  6：未提交 7：计划已转移
     */
    @ApiModelProperty(value = "巡检状态 0：待审核，1：未开始，2：正在执行 3：已完成 4：超时未完成  5：申请转移  6：未提交 7：计划已转移")
    private String childPlanState;
    @ApiModelProperty(hidden = true)
    @TableField(exist = false)
    private String chilePlanStateName;
    /**
     * 任务情况
     */
    @ApiModelProperty(value = "点完成情况")
    private BigDecimal isovertototal0;
    /**
     * 完成进度
     */
    @ApiModelProperty(value = "完成进度")
    private Double percent1;

    @ApiModelProperty(value = "巡检点数量")
    private Long pointNum;

    /**
     * 总共点线或者线长度
     */
    @ApiModelProperty(value = "总共点线或者线长度")
    private Double total;
    /**
     * 总共点线或者线数量
     */
    @ApiModelProperty(value = "总共点线或者线数量")
    private BigDecimal total1;

    /**
     * 点完成情况或线完成长度
     */
    @ApiModelProperty(value = "点完成情况或线完成长度")
    private Double isovertototal;
    /**
     * 点或者线地完成个数
     */
    @ApiModelProperty(value = "点或者线地完成个数")
    private BigDecimal isovertototal1;

    @ApiModelProperty(value = "计划预计完成率")
    private String planRate;

}
