/*
 * Author: wangjian
 * 生成entity
 */
package com.tofly.dyrqSchedule.entity;

import com.baomidou.mybatisplus.annotation.*;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;

import java.math.BigDecimal;
import java.util.Date;
import com.fasterxml.jackson.annotation.JsonFormat;
import org.springframework.format.annotation.DateTimeFormat;

import javax.persistence.Entity;
import javax.persistence.Id;


/**
 * ${comments}
 *
 * @author pra
 * @date Fri Aug 21 00:00:00 CST 2020
 */
@Data
@EqualsAndHashCode(callSuper = true)
@TableName(value="TF_PLAN_PATH_TEMP",resultMap = "planPathTempMap")
@KeySequence("TF_PLAN_PATH_TEMP")
@ApiModel
@Entity(name = "TF_PLAN_PATH_TEMP")
public class PlanPathTemp extends Model<PlanPathTemp> {
    private static final long serialVersionUID = 1L;

        /**
     * $column.comments
     */
            @TableLogic
        @ApiModelProperty(value = "$column.comments")
                private String delFlag;
                /**
     * 巡检点编码
     */
                @Id
        @TableId(value = "ID",type= IdType.INPUT)
            @ApiModelProperty(value = "巡检点编码")
                private Long id;
                /**
     * 临时表记录唯一标识
     */
            @ApiModelProperty(value = "临时表记录唯一标识")
                private Long tempId;
                /**
     * $column.comments
     */
            @ApiModelProperty(value = "$column.comments")
                private Long pointId;
                /**
     * 纬度
     */
            @ApiModelProperty(value = "纬度")
                private BigDecimal lat;
                /**
     * 经度
     */
            @ApiModelProperty(value = "经度")
                private BigDecimal lng;
                /**
     * 0:未到位 1：已到位
     */
            @ApiModelProperty(value = "0:未到位 1：已到位")
                private String isover;
        @ApiModelProperty(hidden = true)
    private String isoverName;
                /**
     * 顺序返给移动端
     */
            @ApiModelProperty(value = "顺序返给移动端")
                private BigDecimal num;
                /**
     * 线到位时间
     */
            @ApiModelProperty(value = "线到位时间")
        @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss",timezone = "GMT+8")
    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm:ss")
                private Date overDate;
                /**
     * $column.comments
     */
            @ApiModelProperty(value = "$column.comments")
                private BigDecimal percent;
                /**
     * $column.comments
     */
            @ApiModelProperty(value = "$column.comments")
                private BigDecimal gpsSpeed;

    @ApiModelProperty(value = "消耗时间")
    private BigDecimal consumeTime;
                /**
     * $column.comments
     */
            @ApiModelProperty(value = "$column.comments")
                private Long childPlanId;
                /**
     * 首次离开时间
     */
            @ApiModelProperty(value = "首次离开时间")
        @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss",timezone = "GMT+8")
    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm:ss")
                private Date firstLeftTime;
            
}
