/*
 * Author: wangjian
 * 生成entity
 */
package com.tofly.dyrqSchedule.entity;

import com.baomidou.mybatisplus.annotation.*;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;

import java.math.BigDecimal;
import java.util.Date;
import com.fasterxml.jackson.annotation.JsonFormat;
import org.springframework.format.annotation.DateTimeFormat;

import javax.persistence.Entity;
import javax.persistence.Id;


/**
 * 巡检点表
 *
 * @author pra
 * @date Fri Aug 21 00:00:00 CST 2020
 */
@Data
@EqualsAndHashCode(callSuper = true)
@TableName(value="TF_PLAN_POINT",resultMap = "planPointMap")
@KeySequence("TF_PLAN_POINT")
@ApiModel
@Entity(name = "TF_PLAN_POINT")
public class PlanPoint extends Model<PlanPoint> {
    private static final long serialVersionUID = 1L;

        /**
     * $column.comments
     */
            @TableLogic
        @ApiModelProperty(value = "$column.comments")
                private String delFlag;
                /**
     * 巡检点编码
     */
                @Id
        @TableId(value = "ID",type= IdType.INPUT)
            @ApiModelProperty(value = "巡检点编码")
                private Long id;
        @ApiModelProperty(hidden = true)
    private String isPlan;
                /**
     * 巡检点名称
     */
            @ApiModelProperty(value = "巡检点名称")
                private String pointName;
                /**
     * 巡检片区编码
     */
            @ApiModelProperty(value = "巡检片区编码")
                private String regionId;
        @ApiModelProperty(hidden = true)
    private String regionName;
                /**
     * 巡检点几何坐标
     */
            @ApiModelProperty(value = "巡检点几何坐标")
                private String geometry;
                /**
     * 巡检点位置
     */
            @ApiModelProperty(value = "巡检点位置")
                private String address;
                /**
     * 平面坐标 X
     */
            @ApiModelProperty(value = "平面坐标 X")
                private BigDecimal x;
                /**
     * 平面坐标 Y
     */
            @ApiModelProperty(value = "平面坐标 Y")
                private BigDecimal y;
                /**
     * 纬度
     */
            @ApiModelProperty(value = "纬度")
                private BigDecimal lat;
                /**
     * 经度
     */
            @ApiModelProperty(value = "经度")
                private BigDecimal lng;
                /**
     * 巡检点备注
     */
            @ApiModelProperty(value = "巡检点备注")
                private String notes;
                /**
     * 创建日期
     */
            @ApiModelProperty(value = "创建日期")
        @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss",timezone = "GMT+8")
    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm:ss")
            @TableField(value = "CREATE_TIME",fill = FieldFill.INSERT)
            private Date createTime;
                /**
     * 所属公司ID
     */
            @ApiModelProperty(value = "所属公司ID")
                private String companyid;
                /**
     * 巡检类型ID(见TF_PLAN_POINT_TYPE)
     */
            @ApiModelProperty(value = "巡检类型ID(见TF_PLAN_POINT_TYPE)")
                private Long deviceTypeId;
        @ApiModelProperty(hidden = true)
    private String deviceTypeName;
                /**
     * 0：无效 1：有效（需要巡检）
     */
            @ApiModelProperty(value = "0：无效 1：有效（需要巡检）")
                private String valid;
        @ApiModelProperty(hidden = true)
    private String validName;
                /**
     * 巡检点编号
     */
            @ApiModelProperty(value = "巡检点编号")
                private String code;
                /**
     * 隐患唯一编码
     */
            @ApiModelProperty(value = "隐患唯一编码")
                private Long troubleId;
                /**
     * 用户名称
     */
            @ApiModelProperty(value = "用户名称")
            @TableField(value = "CREATE_USER",fill = FieldFill.INSERT)
            private Long createUser;
            @ApiModelProperty(hidden = true)
    private String createUserName;
            /**
     * 是否被占用 0 占用 1未占用
     */
            @ApiModelProperty(value = "是否被占用 0 占用 1未占用")
                private String isUse;
        @ApiModelProperty(hidden = true)
    private String isUseName;
                /**
     * $column.comments
     */
            @ApiModelProperty(value = "$column.comments")
                private BigDecimal pipeLength;
            
}
