/*
 * Author: wangjian
 * 生成entity
 */
package com.tofly.dyrqSchedule.entity;

import com.baomidou.mybatisplus.annotation.*;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import javax.persistence.Entity;
import javax.persistence.Id;
import java.math.BigDecimal;
import java.util.Date;
import com.fasterxml.jackson.annotation.JsonFormat;
import org.springframework.format.annotation.DateTimeFormat;


/**
 * 巡检计划统计表
 *
 * @author pra
 * @date Fri Aug 21 00:00:00 CST 2020
 */
@Data
@EqualsAndHashCode(callSuper = true)
@TableName(value="TF_POINT_DAY_CALCULATE",resultMap = "pointDayCalculateMap")
@KeySequence("TF_POINT_DAY_CALCULATE")
@ApiModel
@Entity(name = "TF_POINT_DAY_CALCULATE")
public class PointDayCalculate extends Model<PointDayCalculate> {
    private static final long serialVersionUID = 1L;

    /**
     * 唯一编码
     */
    @Id
    @TableId(value = "ID",type= IdType.INPUT)
    @ApiModelProperty(value = "唯一编码")
    private Long id;
    /**
     * 巡检日期
     */
    @ApiModelProperty(value = "巡检日期")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss",timezone = "GMT+8")
    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm:ss")
    private Date planDate;
    /**
     * 用户唯一编码
     */
    @ApiModelProperty(value = "用户唯一编码")
    private Long userid;
    /**
     * 计划唯一编码
     */
    @ApiModelProperty(value = "计划唯一编码")
    private Long childPlanId;
    /**
     * 总共点线或者线长度
     */
    @ApiModelProperty(value = "总共点线或者线长度")
    private BigDecimal total;
    /**
     * 点完成情况或线完成长度
     */
    @ApiModelProperty(value = "点完成情况或线完成长度")
    private Double isovertototal;
    /**
     * 总共点线或者线数量
     */
    @ApiModelProperty(value = "总共点线或者线数量")
    private BigDecimal total1;
    /**
     * 点或者线地完成个数
     */
    @ApiModelProperty(value = "点或者线地完成个数")
    private BigDecimal isovertototal1;
    /**
     * $column.comments
     */
    @ApiModelProperty(value = "$column.comments")
    private Long deviceTypeId;
    /**
     * 完成率
     */
    @ApiModelProperty(value = "完成率")
    private Double percent;
    /**
     * 任务开始时间
     */
    @ApiModelProperty(value = "任务开始时间")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss",timezone = "GMT+8")
    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm:ss")
    private Date childBeginDate;
    /**
     * 任务结束时间
     */
    @ApiModelProperty(value = "任务结束时间")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss",timezone = "GMT+8")
    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm:ss")
    private Date childEndDate;

}
