/*
 * Author: wangjian
 * 生成entity
 */
package com.tofly.dyrqSchedule.entity;

import com.baomidou.mybatisplus.annotation.*;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;

import java.util.Date;
import com.fasterxml.jackson.annotation.JsonFormat;
import org.springframework.format.annotation.DateTimeFormat;


/**
 * 设备类型表
 *
 * @author pra
 * @date Fri Aug 21 00:00:00 CST 2020
 */
@Data
@EqualsAndHashCode(callSuper = true)
@TableName(value="TF_SYS_DEVICE_TYPE",resultMap = "sysDeviceTypeMap")
@KeySequence("TF_SYS_DEVICE_TYPE")
@ApiModel
public class SysDeviceType extends Model<SysDeviceType> {
    private static final long serialVersionUID = 1L;

        /**
     * $column.comments
     */
            @TableLogic
        @ApiModelProperty(value = "$column.comments")
                private String delFlag;
                /**
     * 检查内容 0：巡检检查项目管理  1：调压柜检查项目管理
     */
            @ApiModelProperty(value = "检查内容 0：巡检检查项目管理  1：调压柜检查项目管理")
                private String checkContent;
                /**
     * $column.comments
     */
        @TableId(value = "ID",type= IdType.INPUT)
            @ApiModelProperty(value = "$column.comments")
                private Long id;
                /**
     * 设备类型名称
     */
            @ApiModelProperty(value = "设备类型名称")
                private String name;
                /**
     * 关联图层id
     */
            @ApiModelProperty(value = "关联图层id")
                private String contactLayerId;
                /**
     * 巡检类型唯一编码
     */
            @ApiModelProperty(value = "巡检类型唯一编码")
                private Long pointTypeId;
        @ApiModelProperty(hidden = true)
    private String pointTypeName;
                /**
     * $column.comments
     */
            @ApiModelProperty(value = "$column.comments")
        @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss",timezone = "GMT+8")
    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm:ss")
            @TableField(value = "CREATE_TIME",fill = FieldFill.INSERT)
            private Date createTime;
                /**
     * 关联图层中文名字
     */
            @ApiModelProperty(value = "关联图层中文名字")
                private String cnContactLayerName;
                /**
     * 关联图层英文名字
     */
            @ApiModelProperty(value = "关联图层英文名字")
                private String enContactLayerName;
                /**
     * sql查询条件
     */
            @ApiModelProperty(value = "sql查询条件")
                private String sqlfilter;
            
}
