/*
 * Author: wangjian
 * 生成entity
 */
package com.tofly.dyrqSchedule.entity;

import com.baomidou.mybatisplus.annotation.*;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;

import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import java.math.BigDecimal;


/**
 * 系统配置表
 *
 * @author pra
 * @date Fri Aug 21 00:00:00 CST 2020
 */
@Data
@EqualsAndHashCode(callSuper = true)
@TableName(value = "TF_SYS_SETTING", resultMap = "sysSettingMap")
@KeySequence("TF_SYS_SETTING")
@ApiModel
@Entity(name = "TF_SYS_SETTING")
public class SysSetting extends Model<SysSetting> {
    private static final long serialVersionUID = 1L;

    /**
     * 删除标记
     */
    @TableLogic
    @ApiModelProperty(value = "删除标记")
    private String delFlag;
    /**
     * 最大时速
     */
    @ApiModelProperty(value = "最大时速")
    private BigDecimal maxSpeed;
    /**
     * 轨迹最大精度(定位最大有效精度)
     */
    @ApiModelProperty(value = "轨迹最大精度(定位最大有效精度)")
    private BigDecimal trackMaxAccuracy;
    /**
     * 轨迹最大速度
     */
    @ApiModelProperty(value = "轨迹最大速度")
    private BigDecimal trackMaxSpeed;
    /**
     * 车辆最大速度(最快参考速度)
     */
    @ApiModelProperty(value = "车辆最大速度(最快参考速度)")
    private BigDecimal carMaxSpeed;
    /**
     * 图片水印(0:是,1:否)
     */
    @ApiModelProperty(value = "图片水印(0:是,1:否)")
    private String imageWatermark;
    /**
     * 主键值
     */
    @Id
    @TableId(value = "ID", type = IdType.INPUT)
    @ApiModelProperty(value = "主键值")
    private Long id;
    /**
     * gps上传频率间隔 单位秒
     */
    @ApiModelProperty(value = "gps上传频率间隔 单位秒")
    private BigDecimal uploadRate;
    /**
     * 服务器IP
     */
    @ApiModelProperty(value = "服务器IP")
    private String serverIp;
    /**
     * 端口设置
     */
    @ApiModelProperty(value = "端口设置")
    private String serverPort;
    /**
     * 终端地图服务地址
     */
    @ApiModelProperty(value = "终端地图服务地址")
    private String mapService;
    /**
     * 到位最小距离 单位米(人巡最大容差)
     */
    @ApiModelProperty(value = "到位最小距离 单位米(人巡最大容差)")
    private BigDecimal minDistanceInPlace;
    /**
     * 轨迹分段点数
     */
    @ApiModelProperty(value = "轨迹分段点数")
    private BigDecimal sectionPointNum;
    /**
     * 刷新间隔
     */
    @ApiModelProperty(value = "刷新间隔")
    private BigDecimal refreshInternal;
    /**
     * 轨迹线颜色
     */
    @ApiModelProperty(value = "轨迹线颜色")
    private String trailLineColor;
    /**
     * 轨迹线细度
     */
    @ApiModelProperty(value = "轨迹线细度")
    private String trailLineWidth;
    /**
     * 轨迹点颜色
     */
    @ApiModelProperty(value = "轨迹点颜色")
    private String trailPointColor;
    /**
     * 轨迹点细度
     */
    @ApiModelProperty(value = "轨迹点细度")
    private String trailPointWidth;
    /**
     * 部署网站名字
     */
    @ApiModelProperty(value = "部署网站名字")
    private String deployWebName;
    /**
     * 车辆到位最小距离 单位米(车巡最大容差)
     */
    @ApiModelProperty(value = "车辆到位最小距离 单位米(车巡最大容差)")
    private BigDecimal carMinDistanceInPlace;
    /**
     * 车辆刷新间隔
     */
    @ApiModelProperty(value = "车辆刷新间隔")
    private BigDecimal carRefreshInternal;
    /**
     * 人轨迹颜色
     */
    @ApiModelProperty(value = "人轨迹颜色")
    private String trailPersonColor;
    /**
     * 车辆轨迹颜色
     */
    @ApiModelProperty(value = "车辆轨迹颜色")
    private String trailCarColor;
    /**
     * 工地监护范围
     */
    @ApiModelProperty(value = "工地监护范围")
    private BigDecimal buildRange;
    /**
     * 安排计划切割线地长度
     */
    @ApiModelProperty(value = "安排计划切割线地长度")
    private BigDecimal cuttingLine;

}
