package com.tofly.dyrqSchedule.handler;


import com.tofly.dyrqSchedule.service.CalLostPlanHandlerService;
import com.xxl.job.core.biz.model.ReturnT;
import com.xxl.job.core.handler.annotation.XxlJob;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;


/**
 * @program: tofly-dyrq
 * @description: 计划重算服务
 * @author: Sumer
 * @create: 2020-08-26 14:13
 */
@Component
@Slf4j
public class CalLostPlanHandler {

    @Autowired
    private CalLostPlanHandlerService calLostPlanHandlerService;

    /**
     * GPS统计服务
     */
    @XxlJob("calLostPlanHandler")
    public ReturnT<String> calLostPlanHandler(String param){
        log.info("计划重算服务start...");
        long l = System.currentTimeMillis();
        calLostPlanHandlerService.calLostPlan();
        log.info("计划重算服务end...耗时 {} ms",System.currentTimeMillis()-l);
        return ReturnT.SUCCESS;

    }

}