package com.tofly.dyrqSchedule.handler;

import com.tofly.common.core.util.Date8Util;
import com.tofly.dyrqSchedule.entity.EsCarGpsUpload;
import com.tofly.dyrqSchedule.entity.EsGpsUpload;
import com.tofly.dyrqSchedule.repository.EsCarGpsUploadRepository;
import com.tofly.dyrqSchedule.repository.EsGpsUploadRepository;
import com.xxl.job.core.biz.model.ReturnT;
import com.xxl.job.core.handler.annotation.XxlJob;
import lombok.AllArgsConstructor;
import org.springframework.stereotype.Component;

import java.util.Date;

/**
 * @author pra
 * @date 2020/12/2 11:19
 * @description 每月一号添加GPS及车辆GPS数据避免当前索引没有数据造成的查询失败
 */

@Component
@AllArgsConstructor
public class EsIndexHandler {
    private final EsGpsUploadRepository esGpsUploadRepository;
    private final EsCarGpsUploadRepository esCarGpsUploadRepository;

    @XxlJob("EsIndexHandler")
    public ReturnT<String> EsIndexHandler(String param) {
        Date now = Date8Util.getCurrentDate();
        EsGpsUpload esGpsUpload = new EsGpsUpload();
        esGpsUpload.setGpstime(now);
        esGpsUpload.setUploadtime(now);
        esGpsUploadRepository.save(esGpsUpload);

        EsCarGpsUpload esCarGpsUpload = new EsCarGpsUpload();
        esCarGpsUpload.setGpstime(now);
        esCarGpsUpload.setUploadtime(now);
        esCarGpsUploadRepository.save(esCarGpsUpload);
        return ReturnT.SUCCESS;
    }

}
