package com.tofly.dyrqSchedule.handler;



import com.tofly.dyrqSchedule.service.GpsCalculateHandlerService;
import com.xxl.job.core.biz.model.ReturnT;
import com.xxl.job.core.handler.annotation.XxlJob;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;


/**
 * @program: tofly-dyrq
 * @description: GPS统计服务
 * @author: Sumer
 * @create: 2020-08-24 16:28
 */
@Component
@Slf4j
public class GpsCalculateHandler {


    @Autowired
    private GpsCalculateHandlerService gpsCalculateHandlerService;

    /**
     * GPS统计服务
     */
    @XxlJob("gpsCalculateHandler")
    public ReturnT<String> gpsCalculateHandler(String param){
        log.info("GPS统计服务start...");
        gpsCalculateHandlerService.gpsCalculate();
        log.info("GPS统计服务end...");
        return ReturnT.SUCCESS;

    }


}