package com.tofly.dyrqSchedule.repository;

import com.tofly.dyrqSchedule.entity.GpsDayCalculate;

import org.apache.ibatis.annotations.Insert;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Query;
import org.springframework.stereotype.Repository;

import java.util.Date;
import java.util.List;

/**
 * @program: tofly-dyrq
 * @description: 累计计算轨迹
 * @author: Sumer
 * @create: 2020-08-27 10:57
 */
@Repository
public interface GpsDayCalculateRepository extends JpaRepository<GpsDayCalculate, Long> {
    /**
     * 获取里程表对应时间范围数据
     * @param startDate
     * @param endDate
     * @param userid
     * @return
     */
    @Query(value = "SELECT * FROM TF_GPS_DAY_CALCULATE t  " +
            "WHERE t.PLAN_DATE>= ?1   " +
            "AND t.PLAN_DATE<= ?2  AND USERID=?3",nativeQuery = true)
    List<GpsDayCalculate> getGpsDayCalculateMileageStatistics(Date startDate ,Date endDate ,Long userid);

}