package com.tofly.dyrqSchedule.repository;


import com.tofly.dyrqSchedule.entity.PlanChild;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Modifying;
import org.springframework.data.jpa.repository.Query;
import org.springframework.stereotype.Repository;

import java.util.Date;
import java.util.List;
import java.util.Map;

@Repository
public interface PlanChildRepository extends JpaRepository<PlanChild, Long> {


    @Query(value = "SELECT * FROM TF_PLAN_CHILD t WHERE t.child_begin_date >= ?1  AND t.child_end_date <= ?2",nativeQuery = true)
    List<Map<String,Object>> findPlanChildList(Date childBeginDate ,Date childEndDate);


    @Query(value = " UPDATE TF_PLAN_CHILD t " +
            "SET t.PERCENT1 = " +
            "(SELECT " +
            "CASE WHEN NVL(d.TOTAL,0) = 0 " +
            "THEN 0 ELSE TRUNC(NVL(c.ISOVER,0)/NVL(d.TOTAL,0),4) END " +
            "FROM " +
            "(SELECT COUNT(*) ISOVER, a.CHILD_PLAN_ID FROM TF_PLAN_PATH_TEMP a " +
            "WHERE a.ISOVER =1 AND a.CHILD_PLAN_ID = ?1 " +
            "GROUP BY a.CHILD_PLAN_ID) c LEFT JOIN (SELECT COUNT(*) TOTAL,b.CHILD_PLAN_ID FROM TF_PLAN_PATH_TEMP b WHERE b.CHILD_PLAN_ID = ?1 GROUP BY b.CHILD_PLAN_ID) d ON c.CHILD_PLAN_ID = d.CHILD_PLAN_ID) " +
            "WHERE t.ID = ?1", nativeQuery = true)
    @Modifying
    Integer updateChildPlan(Long childPlanId);

    @Query(value = " UPDATE TF_PLAN_CHILD t " +
            "SET t.PERCENT = " +
            "(SELECT " +
            "CASE WHEN NVL(d.TOTAL,0) = 0 " +
            "THEN 0 ELSE TRUNC(NVL(c.ISOVER,0)/NVL(d.TOTAL,0),4) END " +
            "FROM " +
            "(SELECT COUNT(*) ISOVER, a.CHILD_PLAN_ID FROM TF_PLAN_POINT_TEMP a " +
            "WHERE a.ISOVER =1 AND a.CHILD_PLAN_ID = ?1 " +
            "GROUP BY a.CHILD_PLAN_ID) c LEFT JOIN " +
            "(SELECT COUNT(*) TOTAL,b.CHILD_PLAN_ID FROM TF_PLAN_POINT_TEMP b " +
            "GROUP BY b.CHILD_PLAN_ID) d ON c.CHILD_PLAN_ID = d.CHILD_PLAN_ID " +
            "WHERE c.CHILD_PLAN_ID = ?1) " +
            "WHERE t.ID = ?1", nativeQuery = true)
    @Modifying
    Integer updateChildPlanOther(Long childPlanId);

    List<PlanChild> findByIdIn(List<String> ids);


    @Query(value = "UPDATE TF_PLAN_CHILD t SET t.TOTAL=?1,t.ISOVERTOTOTAL=?1*T.PERCENT1 WHERE t.ID=?2", nativeQuery = true)
    @Modifying
    Integer updatePlanChildTotal(double total ,long childPlanId);

    /**
     * 更新点到位比例
     * @param percent
     * @param childPlanId
     * @return
     */
    @Query(value = "UPDATE TF_PLAN_CHILD t " +
            "SET t.PERCENT=?1, " +
            "t.PERCENT1=?1, " +
            "t.ISOVERTOTOTAL=t.TOTAL*?1, " +
            "t.ISOVERTOTOTAL1=t.TOTAL*?1 " +
            "WHERE t.ID=?2", nativeQuery = true)
    @Modifying
    Integer updatePlanChildPercent(double percent ,Long childPlanId);

    /**
     * 更新线到位比例
     * @param percent
     * @param tiaoshu
     * @param childPlanId
     * @return
     */
    @Query(value = "UPDATE TF_PLAN_CHILD t " +
            "SET t.PERCENT=?1, " +
            "t.PERCENT1=?1, " +
            "t.ISOVERTOTOTAL=t.TOTAL*?1, " +
            "t.ISOVERTOTOTAL1=?2  " +
            "WHERE t.CHILD_PLAN_ID=?3", nativeQuery = true)
    @Modifying
    Integer updatePlanChildLine(double percent ,double tiaoshu ,Long childPlanId);

    @Query(value = "UPDATE TF_PLAN_CHILD  SET COPY_STATE=2 WHERE ID = ?1" ,nativeQuery = true)
    @Modifying
    Integer updatePlanChildCopyState(Long childPlanId);
}
