package com.tofly.dyrqSchedule.repository;

import com.tofly.dyrqSchedule.entity.PlanPathTemp;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Modifying;
import org.springframework.data.jpa.repository.Query;
import org.springframework.stereotype.Repository;

import java.math.BigDecimal;
import java.util.Date;
import java.util.List;
import java.util.Map;

/**
 * @program: tofly-dyrq
 * @description:
 * @author: Sumer
 * @create: 2020-08-25 15:21
 */
@Repository
public interface PlanPathTempRepository extends JpaRepository<PlanPathTemp, Long> {


    List<PlanPathTemp> findByPointIdAndChildPlanId(long pointId ,long childPlanId);
    @Query(value = "SELECT * FROM TF_PLAN_PATH_TEMP t WHERE t.CHILD_PLAN_ID = ?1 AND t.ISOVER = ?2",nativeQuery = true)
    List<Map<String,Object>> getByChildPlanIdAndIsover(Long childPlanId , String isover);
    /**
     * 更新到位时间
     * @param checkTime
     * @param gpsSpeed
     * @param id
     * @return
     */
    @Query(value = "UPDATE TF_PLAN_PATH_TEMP t SET  " +
            "t.ISOVER=1, " +
            "t.OVER_DATE=?1, " +
            "t.GPS_SPEED=?2 WHERE t.ID=?3", nativeQuery = true)
    @Modifying
    Integer updatePlanPointInPlaceTime(Date checkTime, double gpsSpeed ,String id);


    @Query(value = "UPDATE TF_PLAN_PATH_TEMP t SET " +
            "t.GPS_SPEED = ?3 ,t.OVER_DATE= ?4 , t.ISOVER = 1  " +
            "WHERE t.ID=?1 AND t.child_plan_id = ?2", nativeQuery = true)
    @Modifying
    Integer updatePlanPointInPlaceLinePlace(Long id, Long planId,BigDecimal gpsSpeed ,Date checkTime);
}