package com.tofly.dyrqSchedule.repository;

import com.tofly.dyrqSchedule.entity.PointDayCalculate;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Query;
import org.springframework.stereotype.Repository;

import javax.xml.crypto.Data;
import java.util.Date;
import java.util.List;
@Repository
public interface PointDayCalculateRepository extends JpaRepository<PointDayCalculate, Long> {

    /**
     * 查询计划统计表时间范围内数据
     * @param startDate
     * @param endDate
     * @param userid
     * @param childPlanId
     * @return
     */
    @Query(value = "SELECT * FROM TF_POINT_DAY_CALCULATE t  " +
            "WHERE t.PLAN_DATE>= ?1  " +
            "AND t.PLAN_DATE<= ?2  " +
            "AND USERID=?3  " +
            "AND CHILD_PLAN_ID=?4",nativeQuery = true)
    List<PointDayCalculate> getStatisticsPatrolPlans(Date startDate , Date endDate , Long userid , Long childPlanId);
}
