package com.tofly.dyrqSchedule.service.impl;

import com.tofly.dyrqSchedule.entity.ConjunctiveQuery;
import com.tofly.dyrqSchedule.entity.EsPdaDeviceUpload;
import com.tofly.dyrqSchedule.service.EsPdaDeviceUploadService;
import com.tofly.dyrqSchedule.util.DateTimeUtil;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.elasticsearch.core.ElasticsearchTemplate;
import org.springframework.data.elasticsearch.core.query.IndexQuery;
import org.springframework.data.elasticsearch.core.query.IndexQueryBuilder;
import org.springframework.stereotype.Service;


import java.math.BigDecimal;
import java.time.LocalDateTime;
import java.util.Date;

/**
 * @program: tofly-dyrq
 * @description:
 * @author: Sumer
 * @create: 2020-09-04 10:54
 */
@Service
public class EsPdaDeviceUploadServiceImpl implements EsPdaDeviceUploadService {

    @Autowired
    private ElasticsearchTemplate template;


    @Override
    public void automaticPunchSave(ConjunctiveQuery con, Date default_off, Date default_on) {
        EsPdaDeviceUpload deviceUpload = new EsPdaDeviceUpload();
        deviceUpload.setUserid(con.getUser_id());
        deviceUpload.setGpsState(con.getGps_state());
        deviceUpload.setNetworkState(con.getNetwork_state());
        deviceUpload.setUploadtime(DateTimeUtil.convertLDTToDate(LocalDateTime.now()));
        deviceUpload.setNetworkType(con.getNetwork_state());
        deviceUpload.setElectricity(con.getElectricity());
        deviceUpload.setGpsPrecision(con.getGps_precision());
        deviceUpload.setGpsStar(con.getGps_star());
        deviceUpload.setResidualSpace(con.getResidual_space());
        deviceUpload.setCarid(con.getCarid());
        deviceUpload.setGpsType(con.getGps_type());
//        deviceUpload.setPdaid
//        deviceUpload.setsoftware_ver
        // 上班  下班
        if (null != default_off) {
            deviceUpload.setCheckTime(default_off);
            deviceUpload.setWorkState(new BigDecimal(3));
        } else {
            deviceUpload.setCheckTime(default_on);
            deviceUpload.setWorkState(BigDecimal.ONE);
        }
        IndexQuery indexQuery = new IndexQueryBuilder().withObject(deviceUpload).build();
        template.index(indexQuery);
    }


}