﻿#region 程序集 System.Drawing, Version=4.0.0.0, Culture=neutral, PublicKeyToken=b03f5f7f11d50a3a
// C:\Program Files (x86)\Reference Assemblies\Microsoft\Framework\.NETFramework\v4.5.1\System.Drawing.dll
#endregion

using System.ComponentModel;
using System.Runtime.InteropServices;

namespace System.Drawing
{
    //
    // 摘要:
    //     表示在二维平面中定义点的浮点 x 和 y 坐标的有序对。
    [ComVisible(true)]
    public struct PointF
    {
        //
        // 摘要:
        //     表示 System.Drawing.PointF 类的、成员数据未被初始化的新实例。
        public static readonly PointF Empty;

        //
        // 摘要:
        //     用指定坐标初始化 System.Drawing.PointF 类的新实例。
        //
        // 参数:
        //   x:
        //     该点的水平位置。
        //
        //   y:
        //     该点的垂直位置。
        public PointF(float x, float y);

        //
        // 摘要:
        //     获取一个值，该值指示此 System.Drawing.PointF 是否为空。
        //
        // 返回结果:
        //     如果 System.Drawing.PointF.X 和 System.Drawing.PointF.Y 均为 0，该值为 true；否则为 false。
        [Browsable(false)]
        public bool IsEmpty { get; }
        //
        // 摘要:
        //     获取或设置此 System.Drawing.PointF 的 x 坐标。
        //
        // 返回结果:
        //     此 System.Drawing.PointF 的 x 坐标。
        public float X { get; set; }
        //
        // 摘要:
        //     获取或设置此 System.Drawing.PointF 的 y 坐标。
        //
        // 返回结果:
        //     此 System.Drawing.PointF 的 y 坐标。
        public float Y { get; set; }

        //
        // 摘要:
        //     按指定的 System.Drawing.SizeF 平移给定的 System.Drawing.PointF。
        //
        // 参数:
        //   pt:
        //     要平移的 System.Drawing.PointF。
        //
        //   sz:
        //     System.Drawing.SizeF，它指定要增加到 pt 的坐标的数。
        //
        // 返回结果:
        //     平移后的 System.Drawing.PointF。
        public static PointF Add(PointF pt, SizeF sz);
        //
        // 摘要:
        //     按指定的 System.Drawing.Size 平移给定的 System.Drawing.PointF。
        //
        // 参数:
        //   pt:
        //     要平移的 System.Drawing.PointF。
        //
        //   sz:
        //     System.Drawing.Size，它指定要增加到 pt 的坐标的数。
        //
        // 返回结果:
        //     平移后的 System.Drawing.PointF。
        public static PointF Add(PointF pt, Size sz);
        //
        // 摘要:
        //     按指定大小的负值平移 System.Drawing.PointF。
        //
        // 参数:
        //   pt:
        //     要平移的 System.Drawing.PointF。
        //
        //   sz:
        //     System.Drawing.Size，它指定要从 pt 的坐标中减去的数。
        //
        // 返回结果:
        //     平移后的 System.Drawing.PointF。
        public static PointF Subtract(PointF pt, Size sz);
        //
        // 摘要:
        //     按指定大小的负值平移 System.Drawing.PointF。
        //
        // 参数:
        //   pt:
        //     要平移的 System.Drawing.PointF。
        //
        //   sz:
        //     System.Drawing.SizeF，它指定要从 pt 的坐标中减去的数。
        //
        // 返回结果:
        //     平移后的 System.Drawing.PointF。
        public static PointF Subtract(PointF pt, SizeF sz);
        //
        // 摘要:
        //     指定此 System.Drawing.PointF 是否包含与指定 System.Object 有相同的坐标。
        //
        // 参数:
        //   obj:
        //     要测试的 System.Object。
        //
        // 返回结果:
        //     如果 obj 是一个 System.Drawing.PointF，并且具有与此 System.Drawing.Point 相同的坐标，则此方法将返回 true。
        public override bool Equals(object obj);
        //
        // 摘要:
        //     返回此 System.Drawing.PointF 结构的哈希代码。
        //
        // 返回结果:
        //     一个整数值，它指定此 System.Drawing.PointF 结构的哈希值。
        public override int GetHashCode();
        //
        // 摘要:
        //     将此 System.Drawing.PointF 转换为可读字符串。
        //
        // 返回结果:
        //     表示此 System.Drawing.PointF 的字符串。
        public override string ToString();

        //
        // 摘要:
        //     将 System.Drawing.PointF 平移给定 System.Drawing.Size。
        //
        // 参数:
        //   pt:
        //     要平移的 System.Drawing.PointF。
        //
        //   sz:
        //     System.Drawing.Size，它指定要添加到 pt 的坐标的数字对。
        //
        // 返回结果:
        //     返回经过平移的 System.Drawing.PointF。
        public static PointF operator +(PointF pt, Size sz);
        //
        // 摘要:
        //     按指定的 System.Drawing.SizeF 平移 System.Drawing.PointF。
        //
        // 参数:
        //   pt:
        //     要平移的 System.Drawing.PointF。
        //
        //   sz:
        //     System.Drawing.SizeF，它指定要增加到 System.Drawing.PointF 的 x 坐标和 y 坐标的数。
        //
        // 返回结果:
        //     平移后的 System.Drawing.PointF。
        public static PointF operator +(PointF pt, SizeF sz);
        //
        // 摘要:
        //     按指定 System.Drawing.SizeF 的负值平移 System.Drawing.PointF。
        //
        // 参数:
        //   pt:
        //     要平移的 System.Drawing.PointF。
        //
        //   sz:
        //     System.Drawing.SizeF，它指定要从 pt 的坐标中减去的数。
        //
        // 返回结果:
        //     平移后的 System.Drawing.PointF。
        public static PointF operator -(PointF pt, SizeF sz);
        //
        // 摘要:
        //     将 System.Drawing.PointF 平移给定 System.Drawing.Size 的负数。
        //
        // 参数:
        //   pt:
        //     要平移的 System.Drawing.PointF。
        //
        //   sz:
        //     System.Drawing.Size，它指定要从 pt 的坐标中减去的数。
        //
        // 返回结果:
        //     平移后的 System.Drawing.PointF。
        public static PointF operator -(PointF pt, Size sz);
        //
        // 摘要:
        //     比较两个 System.Drawing.PointF 结构。 此结果指定两个 System.Drawing.PointF 结构的 System.Drawing.PointF.X
        //     和 System.Drawing.PointF.Y 属性的值是否相等。
        //
        // 参数:
        //   left:
        //     要比较的 System.Drawing.PointF。
        //
        //   right:
        //     要比较的 System.Drawing.PointF。
        //
        // 返回结果:
        //     如果左边和右边的 System.Drawing.PointF 结构的 System.Drawing.PointF.X 和 System.Drawing.PointF.Y
        //     值相等，为 true；否则为 false。
        public static bool operator ==(PointF left, PointF right);
        //
        // 摘要:
        //     确定指定点的坐标是否不等。
        //
        // 参数:
        //   left:
        //     要比较的 System.Drawing.PointF。
        //
        //   right:
        //     要比较的 System.Drawing.PointF。
        //
        // 返回结果:
        //     要指示 left 和 right 的 System.Drawing.PointF.X 和 System.Drawing.PointF.Y 值不等，为 true；否则为
        //     false。
        public static bool operator !=(PointF left, PointF right);
    }
}