﻿#region 程序集 mscorlib, Version=4.0.0.0, Culture=neutral, PublicKeyToken=b77a5c561934e089
// C:\Program Files (x86)\Reference Assemblies\Microsoft\Framework\.NETFramework\v4.5.1\mscorlib.dll
#endregion

using System.Collections;

namespace System
{
    //
    // 摘要:
    //     表示 2 元组，即二元组。
    //
    // 类型参数:
    //   T1:
    //     此元组的第一个组件的类型。
    //
    //   T2:
    //     此元组的第二个组件的类型。
    public class Tuple<T1, T2> : IStructuralEquatable, IStructuralComparable, IComparable, ITuple
    {
        //
        // 摘要:
        //     初始化 System.Tuple`2 类的新实例。
        //
        // 参数:
        //   item1:
        //     此元组的第一个组件的值。
        //
        //   item2:
        //     此元组的第二个组件的值。
        public Tuple(T1 item1, T2 item2);

        //
        // 摘要:
        //     获取当前 System.Tuple`2 对象的第一个分量的值。
        //
        // 返回结果:
        //     当前 System.Tuple`2 对象的第一个分量的值。
        public T1 Item1 { get; }
        //
        // 摘要:
        //     获取当前 System.Tuple`2 对象的第二个分量的值。
        //
        // 返回结果:
        //     当前 System.Tuple`2 对象的第二个分量的值。
        public T2 Item2 { get; }

        //
        // 摘要:
        //     返回一个值，该值指示当前的 System.Tuple`2 对象是否与指定对象相等。
        //
        // 参数:
        //   obj:
        //     与该实例进行比较的对象。
        //
        // 返回结果:
        //     如果当前实例等于指定对象，则为 true；否则为 false。
        public override bool Equals(object obj);
        //
        // 摘要:
        //     返回当前 System.Tuple`2 对象的哈希代码。
        //
        // 返回结果:
        //     32 位有符号整数哈希代码。
        public override int GetHashCode();
        //
        // 摘要:
        //     返回一个字符串，该字符串表示此 System.Tuple`2 实例的值。
        //
        // 返回结果:
        //     此 System.Tuple`2 对象的字符串表示形式。
        public override string ToString();
    }
}