﻿using Newtonsoft.Json;
using System;
using System.Collections.Generic;
using System.Configuration;
using System.Data;
using System.Diagnostics;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace CalLostPlan
{
   public class Program
    {
        /// <summary>
        /// 获取表名
        /// </summary>
        /// <param name="tableName"></param>
        /// <param name="search_date"></param>
        /// <returns></returns>
        public static void GetTable(ref string tableName, DateTime search_date)
        {
            string sql = string.Empty;
            try
            {
                string _table_name = tableName;
                //当前地配置时间与当前时间
                DateTime curSetting = DateTime.Parse(ConfigurationManager.AppSettings["DivideTb"]);
                DateTime now = DateTime.Now;
                if (search_date >= curSetting && search_date <= now && search_date.ToString("yyyyMM") != now.ToString("yyyyMM"))
                    tableName = string.Format("{0}_{1}", tableName, search_date.ToString("yyyyMM"));
                sql = string.Format(@"select nvl(count(*), 0) num
                                        from user_tables  where table_name = '{0}'", tableName);
                DataTable dt = ToflyExtendDbHelper.GetInstance().ExecuteSql(sql);
                if (dt == null)
                    tableName = _table_name;
                if (int.Parse(dt.Rows[0]["num"].ToString()) == 0)
                    tableName = _table_name;
            }
            catch (Exception ex)
            {
                Logger.WriteLog(sql + ex.Message);
            }
        }

        public static void Main(string[] args)
        {
            Console.WriteLine("开始。。。");
        
            Stopwatch watch = new Stopwatch();
            watch.Start();
            if (args.Length == 0)
                return;
            string plan_id = string.Empty;
            string search_date = string.Empty;
            string userid = string.Empty;
            string sql = string.Empty;
            decimal percent = 0;
            string applyId = string.Empty;
            string istest = ConfigurationManager.AppSettings["istest"] ?? "0";
            List<string> point_ids = new List<string>();
            plan_id = args[0];
            search_date = args[1];
            userid = args[2];
            percent = decimal.Parse(args[3]);
            if (args.Length > 4)
                applyId = args[4];
            if (istest == "0")
            {
                applyId = args[4];
                sql = string.Format(@"update tf_plan_apply t
                                       set t.state = 1
                                     where t.id ='{0}'", applyId);
                ToflyExtendDbHelper.GetInstance().ExecuteOneSql(sql);
            }
            

            try
            {
                #region 计算
                sql = "SELECT MIN_DISTANCE_IN_PLACE,CAR_MAX_SPEED,MAN_MAX_SPEED FROM TF_SYS_SETTING";
                DataTable dt = ToflyExtendDbHelper.GetInstance().ExecuteSql(sql);
                double _distance = 0;
                double _car_max_speed = 0;
                double _man_max_speed = 0;
                if (dt != null && dt.Rows.Count > 0)
                {
                    _distance = double.Parse(dt.Rows[0]["MIN_DISTANCE_IN_PLACE"].ToString());
                    _car_max_speed = double.Parse(dt.Rows[0]["CAR_MAX_SPEED"].ToString());
                    _man_max_speed = double.Parse(dt.Rows[0]["MAN_MAX_SPEED"].ToString());
                }

                sql = string.Format(@"select b.type,
                                       b.is_setting,
                                       b.device_type_id,
                                       a.total,
                                       a.total1,
                                       a.child_begin_date,
                                       a.child_end_date,
                                       a.plan_mode,
                                       c.geometry
                                  from tf_plan_child a
                                  left join tf_plan_point_type b
                                    on a.device_type_id = b.device_type_id
                                  left join tf_gps_region c
                                    on a.region_id = c.regionid
                                 where a.child_plan_id = '{0}'", plan_id);
                DataTable setting = ToflyExtendDbHelper.GetInstance().ExecuteSql(sql);

                string type = setting.Rows[0]["type"].ToString();
                string is_setting = setting.Rows[0]["is_setting"].ToString();
                string device_type_id = setting.Rows[0]["device_type_id"].ToString();
                string plan_mode = setting.Rows[0]["plan_mode"].ToString();

                string tablename = "TF_GPS_UPLOAD";
                GetTable(ref tablename, DateTime.Parse(search_date));
                string start_date = string.Empty;
                string end_date = string.Empty;
                start_date = search_date;
                end_date = DateTime.Parse(search_date).AddDays(1).AddSeconds(-1).ToString();
                decimal valid_time = 0;
                decimal valid_distance = 0;

                //获取轨迹
                if (plan_mode == "1")
                {
                    sql = string.Format(@"select * from {0} t
                                         where t.userid = '{1}'
                                           and t.check_time >=
                                               to_date('{2}', 'yyyy/MM/dd HH24:MI:SS')
                                           and t.check_time <=
                                               to_date('{3}', 'yyyy/MM/dd HH24:MI:SS')
                                           and t.isvalid=1
                                           and t.gps_timespan < 300
                                           and ((t.network <> 5) or (t.network = 5 and t.gps_precision < 30))
                                           and t.speed<={4}
                                           and t.gps_type=1
                                         order by t.check_time", tablename, userid, start_date, end_date,_car_max_speed);
                }
                else
                {
                    sql = stri ng.Format(@"select * from {0} t
                                         where t.userid = '{1}'
                                           and t.check_time >=
                                               to_date('{2}', 'yyyy/MM/dd HH24:MI:SS')
                                           and t.check_time <=
                                               to_date('{3}', 'yyyy/MM/dd HH24:MI:SS')
                                           and t.isvalid=1
                                           and t.gps_timespan < 300
                                           and ((t.network <> 5) or (t.network = 5 and t.gps_precision < 30))
                                           and t.speed<={4}
                                           and t.gps_type=0
                                         order by t.check_time", tablename, userid, start_date, end_date,_man_max_speed);
                }

                DataTable gpsDt = ToflyExtendDbHelper.GetInstance().ExecuteSql(sql);

                if (gpsDt.Rows.Count == 0)
                {
                    UpdateApply(applyId, percent, point_ids);
                    return;
                }

                List<Gps_Model> _gps = (List<Gps_Model>)DataTableToListHelper.ToList<Gps_Model>(gpsDt);
                int gpsnum = _gps.Count();

              
                int k = 0;
                if (type == "0")
                {
                    #region 服务器计算点到位
                    if (is_setting == "1")
                    {
                        UpdateApply(applyId, percent, point_ids);
                        return;
                    }
                    sql = string.Format(@"select  t.lat,t.lng,t.isover,t.id  from tf_plan_point_temp t where t.child_plan_id='{0}' and t.isover=0", plan_id);
                    DataTable pointDt = ToflyExtendDbHelper.GetInstance().ExecuteSql(sql);

                    if (pointDt.Rows.Count == 0)
                    {
                        UpdateApply(applyId, percent, point_ids);
                        return;
                    }
                    List<Point_Model> point = (List<Point_Model>)DataTableToListHelper.ToList<Point_Model>(pointDt);
                    int pointnum = point.Count();
                   
                    for (int j = 0; j < gpsnum; j++)
                    {
                        double lng1 = double.Parse(_gps[j].location_longitude.ToString());
                        double lat1 = double.Parse(_gps[j].location_latitude.ToString()); ;
                        Range range = GpsHelper.GpsRange(_distance, lng1, lat1);

                        var hasPoint = point.Where(m => (m.lng > range.xMin && m.lng < range.xMax) && (m.lat > range.yMin && m.lat < range.yMax));
                        if (hasPoint.Count() > 0)
                        {
                            var ids = hasPoint.Select(m => m.id).ToArray();
                            point = point.Where(m => !ids.Contains(m.id)).ToList();
                            StringBuilder arrStr = new StringBuilder();
                            if (ids.Length == 1)
                            {
                                arrStr.Append(string.Format("'{0}'", ids[0]));
                            }
                            else
                            {
                                int m = 0;
                                foreach (var a in ids)
                                {
                                    if (!point_ids.Contains(a))
                                        point_ids.Add(a);

                                    if (k == ids.Length - 1)
                                        arrStr.Append(string.Format("'{0}'", a));
                                    else
                                        arrStr.Append(string.Format("'{0}',", a));
                                    m++;
                                }
                            }

                            sql = string.Format(@"update tf_plan_point_temp t set 
                                                t.isover=1,
                                                t.state=1,
                                                t.over_date=to_date('{0}', 'yyyy/MM/dd HH24:MI:SS'),
                                                t.gps_speed='{1}' where t.id  in ({0})", _gps[j].check_time, _gps[j].gps_speed, arrStr.ToString());
                            ToflyExtendDbHelper.GetInstance().ExecuteOneSql(sql);
                            k++;
                        }
                    }
                    #endregion

                    #region 更新点到位比例
                    if (k > 0)
                    {
                        sql = string.Format(@"select (select nvl(count(*),0)
                                                      from tf_plan_point_temp t
                                                     where t.child_plan_id = '{0}') total,
                                                   (select nvl(count(*),0)
                                                      from tf_plan_point_temp t
                                                     where t.child_plan_id = '{0}'
                                                       and t.state = 1) isovertotal
                                              from dual",plan_id);
                        DataTable staticPlan = ToflyExtendDbHelper.GetInstance().ExecuteSql(sql);
                        if (staticPlan.Rows.Count > 0)
                        {
                            decimal isovertotal = decimal.Parse(staticPlan.Rows[0]["isovertotal"].ToString());
                            decimal total = decimal.Parse(staticPlan.Rows[0]["total"].ToString());
                            if (total > 0)
                            {
                                percent = System.Math.Round(isovertotal / total, 4);
                                sql = string.Format(@"update tf_plan_child t 
                                            set t.percent={0},
                                            t.percent1={0},
                                            t.isovertototal=t.total*{0},
                                            t.isovertototal1=t.total*{0} 
                                            where t.child_plan_id='{1}'", percent, plan_id);
                                ToflyExtendDbHelper.GetInstance().ExecuteOneSql(sql);
                            }
                        }
                    }
                    #endregion
                }
                else
                {
                    #region 服务器更新线到位
                    try
                    {
                        sql = string.Format(@"select  t.lat,t.lng,t.isover,t.id,temp_id  from tf_plan_path_temp t where t.child_plan_id='{0}' and t.isover=0", plan_id);
                        DataTable pointDt = ToflyExtendDbHelper.GetInstance().ExecuteSql(sql);

                        if (pointDt.Rows.Count == 0)
                        {
                            UpdateApply(applyId, percent, point_ids);
                            return;
                        }
                        List<Point_Model> point = (List<Point_Model>)DataTableToListHelper.ToList<Point_Model>(pointDt);
                        int pointnum = point.Count();
                        List<string> idsOverList = new List<string>();
                        List<string> idsFirstLeftList = new List<string>();
                        for (int j = 0; j < gpsnum; j++)
                        {
                           
                            double lat1 = double.Parse(_gps[j].location_latitude.ToString());
                            double lng1 = double.Parse(_gps[j].location_longitude.ToString());
                            Range range = GpsHelper.GpsRange(_distance, lng1, lat1);

                            var hasOverPoint = point.Where(m => (m.lng > range.xMin && m.lng < range.xMax) && (m.lat > range.yMin && m.lat < range.yMax) && !idsOverList.Contains(m.id));

                            if (hasOverPoint.Count() > 0)
                            {
                                //标记为轨迹为到位点
                                if (_gps[j].state != 1)
                                {
                                    sql = string.Format(@"update {0} t set t.state=1,t.temp=1 where t.id='{1}'", tablename, _gps[j].id);
                                    ToflyExtendDbHelper.GetInstance().ExecuteOneSql(sql);
                                }

                                var ids = hasOverPoint.Select(m => m.id).ToArray();
                                foreach (var id in ids)
                                {
                                    if (!point_ids.Contains(id))
                                        point_ids.Add(id);

                                    if (idsOverList.Contains(id))
                                        continue;
                                    //更新到位时间
                                    sql = string.Format(@"update tf_plan_path_temp t set 
                                                t.isover=1,
                                                t.over_date=to_date('{0}', 'yyyy/MM/dd HH24:MI:SS'),
                                                t.gps_speed='{1}' where t.id='{2}'", _gps[j].check_time, _gps[j].gps_speed, id);
                                    ToflyExtendDbHelper.GetInstance().ExecuteOneSql(sql);
                                    idsOverList.Add(id);
                                    k++;
                                }
                                continue;
                            }

                            //判断当前点是否在片区范围内
                            GeomeryModel region = JsonConvert.DeserializeObject<GeomeryModel>(setting.Rows[0]["geometry"].ToString());
                            List<PointF> listPointF = new List<PointF>();
                            foreach (var p in region.rings[0])
                            {
                                PointF pointf = new PointF();
                                pointf.X = p[0];
                                pointf.Y = p[1];
                                listPointF.Add(pointf);
                            }


                            PointF inputGps = new PointF();
                            inputGps.X = float.Parse(lng1.ToString());
                            inputGps.Y = float.Parse(lat1.ToString());
                            if (GpsHelper.IsInside(inputGps, listPointF))
                            {
                                sql = string.Format(@"update {0} t set t.temp=1 where t.id='{1}'", tablename, _gps[j].id);
                                ToflyExtendDbHelper.GetInstance().ExecuteOneSql(sql);
                            }
                        }
                    }
                    catch (Exception ex)
                    {
                        UpdateApply(applyId, percent, point_ids);
                        Logger.WriteLine("0055", ex.Message + "服务器更新线到位" + "\r\n" + ex.StackTrace + "\r\n", DateTime.Now);
                    }
                    #endregion

                    #region 有效时长单独计算
                    try
                    {
                        sql = string.Format(@"select nvl(sum(t.distance), 0) validdistance, nvl(sum(t.gps_timespan), 0) validtime
                              from {0} t
                             where t.userid = '{1}'
                               and t.check_time >= to_date('{2}', 'yyyy/MM/dd')
                               and t.check_time <=
                                   to_date('{3}', 'yyyy/MM/dd HH24:MI:SS')
                               and t.isvalid=1
                               and t.gps_type=0
                               and t.temp = 1
                             order by t.check_time
                            ", tablename, userid, start_date, end_date);
                        DataTable validDt = ToflyExtendDbHelper.GetInstance().ExecuteSql(sql);
                        if (validDt.Rows.Count > 0)
                        {
                            valid_distance = decimal.Parse(validDt.Rows[0]["validdistance"].ToString());
                            valid_time = decimal.Parse(validDt.Rows[0]["validtime"].ToString());
                        }
                        else
                        {
                            valid_distance = 0;
                            valid_time = 0;
                        }


                        #region 里程统计更新
                        sql = string.Format(@"select * from TF_GPS_DAY_CALCULATE t where t.plan_date>=to_date('{0}', 'yyyy/MM/dd') 
                    and t.plan_date<=to_date('{1}', 'yyyy/MM/dd HH24:MI:SS') and userid='{2}'", start_date, end_date, userid);
                        //判断当前里程表是否存在数据，若存在，则更新

                        DataTable isHas = ToflyExtendDbHelper.GetInstance().ExecuteSql(sql);
                        if (isHas == null || isHas.Rows.Count == 0)
                        {
                            sql = string.Format(@"insert into TF_GPS_DAY_CALCULATE
                                  (id, 
                                   userid, 
                                   plan_date, 
                                   valid_time,valid_distance)
                                values
                                  (sys_guid(),'{0}',to_date('{1}', 'yyyy/MM/dd'),'{2}','{3}')
                                ", userid, start_date, valid_time,valid_distance);
                        }
                        else
                        {
                            sql = string.Format(@"update  
                                   TF_GPS_DAY_CALCULATE t 
                                   set
                                   valid_time='{0}',
                                   valid_distance='{1}'
                                    where t.id='{2}'",
                                         valid_time,
                                         valid_distance,
                                         isHas.Rows[0]["id"].ToString());
                        }
                        ToflyExtendDbHelper.GetInstance().ExecuteOneSql(sql);
                        #endregion
                    }
                    catch (Exception ex)
                    {
                        UpdateApply(applyId, percent, point_ids);
                        Logger.WriteLine("0055", ex.Message + "有效耗时计算失败" + "\r\n" + ex.StackTrace + "\r\n", DateTime.Now);
                    }

                    #endregion

                    #region 服务器更新线到位比例
            
                    if (k > 0)
                    {
                        sql = string.Format(@"select (select count(*)
                                              from tf_plan_path_temp t
                                             where t.child_plan_id = '{0}'
                                               and t.isover = 1) isovertotal,
                                           (select count(*)
                                              from tf_plan_path_temp t
                                             where t.child_plan_id = '{0}') total,
                                           (select count(*)
                                              from tf_plan_point_temp t
                                             where t.child_plan_id = '{0}'
                                               and t.state = 1) tiaoshu
                                      from dual",plan_id);
                        DataTable staticPlan = ToflyExtendDbHelper.GetInstance().ExecuteSql(sql);
                        if (staticPlan.Rows.Count > 0)
                        {
                            decimal isovertotal = decimal.Parse(staticPlan.Rows[0]["isovertotal"].ToString());
                            decimal total = decimal.Parse(staticPlan.Rows[0]["total"].ToString());
                            decimal tiaoshu = decimal.Parse(staticPlan.Rows[0]["tiaoshu"].ToString());
                            if (total > 0)
                            {
                                percent = System.Math.Round(isovertotal / total, 4);
                                sql = string.Format(@"update tf_plan_child t 
                                            set t.percent={0},
                                            t.percent1={0},
                                            t.isovertototal=t.total*{0},
                                            t.isovertototal1={1} 
                                            where t.child_plan_id='{2}'", percent, tiaoshu, plan_id);
                                ToflyExtendDbHelper.GetInstance().ExecuteOneSql(sql);
                            }
                        }
                    }
                    #endregion
                }

                #region 更新计划统计
                try
                {
                    sql = string.Format(@"select * from tf_point_day_calculate t where t.plan_date>=to_date('{0}', 'yyyy/MM/dd') 
                                 and t.plan_date<=to_date('{1}', 'yyyy/MM/dd HH24:MI:SS') and userid='{2}' and child_plan_id='{3}'",
                                        start_date, end_date, userid, plan_id);
                    DataTable hasChildPlan = ToflyExtendDbHelper.GetInstance().ExecuteSql(sql);
                    decimal isovertototal = 0;
                    decimal isovertototal1 = 0;
                    decimal total = decimal.Parse(setting.Rows[0]["total"].ToString());
                    decimal total1 = decimal.Parse(setting.Rows[0]["total1"].ToString());
                    if (type == "0")
                    {
                        sql = string.Format(@"select (select nvl(count(*), 0)
                                                          from tf_plan_point_temp a
                                                         where a.child_plan_id = '{0}'
                                                           and a.state = 1
                                                           and a.over_date >=
                                                               to_date('{1}', 'yyyy/MM/dd HH24:MI:SS')
                                                           and a.over_date <=
                                                               to_date('{2}', 'yyyy/MM/dd HH24:MI:SS')) isover from dual", plan_id, start_date, end_date);
                        DataTable totalDt = ToflyExtendDbHelper.GetInstance().ExecuteSql(sql);
                        isovertototal = decimal.Parse(totalDt.Rows[0]["isover"].ToString());
                        isovertototal1 = decimal.Parse(totalDt.Rows[0]["isover"].ToString());
                    }
                    else
                    {
                        sql = string.Format(@"select (select nvl(count(*), 0)
                                                          from tf_plan_path_temp a
                                                         where a.child_plan_id = '{0}'
                                                           and a.isover = 1
                                                           and a.over_date >=
                                                               to_date('{1}', 'yyyy/MM/dd HH24:MI:SS')
                                                           and a.over_date <=
                                                               to_date('{2}', 'yyyy/MM/dd HH24:MI:SS')) isover,
                                                       (select nvl(count(*), 0)
                                                          from tf_plan_path_temp a
                                                         where a.child_plan_id = '{0}') total,
                                                       (select nvl(count(*), 0)
                                                        from tf_plan_point_temp a
                                                        where a.child_plan_id = '{0}'
                                                        and a.state =1
                                                        and a.over_date >=
                                                            to_date('{1}', 'yyyy/MM/dd HH24:MI:SS')
                                                        and a.over_date <=
                                                            to_date('{2}', 'yyyy/MM/dd HH24:MI:SS'))num  from dual", plan_id, start_date, end_date);
                        DataTable totalDt = ToflyExtendDbHelper.GetInstance().ExecuteSql(sql);
                        isovertototal = decimal.Parse(totalDt.Rows[0]["isover"].ToString()) == 0 ? 0 : total * (decimal.Parse(totalDt.Rows[0]["isover"].ToString()) / decimal.Parse(totalDt.Rows[0]["total"].ToString()));
                        isovertototal1 = decimal.Parse(totalDt.Rows[0]["num"].ToString());
                    }

                    if (hasChildPlan == null || hasChildPlan.Rows.Count == 0)
                    {
                        sql = string.Format(@"insert into tf_point_day_calculate
                                              (id,
                                               plan_date,
                                               userid,
                                               child_plan_id,
                                               device_type_id,
                                               total,
                                               total1,
                                               isovertototal,
                                               isovertototal1,
                                               child_begin_date,
                                               child_end_date)
                                            values
                                              (sys_guid(), to_date('{0}', 'yyyy/MM/dd') , '{1}', '{2}', '{3}', '{4}', '{5}', '{6}', '{7}',to_date('{8}', 'yyyy/MM/dd HH24:MI:SS'),to_date('{9}', 'yyyy/MM/dd HH24:MI:SS'))",
                                          start_date, userid, plan_id, device_type_id, total, total1, isovertototal, isovertototal1, setting.Rows[0]["child_begin_date"].ToString(), setting.Rows[0]["child_end_date"].ToString());
                    }
                    else
                    {
                        sql = string.Format(@"update  tf_point_day_calculate  set
                                                   total='{0}',
                                                   total1='{1}',
                                                   isovertototal='{2}',
                                                   isovertototal1='{3}',
                                                   child_begin_date=to_date('{4}', 'yyyy/MM/dd HH24:MI:SS'),
                                                   child_end_date=to_date('{5}', 'yyyy/MM/dd HH24:MI:SS')
                                                   where id='{6}'", total, total1, isovertototal, isovertototal1,
                                                           setting.Rows[0]["child_begin_date"].ToString(), setting.Rows[0]["child_end_date"].ToString(),
                                                           hasChildPlan.Rows[0]["id"].ToString());
                    }
                    ToflyExtendDbHelper.GetInstance().ExecuteOneSql(sql);
                }
                catch (Exception ex)
                {
                    UpdateApply(applyId, percent, point_ids);
                    Logger.WriteLine("0055", ex.Message + "更新计划统计" + "\r\n" + ex.StackTrace + "\r\n", DateTime.Now);
                }
                #endregion

                UpdateApply(applyId, percent, point_ids);
                Logger.WriteLog(applyId + "共耗时：" + watch.Elapsed.TotalSeconds);
                #endregion
            }
            catch (Exception ex)
            {
                UpdateApply(applyId, percent, point_ids);
                Logger.WriteLine("0055", ex.Message + "后台到位计算" + "\r\n" + ex.StackTrace + "\r\n" + plan_id + "\r\n" + search_date + "\r\n"+ watch.Elapsed.TotalSeconds, DateTime.Now);
            }
        }

        private static void UpdateApply(string applyId,decimal percent,List<string>point_ids)
        {
            string istest = ConfigurationManager.AppSettings["istest"] ?? "0";
            if (istest == "1")
            {
                TF_PLAN_APPLY apply = new CalLostPlan.TF_PLAN_APPLY();
                apply.ID = applyId;
                apply.AFTER_PER = percent;
                apply.END_DATE = DateTime.Now;
                apply.STATE = 2;
                apply.POINT_IDS = String.Join(",", point_ids);
                ToflyExtendDbHelper.GetInstance().ExecOneDB(SqlInsert.UpdateApply(apply));
            }

            //ToflyExtendDbHelper.GetInstance().ExecuteOneSql(string.Format(@"update tf_plan_apply t
            //                       set t.state = 2,end_date=sysdate,after_per='{0}'
            //                     where t.id ='{1}'", percent, applyId));
        }

        public static void Main1(string[] args)
        {
            Console.WriteLine("开始。。。");

            Stopwatch watch = new Stopwatch();
            watch.Start();
            if (args.Length == 0)
                return;
            string plan_id = string.Empty;
            string search_date = string.Empty;
            string userid = string.Empty;
            string sql = string.Empty;
            decimal percent = 0;
            string applyId = string.Empty;
            List<string> point_ids = new List<string>();
            plan_id = args[0];
            search_date = args[1];
            userid = args[2];
            percent = decimal.Parse(args[3]);
            applyId = args[4];

            sql = string.Format(@"update tf_plan_apply t
                                       set t.state = 1
                                     where t.id ='{0}'", applyId);
            ToflyExtendDbHelper.GetInstance().ExecuteOneSql(sql);

            try
            {
                #region 计算
                sql = "SELECT MIN_DISTANCE_IN_PLACE,CAR_MAX_SPEED,MAN_MAX_SPEED FROM TF_SYS_SETTING";
                DataTable dt = ToflyExtendDbHelper.GetInstance().ExecuteSql(sql);
                double _distance = 0;
                double _car_max_speed = 0;
                double _man_max_speed = 0;
                if (dt != null && dt.Rows.Count > 0)
                {
                    _distance = double.Parse(dt.Rows[0]["MIN_DISTANCE_IN_PLACE"].ToString());
                    _car_max_speed = double.Parse(dt.Rows[0]["CAR_MAX_SPEED"].ToString());
                    _man_max_speed = double.Parse(dt.Rows[0]["MAN_MAX_SPEED"].ToString());
                }

                sql = string.Format(@"select b.type, b.is_setting,b.device_type_id,
                                   a.total,a.total1,a.child_begin_date,a.child_end_date,a.plan_mode
                                  from tf_plan_child a
                                  left join tf_plan_point_type b 
                                 on a.device_type_id=b.device_type_id
                                 where a.child_plan_id = '{0}'", plan_id);
                DataTable setting = ToflyExtendDbHelper.GetInstance().ExecuteSql(sql);

                string type = setting.Rows[0]["type"].ToString();
                string is_setting = setting.Rows[0]["is_setting"].ToString();
                string device_type_id = setting.Rows[0]["device_type_id"].ToString();
                string plan_mode = setting.Rows[0]["plan_mode"].ToString();

                string tablename = "TF_GPS_UPLOAD";
                GetTable(ref tablename, DateTime.Parse(search_date));
                string start_date = string.Empty;
                string end_date = string.Empty;
                start_date = search_date;
                end_date = DateTime.Parse(search_date).AddDays(1).AddSeconds(-1).ToString();

                //获取轨迹
                if (plan_mode == "1")
                {
                    sql = string.Format(@"select * from {0} t
                                         where t.userid = '{1}'
                                           and t.check_time >=
                                               to_date('{2}', 'yyyy/MM/dd HH24:MI:SS')
                                           and t.check_time <=
                                               to_date('{3}', 'yyyy/MM/dd HH24:MI:SS')
                                           and t.isvalid=1
                                           and t.speed<={4}
                                           and t.gps_type=1
                                         order by t.check_time", tablename, userid, start_date, end_date, _car_max_speed);
                }
                else
                {
                    sql = string.Format(@"select * from {0} t
                                         where t.userid = '{1}'
                                           and t.check_time >=
                                               to_date('{2}', 'yyyy/MM/dd HH24:MI:SS')
                                           and t.check_time <=
                                               to_date('{3}', 'yyyy/MM/dd HH24:MI:SS')
                                           and t.isvalid=1
                                           and t.speed<={4}
                                           and t.gps_type=0
                                         order by t.check_time", tablename, userid, start_date, end_date, _man_max_speed);
                }

                DataTable gpsDt = ToflyExtendDbHelper.GetInstance().ExecuteSql(sql);

                if (gpsDt.Rows.Count == 0)
                {
                    UpdateApply(applyId, percent, point_ids);
                    return;
                }

                List<Gps_Model> _gps = (List<Gps_Model>)DataTableToListHelper.ToList<Gps_Model>(gpsDt);
                int gpsnum = _gps.Count();


                int k = 0;
                if (type == "0")
                {
                    #region 服务器计算点到位
                    if (is_setting == "1")
                    {
                        UpdateApply(applyId, percent, point_ids);
                        return;
                    }
                    sql = string.Format(@"select  t.lat,t.lng,t.isover,t.id  from tf_plan_point_temp t where t.child_plan_id='{0}' and t.isover=0", plan_id);
                    DataTable pointDt = ToflyExtendDbHelper.GetInstance().ExecuteSql(sql);

                    if (pointDt.Rows.Count == 0)
                    {
                        UpdateApply(applyId, percent, point_ids);
                        return;
                    }
                    List<Point_Model> point = (List<Point_Model>)DataTableToListHelper.ToList<Point_Model>(pointDt);
                    int pointnum = point.Count();

                    for (int j = 0; j < gpsnum; j++)
                    {
                        double lng1 = double.Parse(_gps[j].location_longitude.ToString());
                        double lat1 = double.Parse(_gps[j].location_latitude.ToString()); ;
                        Range range = GpsHelper.GpsRange(_distance, lng1, lat1);

                        var hasPoint = point.Where(m => (m.lng > range.xMin && m.lng < range.xMax) && (m.lat > range.yMin && m.lat < range.yMax));
                        if (hasPoint.Count() > 0)
                        {
                            var ids = hasPoint.Select(m => m.id).ToArray();
                            point = point.Where(m => !ids.Contains(m.id)).ToList();
                            StringBuilder arrStr = new StringBuilder();
                            if (ids.Length == 1)
                            {
                                arrStr.Append(string.Format("'{0}'", ids[0]));
                            }
                            else
                            {
                                int m = 0;
                                foreach (var a in ids)
                                {
                                    if (!point_ids.Contains(a))
                                        point_ids.Add(a);

                                    if (k == ids.Length - 1)
                                        arrStr.Append(string.Format("'{0}'", a));
                                    else
                                        arrStr.Append(string.Format("'{0}',", a));
                                    m++;
                                }
                            }

                            sql = string.Format(@"update tf_plan_point_temp t set 
                                                t.isover=1,
                                                t.state=1,
                                                t.over_date=to_date('{0}', 'yyyy/MM/dd HH24:MI:SS'),
                                                t.gps_speed='{1}' where t.id  in ({0})", _gps[j].check_time, _gps[j].gps_speed, arrStr.ToString());
                            ToflyExtendDbHelper.GetInstance().ExecuteOneSql(sql);
                            k++;
                        }
                    }
                    #endregion

                    #region 更新点到位比例
                    if (k > 0)
                    {
                        sql = string.Format(@"select (select nvl(count(*),0)
                                                      from tf_plan_point_temp t
                                                     where t.child_plan_id = '{0}') total,
                                                   (select nvl(count(*),0)
                                                      from tf_plan_point_temp t
                                                     where t.child_plan_id = '{0}'
                                                       and t.state = 1) isovertotal
                                              from dual", plan_id);
                        DataTable staticPlan = ToflyExtendDbHelper.GetInstance().ExecuteSql(sql);
                        if (staticPlan.Rows.Count > 0)
                        {
                            decimal isovertotal = decimal.Parse(staticPlan.Rows[0]["isovertotal"].ToString());
                            decimal total = decimal.Parse(staticPlan.Rows[0]["total"].ToString());
                            if (total > 0)
                            {
                                percent = System.Math.Round(isovertotal / total, 4);
                                sql = string.Format(@"update tf_plan_child t 
                                            set t.percent={0},
                                            t.percent1={0},
                                            t.isovertototal=t.total*{0},
                                            t.isovertototal1=t.total*{0} 
                                            where t.child_plan_id='{1}'", percent, plan_id);
                                ToflyExtendDbHelper.GetInstance().ExecuteOneSql(sql);
                            }
                        }
                    }
                    #endregion
                }
                else
                {
                    #region 服务器更新线到位
                    try
                    {
                        sql = string.Format(@"select  t.lat,t.lng,t.isover,t.id,temp_id  from tf_plan_path_temp t where t.child_plan_id='{0}' and t.isover=0", plan_id);
                        DataTable pointDt = ToflyExtendDbHelper.GetInstance().ExecuteSql(sql);

                        if (pointDt.Rows.Count == 0)
                        {
                            UpdateApply(applyId, percent, point_ids);
                            return;
                        }
                        List<Point_Model> point = (List<Point_Model>)DataTableToListHelper.ToList<Point_Model>(pointDt);
                        int pointnum = point.Count();
                        List<string> idsOverList = new List<string>();
                        List<string> idsFirstLeftList = new List<string>();
                        for (int j = 0; j < gpsnum; j++)
                        {

                            double lat1 = double.Parse(_gps[j].location_latitude.ToString());
                            double lng1 = double.Parse(_gps[j].location_longitude.ToString());
                            Range range = GpsHelper.GpsRange(_distance, lng1, lat1);

                            var hasOverPoint = point.Where(m => (m.lng > range.xMin && m.lng < range.xMax) && (m.lat > range.yMin && m.lat < range.yMax) && !idsOverList.Contains(m.id));

                            if (hasOverPoint.Count() > 0)
                            {
                                //标记为轨迹为到位点
                                if (_gps[j].state != 1)
                                {
                                    sql = string.Format(@"update {0} t set t.state=1 where t.id='{1}'", tablename, _gps[j].id);
                                    ToflyExtendDbHelper.GetInstance().ExecuteOneSql(sql);
                                }

                                var ids = hasOverPoint.Select(m => m.id).ToArray();
                                foreach (var id in ids)
                                {
                                    if (!point_ids.Contains(id))
                                        point_ids.Add(id);

                                    if (idsOverList.Contains(id))
                                        continue;
                                    //更新到位时间
                                    sql = string.Format(@"update tf_plan_path_temp t set 
                                                t.isover=1,
                                                t.over_date=to_date('{0}', 'yyyy/MM/dd HH24:MI:SS'),
                                                t.gps_speed='{1}' where t.id='{2}'", _gps[j].check_time, _gps[j].gps_speed, id);
                                    ToflyExtendDbHelper.GetInstance().ExecuteOneSql(sql);
                                    idsOverList.Add(id);
                                    k++;
                                }
                            }

                            var hasFirstLeftPoint = point.Where(m => (m.lng >= range.xMax && m.lat >= range.yMax && idsOverList.Contains(m.id) && !idsFirstLeftList.Contains(m.id)));
                            if (hasFirstLeftPoint.Count() > 0)
                            {
                                var ids = hasFirstLeftPoint.Select(m => m.id).ToArray();
                                foreach (var id in ids)
                                {
                                    if (idsFirstLeftList.Contains(id))
                                        continue;
                                    //更新线到位
                                    sql = string.Format(@"update tf_plan_path_temp t set t.first_left_time=to_date('{0}', 'yyyy/MM/dd HH24:MI:SS') where t.id='{1}'", _gps[j].check_time, id);
                                    ToflyExtendDbHelper.GetInstance().ExecuteOneSql(sql);
                                    idsFirstLeftList.Add(id);
                                }
                            }
                        }
                    }
                    catch (Exception ex)
                    {
                        UpdateApply(applyId, percent, point_ids);
                        Logger.WriteLine("0055", ex.Message + "服务器更新线到位" + "\r\n" + ex.StackTrace + "\r\n", DateTime.Now);
                    }
                    #endregion

                    #region 有效时长单独计算
                    try
                    {
                        //取得当天需要计算有效时间地到位点
                        sql = string.Format(@"select a.lat, a.lng, a.over_date, a.id, b.userid,a.first_left_time
                                          from tf_plan_path_temp a
                                          left join tf_plan_child b
                                            on a.child_plan_id = b.child_plan_id
                                         where a.over_date >= to_date('{0}', 'yyyy/MM/dd')
                                           and a.over_date <= to_date('{1}', 'yyyy/MM/dd HH24:MI:SS')
                                           and a.isover=1
                                           and b.userid='{2}'
                                           and a.first_left_time is not null
                                         order by a.over_date ", start_date, end_date, userid);

                        DataTable path = ToflyExtendDbHelper.GetInstance().ExecuteSql(sql);

                        var _path = (from p in path.AsEnumerable()
                                     select new
                                     {
                                         id = p.Field<string>("id"),
                                         over_date = p.Field<DateTime>("over_date"),
                                         userid = p.Field<string>("userid"),
                                         first_left_time = p.Field<DateTime?>("first_left_time"),
                                         lat = p.Field<decimal>("lat"),
                                         lng = p.Field<decimal>("lng")
                                     }).OrderBy(m => m.over_date);
                        Dictionary<string, Tuple<DateTime, DateTime>> dic = new Dictionary<string, Tuple<DateTime, DateTime>>();
                        int total = _path.Count();
                        var _path1 = _path.ToArray();
                        double total_time = 0;
                        for (int j = 0; j < total; j++)
                        {
                            //离开消耗时间更新到数据库
                            if (j > -1)
                            {
                                TimeSpan ts = _path1[j].first_left_time.Value - _path1[j].over_date;
                                sql = string.Format(@"update tf_plan_path_temp t set t.consume_time='{0}' where t.id='{1}' and t.consume_time is null", ts.TotalSeconds, _path1[j].id);
                            }

                            if (j == 0)
                            {
                                Tuple<DateTime, DateTime> tuple = Tuple.Create<DateTime, DateTime>(_path1[j].over_date, _path1[j].first_left_time.Value);
                                dic.Add(_path1[j].id, tuple);
                                TimeSpan ts = _path1[j].first_left_time.Value - _path1[j].over_date;
                                //如果时间超过10分钟，按照10分钟处理
                                if (ts.TotalSeconds > 600)
                                    total_time += 600;
                                else
                                    total_time += ts.TotalSeconds;
                            }
                            else
                            {
                                //如果B离<=A离（说明第二个点的时间段在第一个时间段内）则跳过这条记录 
                                //注意，如果这个记录被跳过了，那么下一个记录在比较时也应该用这个A点进行比较，
                                //例如，点A，点B，点C，当B点跳过时，点C也应该是与点A进行比较
                                if (_path1[j].first_left_time <= dic.Values.ToArray()[0].Item2)
                                    continue;
                                else if (_path1[j].first_left_time > dic.Values.ToArray()[0].Item2 && _path1[j].over_date <= dic.Values.ToArray()[0].Item2)
                                {
                                    // 如果B离>A离 并且 B到<=A离（说明第二个点的时间段与第一个时间段有交叉）
                                    TimeSpan ts = _path1[j].first_left_time.Value - dic.Values.ToArray()[0].Item2;
                                    //如果时间超过10分钟，按照10分钟处理
                                    if (ts.TotalSeconds > 600)
                                        total_time += 600;
                                    else
                                        total_time += ts.TotalSeconds;
                                    dic.Clear();
                                    Tuple<DateTime, DateTime> tuple = Tuple.Create<DateTime, DateTime>(_path1[j].over_date, _path1[j].first_left_time.Value);
                                    dic.Add(_path1[j].id, tuple);
                                }
                                else
                                {
                                    //如果B离>A离 并且 B到>A离（说明第二点的时间段与第一个时间点没有交叉）
                                    TimeSpan ts = _path1[j].first_left_time.Value - _path1[j].over_date;
                                    //如果时间超过10分钟，按照10分钟处理
                                    if (ts.TotalSeconds > 600)
                                        total_time += 600;
                                    else
                                        total_time += ts.TotalSeconds;
                                    dic.Clear();
                                    Tuple<DateTime, DateTime> tuple = Tuple.Create<DateTime, DateTime>(_path1[j].over_date, _path1[j].first_left_time.Value);
                                    dic.Add(_path1[j].id, tuple);
                                }
                            }
                        }

                        #region 里程统计更新
                        sql = string.Format(@"select * from TF_GPS_DAY_CALCULATE t where t.plan_date>=to_date('{0}', 'yyyy/MM/dd') 
                    and t.plan_date<=to_date('{1}', 'yyyy/MM/dd HH24:MI:SS') and userid='{2}'", start_date, end_date, userid);
                        //判断当前里程表是否存在数据，若存在，则更新

                        DataTable isHas = ToflyExtendDbHelper.GetInstance().ExecuteSql(sql);
                        if (isHas == null || isHas.Rows.Count == 0)
                        {
                            sql = string.Format(@"insert into TF_GPS_DAY_CALCULATE
                                  (id, 
                                   userid, 
                                   plan_date, 
                                   valid_time)
                                values
                                  (sys_guid(),'{0}',to_date('{1}', 'yyyy/MM/dd'),'{2}')
                                ", userid, start_date, total_time);
                        }
                        else
                        {
                            sql = string.Format(@"update  
                                   TF_GPS_DAY_CALCULATE t 
                                   set
                                   valid_time='{0}'
                                    where t.id='{1}'",
                                         total_time,
                                           isHas.Rows[0]["id"].ToString());
                        }
                        ToflyExtendDbHelper.GetInstance().ExecuteOneSql(sql);
                        #endregion
                    }
                    catch (Exception ex)
                    {
                        UpdateApply(applyId, percent, point_ids);
                        Logger.WriteLine("0055", ex.Message + "有效耗时计算失败" + "\r\n" + ex.StackTrace + "\r\n", DateTime.Now);
                    }

                    #endregion

                    #region 服务器更新线到位比例

                    if (k > 0)
                    {
                        sql = string.Format(@"select (select count(*)
                                              from tf_plan_path_temp t
                                             where t.child_plan_id = '{0}'
                                               and t.isover = 1) isovertotal,
                                           (select count(*)
                                              from tf_plan_path_temp t
                                             where t.child_plan_id = '{0}') total,
                                           (select count(*)
                                              from tf_plan_point_temp t
                                             where t.child_plan_id = '{0}'
                                               and t.state = 1) tiaoshu
                                      from dual", plan_id);
                        DataTable staticPlan = ToflyExtendDbHelper.GetInstance().ExecuteSql(sql);
                        if (staticPlan.Rows.Count > 0)
                        {
                            decimal isovertotal = decimal.Parse(staticPlan.Rows[0]["isovertotal"].ToString());
                            decimal total = decimal.Parse(staticPlan.Rows[0]["total"].ToString());
                            decimal tiaoshu = decimal.Parse(staticPlan.Rows[0]["tiaoshu"].ToString());
                            if (total > 0)
                            {
                                percent = System.Math.Round(isovertotal / total, 4);
                                sql = string.Format(@"update tf_plan_child t 
                                            set t.percent={0},
                                            t.percent1={0},
                                            t.isovertototal=t.total*{0},
                                            t.isovertototal1={1} 
                                            where t.child_plan_id='{2}'", percent, tiaoshu, plan_id);
                                ToflyExtendDbHelper.GetInstance().ExecuteOneSql(sql);
                            }
                        }
                    }
                    #endregion
                }

                #region 更新计划统计
                try
                {
                    sql = string.Format(@"select * from tf_point_day_calculate t where t.plan_date>=to_date('{0}', 'yyyy/MM/dd') 
                                 and t.plan_date<=to_date('{1}', 'yyyy/MM/dd HH24:MI:SS') and userid='{2}' and child_plan_id='{3}'",
                                        start_date, end_date, userid, plan_id);
                    DataTable hasChildPlan = ToflyExtendDbHelper.GetInstance().ExecuteSql(sql);
                    decimal isovertototal = 0;
                    decimal isovertototal1 = 0;
                    decimal total = decimal.Parse(setting.Rows[0]["total"].ToString());
                    decimal total1 = decimal.Parse(setting.Rows[0]["total1"].ToString());
                    if (type == "0")
                    {
                        sql = string.Format(@"select (select nvl(count(*), 0)
                                                          from tf_plan_point_temp a
                                                         where a.child_plan_id = '{0}'
                                                           and a.state = 1
                                                           and a.over_date >=
                                                               to_date('{1}', 'yyyy/MM/dd HH24:MI:SS')
                                                           and a.over_date <=
                                                               to_date('{2}', 'yyyy/MM/dd HH24:MI:SS')) isover from dual", plan_id, start_date, end_date);
                        DataTable totalDt = ToflyExtendDbHelper.GetInstance().ExecuteSql(sql);
                        isovertototal = decimal.Parse(totalDt.Rows[0]["isover"].ToString());
                        isovertototal1 = decimal.Parse(totalDt.Rows[0]["isover"].ToString());
                    }
                    else
                    {
                        sql = string.Format(@"select (select nvl(count(*), 0)
                                                          from tf_plan_path_temp a
                                                         where a.child_plan_id = '{0}'
                                                           and a.isover = 1
                                                           and a.over_date >=
                                                               to_date('{1}', 'yyyy/MM/dd HH24:MI:SS')
                                                           and a.over_date <=
                                                               to_date('{2}', 'yyyy/MM/dd HH24:MI:SS')) isover,
                                                       (select nvl(count(*), 0)
                                                          from tf_plan_path_temp a
                                                         where a.child_plan_id = '{0}') total,
                                                       (select nvl(count(*), 0)
                                                        from tf_plan_point_temp a
                                                        where a.child_plan_id = '{0}'
                                                        and a.state =1
                                                        and a.over_date >=
                                                            to_date('{1}', 'yyyy/MM/dd HH24:MI:SS')
                                                        and a.over_date <=
                                                            to_date('{2}', 'yyyy/MM/dd HH24:MI:SS'))num  from dual", plan_id, start_date, end_date);
                        DataTable totalDt = ToflyExtendDbHelper.GetInstance().ExecuteSql(sql);
                        isovertototal = decimal.Parse(totalDt.Rows[0]["isover"].ToString()) == 0 ? 0 : total * (decimal.Parse(totalDt.Rows[0]["isover"].ToString()) / decimal.Parse(totalDt.Rows[0]["total"].ToString()));
                        isovertototal1 = decimal.Parse(totalDt.Rows[0]["num"].ToString());
                    }

                    if (hasChildPlan == null || hasChildPlan.Rows.Count == 0)
                    {
                        sql = string.Format(@"insert into tf_point_day_calculate
                                              (id,
                                               plan_date,
                                               userid,
                                               child_plan_id,
                                               device_type_id,
                                               total,
                                               total1,
                                               isovertototal,
                                               isovertototal1,
                                               child_begin_date,
                                               child_end_date)
                                            values
                                              (sys_guid(), to_date('{0}', 'yyyy/MM/dd') , '{1}', '{2}', '{3}', '{4}', '{5}', '{6}', '{7}',to_date('{8}', 'yyyy/MM/dd HH24:MI:SS'),to_date('{9}', 'yyyy/MM/dd HH24:MI:SS'))",
                                          start_date, userid, plan_id, device_type_id, total, total1, isovertototal, isovertototal1, setting.Rows[0]["child_begin_date"].ToString(), setting.Rows[0]["child_end_date"].ToString());
                    }
                    else
                    {
                        sql = string.Format(@"update  tf_point_day_calculate  set
                                                   total='{0}',
                                                   total1='{1}',
                                                   isovertototal='{2}',
                                                   isovertototal1='{3}',
                                                   child_begin_date=to_date('{4}', 'yyyy/MM/dd HH24:MI:SS'),
                                                   child_end_date=to_date('{5}', 'yyyy/MM/dd HH24:MI:SS')
                                                   where id='{6}'", total, total1, isovertototal, isovertototal1,
                                                           setting.Rows[0]["child_begin_date"].ToString(), setting.Rows[0]["child_end_date"].ToString(),
                                                           hasChildPlan.Rows[0]["id"].ToString());
                    }
                    ToflyExtendDbHelper.GetInstance().ExecuteOneSql(sql);
                }
                catch (Exception ex)
                {
                    UpdateApply(applyId, percent, point_ids);
                    Logger.WriteLine("0055", ex.Message + "更新计划统计" + "\r\n" + ex.StackTrace + "\r\n", DateTime.Now);
                }
                #endregion

                UpdateApply(applyId, percent, point_ids);
                Logger.WriteLog(applyId + "共耗时：" + watch.Elapsed.TotalSeconds);
                #endregion
            }
            catch (Exception ex)
            {
                UpdateApply(applyId, percent, point_ids);
                Logger.WriteLine("0055", ex.Message + "后台到位计算" + "\r\n" + ex.StackTrace + "\r\n" + plan_id + "\r\n" + search_date + "\r\n" + watch.Elapsed.TotalSeconds, DateTime.Now);
            }
        }
    }

    public class apply
    {
        public string id { get; set; }
        public DateTime? start_date { get; set; }

        public decimal? state { get; set; }
    }

    public class Gps_Model
    {
        public string id { get; set; }
        public decimal location_longitude { get; set; }
        public decimal location_latitude { get; set; }
        public decimal gps_speed { get; set; }

        public decimal state { get; set; }
        public DateTime check_time { get; set; }

    }

    public class Point_Model
    {
        public string id { get; set; }
        public string temp_id { get; set; }
        public decimal lat { get; set; }
        public decimal lng { get; set; }
        public decimal isover { get; set; }

    }

    public class SpatialReference
    {
        /// <summary>
        /// 
        /// </summary>
        public int wkid { get; set; }
        /// <summary>
        /// 
        /// </summary>
        public int latestWkid { get; set; }
    }
    public class GeomeryModel
    {
        /// <summary>
        /// 
        /// </summary>
        public List<List<List<float>>> rings { get; set; }
        /// <summary>
        /// 
        /// </summary>
        public SpatialReference spatialReference { get; set; }
    }
}
