﻿using Newtonsoft.Json;
using System;
using System.Collections.Generic;
using System.Configuration;
using System.Data;
using System.Diagnostics;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace ColPipe
{
    class Program
    {
        static void Main(string[] args)
        {
            Stopwatch watch = new Stopwatch();
            watch.Start();
            bool iscol = bool.Parse(ConfigurationManager.AppSettings["iscol"] ?? "false");
            string sql = string.Empty;
            string pointInfo = string.Empty;
            string child_plan_id = string.Empty;

            if (args.Length > 0&& !iscol)
            {
                string[] child_plan_ids = args[0].Split(',');
                StringBuilder arrStr = new StringBuilder();
                int k = 0;
                foreach (var a in child_plan_ids)
                {
                    if (k == child_plan_ids.Length - 1)
                        arrStr.Append(string.Format("'{0}'", a));
                    else
                        arrStr.Append(string.Format("'{0}',", a));
                    k++;
                }

                sql = string.Format(@"select t.* from tf_plan_child t where t.child_plan_id in ({0})", arrStr.ToString());
            }
            else
            {
                sql = string.Format(@"select t.* from tf_plan_child t where t.type=1 and t.percent1>0 and t.isovertototal=0 and child_plan_state not in (5,6,7,8)");
            }

            DataTable dt = ToflyExtendDbHelper.GetInstance().ExecuteSql(sql);
            if (dt.Rows.Count == 0)
                return;
        

            //区分管线图层名
            string[] pipeArrmp = new string[] { "10", "14" };//中压管线
            string[] pipeArrip = new string[] { "9", "13" };//次高压管线
            string[] pipeArrlp = new string[] { "11" };//低压管线
            string[] pipeArrhp = new string[] { "12", "18" };//高压管线
            string nickname = string.Empty;

            try
            {
                foreach (DataRow row in dt.Rows)
                {
                    List<string> sqlList = new List<string>();
                    string _start_date = string.Empty;
                    string _end_date = string.Empty;
                    string _userid = string.Empty;
                    List<GeoClassPath> listPath = new List<GeoClassPath>();

                    _start_date = DateTime.Parse(row["child_begin_date"].ToString()).ToString("yyyy/MM/dd");
                    _end_date = DateTime.Parse(row["child_end_date"].ToString()).ToString("yyyy/MM/dd");
                    _userid = row["userid"].ToString();
                    pointInfo = row["point_info"].ToString();
                    child_plan_id = row["child_plan_id"].ToString();


                    listPath = JsonConvert.DeserializeObject<List<GeoClassPath>>(pointInfo.Trim().TrimStart('"').TrimEnd('"'));
                    double total = 0;
                    foreach (GeoClassPath path in listPath)
                    {
                        double pipelength = 0;

                        if (pipeArrmp.Contains(path.device_type_id))
                        {
                            nickname = "pipesectionmp-";
                        }
                        else if (pipeArrip.Contains(path.device_type_id))
                        {
                            nickname = "pipesectionip-";
                        }
                        else if (pipeArrlp.Contains(path.device_type_id))
                        {
                            nickname = "pipesectionlp-";
                        }
                        else if (pipeArrhp.Contains(path.device_type_id))
                        {
                            nickname = "pipesectionhp-";
                        }
                        else
                        {
                            sql = string.Format(@"select t.pipe_length from tf_plan_point t where t.point_id='{0}'", path.sid);
                            DataTable _dt = ToflyExtendDbHelper.GetInstance().ExecuteSql(sql);
                            if (_dt.Rows.Count == 0|| _dt.Rows[0][0].ToString()=="0")
                            {
                                DataTable lineDt = ToflyExtendDbHelper.GetInstance().ExecuteSql(string.Format(@"select * from tf_plan_path_temp t where t.point_id='{0}' and t.child_plan_id='{1}' order by t.num", path.sid, child_plan_id));

                                //如果当前管线只有一个点，则视为无效管线,计划视为作废
                                if (lineDt.Rows.Count == 1)
                                {
                                    sql = string.Format(@"update tf_plan_point t set t.valid=0 where t.point_id='{0}'", path.sid);
                                    sqlList.Add(sql);
                                    sql = string.Format("update tf_plan_child t set t.child_plan_state=8 where t.child_plan_id='{0}'", child_plan_id);
                                    sqlList.Add(sql);
                                    continue;
                                }
                                int j = 0;
                                double lat1 = 0;
                                double lng1 = 0;
                                double lat2 = 0;
                                double lng2 = 0;
                                foreach (DataRow line in lineDt.Rows)
                                {
                                    if (j == 0)
                                    {
                                        lat2 = double.Parse(line["lat"].ToString());
                                        lng2 = double.Parse(line["lng"].ToString());
                                        j++;
                                        continue;
                                    }
                                    lat1 = lat2;
                                    lng1 = lng2;
                                    lat2 = double.Parse(line["lat"].ToString());
                                    lng2 = double.Parse(line["lng"].ToString());
                                    pipelength += GpsHelper.Distance(lat1, lng1, lat2, lng2);
                                    j++;
                                }
                                total += pipelength;
                            }
                            else
                            {
                                pipelength = Math.Round(double.Parse(_dt.Rows[0][0].ToString()), 2);
                                total += pipelength;
                            }

                            //更新线的长度
                            sql = string.Format(@"update tf_plan_point t set t.pipe_length='{0}' where t.point_id='{1}'", pipelength, path.sid);
                            sqlList.Add(sql);

                            sqlList.Add(string.Format(@"update tf_plan_point_temp t set t.pipe_length={0} where t.point_id='{1}{2}' and t.child_plan_id='{3}'", pipelength, nickname, path.sid, child_plan_id));
                            continue;
                        }
                    


                       
                        var content = JsonConvert.DeserializeObject<ContentModel>(path.content.ToString().TrimStart('\'').TrimEnd('\'').TrimStart('"').TrimEnd('"'));
                        if (string.IsNullOrEmpty(content.sid))
                            continue;
                        pipelength = Math.Round(double.Parse(content.PIPELENGTH), 2);
                        total += pipelength;
                        sqlList.Add(string.Format(@"update tf_plan_point_temp t set t.pipe_length={0} where t.point_id='{1}{2}' and t.child_plan_id='{3}'", pipelength,nickname, content.sid, child_plan_id));
                    }

                    if (total > 0)
                    {
                        sqlList.Add(string.Format(@"update tf_plan_child t set t.total={0},t.isovertototal={0}*t.percent1 where t.child_plan_id='{1}'", total, child_plan_id));
                    }

                    if (ToflyExtendDbHelper.GetInstance().ExcuteBatchCommand(sqlList) > 0)
                    {
                        string exepath = "PlanCalculate";
                        string path = AppDomain.CurrentDomain.BaseDirectory + exepath + "\\" + exepath + ".exe";
                        string[] _args = new string[] { child_plan_id, _start_date, _end_date , _userid };
                        StartProcess(path, _args);
                    }
                }
            }
            catch (Exception ex)
            {
                Logger.WriteLog(ex.Message + ex.StackTrace);
            }

            Logger.WriteLog("共耗时：" + watch.Elapsed.TotalSeconds);
        }

        /// <summary>
        /// 启动服务
        /// </summary>
        /// <param name="runFilePath"></param>
        /// <param name="args"></param>
        /// <returns></returns>
        public static bool StartProcess(string runFilePath, params string[] args)
        {
            string s = "";
            foreach (string arg in args)
            {
                s = s + arg + " ";
            }
            s = s.Trim();
            Process process = new Process();//创建进程对象    
            ProcessStartInfo startInfo = new ProcessStartInfo(runFilePath, s); // 括号里是(程序名,参数)
            process.StartInfo = startInfo;
            process.Start();
            return true;
        }
    }

    public class ContentModel
    {
        public string sid { get; set; }


        public string PIPELENGTH { get; set; }

        public string device_type_id { get; set; }
    }

    public class GeoClassPath
    {
        /// <summary>
        /// 
        /// </summary>
        public string sid { get; set; }
        /// <summary>
        /// 
        /// </summary>
        public GeometryPath geometry { get; set; }
        /// <summary>
        /// 
        /// </summary>
        public string name { get; set; }
        /// <summary>
        /// 
        /// </summary>
        public string address { get; set; }
        /// <summary>
        /// 
        /// </summary>
        public string device_type_id { get; set; }
        /// <summary>
        /// 
        /// </summary>
        public string code { get; set; }
        /// <summary>
        /// 
        /// </summary>
        public string regionname { get; set; }
        /// <summary>
        /// 
        /// </summary>
        public string pipe_length { get; set; }
        /// <summary>
        /// 
        /// </summary>
        public string content { get; set; }

        /// <summary>
        /// 
        /// </summary>
        public string rfid { get; set; }
    }

    public class GeometryPath
    {
        /// <summary>
        /// 
        /// </summary>
        public List<List<List<double>>> paths { get; set; }
        /// <summary>
        /// 
        /// </summary>
        public SpatialReference spatialReference { get; set; }
    }

    /// <summary>
    /// 
    /// </summary>
    public class SpatialReference
    {
        /// <summary>
        /// 
        /// </summary>
        public int wkid { get; set; }

    }
}
