﻿using Newtonsoft.Json;
using Newtonsoft.Json.Linq;
using System;
using System.Collections.Generic;
using System.Configuration;
using System.Data;
using System.Diagnostics;
using System.IO;
using System.Linq;
using System.Net;
using System.Text;
using System.Threading.Tasks;

namespace GpsCalculate
{
   public class Program
    {
        public static void Main(string[] args)
        {
            var isZbState = getZbState();               //判断是否启用灾备系统 启动：true，停用：false
            var isZb = ConfigurationManager.AppSettings["iszb"];            //灾备端：1，正式端：0
            if (isZb == "0" && isZbState != false)            //正式库 = 灾备未启动 = 启动正式库服务
            {
                return;
            }
            if (isZb == "1" && isZbState != true)            //灾备库 = 灾备启动 = 启动灾备库服务
            {
                return;
            }

            DateTime now = DateTime.Now;
            int totalMin = now.Hour * 60 + now.Minute;
            //if (totalMin < 7 * 60 || totalMin > 19 * 60)
            //    return;
            Console.WriteLine("开始。。。");
            Stopwatch watch = new Stopwatch();
            watch.Start();
            List<string> sql_list = new List<string>();
            string sql = string.Empty;
            string _start_date = string.Empty;
            string _end_date = string.Empty;
            _start_date = ConfigurationManager.AppSettings["start_date"];
            _end_date = ConfigurationManager.AppSettings["end_date"];
            if(string.IsNullOrEmpty(_start_date))
                _start_date = now.ToString("yyyy/MM/dd");
            if (string.IsNullOrEmpty(_end_date))
                _end_date = now.ToString("yyyy/MM/dd");
            TimeSpan _ts = DateTime.Parse(_end_date) - DateTime.Parse(_start_date);
            int days = (int)_ts.TotalDays+1;
            string tablename = "TF_GPS_UPLOAD";
            double _distance = 0;
            sql = "select MIN_DISTANCE_IN_PLACE from tf_sys_setting";
            DataTable distanceDt = ToflyExtendDbHelper.GetInstance().ExecuteSql(sql);
            if (distanceDt != null && distanceDt.Rows.Count > 0)
                _distance = double.Parse(distanceDt.Rows[0][0].ToString());

            for (int q = 0; q < days; q++)
            {
                string start_date = string.Empty;
                string end_date = string.Empty;
                start_date = DateTime.Parse(_start_date).AddDays(q).ToString("yyyy/MM/dd");
                end_date = DateTime.Parse(_start_date).AddDays(1 + q).AddSeconds(-1).ToString();

                GetTable(ref tablename, DateTime.Parse(start_date));
                sql = string.Format(@"select * from tf_pda_monitor t where t.monitor_date = to_date('{0}', 'yyyy/MM/dd') and t.userid='5E682431CCDFC708E0530B9762C0E73D'", start_date);
                DataTable dt = ToflyExtendDbHelper.GetInstance().ExecuteSql(sql);
                if (dt.Rows.Count == 0)
                    continue;
                int usertotal = dt.Rows.Count;
                for (int i = 0; i < usertotal; i++)
                {
                    string userid = dt.Rows[i]["userid"].ToString();
                    sql = string.Format(@"select case
                                     when d.type = 0 then
                                      b.lat
                                     else
                                      c.lat
                                       end lat,
                                       case
                                         when d.type = 0 then
                                          b.lng
                                         else
                                          c.lng
                                       end lng,
                                       case
                                         when d.type = 0 then
                                          b.isover
                                         else
                                          c.isover
                                       end isover,
                                       case
                                         when d.type = 0 then
                                          b.id
                                         else
                                          c.id
                                       end temp_id,
                                       case
                                        when d.type = 0 then
                                        null
                                        else
                                        b.id
                                      end path_id,
                                       d.type,
                                       b.userid,
                                       c.num,
                                       a.child_plan_id plan_id,
                                       a.child_plan_id ,
                                       a.plan_mode,
                                       a.child_begin_date,
                                       a.child_end_date
                                  from
                                  tf_plan_child a left join
                                 tf_plan_point_temp b on a.child_plan_id=b.child_plan_id
                                  left join tf_plan_path_temp c
                                    on b.id = c.temp_id
                                  left join tf_plan_point_type d
                                    on b.device_type_id = d.device_type_id
                                where a.userid='{0}'  
                                and ((a.child_begin_date <=
                                to_date('{1}', 'yyyy/MM/dd HH24:MI:SS') and
                                a.child_end_date >=
                                to_date('{2}', 'yyyy/MM/dd HH24:MI:SS')) or
                                (to_date('{1}', 'yyyy/MM/dd HH24:MI:SS') <=
                                a.child_begin_date and
                                to_date('{2}', 'yyyy/MM/dd HH24:MI:SS') >=
                                a.child_begin_date) or
                                (to_date('{1}', 'yyyy/MM/dd HH24:MI:SS') <=
                                a.child_end_date and
                                to_date('{2}', 'yyyy/MM/dd HH24:MI:SS') >=
                                a.child_end_date)) and d.is_setting=0 and (b.isover=0 or c.isover=0)", userid,start_date,end_date);
                    DataTable pointDt = ToflyExtendDbHelper.GetInstance().ExecuteSql(sql);
                    if (pointDt.Rows.Count == 0)
                        continue;
                    sql = string.Format(@"select  t.*
                                          from {3} t
                                         where t.userid = '{0}'
                                           and t.check_time >=
                                               to_date('{1}', 'yyyy/MM/dd')
                                           and t.check_time <=
                                               to_date('{2}', 'yyyy/MM/dd HH24:MI:SS')
                                           and t.isvalid=1
                                           and t.gps_type=0
                                         order by t.check_time", userid, start_date, end_date, tablename);
                    DataTable gpsDt = ToflyExtendDbHelper.GetInstance().ExecuteSql(sql);
                    if(gpsDt.Rows.Count==0)
                        continue;
                    foreach (DataRow point in pointDt.Rows)
                    {
                        double lat1 = double.Parse(point["lat"].ToString());
                        double lng1 = double.Parse(point["lng"].ToString());
                        foreach (DataRow gps in gpsDt.Rows)
                        {
                            double lat2 = double.Parse(gps["location_latitude"].ToString());
                            double lng2 = double.Parse(gps["location_longitude"].ToString());
                            double distance = GpsHelper.Distance(lat1, lng1, lat2, lng2);
                            if (distance > _distance)
                                continue;
                            string type = point["type"].ToString();
                            string temp_id = point["temp_id"].ToString();
                            string gps_speed = gps["gps_speed"].ToString();
                            string check_time = gps["check_time"].ToString();
                            string child_plan_id = point["child_plan_id"].ToString();
                            if (type == "1")
                            {
                                sql = string.Format(@"update tf_plan_path_temp t set 
                                                t.isover=1,
                                                t.over_date=to_date('{0}', 'yyyy/MM/dd HH24:MI:SS'),
                                                t.gps_speed='{1}' where t.id='{2}'", check_time, gps_speed, temp_id);
                                ToflyExtendDbHelper.GetInstance().ExecuteOneSql(sql);
                                sql = string.Format(@"update tf_plan_child t
                                               set t.percent1      =
                                                   (select case
                                                             when nvl(d.total, 0) = 0 then
                                                              0
                                                             else
                                                              trunc(nvl(c.isover, 0) / nvl(d.total, 0), 4)
                                                           end
                                                      from (select count(*) isover, a.child_plan_id
                                                              from tf_plan_path_temp a
                                                             where a.isover = 1 and a.child_plan_id='{0}'
                                                             group by a.child_plan_id) c
                                                      left join (select count(*) total, b.child_plan_id
                                                                  from tf_plan_path_temp b where b.child_plan_id='{0}'
                                                                 group by b.child_plan_id) d
                                                        on c.child_plan_id = d.child_plan_id) where t.child_plan_id='{0}'", child_plan_id);
                                ToflyExtendDbHelper.GetInstance().ExecuteOneSql(sql);
                            }
                            else
                            {
                                sql = string.Format(@"update tf_plan_point_temp t set 
                                                t.over_date=to_date('{0}', 'yyyy/MM/dd HH24:MI:SS'),
                                                t.isover=1,
                                                t.gps_speed='{1}' where t.id='{2}'", check_time, gps_speed, temp_id);
                                ToflyExtendDbHelper.GetInstance().ExecuteOneSql(sql);

                                sql = string.Format(@"update tf_plan_child t
                                   set t.percent =
                                       (select case
                                                 when nvl(d.total, 0) = 0 then
                                                  0
                                                 else
                                                  trunc(nvl(c.isover, 0) / nvl(d.total, 0), 4)
                                               end
                                          from (select count(*) isover, a.child_plan_id
                                                  from tf_plan_point_temp a
                                                 where a.isover = 1
                                                 group by a.child_plan_id) c
                                          left join (select count(*) total, b.child_plan_id
                                                      from tf_plan_point_temp b
                                                     group by b.child_plan_id) d
                                            on c.child_plan_id = d.child_plan_id
                                         where c.child_plan_id = '{0}')
                                 where t.child_plan_id = '{0}'", child_plan_id);
                                ToflyExtendDbHelper.GetInstance().ExecuteOneSql(sql);
                            }
                            break;
                        }
                    }
                }
            }
            Logger.WriteLog("共耗时：" + watch.Elapsed.TotalSeconds);
        }

        /// <summary>
        /// 获取表名
        /// </summary>
        /// <param name="tableName"></param>
        /// <param name="search_date"></param>
        /// <returns></returns>
        public static void GetTable(ref string tableName, DateTime search_date)
        {
            string sql = string.Empty;
            try
            {
                string _table_name = tableName;
                //当前地配置时间与当前时间
                DateTime curSetting = DateTime.Parse(ConfigurationManager.AppSettings["DivideTb"]);
                DateTime now = DateTime.Now;
                if (search_date >= curSetting && search_date <= now && search_date.ToString("yyyyMM") != now.ToString("yyyyMM"))
                    tableName = string.Format("{0}_{1}", tableName, search_date.ToString("yyyyMM"));
                sql = string.Format(@"select nvl(count(*), 0) num
                                        from user_tables  where table_name = '{0}'", tableName);
                DataTable dt = ToflyExtendDbHelper.GetInstance().ExecuteSql(sql);
                if (dt == null)
                    tableName = _table_name;
                if (int.Parse(dt.Rows[0]["num"].ToString()) == 0)
                    tableName = _table_name;
            }
            catch (Exception ex)
            {
                Logger.WriteLog(sql + ex.Message);
            }
        }

        #region 功能：获取灾备系统启用状态(True=>启动,False=>停用)
        /// <summary>
        /// 功能：获取灾备系统启用状态(True=>启动,False=>停用)
        /// </summary>
        /// <returns></returns>
        private static bool getZbState()
        {
            var isZbState = false;
            //获取灾备API
            var zbApi = ConfigurationManager.AppSettings["zbapi"] + "";      //灾备API
            if (string.IsNullOrWhiteSpace(zbApi))
            {
                return isZbState;
            }
            var jsonStr = doPostRequest(zbApi);
            if (string.IsNullOrWhiteSpace(jsonStr))
            {
                return isZbState;
            }
            var objJson = (JObject)JsonConvert.DeserializeObject(jsonStr);
            var _open = objJson["result"]["open"] + "";
            if (!string.IsNullOrWhiteSpace(_open))
            {
                isZbState = Boolean.Parse(_open);
                return isZbState;
            }
            return isZbState;
        }

        /// <summary>
        /// 功能：POST方式发送得结果
        /// </summary>
        /// <param name="url"></param>
        /// <param name="bData"></param>
        /// <returns></returns>
        private static string doPostRequest(string url)
        {
            System.Net.HttpWebRequest hwRequest;
            System.Net.HttpWebResponse hwResponse;

            string strResult = string.Empty;
            try
            {
                hwRequest = (System.Net.HttpWebRequest)System.Net.WebRequest.Create(url);
                hwRequest.Timeout = 5000;
                hwRequest.Method = "GET";
                hwRequest.ContentType = "application/x-www-form-urlencoded";//application/x-www-form-urlencoded
            }
            catch (System.Exception err)
            {
                return strResult;
            }

            //get response
            try
            {
                hwResponse = (HttpWebResponse)hwRequest.GetResponse();
                StreamReader srReader = new StreamReader(hwResponse.GetResponseStream(), Encoding.UTF8);
                strResult = srReader.ReadToEnd();
                srReader.Close();
                hwResponse.Close();
            }
            catch (System.Exception err)
            {
                //WriteErrLog(err.ToString());

            }

            return strResult;
        }
        #endregion
    }




    public class Gps_Model
    {
        public string id { get; set; }
        public decimal lng { get; set; }
        public decimal lat { get; set; }
        public DateTime check_time { get; set; }
  
    }
}
