﻿using Newtonsoft.Json;
using Newtonsoft.Json.Linq;
using Oracle.ManagedDataAccess.Client;
using System;
using System.Collections.Generic;
using System.Configuration;
using System.Data;
using System.Data.Common;
using System.Diagnostics;
using System.IO;
using System.Linq;
using System.Net;
using System.Text;
using System.Threading.Tasks;

namespace SyncMonitor
{
    public class Program
    {
        public static void Main(string[] args)
        {
            var isZbState = getZbState();               //判断是否启用灾备系统 启动：true，停用：false
            var isZb = ConfigurationManager.AppSettings["iszb"];            //灾备端：1，正式端：0
            var isSql = ConfigurationManager.AppSettings["issql"];          //是否记录SQL语句 0=>不记录,1=记录
            if (isZb == "0" && isZbState != false)            //正式库 = 灾备未启动 = 启动正式库服务
            {
                Logger.WriteLog("启动正式库服务"+ isZbState+" - "+ isZb);
                return;
            }
            if (isZb == "1" && isZbState != true)            //灾备库 = 灾备启动 = 启动灾备库服务
            {
                Logger.WriteLog("启动灾备库服务" + isZbState + " - " + isZb);
                return;
            }

            if (ConfigurationManager.AppSettings["islength"].ToString() == "1")
            {
                CalLenth();
            }

            Console.WriteLine("开始。。。");
            Stopwatch watch = new Stopwatch();
            watch.Start();
            List<string> sql_list = new List<string>();
            string sql = string.Empty;
            DateTime now = DateTime.Now;
            string _start_date = string.Empty;
            string _end_date = string.Empty;
            int totalMin = now.Hour * 60 + now.Minute;
            _start_date = ConfigurationManager.AppSettings["start_date"];
            _end_date = ConfigurationManager.AppSettings["end_date"];
            if (string.IsNullOrEmpty(_start_date))
                _start_date = now.ToString("yyyy/MM/dd");
            if (string.IsNullOrEmpty(_end_date))
                _end_date = now.ToString("yyyy/MM/dd");

            TimeSpan _ts = DateTime.Parse(_end_date) - DateTime.Parse(_start_date);
            int days = (int)_ts.TotalDays + 1;

            if (ConfigurationManager.AppSettings["open"] == "true")
            {
                #region 巡检点、巡检线统计
             
                for (int q = 0; q < days; q++)
                {
                    string start_date = string.Empty;
                    string end_date = string.Empty;
                    start_date = DateTime.Parse(_start_date).AddDays(q).ToString("yyyy/MM/dd");
                    end_date = DateTime.Parse(_start_date).AddDays(1 + q).AddSeconds(-1).ToString();
                 
                    if (ConfigurationManager.AppSettings["isautosign"].ToString() == "1" && totalMin < 30)
                    {
                        AutoSign(start_date, sql, end_date);
                    }

                    if (ConfigurationManager.AppSettings["isautocopy"].ToString() == "1" && totalMin < 30)
                    {
                        AutoCopy(start_date, sql, end_date);
                    }

                    if (totalMin < 7 * 60 || totalMin > 19 * 60)
                        return;

                    #region 更新录入状态
                    try
                    {
                        //查询出当前用户当天的计划
                        //sql = string.Format(@"select t.*,t1.type
                        //                  from tf_plan_child t left join tf_plan_point_type t1 on t.device_type_id=t1.device_type_id
                        //                 where t.child_begin_date <=
                        //                       to_date('{0}', 'yyyy/MM/dd')
                        //                   and t.child_end_date >=
                        //                       to_date('{1}', 'yyyy/MM/dd HH24:MI:SS')", start_date, end_date);
                        //sql = string.Format(@"select t.*,t1.type
                        //                  from tf_plan_child t left join tf_plan_point_type t1 on t.device_type_id=t1.device_type_id
                        //                 where t.child_begin_date >
                        //                       to_date('{0}', 'yyyy/MM/dd')", start_date, end_date);
                        //sql = string.Format(@"select t.*,t1.type
                        //                  from tf_plan_child t left join tf_plan_point_type t1 on t.device_type_id=t1.device_type_id and t.device_type_id in ('2', '3', '4', '7', '8' , "19")");

                        ////查询出当前用户当天的计划
                        //sql = string.Format(@"select t.*,t1.type
                        //                  from tf_plan_child t left join tf_plan_point_type t1 on t.device_type_id=t1.device_type_id
                        //                 where t.child_begin_date <=
                        //                       to_date('{0}', 'yyyy/MM/dd')
                        //                   and t.child_end_date >=
                        //                       to_date('{1}', 'yyyy/MM/dd HH24:MI:SS')  and t.device_type_id in ('2', '3', '4', '7', '8', "19" )", start_date, end_date);
                        sql = @"select t.*,t1.type
                                          from tf_plan_child t left join tf_plan_point_type t1 on t.device_type_id=t1.device_type_id";
                        DataTable plan = ToflyExtendDbHelper.GetInstance().ExecuteSql(sql);
                        string[] luru = new string[] { "2", "3", "4", "5", "7", "8", "19" };
                        foreach (DataRow row in plan.Rows)
                        {

                            decimal pointTotal = 0;
                            decimal pointIsoverTotal = 0;
                            decimal isover = 0;
                            decimal total = 0;
                            decimal percent = 0;
                            if (row["type"].ToString() == "1")
                            {

                                #region 更新巡检线录入状态
                                sql = string.Format(@"select (select count(*)
                                                          from tf_plan_path_temp a
                                                         where a.child_plan_id = '{0}')pointTotal,
                                                       (select count(*)
                                                          from tf_plan_path_temp a
                                                         where a.child_plan_id = '{0}'
                                                           and a.isover = 1)pointIsoverTotal,
                                                       (select nvl(count(*), 0)
                                                          from (select nvl(count(*), 0)
                                                                  from tf_plan_path_temp a
                                                                 where a.isover = 0
                                                                   and a.child_plan_id = '{0}'
                                                                 group by a.child_plan_id, a.temp_id, a.isover)) noisover,
                                                       (select count(*)
                                                          from tf_plan_point_temp t
                                                         where t.child_plan_id = '{0}') total
                                                  from dual ", row["child_plan_id"].ToString());
                                DataTable path = ToflyExtendDbHelper.GetInstance().ExecuteSql(sql);
                                total = decimal.Parse(path.Rows[0]["total"].ToString());
                                isover = total - decimal.Parse(path.Rows[0]["noisover"].ToString());
                                pointTotal = decimal.Parse(path.Rows[0]["pointTotal"].ToString());
                                pointIsoverTotal = decimal.Parse(path.Rows[0]["pointIsoverTotal"].ToString());
                                percent = pointTotal == 0 ? 0 : System.Math.Round(pointIsoverTotal / pointTotal, 4);
                                //更新到位条数
                                sql = string.Format("update tf_plan_child t set t.percent='{0}',t.percent1='{0}', t.isovertototal=t.total*{0}, t.total1='{1}',t.isovertototal1='{2}' where t.child_plan_id='{3}'", percent, total, isover, row["child_plan_id"].ToString());
                                sql_list.Add(sql);
                                //更新录入状态
                                sql = string.Format(@"select max(a.over_date)over_date, nvl(max(a.gps_speed),0)gps_speed, a.temp_id
                                                      from tf_plan_path_temp a
                                                      left join tf_plan_point_temp b
                                                        on a.temp_id = b.id
                                                     where a.temp_id not in
                                                           (select t.temp_id
                                                              from tf_plan_path_temp t
                                                             where t.isover = 0
                                                               and t.child_plan_id = '{0}'
                                                             group by t.child_plan_id, t.temp_id, t.isover)
                                                       and a.child_plan_id = '{0}'
                                                       and b.state = 0
                                                     group by a.temp_id, a.child_plan_id", row["child_plan_id"].ToString());
                                DataTable point = ToflyExtendDbHelper.GetInstance().ExecuteSql(sql);
                                foreach (DataRow row1 in point.Rows)
                                {
                                    sql = string.Format(@"update tf_plan_point_temp a set
                                                            a.isover =1,
                                                            a.gps_speed='{0}',
                                                            a.state=1,a.over_date=to_date('{1}','yyyy/MM/dd HH24:MI:SS')  
                                                            where a.id = '{2}'", row1["gps_speed"].ToString(), row1["over_date"].ToString(), row1["temp_id"].ToString());
                                    sql_list.Add(sql);
                                }
                                #endregion
                            }
                            else if (!luru.Contains(row["device_type_id"].ToString()))
                            {
                                #region  更新巡检点录入状态
                                sql = string.Format(@"select (select nvl(count(*), 0)
                                                  from tf_plan_point_temp t
                                                 where t.child_plan_id = '{0}')total,
                                               (select nvl(count(*), 0)
                                                   from tf_plan_point_temp t
                                                 where t.child_plan_id = '{0}'
                                                   and t.isover = 1)isover
                                                  from dual", row["child_plan_id"].ToString());
                                DataTable point = ToflyExtendDbHelper.GetInstance().ExecuteSql(sql);
                                total = decimal.Parse(point.Rows[0]["total"].ToString());
                                isover = decimal.Parse(point.Rows[0]["isover"].ToString());
                                percent = total == 0 ? 0 : System.Math.Round(isover / total, 4);
                                sql = string.Format(@"update tf_plan_child t set t.total='{0}',t.total1='{0}',t.isovertototal='{1}',t.isovertototal1='{1}',t.percent='{2}',t.percent1='{2}' where t.child_plan_id='{3}'", total, isover, percent, row["child_plan_id"].ToString());
                                ToflyExtendDbHelper.GetInstance().ExecuteOneSql(sql);
                                //sql_list.Add(sql);
                                sql = string.Format("update tf_plan_point_temp t set t.state=1 where t.child_plan_id='{0}' and t.isover=1", row["child_plan_id"].ToString());
                                ToflyExtendDbHelper.GetInstance().ExecuteOneSql(sql);
                                // sql_list.Add(sql);
                                #endregion
                            }
                            else
                            {
                                #region 更新设备录入状态
                                sql = string.Format(@"select nvl(count(*),0)total from tf_plan_point_temp t where t.child_plan_id = '{0}'", row["child_plan_id"].ToString());
                                DataTable point = ToflyExtendDbHelper.GetInstance().ExecuteSql(sql);
                                total = decimal.Parse(point.Rows[0]["total"].ToString());

                                if (row["device_type_id"].ToString() == "5")
                                {
                                    sql = string.Format(@"select * from tf_plan_point_temp t where t.child_plan_id='{0}'", row["child_plan_id"].ToString());
                                    DataTable trouble = ToflyExtendDbHelper.GetInstance().ExecuteSql(sql);

                                    foreach (DataRow row1 in trouble.Rows)
                                    {
                                        sql = string.Format(@"select (select nvl(count(*), 0)
                                                                  from tf_plan_trouble_record t
                                                                 where t.child_plan_id = '{0}'
                                                                   and t.trouble_id = '{1}') record,
                                                               (select nvl(count(*), 0)
                                                                  from tf_trouble_check t
                                                                 where t.child_plan_id = '{0}'
                                                                   and t.trouble_id = '{1}') clear
                                                          from dual", row["child_plan_id"].ToString(), row1["trouble_id"].ToString());
                                        DataTable _trouble = ToflyExtendDbHelper.GetInstance().ExecuteSql(sql);
                                        if (decimal.Parse(_trouble.Rows[0]["record"].ToString()) > 0 || decimal.Parse(_trouble.Rows[0]["clear"].ToString()) > 0)
                                        {
                                            isover += 1;
                                            sql = string.Format(@"update tf_plan_point_temp t set t.state=1 where t.id='{0}'", row1["id"].ToString());
                                            ToflyExtendDbHelper.GetInstance().ExecuteOneSql(sql);
                                           // sql_list.Add(sql);
                                        }
                                    }
                                    percent = total == 0 ? 0 : System.Math.Round(isover / total, 4);
                                }
                                else
                                {
                                    sql = string.Format(@"select nvl(count(*),0)total from tf_plan_point_temp t where t.child_plan_id = '{0}'", row["child_plan_id"].ToString());
                                    DataTable point1 = ToflyExtendDbHelper.GetInstance().ExecuteSql(sql);
                                    total = decimal.Parse(point1.Rows[0]["total"].ToString());

                                    sql = string.Format(@"select * from tf_plan_point_temp t where t.child_plan_id='{0}'", row["child_plan_id"].ToString());
                                    DataTable trouble = ToflyExtendDbHelper.GetInstance().ExecuteSql(sql);

                                    foreach (DataRow row1 in trouble.Rows)
                                    {
                                        sql = string.Format(@"select (select nvl(count(*), 0)
                                                              from tf_plan_adjustable_pressure t
                                                             where t.child_plan_id = '{0}'
                                                               and t.point_id = '{1}') record,
                                                           (select nvl(count(*), 0)
                                                              from tf_plan_valve t
                                                             where t.child_plan_id = '{0}'
                                                               and t.point_id = '{1}') clear
                                                      from dual", row["child_plan_id"].ToString(), row1["point_id"].ToString());
                                        DataTable _trouble = ToflyExtendDbHelper.GetInstance().ExecuteSql(sql);
                                        if (decimal.Parse(_trouble.Rows[0]["record"].ToString()) > 0 || decimal.Parse(_trouble.Rows[0]["clear"].ToString()) > 0)
                                        {
                                            isover += 1;
                                            sql = string.Format(@"update tf_plan_point_temp t set t.state=1 where t.id='{0}'", row1["id"].ToString());
                                            ToflyExtendDbHelper.GetInstance().ExecuteOneSql(sql);
                                            //sql_list.Add(sql);
                                        }
                                    }
                                    percent = total == 0 ? 0 : System.Math.Round(isover / total, 4);
                                }

                                sql = string.Format("update tf_plan_child t set t.total='{0}',t.total1='{0}',t.percent='{1}',t.percent1='{1}',t.isovertototal='{2}',t.isovertototal1='{2}' where t.child_plan_id = '{3}'", total, percent, isover, row["child_plan_id"].ToString());
                                ToflyExtendDbHelper.GetInstance().ExecuteOneSql(sql);
                                //sql_list.Add(sql);
                                #endregion
                            }

                            //更新线到位比例
                            sql = string.Format(@"select * from tf_plan_point_temp t where t.child_plan_id='{0}' and t.state=0", row["child_plan_id"].ToString());
                            DataTable temp = ToflyExtendDbHelper.GetInstance().ExecuteSql(sql);
                            foreach (DataRow row1 in temp.Rows)
                            {
                                sql = string.Format(@"update tf_plan_point_temp t set t.path_isover=(select count(*) from tf_plan_path_temp a
                                            where a.temp_id=t.id and a.isover=1)/(select count(*) from tf_plan_path_temp a where a.temp_id=t.id) where t.id='{0}'", row1["id"].ToString());
                                ToflyExtendDbHelper.GetInstance().ExecuteOneSql(sql);
                                //sql_list.Add(sql);
                            }

                            //更新计划状态
                            sql = string.Format("update tf_plan_child t set t.child_plan_state=3 where t.percent1=1 and t.child_plan_id='{0}' ", row["child_plan_id"].ToString());
                            ToflyExtendDbHelper.GetInstance().ExecuteOneSql(sql);
                            // sql_list.Add(sql);
                        }
                    }
                    catch (Exception e)
                    {
                        Logger.WriteErrorLog("实时监控计划状态、线到位长度、线到位条数、线录入状态、到位时间" + "\r\n" + e.Message + "\r\n" + e.StackTrace);
                    }
                    #endregion
                }
                #endregion
            }
            else
            {
                #region 功能：2019-04-26 隐患账号同步
                Up_Third_Trouble_User(ref sql_list);
                #endregion

                #region 隐患同步
                SynTrouble(sql, ref sql_list);
                #endregion

                #region 实时监控计划状态和线到位长度、线到位条数、线录入状态、到位时间和点录入状态
                for (int q = 0; q < days; q++)
                {
                    string start_date = string.Empty;
                    string end_date = string.Empty;
                    start_date = DateTime.Parse(_start_date).AddDays(q).ToString("yyyy/MM/dd");
                    end_date = DateTime.Parse(_start_date).AddDays(1 + q).AddSeconds(-1).ToString();
                  
                    if (ConfigurationManager.AppSettings["isautosign"].ToString() == "1" && totalMin < 30)
                    {
                        AutoSign(start_date, sql, end_date);
                        Logger.WriteLog("自动签到已执行");
                    }

                    if (ConfigurationManager.AppSettings["isfunctionfirst"].ToString() == "1")
                    {
                        if (ConfigurationManager.AppSettings["isautocopy"].ToString() == "1" && (totalMin < 30 || totalMin > 19 * 60))
                        {
                            AutoCopy(start_date, sql, end_date);
                            Logger.WriteLog("自动复制已执行");
                        }

                    }
                    else
                    {
                        if (ConfigurationManager.AppSettings["isautocopy"].ToString() == "1")
                        {
                            AutoCopy(start_date, sql, end_date);
                            Logger.WriteLog("自动复制已执行");
                        }
                    }
                  
                    //if (totalMin < 7 * 60 || totalMin > 19 * 60)
                    //    return;
                    #region 更新录入状态
                    try
                    {
                        //查询出当前用户当天的计划
                        sql = string.Format(@"select t.child_plan_id,t1.type
                                          from tf_plan_child t left join tf_plan_point_type t1 on t.device_type_id=t1.device_type_id
                                         where ((t.child_begin_date <= to_date('{0}', 'yyyy/MM/dd') and
                                           t.child_end_date >=
                                           to_date('{1}', 'yyyy/MM/dd HH24:MI:SS')) or
                                           (t.child_begin_date >= to_date('{0}', 'yyyy/MM/dd') and
                                           t.child_begin_date <=
                                           to_date('{1}', 'yyyy/MM/dd HH24:MI:SS')) or
                                           (t.child_end_date >= to_date('{0}', 'yyyy/MM/dd') and
                                           t.child_end_date <=
                                           to_date('{1}', 'yyyy/MM/dd HH24:MI:SS')))", start_date, end_date);
                        DataTable plan = ToflyExtendDbHelper.GetInstance().ExecuteSql(sql);
                        if (isSql == "1")
                            Logger.WriteErrorLog("1、plan:" + "\r\n" + sql + "\r\n 数量：" + plan.Rows.Count + "  " + start_date);

                        foreach (DataRow row in plan.Rows)
                        {
                            decimal isover = 0;
                          
                            if (row["type"].ToString() == "1")
                            {
                                sql = string.Format(@"select (select nvl(count(*), 0)
                                                  from(select nvl(count(*), 0)
                                                          from tf_plan_path_temp a
                                                         where a.isover = 0
                                                           and a.child_plan_id = '{0}'
                                                         group by a.child_plan_id, a.temp_id, a.isover)) noisover,
                                               (select count(*)
                                                  from tf_plan_point_temp t
                                                 where t.child_plan_id = '{0}') total
                                          from dual ", row["child_plan_id"].ToString());
                                DataTable path = ToflyExtendDbHelper.GetInstance().ExecuteSql(sql);
                                if (isSql == "1")
                                    Logger.WriteErrorLog("2、path:" + "\r\n" + sql + "\r\n 数量：" + path.Rows.Count + "  " + start_date);
                                isover = decimal.Parse(path.Rows[0]["total"].ToString()) - decimal.Parse(path.Rows[0]["noisover"].ToString());
                                //更新到位条数
                                sql = string.Format("update tf_plan_child t set t.isovertototal=t.total*t.percent1,t.isovertototal1={0},t.percent=t.percent1 where t.child_plan_id='{1}'", isover, row["child_plan_id"].ToString());
                                ToflyExtendDbHelper.GetInstance().ExecuteOneSql(sql);
                                if (isSql == "1")
                                    Logger.WriteErrorLog("3、更新到位条数:" + "\r\n" + sql);
                                //sql_list.Add(sql);
                                //更新录入状态
                                sql = string.Format(@"select max(a.over_date)over_date, nvl(max(a.gps_speed),0)gps_speed, a.temp_id
                                                      from tf_plan_path_temp a
                                                      left join tf_plan_point_temp b
                                                        on a.temp_id = b.id
                                                     where a.temp_id not in
                                                           (select t.temp_id
                                                              from tf_plan_path_temp t
                                                             where t.isover = 0
                                                               and t.child_plan_id = '{0}'
                                                             group by t.child_plan_id, t.temp_id, t.isover)
                                                       and a.child_plan_id = '{0}'
                                                       and b.state = 0
                                                     group by a.temp_id, a.child_plan_id", row["child_plan_id"].ToString());
                                DataTable point = ToflyExtendDbHelper.GetInstance().ExecuteSql(sql);
                                if (isSql == "1")
                                    Logger.WriteErrorLog("4、point:" + "\r\n" + sql + "\r\n 数量：" + point.Rows.Count);
                                foreach (DataRow row1 in point.Rows)
                                {
                                    sql = string.Format(@"update tf_plan_point_temp a set
                                                            a.isover =1,
                                                            a.gps_speed='{0}',
                                                            a.state=1,a.over_date=to_date('{1}','yyyy/MM/dd HH24:MI:SS')  
                                                            where a.id = '{2}'", row1["gps_speed"].ToString(), row1["over_date"].ToString(), row1["temp_id"].ToString());
                                    ToflyExtendDbHelper.GetInstance().ExecuteOneSql(sql);
                                    // sql_list.Add(sql);
                                    if (isSql == "1")
                                        Logger.WriteErrorLog("5、tf_plan_point_temp:" + "\r\n" + sql);
                                }
                            }

                            //更新计划状态
                            sql = string.Format("update tf_plan_child t set t.child_plan_state=3 where t.percent1=1 and t.child_plan_id='{0}' ", row["child_plan_id"].ToString());
                            ToflyExtendDbHelper.GetInstance().ExecuteOneSql(sql);
                            if (isSql == "1")
                                Logger.WriteErrorLog("6、更新计划状态:" + "\r\n" + sql);
                            // sql_list.Add(sql);
                        }
                    }
                    catch (Exception e)
                    {
                        Logger.WriteErrorLog("实时监控计划状态、线到位长度、线到位条数、线录入状态、到位时间" + "\r\n" + e.Message + "\r\n" + e.StackTrace);
                    }
                    #endregion
                }
                #endregion

               
            }

            try
            {
                int result = ToflyExtendDbHelper.GetInstance().ExcuteBatchCommand(sql_list);
            }
            catch (Exception e)
            {
                Logger.WriteErrorLog("执行插入sql失败" + "\r\n" + e.Message + "\r\n" + e.StackTrace);
            }
            Logger.WriteLog("共耗时：" + watch.Elapsed.TotalSeconds);
            Console.WriteLine("共耗时：" + watch.Elapsed.TotalSeconds);
        }


        /// <summary>
        /// 隐患同步
        /// </summary>
        /// <param name="sql"></param>
        /// <param name="sql_list"></param>
        private static void SynTrouble(string sql,ref List<string> sql_list)
        {
            #region 隐患同步
            sql = @"select *
                      from third_trouble@third_trouble_dblink t
                     where t.is_xjsync = 0 or t.is_xjsync is null ";
            DataTable troubleSync = ToflyExtendDbHelper.GetInstance().ExecuteSql(sql);
            foreach (DataRow row in troubleSync.Rows)
            {
                if (row["state"].ToString() == "2")
                {
                    sql = string.Format(@"update tf_trouble t set t.process_id='8',t.handle_state=1,t.handle_username='{0}', t.handle_result='{1}',t.handle_time= to_date('{2}', 'yyyy/MM/dd  HH24:MI:SS') where t.id='{3}'", row["cljgtxr"].ToString(), row["cljg"].ToString(), row["cljgtxsj"].ToString(), row["id"].ToString());
                    ToflyExtendDbHelper.GetInstance().ExecuteOneSql(sql);
                    // sql_list.Add(sql);
                    sql = string.Format(@"update third_trouble@third_trouble_dblink t set t.is_xjsync='1' where t.id='{0}'", row["id"].ToString());
                    //sql = string.Format(@"update third_trouble@third_trouble_dblink t set t.state=2 where t.id='{0}'", row["id"].ToString());
                    ToflyExtendDbHelper.GetInstance().ExecuteOneSql(sql);
                    // sql_list.Add(sql);
                }
                else if (row["state"].ToString() == "1")
                {
                    sql = string.Format(@"update tf_trouble t set t.process_id='6',t.handle_state='2' where t.id='{0}'", row["id"].ToString());
                    ToflyExtendDbHelper.GetInstance().ExecuteOneSql(sql);
                    //sql_list.Add(sql);
                }
                //else if (row["state"].ToString() == "3" && !string.IsNullOrEmpty(row["cljgtxr"].ToString()))
                //{
                //    sql = string.Format(@"update third_trouble@third_trouble_dblink t set  t.state=2 where t.id='{0}' and t.cljgtxr is not null", row["id"].ToString());
                //    ToflyExtendDbHelper.GetInstance().ExecuteOneSql(sql);
                //    //sql_list.Add(sql);
                //}
                else if (row["state"].ToString() == "3")
                {
                    sql = string.Format(@"update tf_trouble t set  t.handle_state=3 where t.id='{0}' and t.handle_state=2", row["id"].ToString());
                    ToflyExtendDbHelper.GetInstance().ExecuteOneSql(sql);
                    //sql_list.Add(sql);
                }



                //if (row["state"].ToString() == "2")
                //{
                //    sql = string.Format(@"update tf_trouble t set t.process_id='8',t.handle_state=1,t.handle_username='{0}', t.handle_result='{1}',t.handle_time= to_date('{2}', 'yyyy/MM/dd  HH24:MI:SS') where t.id='{3}'", row["cljgtxr"].ToString(), row["cljg"].ToString(), row["cljgtxsj"].ToString(), row["id"].ToString());
                //    ToflyExtendDbHelper.GetInstance().ExecuteOneSql(sql);
                //    // sql_list.Add(sql);
                //    sql = string.Format(@"update third_trouble@third_trouble_dblink t set t.is_xjsync='1' where t.id='{0}'", row["id"].ToString());
                //    //sql = string.Format(@"update third_trouble@third_trouble_dblink t set t.state=2 where t.id='{0}'", row["id"].ToString());
                //    ToflyExtendDbHelper.GetInstance().ExecuteOneSql(sql);
                //   // sql_list.Add(sql);
                //}
                //else if (row["state"].ToString() == "1")
                //{
                //    sql = string.Format(@"update tf_trouble t set t.process_id='6',t.handle_state='2' where t.id='{0}'", row["id"].ToString());
                //    ToflyExtendDbHelper.GetInstance().ExecuteOneSql(sql);
                //    //sql_list.Add(sql);
                //}
                //else if (row["state"].ToString() == "3" && !string.IsNullOrEmpty(row["cljgtxr"].ToString()))
                //{
                //    sql = string.Format(@"update third_trouble@third_trouble_dblink t set  t.state=2 ,t.is_xjsync='1' where t.id='{0}' and t.cljgtxr is not null", row["id"].ToString());
                //    ToflyExtendDbHelper.GetInstance().ExecuteOneSql(sql);
                //    //sql_list.Add(sql);
                //}
                //else if (row["state"].ToString() == "3")
                //{
                //    sql = string.Format(@"update tf_trouble t set  t.handle_state=3 where t.id='{0}' and t.handle_state=2", row["id"].ToString());
                //    ToflyExtendDbHelper.GetInstance().ExecuteOneSql(sql);
                //    //sql_list.Add(sql);
                //}
            }
            #endregion
        }

        private static void CalLenth()
        {
            string sql = string.Empty;
            sql = string.Format(@"select max(a.id) tempid
                                  from tf_plan_point_temp a
                                  left join tf_plan_point_type b
                                    on a.device_type_id = b.device_type_id
                                 where a.pipe_length is null
                                   and b.type = '1'
                                 group by a.child_plan_id,a.id");
            DataTable dt = ToflyExtendDbHelper.GetInstance().ExecuteSql(sql);
            List<string> list = new List<string>();
            foreach (DataRow row in dt.Rows)
            {
                try
                {
                    sql = string.Format(@"select * from tf_plan_path_temp t where t.temp_id='{0}' order by t.num",row["tempid"].ToString());
                    DataTable paths = ToflyExtendDbHelper.GetInstance().ExecuteSql(sql);

                    int k=0 ;
                    double lat1 = 0;
                    double lng1 = 0;
                    double lat2 = 0;
                    double lng2 = 0;
                    double total = 0;
                    foreach (DataRow row1 in paths.Rows)
                    {
                        if (k == 0)
                        {
                            lat1 = double.Parse(row1["lat"].ToString());
                            lng1 = double.Parse(row1["lng"].ToString());
                        }
                        else
                        {
                            lat2 = lat1;
                            lng2 = lng1;

                            lat1 = double.Parse(row1["lat"].ToString());
                            lng1 = double.Parse(row1["lng"].ToString());
                         
                            total += GpsHelper.Distance(lat1, lng1, lat2, lng2);
                        }
                        k++;
                    }
                    sql = string.Format("update tf_plan_point_temp set PIPE_LENGTH={0} where id='{1}'", total, row["tempid"].ToString());
                    list.Add(sql);

                }
                catch (Exception ex)
                {
                    throw ex;
                }
            }
            try
            {
                ToflyExtendDbHelper.GetInstance().ExcuteBatchCommand(list);
            }
            catch (Exception ex)
            {
                throw ex;
            }

        }

        /// <summary>
        /// 自动复制签退签到
        /// </summary>
        /// <param name="start_date"></param>
        /// <param name="sql"></param>
        /// <param name="end_date"></param>
        private static void AutoSign(string start_date,string sql,string end_date)
        {
            DateTime _start_date = DateTime.Parse(start_date).AddDays(-1);
            DateTime _end_date = DateTime.Parse(end_date).AddDays(-1);
            decimal on_num = 0;
            decimal off_num = 0;

         
            string str_start_date = _start_date.ToString("yyyy/MM/dd");
            string default_off = string.Format("{0} 23:59:59", str_start_date);
            string default_on = string.Format("{0} 00:00:01", start_date);

            //sql = string.Format("select * from tf_pda_monitor t left join tf_pda_user t1 on t.userid=t1.userid where t.monitor_date=to_date('{0}', 'yyyy/MM/dd') and t.isautosign is null and t.work_state<>5 ", str_start_date);
            sql = string.Format("select * from tf_pda_monitor t left join tf_pda_user t1 on t.userid=t1.userid where t.monitor_date=to_date('{0}', 'yyyy/MM/dd') and t.isautosign is null", str_start_date);
            DataTable dt = ToflyExtendDbHelper.GetInstance().ExecuteSql(sql);
            
            try
            {
                foreach (DataRow row in dt.Rows)
                {
                    if (row["userid"].ToString() == "0B5E385DA3B04B32A1E160CDD2544129" && row["work_state"].ToString() == "5")
                        continue;
                    if (row["userid"].ToString() == "3EB3BA1F85EC43F88E74649EF88781E4" && row["work_state"].ToString() == "5")
                        continue;
                    #region 自动签到签退
                    sql = string.Format(@"select (select nvl(count(*),0)  from tf_pda_sign t
                                       where t.sign_time >= to_date( '{0}',' yyyy / MM / dd HH24: MI :SS ')
                                         and t.sign_time <= to_date( '{1}',' yyyy / MM / dd HH24: MI :SS ')
                                         and t.userid = '{2}' and t.sign_type='1')on_num, 
                                    (select nvl(count(*),0)  from tf_pda_sign t
                                       where t.sign_time >= to_date( '{0}',' yyyy / MM / dd HH24: MI :SS ')
                                         and t.sign_time <= to_date( '{1}',' yyyy / MM / dd HH24: MI :SS ')
                                         and t.userid = '{2}' and t.sign_type='2')off_num from dual", _start_date, _end_date, row["userid"].ToString());
                    DataTable dt1 = ToflyExtendDbHelper.GetInstance().ExecuteSql(sql);

                    on_num = decimal.Parse(dt1.Rows[0]["on_num"].ToString());
                    off_num = decimal.Parse(dt1.Rows[0]["off_num"].ToString());
                    if (on_num > 0 && on_num > off_num)
                    {
                        #region 自动下班
                        //插入设备下班日志
                        sql = string.Format(@"insert into tf_pda_device_upload(
                                        id, userid, gps_state, network_state,check_time, upload_time,
                                        work_state,  network_type,electricity, gps_precision, gps_star,
                                        residual_space,carid, gps_type,pdaid,software_ver) values
                                        (SYS_GUID(), '{0}','{1}','{2}',to_date('{3}','yyyy/MM/dd HH24:MI:SS'),
                                        sysdate,3,'{4}','{5}', '{6}', '{7}', '{8}', '{9}', '{10}', '{11}', '{12}')",
                                            row["userid"].ToString(), row["gps_state"].ToString(), row["network_state"].ToString(),
                                            default_off, row["network_type"].ToString(), row["electricity"].ToString(), row["gps_precision"].ToString()
                                            , row["gps_star"].ToString(), row["residual_space"].ToString(), row["carid"].ToString(), row["gps_type"].ToString()
                                            , row["pdaid"].ToString(), row["software_ver"].ToString());
                        ToflyExtendDbHelper.GetInstance().ExecuteOneSql(sql);
                        //插入签退数据
                        sql = string.Format(@"insert into tf_pda_sign t
                                            (t.id,
                                             t.userid,
                                             t.sign_time,
                                             t.padid,
                                             t.sign_address,
                                             t.sign_type,
                                             t.location_longitude,
                                             t.location_latitude,
                                             t.companyid,
                                             t.flag,
                                             t.section,
                                             t.software_ver)
                                          values
                                            (sys_guid(), '{0}', to_date( '{1}','yyyy/MM/dd HH24:MI:SS'), '{2}', '', 2,'{3}', '{4}', '{5}', 2, '{6}', '{7}')",
                                              row["userid"].ToString(), default_off, row["pdaid"].ToString(), row["lng"].ToString(), row["lat"].ToString(), 
                                              row["companyid"].ToString(), on_num, row["software_ver"].ToString());
                        ToflyExtendDbHelper.GetInstance().ExecuteOneSql(sql);
                        //用户上线未离线状态
                        sql = string.Format(@"update tf_pda_user t set t.online_state=1 where t.userid='{0}'", row["userid"].ToString());
                        ToflyExtendDbHelper.GetInstance().ExecuteOneSql(sql); 
                        #endregion

                        #region 自动上班
                        //插入设备上班日志
                        sql = string.Format(@"insert into tf_pda_device_upload(
                                        id, userid, gps_state, network_state,check_time, upload_time,
                                        work_state,  network_type,electricity, gps_precision, gps_star,
                                        residual_space,carid, gps_type,pdaid,software_ver) values
                                        (SYS_GUID(), '{0}','{1}','{2}',to_date('{3}','yyyy/MM/dd HH24:MI:SS'),
                                        sysdate,1,'{4}','{5}', '{6}', '{7}', '{8}', '{9}', '{10}', '{11}', '{12}')",
                                            row["userid"].ToString(), row["gps_state"].ToString(), row["network_state"].ToString(),
                                            default_on, row["network_type"].ToString(), row["electricity"].ToString(), row["gps_precision"].ToString()
                                            , row["gps_star"].ToString(), row["residual_space"].ToString(), row["carid"].ToString(), row["gps_type"].ToString(), row["pdaid"].ToString(), row["software_ver"].ToString());
                        ToflyExtendDbHelper.GetInstance().ExecuteOneSql(sql);
                        //插入签到数据
                        sql = string.Format(@"insert into tf_pda_sign t
                                            (t.id,
                                             t.userid,
                                             t.sign_time,
                                             t.padid,
                                             t.sign_address,
                                             t.sign_type,
                                             t.location_longitude,
                                             t.location_latitude,
                                             t.companyid,
                                             t.flag,
                                             t.section,
                                             t.software_ver)
                                          values
                                            (sys_guid(), '{0}', to_date( '{1}','yyyy/MM/dd HH24:MI:SS'), '{2}', '', 1,'{3}', '{4}', '{5}', 2, 1,'{6}')",
                                              row["userid"].ToString(), default_on, row["pdaid"].ToString(), row["lng"].ToString(), row["lat"].ToString(), row["companyid"].ToString(), row["software_ver"].ToString());
                        ToflyExtendDbHelper.GetInstance().ExecuteOneSql(sql); 
                        #endregion

                    }
                    #endregion

                    #region 自动签到
                    ////当天轨迹判断
                    ///decimal gps_num = 0;
                    ///decimal sign_num = 0;
                    //sql = string.Format(@"select count(*) gps_num
                    //                        from tf_gps_upload t
                    //                       where t.check_time >=
                    //                             to_date('{0}','yyyy/MM/dd HH24:MI:SS')
                    //                         and t.check_time <=
                    //                             to_date('{1}','yyyy/MM/dd HH24:MI:SS')
                    //                         and t.userid = '{2}'", start_date, end_date, row["userid"].ToString());
                    //dt1 = ToflyExtendDbHelper.GetInstance().ExecuteSql(sql);
                    //gps_num = decimal.Parse(dt1.Rows[0]["gps_num"].ToString());
                    ////当前签到判断
                    //sql = string.Format(@"select count(*) sign_num
                    //                        from tf_pda_sign t
                    //                       where t.sign_time >= to_date('{0}','yyyy / MM / dd HH24 :MI :SS ')
                    //                         and t.sign_time <= to_date('{1}','yyyy / MM / dd HH24 :MI :SS ')
                    //                         and t.userid = '{2}'", start_date, end_date, row["userid"].ToString());
                    //dt1 = ToflyExtendDbHelper.GetInstance().ExecuteSql(sql);
                    //sign_num = decimal.Parse(dt1.Rows[0]["sign_num"].ToString());
                    //if (gps_num > 0 && sign_num == 0)
                    //{
                    //    //插入设备上班日志
                    //    sql = string.Format(@"insert into tf_pda_device_upload(
                    //                    id, userid, gps_state, network_state,check_time, upload_time,
                    //                    work_state,  network_type,electricity, gps_precision, gps_star,
                    //                    residual_space,carid, gps_type,pdaid) values
                    //                    (SYS_GUID(), '{0}','{1}','{2}',to_date('{3}','yyyy/MM/dd HH24:MI:SS'),
                    //                    sysdate,1,'{4}','{5}', '{6}', '{7}', '{8}', '{9}', '{10}', '{11}')",
                    //                        row["userid"].ToString(), row["gps_state"].ToString(), row["network_state"].ToString(),
                    //                        default_on, row["network_type"].ToString(), row["electricity"].ToString(), row["gps_precision"].ToString()
                    //                        , row["gps_star"].ToString(), row["residual_space"].ToString(), row["carid"].ToString(), row["gps_type"].ToString(), row["pdaid"].ToString());
                    //    ToflyExtendDbHelper.GetInstance().ExecuteOneSql(sql);
                    //    //插入签到数据
                    //    sql = string.Format(@"insert into tf_pda_sign t
                    //                        (t.id,
                    //                         t.userid,
                    //                         t.sign_time,
                    //                         t.padid,
                    //                         t.sign_address,
                    //                         t.sign_type,
                    //                         t.location_longitude,
                    //                         t.location_latitude,
                    //                         t.companyid,
                    //                         t.flag,
                    //                         t.section)
                    //                      values
                    //                        (sys_guid(), '{0}', to_date( '{1}','yyyy/MM/dd HH24:MI:SS'), '{2}', '', 1,'{3}', '{4}', '{5}', 2, 1)",
                    //                          row["userid"].ToString(), default_on, row["pdaid"].ToString(), row["lng"].ToString(), row["lat"].ToString(), row["companyid"].ToString());
                    //    ToflyExtendDbHelper.GetInstance().ExecuteOneSql(sql);
                    //} 

                    #endregion

                    sql = string.Format(@"update tf_pda_monitor t set t.isautosign=1 where t.id='{0}'", row["id"].ToString());
                    ToflyExtendDbHelper.GetInstance().ExecuteOneSql(sql);
                }
            }
            catch (Exception e)
            {
                Logger.WriteErrorLog("自动签退、签到" + "\r\n" + e.Message + "\r\n" + e.StackTrace);
            }
        }


        /// <summary>
        /// 自动复制
        /// </summary>
        /// <param name="start_date"></param>
        /// <param name="sql"></param>
        /// <param name="end_date"></param>
        private static void AutoCopy(string start_date, string sql, string end_date)
        {
            try
            {
               
                string _start_date = string.Format("{0} {1}", start_date,DateTime.Now.ToString("HH:MM:ss"));
                string msg = string.Empty;
                //sql = string.Format(@"select a.*,
                //                             b.type,
                //                             c.period_name,
                //                             c.period_type
                //                          from tf_plan_child a
                //                          left join tf_plan_point_type b  
                //                          on a.device_type_id=b.device_type_id
                //                          left join tf_plan_period_type c 
                //                          on c.period_id=a.period_id
                //                          where  a.child_begin_date <=
                //                               to_date('{0}', 'yyyy/MM/dd HH24:MI:SS')
                //                           and a.child_end_date >=
                //                               to_date('{1}', 'yyyy/MM/dd HH24:MI:SS') and a.copy_state=1 ", _start_date, end_date);

                sql = string.Format(@"select a.*,
                                             b.type,
                                             c.period_name,
                                             c.period_type
                                          from tf_plan_child a
                                          left join tf_plan_point_type b  
                                          on a.device_type_id=b.device_type_id
                                          left join tf_plan_period_type c 
                                          on c.period_id=a.period_id
                                          where  a.copy_state=1 and a.child_plan_state=2  and a.copy_num>0 ");
               

                //sql = string.Format(@"select a.*,
                //                      b.type,
                //                      c.period_name,
                //                      c.period_type
                //                 from tf_plan_child a
                //                 left join tf_plan_point_type b
                //                   on a.device_type_id = b.device_type_id
                //                 left join tf_plan_period_type c
                //                   on c.period_id = a.period_id
                //                where a.copy_state = 1
                //                  and a.copy_num > 0
                //                  and a.child_begin_date >=
                //                      to_date('2018/12/1 0:00:00',
                //                              'yyyy/MM/dd HH24:MI:SS')
                //                  and a.child_end_date <=
                //                      to_date('2018/12/7 23:59:59',
                //                              'yyyy/MM/dd HH24:MI:SS')
                //                  and a.companyid = '113'
                //                  and a.device_type_id = '6'");
                //sql = @"select a.*, b.type, c.period_name, c.period_type
                //              from tf_plan_child a
                //              left join tf_plan_point_type b
                //                on a.device_type_id = b.device_type_id
                //              left join tf_plan_period_type c
                //                on c.period_id = a.period_id
                //             where a.copy_state = 1
                //               and a.child_plan_state = 3
                //               and a.copy_num > 0
                //               and a.companyid = '113'
                //               and a.period_id = '3'
                //               and a.percent = 1
                //               and a.userid not in ('5E682431CCD6C708E0530B9762C0E73D',
                //                                    '5E682431CD5FC708E0530B9762C0E73D')";

                //sql = @"select a.*, b.type, c.period_name, c.period_type
                //              from tf_plan_child a
                //              left join tf_plan_point_type b
                //                on a.device_type_id = b.device_type_id
                //              left join tf_plan_period_type c
                //                on c.period_id = a.period_id
                //             where a.copy_state = 2
                //               and a.child_plan_state = 3
                //               and a.copy_num > 0
                //               and a.companyid = '113'
                //               and a.period_id = '3'
                //               and a.percent = 1
                //               and a.userid not in ('5E682431CCD6C708E0530B9762C0E73D',
                //                                    '5E682431CD5FC708E0530B9762C0E73D')
                //               and a.child_begin_date >=
                //                   to_date('2018/7/8 0:00:00', 'yyyy/MM/dd HH24:MI:SS')
                //               and a.child_end_date <=
                //                   to_date('2018/7/14 23:59:59', 'yyyy/MM/dd HH24:MI:SS')
                //               and a.device_type_id = '4'";
                DataTable dt = ToflyExtendDbHelper.GetInstance().ExecuteSql(sql);

                //2019-05-05 增加日志记录
                Logger.WriteLog("循环的日志列表：数量:" + dt.Rows.Count);

                string[] pipeArr = new string[] { "9", "10", "11", "12", "13", "14", "18" };//次高压管线、中压管线、低压管线、高压管线、次高压管线、中压管线、高压管线
                string[] boosterArr = new string[] { "2", "3" };//调压箱、调压柜
                string[] valveArr = new string[] { "4" };//阀门
                string[] valveCellArr = new string[] { "7" };//阀室
                string[] pointArr = new string[] { "1", "6" };//巡检点、巡检线
                string tablename = string.Empty;
                List<CollectModel> listCorrect = new List<CollectModel>();
                string plan_id = string.Empty;
                string companyid = string.Empty;
                string device_type_id = string.Empty;
                string type = string.Empty;
                string iscorrect = ConfigurationManager.AppSettings["isautocopy"] ?? "0";

                foreach (DataRow row in dt.Rows)
                {
                    List<DbCommand> DbCommand = new List<DbCommand>();
                    DateTime now = DateTime.Now;
                    //DateTime beforeDay = DateTime.Parse(row["child_end_date"].ToString());
                    //if (now.ToString("yyyy/MM/dd") != beforeDay.ToString("yyyy/MM/dd"))
                    //    continue;
                    plan_id = row["child_plan_id"].ToString();
                    companyid = row["companyid"].ToString();
                    device_type_id = row["device_type_id"].ToString();
                    type = row["type"].ToString();
                    
                    try
                    {
                        TF_PLAN_CHILD entity = new TF_PLAN_CHILD();
                        entity.CREATE_USER = row["create_user"].ToString();
                        entity.CREATE_TIME = now;
                        entity.COMPANYID = companyid;
                        entity.PLAN_MODE = string.IsNullOrEmpty(row["plan_mode"].ToString()) ? 0 : decimal.Parse(row["plan_mode"].ToString());
                        entity.REGION_ID = row["region_id"].ToString();
                        entity.USERID = row["userid"].ToString();
                        entity.DEVICE_TYPE_ID = row["device_type_id"].ToString();
                        entity.PERIOD_ID = row["period_id"].ToString();
                        entity.INTERVAL_DAYS = string.IsNullOrEmpty(row["interval_days"].ToString()) ? 0 : decimal.Parse(row["interval_days"].ToString());
                        entity.N = string.IsNullOrEmpty(row["n"].ToString()) || row["n"].ToString() == "0" ? 1 : decimal.Parse(row["n"].ToString());
                        DateTime? child_begin_date = DateTime.Parse(row["child_begin_date"].ToString());
                        DateTime? child_end_date = DateTime.Parse(row["child_end_date"].ToString());
                        int n = (int)entity.N;
                        SyncMonitor.Common.GetStartEndDate.getMonth(row["period_name"].ToString(), ref child_begin_date, ref child_end_date, n);
                        entity.CHILD_BEGIN_DATE = child_begin_date;
                        entity.CHILD_END_DATE = child_end_date;
                        entity.N = 0;
                        entity.DESCRIPTION = row["description"].ToString();
                        entity.ISJURISDICTION = string.IsNullOrEmpty(row["isjurisdiction"].ToString()) ? 0 : decimal.Parse(row["isjurisdiction"].ToString());
                        entity.MAP_RANGE = row["map_range"].ToString();
                        entity.PLAN_NAME = row["plan_name"].ToString();
                        entity.PLAN_TYPE = string.IsNullOrEmpty(row["plan_type"].ToString()) ? 0 : decimal.Parse(row["plan_type"].ToString());
                        entity.LAST_TIME = now;
                        decimal copy_num = 0;
                        copy_num = decimal.Parse(row["copy_num"].ToString());
                        entity.COPY_NUM = copy_num - 1;
                        if (copy_num < 0)
                            entity.COPY_NUM = 0;
                        entity.COPY_STATE = 1;
                        entity.PERIOD_TYPE = string.IsNullOrEmpty(row["period_type"].ToString()) ? 0 : decimal.Parse(row["period_type"].ToString());
                        entity.TYPE = string.IsNullOrEmpty(row["type"].ToString()) ? 0 : decimal.Parse(row["type"].ToString());

                        if (now < entity.CHILD_BEGIN_DATE)
                            entity.CHILD_PLAN_STATE = 1;
                        else
                            entity.CHILD_PLAN_STATE = 2;

                        #region 校正计划内容
                        sql = string.Empty;

                        if (entity.REGION_ID != "1")
                        {
                            if (pipeArr.Contains(device_type_id) && iscorrect == "1")
                            {
                                tablename = "PIPESECTION";
                                //校正管线
                                if (companyid == "113")
                                    tablename = "PIPESECTION_GW";
                                //区分管线图层名
                                string[] pipeArrmp = new string[] { "10", "14" };//中压管线
                                string[] pipeArrip = new string[] { "9", "13" };//次高压管线
                                string[] pipeArrlp = new string[] { "11" };//低压管线
                                string[] pipeArrhp = new string[] { "12", "18" };//高压管线
                                string nickname = string.Empty;
                                if (pipeArrmp.Contains(device_type_id))
                                {
                                    nickname = "pipesectionmp";
                                }
                                else if (pipeArrip.Contains(device_type_id))
                                {
                                    nickname = "pipesectionip";
                                }
                                else if (pipeArrlp.Contains(device_type_id))
                                {
                                    nickname = "pipesectionlp";
                                }
                                else if (pipeArrhp.Contains(device_type_id))
                                {
                                    nickname = "pipesectionhp";
                                }

                                sql = string.Format(@"select t.id,t.point_id
                                          from tf_plan_point_temp t
                                         where t.child_plan_id = '{0}'
                                           and replace(t.point_id, '{2}-', '')<>'null'
                                           and replace(t.point_id, '{2}-', '') <> 'undefined'
                                           and not exists (select t1.sid from {1}@SDE_JXW_CS_DBLINK t1
                                         where t1.sid = replace(t.point_id, '{2}-', ''))", plan_id, tablename, nickname);

                            }
                            else if (boosterArr.Contains(device_type_id) && iscorrect == "1")
                            {
                                tablename = "BOOSTER";
                                //校正调压箱
                                if (companyid == "113")
                                    tablename = "BOOSTER_GW";

                                sql = string.Format(@"select t.id,t.point_id
                                          from tf_plan_point_temp t
                                         where t.child_plan_id = '{0}'
                                           and replace(t.point_id, 'booster-', '')<>'null'
                                           and replace(t.point_id, 'booster-', '') <> 'undefined'
                                            and not exists (select t1.sid from {1}@SDE_JXW_CS_DBLINK t1
                                         where t1.sid = replace(t.point_id, 'booster-', ''))", plan_id, tablename);
                            }
                            else if (valveArr.Contains(device_type_id) && iscorrect == "1")
                            {
                                tablename = "VALVE";
                                //校正阀门
                                if (companyid == "113")
                                    tablename = "VALVE_GW";

                                sql = string.Format(@"select t.id,t.point_id
                                          from tf_plan_point_temp t
                                         where t.child_plan_id = '{0}'
                                           and replace(t.point_id, 'valve-', '')<>'null'
                                           and replace(t.point_id, 'valve-', '') <> 'undefined'
                                           and not exists (select t1.sid from {1}@SDE_JXW_CS_DBLINK t1
                                         where t1.sid = replace(t.point_id, 'valve-', ''))", plan_id, tablename);

                            }
                            else if (valveCellArr.Contains(device_type_id) && iscorrect == "1")
                            {
                                tablename = "VALVECELL";
                                //校正阀室
                                if (companyid == "113")
                                    tablename = "VALVE_GW";

                                sql = string.Format(@"select t.id,t.point_id
                                          from tf_plan_point_temp t
                                         where t.child_plan_id = '{0}'
                                           and replace(t.point_id, 'fswall-', '')<>'null'
                                           and replace(t.point_id, 'fswall-', '') <> 'undefined'
                                           and not exists (select t1.sid from {1}@SDE_JXW_CS_DBLINK t1
                                         where t1.sid = replace(t.point_id, 'fswall-', ''))", plan_id, tablename);
                            }
                            else if (pointArr.Contains(device_type_id) && iscorrect == "1")
                            {
                                tablename = "tf_plan_point";
                                sql = string.Format(@"select t.id,t.point_id
                                          from tf_plan_point_temp t
                                         where t.child_plan_id = '{0}'
                                           and t.point_id<>'null'
                                           and t.point_id <> 'undefined'
                                           and not exists (select t1.point_id from {1} t1
                                         where t1.point_id = t.point_id  and t1.valid=1)", plan_id, tablename);
                            }
                        }

                        if (!string.IsNullOrEmpty(sql))
                        {
                            DataTable dtCorrect = ToflyExtendDbHelper.GetInstance().ExecuteSql(sql);
                            listCorrect = (List<CollectModel>)DataTableToListHelper.ToList<CollectModel>(dtCorrect);
                        }
                        var ids = listCorrect.Select(m => m.point_id);
                        List<GeoClass> list = new List<GeoClass>();
                        List<GeoClassPath> listPath = new List<GeoClassPath>();

                        List<GeoClass> list1 = new List<GeoClass>();
                        List<GeoClassPath> listPath1 = new List<GeoClassPath>();

                        if (type == "0")
                        {
                            list = JsonConvert.DeserializeObject<List<GeoClass>>(row["point_info"].ToString().Trim().TrimStart('"').TrimEnd('"'));
                            if (ids.Count() > 0)
                            {
                                list1 = list.Where(m => ids.Contains(m.sid)).ToList();
                                list = list.Where(m => !ids.Contains(m.sid)).ToList();
                                entity.POINT_INFO = JsonConvert.SerializeObject(list);
                            }
                            else
                            {
                                entity.POINT_INFO = row["point_info"].ToString();
                            }
                        }
                        else
                        {
                            listPath = JsonConvert.DeserializeObject<List<GeoClassPath>>(row["point_info"].ToString().Trim().TrimStart('"').TrimEnd('"'));
                            if (ids.Count() > 0)
                            {
                                listPath1 = listPath.Where(m => ids.Contains(m.sid)).ToList();
                                listPath = listPath.Where(m => !ids.Contains(m.sid)).ToList();
                                entity.POINT_INFO = JsonConvert.SerializeObject(listPath);
                            }
                            else
                            {
                                entity.POINT_INFO = row["point_info"].ToString();
                            }
                        }
                        #endregion


                        if (type == "0")
                            list = JsonConvert.DeserializeObject<List<GeoClass>>(entity.POINT_INFO.Trim().TrimStart('"').TrimEnd('"'));
                        else
                            listPath = JsonConvert.DeserializeObject<List<GeoClassPath>>(entity.POINT_INFO.Trim().TrimStart('"').TrimEnd('"'));

                        #region 参数配置

                        sql = string.Format("select * from TF_SYS_DEVICE_SETTING t where t.child_plan_id='{0}'", plan_id);
                        DataTable dt1 = ToflyExtendDbHelper.GetInstance().ExecuteSql(sql);
                        List<Setting_Plan> _settingPlan = new List<Setting_Plan>();
                        foreach (DataRow row1 in dt1.Rows)
                        {
                            Setting_Plan _setting = new Setting_Plan();
                            _setting.cnname = row1["cnname"].ToString();
                            _setting.enname = row1["enname"].ToString();
                            _setting.type = decimal.Parse(row1["para_type"].ToString());
                            _setting.isphoto = decimal.Parse(row1["isphoto"].ToString());
                            _settingPlan.Add(_setting);
                        }
                        #endregion

                        //2019-05-05 增加日志记录
                        Logger.WriteLog("循环的日志列表：copy_from_plan:" + plan_id);

                        DbCommand.Add(ToflyExtendDbHelper.GetInstance().UpdatePlanCommand(plan_id));
                        DbCommand.AddRange(Add_Plan_Point_Command(entity, list, listPath, type, ref msg, _settingPlan, true, list1, listPath1));
                        ToflyExtendDbHelper.GetInstance().ExecDB(DbCommand);
                    }
                    catch (Exception e)
                    {
                        Logger.WriteErrorLog("自动复制计划失败id：" + plan_id + "\r\n" + e.Message + "\r\n" + e.StackTrace);
                    }
                }
              
            }
            catch (Exception e)
            {
                Logger.WriteErrorLog("自动复制计划" + "\r\n" + e.Message + "\r\n" + e.StackTrace);
            }
        }



        /// <summary>
        /// 添加子计划、添加巡检点到临时表
        /// </summary>
        /// <param name="entity"></param>
        /// <param name="list"></param>
        /// <param name="listPath"></param>
        /// <param name="type"></param>
        /// <param name="msg"></param>
        /// <param name="settingplan"></param>
        /// <param name="allow"></param>
        /// <returns></returns>
        private static List<DbCommand> Add_Plan_Point_Command(TF_PLAN_CHILD entity, List<GeoClass> list, List<GeoClassPath> listPath, string type, ref string msg, List<Setting_Plan> settingplan, bool allow = true, List<GeoClass> list1 = null, List<GeoClassPath> listPath1 = null)
        {
            List<DbCommand> sql = new List<DbCommand>();
            int serial_number = 0; //确定巡检计划循环次数
            int addition_days = 0;//每次加多少天
            TimeSpan ts = entity.CHILD_END_DATE.Value - entity.CHILD_BEGIN_DATE.Value;

            switch (entity.PERIOD_ID)
            {
                case "1":
                    serial_number = (int)ts.TotalDays + 1;
                    addition_days = 1;
                    break;
                case "2":
                    serial_number = (int)(ts.TotalDays + 1) / 2;
                    addition_days = 2;
                    break;
            }

            if (entity.PERIOD_ID == "1" || entity.PERIOD_ID == "2")
            {
                sql = Add_Day_Plan_Command(entity, serial_number, addition_days, list, listPath, type, ref msg, settingplan, allow, list1, listPath1);
            }
            else
            {
                sql = Add_Plan_Command(entity, list, listPath, type, ref msg, settingplan, allow, list1, listPath1);
            }
            return sql;
        }

        protected static List<DbCommand> Add_Plan_Command(TF_PLAN_CHILD entity, List<GeoClass> list, List<GeoClassPath> listPath, string type, ref string msg, List<Setting_Plan> settingplan, bool allow, List<GeoClass> list1 = null, List<GeoClassPath> listPath1 = null)
        {
            List<DbCommand> DbCommand = new List<DbCommand>();
            DateTime now = DateTime.Now;
            TF_PLAN_CHILD entity_child = new TF_PLAN_CHILD();
            string child_plan_id = StringHelper.NewId;
            entity_child.CHILD_PLAN_ID = child_plan_id;
            int point_num = 0;
            if (entity.PERIOD_TYPE == 1)
            {
                entity_child.CHILD_BEGIN_DATE = entity.CHILD_BEGIN_DATE;
                entity_child.CHILD_END_DATE = entity.CHILD_END_DATE.Value;
            }
            else
            {
                entity_child.CHILD_BEGIN_DATE = entity.CHILD_BEGIN_DATE;
                entity_child.CHILD_END_DATE = entity.CHILD_END_DATE.Value.AddDays(1).AddSeconds(-1);
            }
            entity_child.PERIOD_ID = entity.PERIOD_ID;
            entity_child.DEVICE_TYPE_ID = entity.DEVICE_TYPE_ID;
            entity_child.CHILD_NUM = 0;
            entity_child.PERCENT = 0;
            entity_child.USERID = entity.USERID;
            entity_child.COMPANYID = entity.COMPANYID;
            entity_child.REGION_ID = entity.REGION_ID;
            entity_child.PERCENT1 = 0;
            entity_child.COPY_STATE = entity.COPY_STATE;
            entity_child.MAP_RANGE = entity.MAP_RANGE;
            entity_child.INTERVAL_DAYS = entity.INTERVAL_DAYS;
            entity_child.DESCRIPTION = entity.DESCRIPTION;
            entity_child.PLAN_NAME = entity.PLAN_NAME;
            entity_child.PLAN_MODE = entity.PLAN_MODE;
            entity_child.POINT_INFO = entity.POINT_INFO;
            entity_child.ISJURISDICTION = entity.ISJURISDICTION;
            if (entity_child.CHILD_BEGIN_DATE < now)
                entity_child.CHILD_PLAN_STATE = 2;
            else
                entity_child.CHILD_PLAN_STATE = 1;
            entity_child.CREATE_TIME = entity.CREATE_TIME;
            entity_child.CREATE_USER = entity.CREATE_USER;
            entity_child.LAST_TIME = entity.CREATE_TIME;
            entity_child.ISOVERTOTOTAL = 0;
            entity_child.ISOVERTOTOTAL1 = 0;
            entity_child.N = entity.N;
            entity_child.COPY_NUM = entity.COPY_NUM;
            entity_child.PLAN_TYPE = entity.PLAN_TYPE;
            entity_child.TYPE = entity.TYPE;

            //日志
            Logger.WriteLog("Add_Plan_Command：copy_from_plan:" + entity.CHILD_PLAN_ID + "copy_new_plan:" + child_plan_id);

            if (type == "1")
            {
                entity_child.TOTAL = (from a in listPath select Convert.ToDecimal(a.pipe_length)).Sum();//线总长度
                if (entity_child.TOTAL == 0 && entity_child.DEVICE_TYPE_ID == "6")
                {
                    var pointid = listPath.Select(m => m.sid);
                    StringBuilder arrStr = new StringBuilder();
                    int k = 0;
                    foreach (var a in pointid)
                    {
                        if (k == pointid.Count() - 1)
                            arrStr.Append(string.Format("'{0}'", a));
                        else
                            arrStr.Append(string.Format("'{0}',", a));
                        k++;
                    }
                    string sql = string.Format(@"select sum(t.pipe_length)pipe_length from tf_plan_point t where t.point_id in ({0})", arrStr.ToString());
                    DataTable dt = ToflyExtendDbHelper.GetInstance().ExecuteSql(sql);
                    entity_child.TOTAL = dt.Rows.Count == 0 ? 0 : decimal.Parse(dt.Rows[0][0].ToString());
                }
                else
                {
                    if (entity_child.TOTAL == 0)
                    {
                        var contents = listPath.Select(m => m.content);
                        double pipelength = 0;
                        foreach (var content in contents)
                        {
                            ContentModel contentsList = JsonConvert.DeserializeObject<ContentModel>(content.ToString().TrimStart('\'').TrimEnd('\'').TrimStart('"').TrimEnd('"'));
                            pipelength += contentsList.PIPELENGTH.Value;
                        }

                        entity_child.TOTAL = Convert.ToDecimal(pipelength);
                    }
                }
                entity_child.TOTAL1 = listPath.Count();//线条数
            }
            else
            {
                entity_child.TOTAL = list.Count();//点总长度
                entity_child.TOTAL1 = list.Count();//线总点数
                point_num = list.Count();
            }
         

            //添加配置参数
            if (settingplan != null)
            {
                if (settingplan.Count > 0)
                    DbCommand.AddRange(ToflyExtendDbHelper.GetInstance().AddSysDeviceSetting(settingplan, child_plan_id));
            }

            if (type == "0")
            {
                #region 巡检点
                foreach (var o in list)
                {
                    TF_PLAN_POINT_TEMP entity_temp = new TF_PLAN_POINT_TEMP();
                    entity_temp.ID = StringHelper.NewId;
                    entity_temp.POINT_ID = string.IsNullOrEmpty(o.sid) ? StringHelper.NewId : o.sid;
                    entity_temp.GEOMETRY = JsonConvert.SerializeObject(o.geometry);
                    entity_temp.CHILD_PLAN_ID = child_plan_id;
                    entity_temp.USERID = entity.USERID;
                    entity_temp.COMPANYID = entity.COMPANYID;
                    entity_temp.ISOVER = 0;
                    entity_temp.REGIONNAME = o.regionname;
                    entity_temp.CONTENT = o.content == null ? "" : entity_temp.CONTENT = o.content == null ? "" : o.content.TrimStart('\'').TrimEnd('\'').TrimStart('"').TrimEnd('"');
                    entity_temp.REGION_ID = entity.REGION_ID;
                    entity_temp.DEVICE_TYPE_ID = o.device_type_id;
                    entity_temp.NAME = o.name;
                    entity_temp.ADDRESS = o.address;
                    entity_temp.PERIOD_ID = entity.PERIOD_ID;
                    entity_temp.LAT = o.geometry.y;
                    entity_temp.LNG = o.geometry.x;
                    entity_temp.CODE = o.code;
                    entity_temp.TYPE = 0;
                    entity_temp.STATE = 0;
                    entity_temp.PIPE_LENGTH = "0";
                    entity_temp.RFID = o.rfid;
                    DbCommand.Add(ToflyExtendDbHelper.GetInstance().AddPointTempCommand(entity_temp));
                }

                //是否有纠正内容
                if (list1 != null)
                {
                    if (list1.Count > 0)
                        DbCommand.Add(ToflyExtendDbHelper.GetInstance().AddPlanCorrectCommand(child_plan_id, entity.CHILD_PLAN_ID, JsonConvert.SerializeObject(list1)));
                }
                #endregion
            }
            else
            {
                #region 巡检线
                foreach (var o in listPath)
                {
                    TF_PLAN_POINT_TEMP entity_temp = new TF_PLAN_POINT_TEMP();
                    entity_temp.ID = StringHelper.NewId;
                    entity_temp.POINT_ID = o.sid;
                    entity_temp.GEOMETRY = JsonConvert.SerializeObject(o.geometry);
                    entity_temp.CHILD_PLAN_ID = child_plan_id;
                    entity_temp.USERID = entity.USERID;
                    entity_temp.COMPANYID = entity.COMPANYID;
                    entity_temp.ISOVER = 0;
                    entity_temp.REGIONNAME = o.regionname;
                    entity_temp.CONTENT = o.content == null ? "" : entity_temp.CONTENT = o.content == null ? "" : o.content.TrimStart('\'').TrimEnd('\'').TrimStart('"').TrimEnd('"');
                    entity_temp.REGION_ID = entity.REGION_ID;
                    entity_temp.DEVICE_TYPE_ID = o.device_type_id;
                    entity_temp.NAME = o.name;
                    entity_temp.ADDRESS = o.address;
                    entity_temp.PERIOD_ID = entity.PERIOD_ID;
                    entity_temp.CODE = o.code;
                    entity_temp.TYPE = 1;
                    entity_temp.STATE = 0;
                    entity_temp.PIPE_LENGTH = o.pipe_length;
                    entity_temp.RFID = o.rfid;

                    GeometryPath paths = JsonConvert.DeserializeObject<GeometryPath>(JsonConvert.SerializeObject(o.geometry));
                    int k = 1;
                    foreach (var p in paths.paths[0])
                    {
                        TF_PLAN_PATH_TEMP pathTemp = new TF_PLAN_PATH_TEMP();
                        pathTemp.ID = StringHelper.NewId;
                        pathTemp.TEMP_ID = entity_temp.ID;
                        pathTemp.POINT_ID = entity_temp.POINT_ID;
                        pathTemp.LAT = (decimal)p[1];
                        pathTemp.LNG = (decimal)p[0];
                        pathTemp.ISOVER = 0;
                        pathTemp.NUM = k;
                        pathTemp.COMPANYID = entity_temp.COMPANYID;
                        pathTemp.CHILD_PLAN_ID = child_plan_id;
                        DbCommand.Add(ToflyExtendDbHelper.GetInstance().AddPathTempCommand(pathTemp));
                        k++;
                        point_num++;
                    }
                    DbCommand.Add(ToflyExtendDbHelper.GetInstance().AddPointTempCommand(entity_temp));
                }
                //是否有纠正内容
                if (listPath1 != null)
                {
                    if (listPath1.Count > 0)
                        DbCommand.Add(ToflyExtendDbHelper.GetInstance().AddPlanCorrectCommand(child_plan_id, entity.CHILD_PLAN_ID, JsonConvert.SerializeObject(listPath1)));
                }
                #endregion
            }
            entity_child.POINT_NUM = point_num;
            DbCommand.Add(ToflyExtendDbHelper.GetInstafnce().AddChildCommand(entity_child));
            return DbCommand;
        }
        protected static List<DbCommand> Add_Day_Plan_Command(TF_PLAN_CHILD entity, int serial_number, int addition_days, List<GeoClass> list, List<GeoClassPath> listPath, string type, ref string msg, List<Setting_Plan> settingplan, bool allow, List<GeoClass> list1 = null, List<GeoClassPath> listPath1 = null)
        {
            List<DbCommand> DbCommand = new List<DbCommand>();
            DateTime now = DateTime.Now;
            for (int i = 1; i <= serial_number; i++)
            {
                int point_num = 0;
                TF_PLAN_CHILD entity_child = new TF_PLAN_CHILD();
                string child_plan_id = StringHelper.NewId;
                entity_child.CHILD_PLAN_ID = child_plan_id;
                //日志
                Logger.WriteLog("Add_Day_Plan_Command：copy_from_plan:" + entity.CHILD_PLAN_ID + "copy_new_plan:" + child_plan_id + "serial_number:" + serial_number + "i:" + i);
                entity_child.CHILD_BEGIN_DATE = entity.CHILD_BEGIN_DATE.Value.AddDays(i - 1);
                entity_child.CHILD_END_DATE = entity.CHILD_BEGIN_DATE.Value.AddDays((i) * addition_days).AddSeconds(-1);
                entity_child.PERIOD_ID = entity.PERIOD_ID;
                entity_child.DEVICE_TYPE_ID = entity.DEVICE_TYPE_ID;
                entity_child.CHILD_NUM = i;
                entity_child.PERCENT = 0;
                entity_child.USERID = entity.USERID;
                entity_child.COMPANYID = entity.COMPANYID;
                entity_child.REGION_ID = entity.REGION_ID;
                entity_child.PERCENT1 = 0;
                entity_child.COPY_STATE = entity.COPY_STATE;
                entity_child.MAP_RANGE = entity.MAP_RANGE;
                entity_child.INTERVAL_DAYS = entity.INTERVAL_DAYS;
                entity_child.DESCRIPTION = entity.DESCRIPTION;
                entity_child.PLAN_NAME = entity.PLAN_NAME;
                entity_child.PLAN_MODE = entity.PLAN_MODE;
                entity_child.POINT_INFO = entity.POINT_INFO;
                entity_child.ISJURISDICTION = entity.ISJURISDICTION;
                if (entity_child.CHILD_BEGIN_DATE < now)
                    entity_child.CHILD_PLAN_STATE = 2;
                else
                    entity_child.CHILD_PLAN_STATE = 1;
                entity_child.CREATE_TIME = entity.CREATE_TIME;
                entity_child.CREATE_USER = entity.CREATE_USER;
                entity_child.LAST_TIME = entity.CREATE_TIME;
                entity_child.ISOVERTOTOTAL = 0;
                entity_child.ISOVERTOTOTAL1 = 0;
                entity_child.N = entity.N;
                entity_child.COPY_NUM = entity.COPY_NUM;
                entity_child.PLAN_TYPE = entity.PLAN_TYPE;
                entity_child.TYPE = entity.TYPE;
                if (type == "1")
                {
                    entity_child.TOTAL = (from a in listPath select Convert.ToDecimal(a.pipe_length)).Sum();//线总长度
                    if (entity_child.TOTAL == 0 && entity_child.DEVICE_TYPE_ID == "6")
                    {
                        var pointid = listPath.Select(m => m.sid);
                        StringBuilder arrStr = new StringBuilder();
                        int k = 0;
                        foreach (var a in pointid)
                        {
                            if (k == pointid.Count() - 1)
                                arrStr.Append(string.Format("'{0}'", a));
                            else
                                arrStr.Append(string.Format("'{0}',", a));
                            k++;
                        }
                        string sql = string.Format(@"select sum(t.pipe_length)pipe_length from tf_plan_point t where t.point_id in ({0})", arrStr.ToString());
                        DataTable dt = ToflyExtendDbHelper.GetInstance().ExecuteSql(sql);
                        entity_child.TOTAL = dt.Rows.Count == 0 ? 0 : decimal.Parse(dt.Rows[0][0].ToString());
                    }
                    else
                    {
                        if (entity_child.TOTAL == 0)
                        {
                            var contents = listPath.Select(m => m.content);
                            double pipelength = 0;
                            foreach (var content in contents)
                            {
                                ContentModel contentsList = JsonConvert.DeserializeObject<ContentModel>(content.ToString().TrimStart('\'').TrimEnd('\'').TrimStart('"').TrimEnd('"'));
                                pipelength += contentsList.PIPELENGTH.Value;
                            }

                            entity_child.TOTAL = Convert.ToDecimal(pipelength);
                        }
                    }
                    entity_child.TOTAL1 = listPath.Count();//线条数
                }
                else
                {
                    entity_child.TOTAL = list.Count();//线总点数
                    entity_child.TOTAL1 = list.Count();//线总点数
                    point_num = list.Count();
                }

              

                //添加配置参数
                if (settingplan != null)
                {
                    if (settingplan.Count > 0)
                        DbCommand.AddRange(ToflyExtendDbHelper.GetInstance().AddSysDeviceSetting(settingplan, child_plan_id));
                }

                if (type == "0")
                {
                    #region 巡检点
                    foreach (var o in list)
                    {
                        TF_PLAN_POINT_TEMP entity_temp = new TF_PLAN_POINT_TEMP();
                        entity_temp.ID = StringHelper.NewId;

                        entity_temp.POINT_ID = string.IsNullOrEmpty(o.sid) ? StringHelper.NewId : o.sid;
                        entity_temp.GEOMETRY = JsonConvert.SerializeObject(o.geometry);
                        entity_temp.CHILD_PLAN_ID = child_plan_id;
                        entity_temp.USERID = entity.USERID;
                        entity_temp.COMPANYID = entity.COMPANYID;
                        entity_temp.ISOVER = 0;
                        entity_temp.REGIONNAME = o.regionname;
                        entity_temp.CONTENT = o.content == null ? "" : o.content.TrimStart('\'').TrimEnd('\'').TrimStart('"').TrimEnd('"');
                        entity_temp.REGION_ID = entity.REGION_ID;
                        entity_temp.DEVICE_TYPE_ID = o.device_type_id;
                        entity_temp.NAME = o.name;
                        entity_temp.ADDRESS = o.address;
                        entity_temp.PERIOD_ID = entity.PERIOD_ID;
                        entity_temp.LAT = o.geometry.y;
                        entity_temp.LNG = o.geometry.x;
                        entity_temp.CODE = o.code;
                        entity_temp.TYPE = 0;
                        entity_temp.STATE = 0;
                        entity_temp.PIPE_LENGTH = "0";
                        entity_temp.RFID = o.rfid;
                        DbCommand.Add(ToflyExtendDbHelper.GetInstance().AddPointTempCommand(entity_temp));

                    }
                    //是否有纠正内容
                    if (list1 != null)
                    {
                        if (list1.Count > 0)
                            DbCommand.Add(ToflyExtendDbHelper.GetInstance().AddPlanCorrectCommand(child_plan_id, entity.CHILD_PLAN_ID, JsonConvert.SerializeObject(list1)));
                    }
                    #endregion
                }
                else
                {
                    #region 巡检线
                    foreach (var o in listPath)
                    {
                        TF_PLAN_POINT_TEMP entity_temp = new TF_PLAN_POINT_TEMP();
                        entity_temp.ID = StringHelper.NewId;
                        entity_temp.POINT_ID = o.sid;
                        entity_temp.GEOMETRY = JsonConvert.SerializeObject(o.geometry);
                        entity_temp.CHILD_PLAN_ID = child_plan_id;
                        entity_temp.USERID = entity.USERID;
                        entity_temp.COMPANYID = entity.COMPANYID;
                        entity_temp.ISOVER = 0;
                        entity_temp.REGIONNAME = o.regionname;
                        entity_temp.CONTENT = o.content == null ? "" : entity_temp.CONTENT = o.content == null ? "" : o.content.TrimStart('\'').TrimEnd('\'').TrimStart('"').TrimEnd('"');
                        entity_temp.REGION_ID = entity.REGION_ID;
                        entity_temp.DEVICE_TYPE_ID = o.device_type_id;
                        entity_temp.NAME = o.name;
                        entity_temp.ADDRESS = o.address;
                        entity_temp.PERIOD_ID = entity.PERIOD_ID;
                        entity_temp.CODE = o.code;
                        entity_temp.TYPE = 1;
                        entity_temp.STATE = 0;
                        entity_temp.PIPE_LENGTH = o.pipe_length;
                        entity_temp.RFID = o.rfid;
                        GeometryPath paths = JsonConvert.DeserializeObject<GeometryPath>(JsonConvert.SerializeObject(o.geometry));
                        int k = 1;
                        foreach (var p in paths.paths[0])
                        {
                            TF_PLAN_PATH_TEMP pathTemp = new TF_PLAN_PATH_TEMP();
                            pathTemp.ID = StringHelper.NewId;
                            pathTemp.TEMP_ID = entity_temp.ID;
                            pathTemp.POINT_ID = entity_temp.POINT_ID;
                            pathTemp.LAT = (decimal)p[1];
                            pathTemp.LNG = (decimal)p[0];
                            pathTemp.ISOVER = 0;
                            pathTemp.NUM = k;
                            pathTemp.COMPANYID = entity_temp.COMPANYID;
                            pathTemp.CHILD_PLAN_ID = child_plan_id;
                            DbCommand.Add(ToflyExtendDbHelper.GetInstance().AddPathTempCommand(pathTemp));
                            k++;
                            point_num++;
                        }
                        DbCommand.Add(ToflyExtendDbHelper.GetInstance().AddPointTempCommand(entity_temp));
                    }

                    //是否有纠正内容
                    if (listPath1 != null)
                    {
                        if (listPath1.Count > 0)
                            DbCommand.Add(ToflyExtendDbHelper.GetInstance().AddPlanCorrectCommand(child_plan_id, entity.CHILD_PLAN_ID, JsonConvert.SerializeObject(listPath1)));
                    }
                    #endregion
                }

                entity_child.POINT_NUM = point_num;
                DbCommand.Add(ToflyExtendDbHelper.GetInstance().AddChildCommand(entity_child));
            }
            return DbCommand;
        }

        #region 功能：[2019-04-23] 当巡检人员的登录账号有修改时，要同步修改隐患中间表的巡检人员账号信息
        /// <summary>
        /// 功能：当巡检人员的登录账号有修改时，要同步修改隐患中间表的巡检人员账号信息
        /// 作者：周金柱
        /// 时间：2019-04-23
        /// </summary>
        /// <param name="sql_list"></param>
        protected static void Up_Third_Trouble_User(ref List<string> sql_list)
        {
            //string querySql = string.Format(@"select a.id,a.loginid as newcode,b.usercode from (
            //            select a.id, b.loginid from tf_trouble a left join tf_pda_user b on a.userid = b.userid where b.loginid is not null) a
            //            left join third_trouble@THIRD_TROUBLE_DBLINK b on(b.id = a.id and b.USERCODE != a.loginid)
            //            where b.usercode is not null");

            //同步隐患数据
            string upSql = string.Format(@"update third_trouble@third_trouble_dblink c set usercode = 
                        (
                          select a.loginid from(
                          select a.id, b.loginid from tf_trouble a left join tf_pda_user b on a.userid = b.userid where b.loginid is not null) a
                          left join third_trouble@third_trouble_dblink b on(b.id = a.id and b.USERCODE != a.loginid)
                          where b.usercode is not null and a.id = c.id
                        ) where c.id in (select a.id from(
                        select a.id, b.loginid from tf_trouble a left join tf_pda_user b on a.userid = b.userid where b.loginid is not null) a
                        left join third_trouble@third_trouble_dblink b on(b.id = a.id and b.USERCODE != a.loginid)
                        where b.usercode is not null)");
            sql_list.Add(upSql);
        }
        #endregion

        #region 功能：获取灾备系统启用状态(True=>启动,False=>停用)
        /// <summary>
        /// 功能：获取灾备系统启用状态(True=>启动,False=>停用)
        /// </summary>
        /// <returns></returns>
        private static bool getZbState()
        {
            var isZbState = false;
            //获取灾备API
            var zbApi = ConfigurationManager.AppSettings["zbapi"] + "";      //灾备API
            if (string.IsNullOrWhiteSpace(zbApi))
            {
                return isZbState;
            }
            var jsonStr = doPostRequest(zbApi);
            if (string.IsNullOrWhiteSpace(jsonStr))
            {
                return isZbState;
            }
            var objJson = (JObject)JsonConvert.DeserializeObject(jsonStr);
            var _open = objJson["result"]["open"] + "";
            if (!string.IsNullOrWhiteSpace(_open))
            {
                isZbState = Boolean.Parse(_open);
                return isZbState;
            }
            return isZbState;
        }

        /// <summary>
        /// 功能：POST方式发送得结果
        /// </summary>
        /// <param name="url"></param>
        /// <param name="bData"></param>
        /// <returns></returns>
        private static string doPostRequest(string url)
        {
            System.Net.HttpWebRequest hwRequest;
            System.Net.HttpWebResponse hwResponse;

            string strResult = string.Empty;
            try
            {
                hwRequest = (System.Net.HttpWebRequest)System.Net.WebRequest.Create(url);
                hwRequest.Timeout = 5000;
                hwRequest.Method = "GET";
                hwRequest.ContentType = "application/x-www-form-urlencoded";//application/x-www-form-urlencoded
            }
            catch (System.Exception err)
            {
                return strResult;
            }

            //get response
            try
            {
                hwResponse = (HttpWebResponse)hwRequest.GetResponse();
                StreamReader srReader = new StreamReader(hwResponse.GetResponseStream(), Encoding.UTF8);
                strResult = srReader.ReadToEnd();
                srReader.Close();
                hwResponse.Close();
            }
            catch (System.Exception err)
            {
                //WriteErrLog(err.ToString());

            }

            return strResult;
        }
        #endregion
    }


    public class Setting_Plan
    {
        /// <summary>
        /// 参数中文名字[选填]
        /// </summary>
        public string cnname { get; set; }
        /// <summary>
        ///参数英文名字[选填]
        /// </summary>
        public string enname { get; set; }

        /// <summary>
        ///参数类型 0 选填 1 不用填 2 必填[选填] 
        /// </summary>
        public decimal? type { get; set; }
        /// <summary>
        ///是否拍照 0：选拍 1：必拍[选填] 
        /// </summary>
        public decimal? isphoto { get; set; }

    }

    public class ContentModel
    {
        /// <summary>
        /// 
        /// </summary>
        public double? PIPELENGTH { get; set; }


    }

    public  class TF_PLAN_CHILD
    {
        public string CHILD_PLAN_ID { get; set; }
        public Nullable<decimal> CHILD_NUM { get; set; }
        public Nullable<System.DateTime> CHILD_BEGIN_DATE { get; set; }
        public Nullable<System.DateTime> CHILD_END_DATE { get; set; }
        public string PERIOD_ID { get; set; }
        public string DEVICE_TYPE_ID { get; set; }
        public Nullable<decimal> PERCENT { get; set; }
        public Nullable<System.DateTime> LAST_TIME { get; set; }
        public string USERID { get; set; }
        public string COMPANYID { get; set; }
        public string REGION_ID { get; set; }
        public Nullable<decimal> CHILD_PLAN_STATE { get; set; }
        public Nullable<decimal> PERCENT1 { get; set; }
        public Nullable<decimal> TOTAL1 { get; set; }
        public Nullable<decimal> ISOVERTOTOTAL1 { get; set; }
        public Nullable<decimal> ISOVERTOTOTAL { get; set; }
        public Nullable<decimal> TOTAL { get; set; }
        public Nullable<decimal> COPY_STATE { get; set; }
        public string POINT_INFO { get; set; }
        public Nullable<decimal> PLAN_MODE { get; set; }
        public string PLAN_NAME { get; set; }
        public string MAP_RANGE { get; set; }
        public Nullable<decimal> ISJURISDICTION { get; set; }
        public Nullable<decimal> INTERVAL_DAYS { get; set; }
        public Nullable<decimal> N { get; set; }
        public string DESCRIPTION { get; set; }
        public Nullable<System.DateTime> CREATE_TIME { get; set; }
        public string CREATE_USER { get; set; }
        public Nullable<decimal> PERIOD_TYPE { get; set; }
        public Nullable<decimal> COPY_NUM { get; set; }
        public Nullable<decimal> POINT_NUM { get; set; }
        public Nullable<decimal> PLAN_TYPE { get; set; }

        public Nullable<decimal> TYPE { get; set; }
    }

    public  class TF_PLAN_POINT_TEMP
    {
        public string ID { get; set; }
        public string POINT_ID { get; set; }
        public Nullable<decimal> ISOVER { get; set; }
        public string CHILD_PLAN_ID { get; set; }
        public string USERID { get; set; }
        public string COMPANYID { get; set; }
        public string REGION_ID { get; set; }
        public string DEVICE_TYPE_ID { get; set; }
        public string PERIOD_ID { get; set; }
        public string GEOMETRY { get; set; }
        public string NAME { get; set; }
        public string ADDRESS { get; set; }
        public string REGIONNAME { get; set; }
        public Nullable<decimal> LAT { get; set; }
        public Nullable<decimal> LNG { get; set; }
        public Nullable<decimal> STATE { get; set; }
        public string TROUBLE_ID { get; set; }
        public Nullable<System.DateTime> OVER_DATE { get; set; }
        public Nullable<decimal> PATH_ISOVER { get; set; }
        public string NOTES { get; set; }
        public string CODE { get; set; }
        public string CONTENT { get; set; }
        public Nullable<decimal> GPS_SPEED { get; set; }
        public string PIPE_LENGTH { get; set; }
        public Nullable<decimal> TYPE { get; set; }
        public Nullable<decimal> SID { get; set; }

        public string RFID { get; set; }
    }

    public partial class TF_PLAN_PATH_TEMP
    {
        public string ID { get; set; }
        public string TEMP_ID { get; set; }
        public string POINT_ID { get; set; }
        public Nullable<decimal> LAT { get; set; }
        public Nullable<decimal> LNG { get; set; }
        public Nullable<decimal> ISOVER { get; set; }
        public Nullable<decimal> NUM { get; set; }
        public Nullable<System.DateTime> OVER_DATE { get; set; }
        public Nullable<decimal> PERCENT { get; set; }
        public Nullable<decimal> GPS_SPEED { get; set; }
        public string CHILD_PLAN_ID { get; set; }
        public Nullable<System.DateTime> FIRST_LEFT_TIME { get; set; }
        public Nullable<decimal> SID { get; set; }
        public Nullable<decimal> STATE { get; set; }

        public string COMPANYID { get; set; }
    }
    public class GeoClass
    {
        /// <summary>
        /// 
        /// </summary>
        public string sid { get; set; }
        /// <summary>
        /// 
        /// </summary>
        public Geometry geometry { get; set; }
        /// <summary>
        /// 
        /// </summary>
        public string name { get; set; }
        /// <summary>
        /// 
        /// </summary>
        public string address { get; set; }
        /// <summary>
        /// 
        /// </summary>
        public string device_type_id { get; set; }
        /// <summary>
        /// 
        /// </summary>
        public string regionname { get; set; }

        /// <summary>
        /// 
        /// </summary>
        public string code { get; set; }
        /// <summary>
        /// 
        /// </summary>
        public string content { get; set; }

        /// <summary>
        /// 
        /// </summary>
        public string pipe_length { get; set; }

        /// <summary>
        /// 
        /// </summary>
        public string rfid { get; set; }
    }

    /// <summary>
    /// 巡检线
    /// </summary>
    public class GeoClassPath
    {
        /// <summary>
        /// 
        /// </summary>
        public string sid { get; set; }
        /// <summary>
        /// 
        /// </summary>
        public GeometryPath geometry { get; set; }
        /// <summary>
        /// 
        /// </summary>
        public string name { get; set; }
        /// <summary>
        /// 
        /// </summary>
        public string address { get; set; }
        /// <summary>
        /// 
        /// </summary>
        public string device_type_id { get; set; }
        /// <summary>
        /// 
        /// </summary>
        public string code { get; set; }
        /// <summary>
        /// 
        /// </summary>
        public string regionname { get; set; }
        /// <summary>
        /// 
        /// </summary>
        public string pipe_length { get; set; }
        /// <summary>
        /// 
        /// </summary>
        public string content { get; set; }

        /// <summary>
        /// 
        /// </summary>
        public string rfid { get; set; }
    }

    /// <summary>
    /// 
    /// </summary>
    public class Geometry
    {
        /// <summary>
        /// 
        /// </summary>
        public decimal? x { get; set; }
        /// <summary>
        /// 
        /// </summary>
        public decimal? y { get; set; }

        /// <summary>
        /// 
        /// </summary>
        public SpatialReference spatialReference { get; set; }
    }

    /// <summary>
    /// 
    /// </summary>
    public class GeometryPath
    {
        /// <summary>
        /// 
        /// </summary>
        public List<List<List<double>>> paths { get; set; }
        /// <summary>
        /// 
        /// </summary>
        public SpatialReference spatialReference { get; set; }
    }



    /// <summary>
    /// 
    /// </summary>
    public class SpatialReference
    {
        /// <summary>
        /// 
        /// </summary>
        public int wkid { get; set; }

    }

    public class CollectModel
    {
        public string id { get; set; }
        public string point_id { get; set; }
    }

}
