package com.tofly.dyrqcar.custom.controller;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.tofly.common.core.entity.ResultRespone;
import com.tofly.dyrqcar.custom.service.CustomCarService;
import com.tofly.dyrqcar.entity.CarOil;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import lombok.AllArgsConstructor;
import org.springframework.web.bind.annotation.*;

/**
 * @author pra
 * @date 2020/10/19 10:17
 * @description
 */
@RestController
@AllArgsConstructor
@RequestMapping("/caroil")
@Api(tags="车辆油耗信息管理接口")
public class CustomCarOilController {
    private final CustomCarService customCarService;

    @ApiOperation(value = "分页查询")
    @GetMapping("/page")
    public ResultRespone getCarOilPage(Page page, @ModelAttribute CarOil carOil) {
        return ResultRespone.success(customCarService.getCarOilPage(page ,carOil));
    }
}
