package com.tofly.dyrqcar.custom.service.impl;

import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.tofly.common.core.util.FtpUtil;
import com.tofly.dyrqcar.custom.entity.CustomCarBaseinfo;
import com.tofly.dyrqcar.custom.mapper.CustomCarBaseinfoMapper;
import com.tofly.dyrqcar.custom.service.CustomCarBaseinfoService;
import com.tofly.dyrqcar.entity.CarBaseinfo;
import com.tofly.dyrqcar.service.CarBaseinfoService;
import lombok.AllArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.Arrays;
import java.util.Date;
import java.util.List;
import java.util.Map;

@Service
@AllArgsConstructor
@Slf4j
public class CustomCarBaseinfoServiceImpl extends ServiceImpl<CustomCarBaseinfoMapper, CustomCarBaseinfo> implements CustomCarBaseinfoService {
    private CarBaseinfoService carBaseinfoService;

    @Override
    public Page<Map> pageByCarNumber(Page page, String number) {
        return page.setRecords(baseMapper.pageByCarNumber(page, number));
    }

    @Override
    @Transactional
    public boolean removeById(String ids) {
        List<String> list = Arrays.asList(ids.split(","));
        List<CarBaseinfo> list1 = carBaseinfoService.list(Wrappers.<CarBaseinfo>lambdaQuery()
                .in(CarBaseinfo::getId, list));
        list1.forEach(k->{
            FtpUtil.deleteFile(k.getCarPic());
        });
        carBaseinfoService.update(Wrappers.<CarBaseinfo>lambdaUpdate().in(CarBaseinfo::getId,list)
                .set(CarBaseinfo::getDelTime,new Date()));
        carBaseinfoService.remove(Wrappers.<CarBaseinfo>lambdaQuery()
                .in(CarBaseinfo::getId,list));
        //uploadPhotoService.removeByIds(list);
        return true;
    }
}
