/*
 * Author: wangjian
 * 生成entity
 */
package com.tofly.dyrqcar.entity;

import com.baomidou.mybatisplus.annotation.*;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;

import java.util.Date;
import com.fasterxml.jackson.annotation.JsonFormat;
import org.springframework.format.annotation.DateTimeFormat;


/**
 * 车辆基本信息管理
 *
 * @author Zhangyu
 * @date Mon Apr 27 00:00:00 GMT+08:00 2020
 */
@Data
@EqualsAndHashCode(callSuper = true)
@TableName(value="TF_CAR_BASEINFO",resultMap = "carBaseinfoMap")
@KeySequence("TF_CAR_BASEINFO")
@ApiModel
public class CarBaseinfo extends Model<CarBaseinfo> {
    private static final long serialVersionUID = 1L;

        /**
     * 限速
     */
            @ApiModelProperty(value = "限速")
                private String speedLimit;
                /**
     * ID，主键
     */
        @TableId(value = "ID",type= IdType.INPUT)
            @ApiModelProperty(value = "ID，主键")
                private Long id;
                /**
     * 部门编号
     */
            @ApiModelProperty(value = "部门编号")
                private Long departmentId;
        @ApiModelProperty(hidden = true)
    private String departmentName;
                /**
     * 车牌号
     */
            @ApiModelProperty(value = "车牌号")
                private String carNumber;
                /**
     * 当前状态
     */
            @ApiModelProperty(value = "当前状态")
                private String carStatas;
                /**
     * 车辆类型
     */
            @ApiModelProperty(value = "车辆类型")
                private Long carType;
    @ApiModelProperty(hidden = true)
    @TableField(exist = false)
    private String carTypeName;
                /**
     * 负责人
     */
            @ApiModelProperty(value = "负责人")
                private String manager;
                /**
     * 创建时间
     */
            @ApiModelProperty(value = "创建时间")
        @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss",timezone = "GMT+8")
    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm:ss")
            @TableField(value = "CREATE_TIME",fill = FieldFill.INSERT)
            private Date createTime;
                /**
     * 创建人
     */
            @ApiModelProperty(value = "创建人")
            @TableField(value = "CREATE_USER",fill = FieldFill.INSERT)
            private Long createUser;
            @ApiModelProperty(hidden = true)
    private String createUserName;
            /**
     * 车辆照片
     */
            @ApiModelProperty(value = "车辆照片")
                private String carPic;
                /**
     * 删除标记
     */
            @TableLogic
        @ApiModelProperty(value = "删除标记")
                private String delFlag;

    /**
     *  删除时间
     */
    @ApiModelProperty(value = "删除时间")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss",timezone = "GMT+8")
    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm:ss")
    private Date delTime;

    /**
     * 状况管理(0:在用,1:停用,2:报废)
     */
    @ApiModelProperty(value = "状况管理(0:在用,1:停用,2:报废)")
    private String state;
    @ApiModelProperty(hidden = true)
    private String stateName;
}
