/*
 * Author: wangjian
 * 生成controller
 */
package com.tofly.dyrq.controller;

import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.tofly.common.core.entity.ResultRespone;
import com.tofly.common.log.annotation.ToFlyAppLog;
import com.tofly.dyrq.custom.mapper.PointContentMapper;
import com.tofly.dyrq.entity.AppFile;
import com.tofly.dyrq.service.AppFileService;
import lombok.AllArgsConstructor;
import org.springframework.web.bind.annotation.*;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import org.springframework.web.bind.annotation.ModelAttribute;

import java.util.Arrays;
/**
 * APP文件参数表
 *
 * @author Zhangyu
 * @date Mon Oct 26 00:00:00 GMT+08:00 2020
 */
@RestController
@AllArgsConstructor
@RequestMapping("/appfile")
@Api(tags="APP文件参数表接口")
public class AppFileController {

    private final  AppFileService appFileService;
    

    /**
    * 分页查询
    * @param page 分页对象
    * @param appFile APP文件参数表
    * @return
    */
    @GetMapping("/page" )
    @ApiOperation(value = "分页查询")
    public ResultRespone getAppFilePage(Page page, @ModelAttribute AppFile appFile) {
      return ResultRespone.success(appFileService.page(page, Wrappers.query(appFile)));
    }
    
    
  
    
    


    /**
     * 通过id查询APP文件参数表
     * @param id id
     * @return ResultRespone
     *//*
    @GetMapping("/{id}" )
    @ApiOperation(value = "通过ID查询")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "id", value = "ID", required = true, dataType = "Long")
    })
    public ResultRespone getById(@PathVariable("id" ) Long id) {
      return ResultRespone.success(appFileService.getById(id));
    }

    *//**
     * 新增APP文件参数表
     * @param appFile APP文件参数表
     * @return ResultRespone
     *//*
    @ToFlyAppLog(title="新增APP文件参数表" )
    @ApiOperation(value = "新增APP文件参数表")
    @PostMapping
    public ResultRespone save(@RequestBody AppFile appFile) {
      return ResultRespone.success(appFileService.save(appFile));
    }

    *//**
     * 修改APP文件参数表
     * @param appFile APP文件参数表
     * @return ResultRespone
     *//*
    @ToFlyAppLog(title="修改APP文件参数表" )
    @ApiOperation(value = "修改APP文件参数表")
    @PutMapping
    public ResultRespone updateById(@RequestBody AppFile appFile) {
      return ResultRespone.success(appFileService.updateById(appFile));
    }

    *//**
     * 通过id删除APP文件参数表
     * @param id id
     * @return ResultRespone
     *//*
    @ToFlyAppLog(title="通过id删除APP文件参数表" )
    @ApiOperation(value = "通过ID删除APP文件参数表")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "id", value = "ID", required = true, dataType = "Long")
    })
    @DeleteMapping("/{id}" )
    public ResultRespone removeById(@PathVariable Long id) {
      return ResultRespone.success(appFileService.removeById(id));
    }*/

    /**
     * 通过id批量删除APP文件参数表
     * @param ids id
     * @return ResultRespone
     */
    @ToFlyAppLog(title="通过id批量删除APP文件参数表" )
    @ApiOperation(value = "通过ID批量删除APP文件参数表")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "ids", value = "批量删除，多个id以逗号隔开", required = true, dataType = "String")
    })
    @DeleteMapping("/deleteByIds" )
    public ResultRespone removeById(String ids) {
        return ResultRespone.success(appFileService.removeByIds(Arrays.asList(ids.split(","))));
    }
}
