/*
 * Author: wangjian
 * 生成controller
 */
package com.tofly.dyrq.controller;

import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.tofly.common.core.entity.ResultRespone;
import com.tofly.common.log.annotation.ToFlyAppLog;
import com.tofly.dyrq.entity.DeviceUpload;
import com.tofly.dyrq.service.DeviceUploadService;
import lombok.AllArgsConstructor;
import org.springframework.web.bind.annotation.*;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import org.springframework.web.bind.annotation.ModelAttribute;

import java.util.Arrays;
/**
 * ${comments}
 *
 * @author admin
 * @date Sat May 09 00:00:00 CST 2020
 */
@RestController
@AllArgsConstructor
@RequestMapping("/deviceupload")
@Api(tags="巡检设备信息上传表接口")
public class DeviceUploadController {

    private final  DeviceUploadService deviceUploadService;

    /**
    * 分页查询
    * @param page 分页对象
    * @param deviceUpload ${comments}
    * @return
    */
//    @GetMapping("/page" )
//    @ApiOperation(value = "分页查询")
//    public ResultRespone getDeviceUploadPage(Page page, @ModelAttribute DeviceUpload deviceUpload) {
//      return ResultRespone.success(deviceUploadService.page(page, Wrappers.query(deviceUpload)));
//    }


    /**
     * 通过id查询${comments}
     * @param id id
     * @return ResultRespone
     */
    @GetMapping("/{id}" )
    @ApiOperation(value = "通过ID查询")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "id", value = "ID", required = true, dataType = "Long")
    })
    public ResultRespone getById(@PathVariable("id" ) String id) {
      return ResultRespone.success(deviceUploadService.getById(id));
    }
//
//    /**
//     * 新增${comments}
//     * @param deviceUpload ${comments}
//     * @return ResultRespone
//     */
//    @ToFlyAppLog(title="新增巡检设备信息上传表" )
//    @ApiOperation(value = "新增巡检设备信息上传表")
//    @PostMapping
//    public ResultRespone save(@RequestBody DeviceUpload deviceUpload) {
//      return ResultRespone.success(deviceUploadService.save(deviceUpload));
//    }
//
//    /**
//     * 修改${comments}
//     * @param deviceUpload ${comments}
//     * @return ResultRespone
//     */
//    @ToFlyAppLog(title="修改巡检设备信息上传表" )
//    @ApiOperation(value = "修改巡检设备信息上传表")
//    @PutMapping
//    public ResultRespone updateById(@RequestBody DeviceUpload deviceUpload) {
//      return ResultRespone.success(deviceUploadService.updateById(deviceUpload));
//    }
//
//    /**
//     * 通过id删除${comments}
//     * @param id id
//     * @return ResultRespone
//     */
//    @ToFlyAppLog(title="通过id删除巡检设备信息上传表" )
//    @ApiOperation(value = "通过ID删除巡检设备信息上传表")
//    @ApiImplicitParams({
//            @ApiImplicitParam(name = "id", value = "ID", required = true, dataType = "Long")
//    })
//    @DeleteMapping("/{id}" )
//    public ResultRespone removeById(@PathVariable Long id) {
//      return ResultRespone.success(deviceUploadService.removeById(id));
//    }
//
//    /**
//     * 通过id批量删除${comments}
//     * @param ids id
//     * @return ResultRespone
//     */
//    @ToFlyAppLog(title="通过id批量删除" )
//    @ApiOperation(value = "通过ID批量删除")
//    @ApiImplicitParams({
//            @ApiImplicitParam(name = "ids", value = "批量删除，多个id以逗号隔开", required = true, dataType = "String")
//    })
//    @DeleteMapping("/deleteByIds" )
//    public ResultRespone removeById(String ids) {
//        return ResultRespone.success(deviceUploadService.removeByIds(Arrays.asList(ids.split(","))));
//    }
}
