/*
 * Author: wangjian
 * 生成controller
 */
package com.tofly.dyrq.controller;

import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.tofly.common.core.entity.ResultRespone;
import com.tofly.common.log.annotation.ToFlyAppLog;
import com.tofly.dyrq.entity.EpmtArchives;
import com.tofly.dyrq.service.EpmtArchivesService;
import lombok.AllArgsConstructor;
import org.springframework.web.bind.annotation.*;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import org.springframework.web.bind.annotation.ModelAttribute;

import java.util.Arrays;
/**
 * 设备管理档案表
 *
 * @author Zhangyu
 * @date Tue Dec 15 00:00:00 GMT+08:00 2020
 */
@RestController
@AllArgsConstructor
@RequestMapping("/epmtarchives")
@Api(tags="设备管理档案表接口")
public class EpmtArchivesController {

    private final  EpmtArchivesService epmtArchivesService;

    /**
    * 分页查询
    * @param page 分页对象
    * @param epmtArchives 设备管理档案表
    * @return
    */
    @GetMapping("/page" )
    @ApiOperation(value = "分页查询")
    public ResultRespone getEpmtArchivesPage(Page page, @ModelAttribute EpmtArchives epmtArchives) {
      return ResultRespone.success(epmtArchivesService.page(page, Wrappers.query(epmtArchives)));
    }


    /**
     * 通过id查询设备管理档案表
     * @param id id
     * @return ResultRespone
     */
    @GetMapping("/{id}" )
    @ApiOperation(value = "通过ID查询")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "id", value = "ID", required = true, dataType = "Long")
    })
    public ResultRespone getById(@PathVariable("id" ) Long id) {
      return ResultRespone.success(epmtArchivesService.getById(id));
    }

    /**
     * 新增设备管理档案表
     * @param epmtArchives 设备管理档案表
     * @return ResultRespone
     *//*
    @ToFlyAppLog(title="新增设备管理档案表" )
    @ApiOperation(value = "新增设备管理档案表")
    @PostMapping
    public ResultRespone save(@RequestBody EpmtArchives epmtArchives) {
      return ResultRespone.success(epmtArchivesService.save(epmtArchives));
    }

    *//**
     * 修改设备管理档案表
     * @param epmtArchives 设备管理档案表
     * @return ResultRespone
     *//*
    @ToFlyAppLog(title="修改设备管理档案表" )
    @ApiOperation(value = "修改设备管理档案表")
    @PutMapping
    public ResultRespone updateById(@RequestBody EpmtArchives epmtArchives) {
      return ResultRespone.success(epmtArchivesService.updateById(epmtArchives));
    }

    *//**
     * 通过id删除设备管理档案表
     * @param id id
     * @return ResultRespone
     *//*
    @ToFlyAppLog(title="通过id删除设备管理档案表" )
    @ApiOperation(value = "通过ID删除设备管理档案表")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "id", value = "ID", required = true, dataType = "Long")
    })
    @DeleteMapping("/{id}" )
    public ResultRespone removeById(@PathVariable Long id) {
      return ResultRespone.success(epmtArchivesService.removeById(id));
    }

    *//**
     * 通过id批量删除设备管理档案表
     * @param ids id
     * @return ResultRespone
     *//*
    @ToFlyAppLog(title="通过id批量删除设备管理档案表" )
    @ApiOperation(value = "通过ID批量删除设备管理档案表")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "ids", value = "批量删除，多个id以逗号隔开", required = true, dataType = "String")
    })
    @DeleteMapping("/deleteByIds" )
    public ResultRespone removeById(String ids) {
        return ResultRespone.success(epmtArchivesService.removeByIds(Arrays.asList(ids.split(","))));
    }*/
}
