/*
 * Author: wangjian
 * 生成controller
 */
package com.tofly.dyrq.controller;

import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.tofly.common.core.entity.ResultRespone;
import com.tofly.common.log.annotation.ToFlyAppLog;
import com.tofly.dyrq.entity.MaintenanceDevice;
import com.tofly.dyrq.service.MaintenanceDeviceService;
import lombok.AllArgsConstructor;
import org.springframework.web.bind.annotation.*;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import org.springframework.web.bind.annotation.ModelAttribute;

import java.util.Arrays;
/**
 * 设备设施运行维修保养登记表
 *
 * @author admin
 * @date Fri Jun 05 00:00:00 CST 2020
 */
@RestController
@AllArgsConstructor
@RequestMapping("/maintenancedevice")
@Api(tags="设备设施运行维修保养登记表接口")
public class MaintenanceDeviceController {

    private final  MaintenanceDeviceService maintenanceDeviceService;

    /**
    * 分页查询
    * @param page 分页对象
    * @param maintenanceDevice 设备设施运行维修保养登记表
    * @return
    */
//    @GetMapping("/page" )
//    @ApiOperation(value = "分页查询")
//    public ResultRespone getMaintenanceDevicePage(Page page, @ModelAttribute MaintenanceDevice maintenanceDevice) {
//      return ResultRespone.success(maintenanceDeviceService.page(page, Wrappers.query(maintenanceDevice)));
//    }
//
//
//    /**
//     * 通过id查询设备设施运行维修保养登记表
//     * @param id id
//     * @return ResultRespone
//     */
//    @GetMapping("/{id}" )
//    @ApiOperation(value = "通过ID查询")
//    @ApiImplicitParams({
//            @ApiImplicitParam(name = "id", value = "ID", required = true, dataType = "Long")
//    })
//    public ResultRespone getById(@PathVariable("id" ) Long id) {
//      return ResultRespone.success(maintenanceDeviceService.getById(id));
//    }
//
//    /**
//     * 新增设备设施运行维修保养登记表
//     * @param maintenanceDevice 设备设施运行维修保养登记表
//     * @return ResultRespone
//     */
//    @ToFlyAppLog(title="新增设备设施运行维修保养登记表" )
//    @ApiOperation(value = "新增设备设施运行维修保养登记表")
//    @PostMapping
//    public ResultRespone save(@RequestBody MaintenanceDevice maintenanceDevice) {
//      return ResultRespone.success(maintenanceDeviceService.save(maintenanceDevice));
//    }
//
//    /**
//     * 修改设备设施运行维修保养登记表
//     * @param maintenanceDevice 设备设施运行维修保养登记表
//     * @return ResultRespone
//     */
//    @ToFlyAppLog(title="修改设备设施运行维修保养登记表" )
//    @ApiOperation(value = "修改设备设施运行维修保养登记表")
//    @PutMapping
//    public ResultRespone updateById(@RequestBody MaintenanceDevice maintenanceDevice) {
//      return ResultRespone.success(maintenanceDeviceService.updateById(maintenanceDevice));
//    }

    /**
     * 通过id删除设备设施运行维修保养登记表
     * @param id id
     * @return ResultRespone
     */
//    @ToFlyAppLog(title="通过id删除设备设施运行维修保养登记表" )
//    @ApiOperation(value = "通过ID删除设备设施运行维修保养登记表")
//    @ApiImplicitParams({
//            @ApiImplicitParam(name = "id", value = "ID", required = true, dataType = "Long")
//    })
//    @DeleteMapping("/{id}" )
//    public ResultRespone removeById(@PathVariable Long id) {
//      return ResultRespone.success(maintenanceDeviceService.removeById(id));
//    }

    /**
     * 通过id批量删除设备设施运行维修保养登记表
     * @param ids id
     * @return ResultRespone
     */
    @ToFlyAppLog(title="通过id批量删除设备设施运行维修保养登记表" )
    @ApiOperation(value = "通过ID批量删除设备设施运行维修保养登记表")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "ids", value = "批量删除，多个id以逗号隔开", required = true, dataType = "String")
    })
    @DeleteMapping("/deleteByIds" )
    public ResultRespone removeById(String ids) {
        return ResultRespone.success(maintenanceDeviceService.removeByIds(Arrays.asList(ids.split(","))));
    }
}
