/*
 * Author: wangjian
 * 生成controller
 */
package com.tofly.dyrq.controller;

import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.tofly.common.core.entity.ResultRespone;
import com.tofly.common.log.annotation.ToFlyAppLog;
import com.tofly.dyrq.entity.MaintenanceMenu;
import com.tofly.dyrq.service.MaintenanceMenuService;
import lombok.AllArgsConstructor;
import org.springframework.web.bind.annotation.*;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import org.springframework.web.bind.annotation.ModelAttribute;

import java.util.Arrays;
/**
 * 调压设备检查内容表
 *
 * @author admin
 * @date Fri Jun 05 00:00:00 CST 2020
 */
@RestController
@AllArgsConstructor
@RequestMapping("/maintenancemenu")
@Api(tags="调压设备检查内容表接口")
public class MaintenanceMenuController {

    private final  MaintenanceMenuService maintenanceMenuService;

    /**
    * 分页查询
    * @param page 分页对象
    * @param maintenanceMenu 调压设备检查内容表
    * @return
    *//*
    @GetMapping("/page" )
    @ApiOperation(value = "分页查询")
    public ResultRespone getMaintenanceMenuPage(Page page, @ModelAttribute MaintenanceMenu maintenanceMenu) {
      return ResultRespone.success(maintenanceMenuService.page(page, Wrappers.query(maintenanceMenu)));
    }*/


    /**
     * 通过id查询调压设备检查内容表
     * @param id id
     * @return ResultRespone
     */
    @GetMapping("/{id}" )
    @ApiOperation(value = "通过ID查询")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "id", value = "ID", required = true, dataType = "Long")
    })
    public ResultRespone getById(@PathVariable("id" ) Long id) {
      return ResultRespone.success(maintenanceMenuService.getById(id));
    }

    /**
     * 新增调压设备检查内容表
     * @param maintenanceMenu 调压设备检查内容表
     * @return ResultRespone
     */
    @ToFlyAppLog(title="新增调压设备检查内容表" )
    @ApiOperation(value = "新增调压设备检查内容表")
    @PostMapping
    public ResultRespone save(@RequestBody MaintenanceMenu maintenanceMenu) {
      return ResultRespone.success(maintenanceMenuService.save(maintenanceMenu));
    }

    /**
     * 修改调压设备检查内容表
     * @param maintenanceMenu 调压设备检查内容表
     * @return ResultRespone
     */
    @ToFlyAppLog(title="修改调压设备检查内容表" )
    @ApiOperation(value = "修改调压设备检查内容表")
    @PutMapping
    public ResultRespone updateById(@RequestBody MaintenanceMenu maintenanceMenu) {
      return ResultRespone.success(maintenanceMenuService.updateById(maintenanceMenu));
    }

    /**
     * 通过id删除调压设备检查内容表
     * @param id id
     * @return ResultRespone
     */
    @ToFlyAppLog(title="通过id删除调压设备检查内容表" )
    @ApiOperation(value = "通过ID删除调压设备检查内容表")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "id", value = "ID", required = true, dataType = "Long")
    })
    @DeleteMapping("/{id}" )
    public ResultRespone removeById(@PathVariable Long id) {
      return ResultRespone.success(maintenanceMenuService.removeById(id));
    }

    /**
     * 通过id批量删除调压设备检查内容表
     * @param ids id
     * @return ResultRespone
     */
    @ToFlyAppLog(title="通过id批量删除调压设备检查内容表" )
    @ApiOperation(value = "通过ID批量删除调压设备检查内容表")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "ids", value = "批量删除，多个id以逗号隔开", required = true, dataType = "String")
    })
    @DeleteMapping("/deleteByIds" )
    public ResultRespone removeById(String ids) {
        return ResultRespone.success(maintenanceMenuService.removeByIds(Arrays.asList(ids.split(","))));
    }
}
