/*
 * Author: wangjian
 * 生成controller
 */
package com.tofly.dyrq.controller;

import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.tofly.common.core.entity.ResultRespone;
import com.tofly.common.log.annotation.ToFlyAppLog;
import com.tofly.dyrq.entity.Message;
import com.tofly.dyrq.service.MessageService;
import lombok.AllArgsConstructor;
import org.springframework.web.bind.annotation.*;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import org.springframework.web.bind.annotation.ModelAttribute;

import java.util.Arrays;
/**
 * 消息推送表
 *
 * @author admin
 * @date Tue Jun 16 00:00:00 CST 2020
 */
@RestController
@AllArgsConstructor
@RequestMapping("/message")
@Api(tags="消息推送表接口")
public class MessageController {

    private final  MessageService messageService;

    /**
    * 分页查询
    * @param page 分页对象
    * @param message 消息推送表
    * @return
    */
    @GetMapping("/page" )
    @ApiOperation(value = "分页查询")
    public ResultRespone getMessagePage(Page page, @ModelAttribute Message message) {
      return ResultRespone.success(messageService.page(page, Wrappers.query(message)));
    }


    /**
     * 通过id查询消息推送表
     * @param id id
     * @return ResultRespone
     */
//    @GetMapping("/{id}" )
//    @ApiOperation(value = "通过ID查询")
//    @ApiImplicitParams({
//            @ApiImplicitParam(name = "id", value = "ID", required = true, dataType = "Long")
//    })
//    public ResultRespone getById(@PathVariable("id" ) Long id) {
//      return ResultRespone.success(messageService.getById(id));
//    }

    /**
     * 新增消息推送表
     * @param message 消息推送表
     * @return ResultRespone
     */
//    @ToFlyAppLog(title="新增消息推送表" )
//    @ApiOperation(value = "新增消息推送表")
//    @PostMapping
//    public ResultRespone save(@RequestBody Message message) {
//      return ResultRespone.success(messageService.save(message));
//    }

    /**
     * 修改消息推送表
     * @param message 消息推送表
     * @return ResultRespone
     */
//    @ToFlyAppLog(title="修改消息推送表" )
//    @ApiOperation(value = "修改消息推送表")
//    @PutMapping
//    public ResultRespone updateById(@RequestBody Message message) {
//      return ResultRespone.success(messageService.updateById(message));
//    }
//
//    /**
//     * 通过id删除消息推送表
//     * @param id id
//     * @return ResultRespone
//     */
//    @ToFlyAppLog(title="通过id删除消息推送表" )
//    @ApiOperation(value = "通过ID删除消息推送表")
//    @ApiImplicitParams({
//            @ApiImplicitParam(name = "id", value = "ID", required = true, dataType = "Long")
//    })
//    @DeleteMapping("/{id}" )
//    public ResultRespone removeById(@PathVariable Long id) {
//      return ResultRespone.success(messageService.removeById(id));
//    }
//
//    /**
//     * 通过id批量删除消息推送表
//     * @param ids id
//     * @return ResultRespone
//     */
//    @ToFlyAppLog(title="通过id批量删除消息推送表" )
//    @ApiOperation(value = "通过ID批量删除消息推送表")
//    @ApiImplicitParams({
//            @ApiImplicitParam(name = "ids", value = "批量删除，多个id以逗号隔开", required = true, dataType = "String")
//    })
//    @DeleteMapping("/deleteByIds" )
//    public ResultRespone removeById(String ids) {
//        return ResultRespone.success(messageService.removeByIds(Arrays.asList(ids.split(","))));
//    }
}
