/*
 * Author: wangjian
 * 生成controller
 */
package com.tofly.dyrq.controller;

import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.tofly.common.core.entity.ResultRespone;
import com.tofly.common.log.annotation.ToFlyAppLog;
import com.tofly.dyrq.entity.PlanChild;
import com.tofly.dyrq.service.PlanChildService;
import lombok.AllArgsConstructor;
import org.springframework.web.bind.annotation.*;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import org.springframework.web.bind.annotation.ModelAttribute;

import java.util.Arrays;
/**
 * 一月一巡计划
 *
 * @author wangjian
 * @date Fri Apr 17 00:00:00 CST 2020
 */
@RestController
@AllArgsConstructor
@RequestMapping("/planchild")
@Api(tags="巡检计划表接口")
public class PlanChildController {

    private final  PlanChildService planChildService;

    /**
    * 分页查询
    * @param page 分页对象
    * @param planChild 一月一巡计划
    * @return
    */
//    @GetMapping("/page" )
//    @ApiOperation(value = "分页查询")
//    public ResultRespone getPlanChildPage(Page page, @ModelAttribute PlanChild planChild) {
//      return ResultRespone.success(planChildService.page(page, Wrappers.query(planChild)));
//    }


    /**
     * 通过id查询一月一巡计划
     * @param childPlanId id
     * @return ResultRespone
     */
    @GetMapping("/{childPlanId}" )
    @ApiOperation(value = "通过子计划ID查询")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "childPlanId", value = "ID", required = true, dataType = "Long")
    })
    public ResultRespone getById(@PathVariable("childPlanId" ) Long childPlanId) {
      return ResultRespone.success(planChildService.getById(childPlanId));
    }

    /**
     * 新增一月一巡计划
     * @param planChild 一月一巡计划
     * @return ResultRespone
     */
//    @ToFlyAppLog(title="新增一月一巡计划" )
//    @ApiOperation(value = "新增一月一巡计划")
//    @PostMapping
//    public ResultRespone save(@RequestBody PlanChild planChild) {
//      return ResultRespone.success(planChildService.save(planChild));
//    }

    /**
     * 修改一月一巡计划
     * @param planChild 一月一巡计划
     * @return ResultRespone
     */
//    @ToFlyAppLog(title="修改一月一巡计划" )
//    @ApiOperation(value = "修改一月一巡计划")
//    @PutMapping
//    public ResultRespone updateById(@RequestBody PlanChild planChild) {
//      return ResultRespone.success(planChildService.updateById(planChild));
//    }

    /**
     * 通过id删除一月一巡计划
     * @param childPlanId id
     * @return ResultRespone
     */
//    @ToFlyAppLog(title="通过id删除一月一巡计划" )
//    @ApiOperation(value = "通过ID删除一月一巡计划")
//    @ApiImplicitParams({
//            @ApiImplicitParam(name = "childPlanId", value = "ID", required = true, dataType = "Long")
//    })
//    @DeleteMapping("/{childPlanId}" )
//    public ResultRespone removeById(@PathVariable Long childPlanId) {
//      return ResultRespone.success(planChildService.removeById(childPlanId));
//    }
//
//    /**
//     * 通过id批量删除一月一巡计划
//     * @param ids id
//     * @return ResultRespone
//     */
//    @ToFlyAppLog(title="通过id批量删除一月一巡计划" )
//    @ApiOperation(value = "通过ID批量删除一月一巡计划")
//    @ApiImplicitParams({
//            @ApiImplicitParam(name = "ids", value = "批量删除，多个id以逗号隔开", required = true, dataType = "String")
//    })
//    @DeleteMapping("/deleteByIds" )
//    public ResultRespone removeById(String ids) {
//        return ResultRespone.success(planChildService.removeByIds(Arrays.asList(ids.split(","))));
//    }
}
