/*
 * Author: wangjian
 * 生成controller
 */
package com.tofly.dyrq.controller;

import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.tofly.common.core.entity.ResultRespone;
import com.tofly.common.log.annotation.ToFlyAppLog;
import com.tofly.dyrq.entity.PlanPointType;
import com.tofly.dyrq.service.PlanPointTypeService;
import lombok.AllArgsConstructor;
import org.springframework.web.bind.annotation.*;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import org.springframework.web.bind.annotation.ModelAttribute;

import java.util.Arrays;
/**
 * 巡检类型配置表
 *
 * @author wangjian
 * @date Mon Apr 20 00:00:00 CST 2020
 */
@RestController
@AllArgsConstructor
@RequestMapping("/planpointtype")
@Api(tags="巡检类型配置表接口")
public class PlanPointTypeController {

    private final  PlanPointTypeService planPointTypeService;

//    /**
//    * 分页查询
//    * @param page 分页对象
//    * @param planPointType 巡检类型配置表
//    * @return
//    */
//    @GetMapping("/page" )
//    @ApiOperation(value = "分页查询")
//    public ResultRespone getPlanPointTypePage(Page page, @ModelAttribute PlanPointType planPointType) {
//      return ResultRespone.success(planPointTypeService.page(page, Wrappers.query(planPointType)));
//    }


    /**
     * 通过id查询巡检类型配置表
     * @param id id
     * @return ResultRespone
     */
    @GetMapping("/{id}" )
    @ApiOperation(value = "通过ID查询")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "id", value = "ID", required = true, dataType = "Long")
    })
    public ResultRespone getById(@PathVariable("id" ) Long id) {
      return ResultRespone.success(planPointTypeService.getById(id));
    }

    /**
     * 新增巡检类型配置表
     * @param planPointType 巡检类型配置表
     * @return ResultRespone
     */
    @ToFlyAppLog(title="新增巡检类型配置表" )
    @ApiOperation(value = "新增巡检类型配置表")
    @PostMapping
    public ResultRespone save(@RequestBody PlanPointType planPointType) {
      return ResultRespone.success(planPointTypeService.save(planPointType));
    }

    /**
     * 修改巡检类型配置表
     * @param planPointType 巡检类型配置表
     * @return ResultRespone
     */
    @ToFlyAppLog(title="修改巡检类型配置表" )
    @ApiOperation(value = "修改巡检类型配置表")
    @PutMapping
    public ResultRespone updateById(@RequestBody PlanPointType planPointType) {
      return ResultRespone.success(planPointTypeService.updateById(planPointType));
    }

    /**
     * 通过id删除巡检类型配置表
     * @param id id
     * @return ResultRespone
     */
//    @ToFlyAppLog(title="通过id删除巡检类型配置表" )
//    @ApiOperation(value = "通过ID删除巡检类型配置表")
//    @ApiImplicitParams({
//            @ApiImplicitParam(name = "id", value = "ID", required = true, dataType = "Long")
//    })
//    @DeleteMapping("/{id}" )
//    public ResultRespone removeById(@PathVariable Long id) {
//      return ResultRespone.success(planPointTypeService.removeById(id));
//    }

    /**
     * 通过id批量删除巡检类型配置表
     * @param ids id
     * @return ResultRespone
     */
//    @ToFlyAppLog(title="通过id批量删除巡检类型配置表" )
//    @ApiOperation(value = "通过ID批量删除巡检类型配置表")
//    @ApiImplicitParams({
//            @ApiImplicitParam(name = "ids", value = "批量删除，多个id以逗号隔开", required = true, dataType = "String")
//    })
//    @DeleteMapping("/deleteByIds" )
//    public ResultRespone removeById(String ids) {
//        return ResultRespone.success(planPointTypeService.removeByIds(Arrays.asList(ids.split(","))));
//    }
}
