/*
 * Author: wangjian
 * 生成controller
 */
package com.tofly.dyrq.controller;

import com.tofly.common.core.entity.ResultRespone;
import com.tofly.common.log.annotation.ToFlyAppLog;
import com.tofly.dyrq.entity.SysDeviceType;
import com.tofly.dyrq.service.SysDeviceTypeService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import lombok.AllArgsConstructor;
import org.springframework.web.bind.annotation.*;

/**
 * 设备类型表
 *
 * @author wangjian
 * @date Fri Apr 03 00:00:00 CST 2020
 */
@RestController
@AllArgsConstructor
@RequestMapping("/sysdevicetype")
@Api(tags="设备类型表接口")
public class SysDeviceTypeController {

    private final  SysDeviceTypeService sysDeviceTypeService;

//    /**
//    * 分页查询
//    * @param page 分页对象
//    * @param sysDeviceType 设备类型表
//    * @return
//    */
//    @GetMapping("/page" )
//    @ApiOperation(value = "分页查询")
//    public ResultRespone getSysDeviceTypePage(Page page, @ModelAttribute SysDeviceType sysDeviceType) {
//      return ResultRespone.success(sysDeviceTypeService.page(page, Wrappers.query(sysDeviceType)));
//    }


    /**
     * 通过id查询设备类型表
     * @param id id
     * @return ResultRespone
     */
    @GetMapping("/{id}" )
    @ApiOperation(value = "通过ID查询")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "id", value = "ID", required = true, dataType = "Long")
    })
    public ResultRespone getById(@PathVariable("id" ) Long id) {
      return ResultRespone.success(sysDeviceTypeService.getById(id));
    }

    /**
     * 新增设备类型表
     * @param sysDeviceType 设备类型表
     * @return ResultRespone
     */
    @ToFlyAppLog(title="新增设备类型表" )
    @ApiOperation(value = "新增设备类型表")
    @PostMapping
    public ResultRespone save(@RequestBody SysDeviceType sysDeviceType) {
      return ResultRespone.success(sysDeviceTypeService.save(sysDeviceType));
    }

    /**
     * 修改设备类型表
     * @param sysDeviceType 设备类型表
     * @return ResultRespone
     */
    @ToFlyAppLog(title="修改设备类型表" )
    @ApiOperation(value = "修改设备类型表")
    @PutMapping
    public ResultRespone updateById(@RequestBody SysDeviceType sysDeviceType) {
      return ResultRespone.success(sysDeviceTypeService.updateById(sysDeviceType));
    }

    /**
     * 通过id删除设备类型表
     * @param id id
     * @return ResultRespone
     */
//    @ToFlyAppLog(title="通过id删除设备类型表" )
//    @ApiOperation(value = "通过ID删除设备类型表")
//    @ApiImplicitParams({
//            @ApiImplicitParam(name = "id", value = "ID", required = true, dataType = "Long")
//    })
//    @DeleteMapping("/{id}" )
//    public ResultRespone removeById(@PathVariable Long id) {
//      return ResultRespone.success(sysDeviceTypeService.removeById(id));
//    }
}
