package com.tofly.dyrq.controller;

import com.baomidou.mybatisplus.core.toolkit.IdWorker;
import com.tofly.common.core.entity.ResultRespone;
import com.tofly.common.core.util.FtpUtil;
import com.tofly.common.schedulle.config.MyScheduleTask;
import com.tofly.common.schedulle.config.MyTaskRegistrar;
import com.tofly.common.schedulle.config.ScheduleRunnable;
import com.tofly.dyrq.config.FilePathBean;
import com.tofly.dyrq.custom.mapper.OtherMapper;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.annotation.Reference;
import org.springframework.scheduling.annotation.ScheduledAnnotationBeanPostProcessor;
import org.springframework.scheduling.config.ScheduledTaskHolder;
import org.springframework.scheduling.config.ScheduledTaskRegistrar;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.List;
import java.util.Map;

/**
 * @author tuonbed
 * @date 2020/3/26  14:43
 */
@RequestMapping("/test")
@Api(tags="测试测试")
@RestController
public class TestController {

    @Autowired
    private MyTaskRegistrar myTaskRegistrar;

    @Autowired
    private ScheduledTaskHolder scheduledTaskHolder;
    
    @Reference
    private ScheduledTaskRegistrar scheduledTaskRegistrar;

    @Autowired
    private FilePathBean filePathBean;

    @Autowired
    private OtherMapper otherMapper;



    @GetMapping("/tasknoparams")
    @ApiOperation(value = "无参任务")
    public void testTask() throws InterruptedException {
        ScheduleRunnable task = new ScheduleRunnable("demoTask", "taskNoParams");
        myTaskRegistrar.addCronTask(task, "0/10 * * * * ?");
    }

    @GetMapping("/taskwithparams")
    @ApiOperation(value = "有参任务")
    public void testHaveParamsTask() throws InterruptedException {
        ScheduleRunnable task = new ScheduleRunnable("demoTask", "taskWithParams", "haha", 23);
        myTaskRegistrar.addCronTask(task, "0/10 * * * * ?");
    }

    @GetMapping("/getTasks")
    @ApiOperation(value = "获取任务信息")
    public Map getTasks(){
        Map<Runnable, MyScheduleTask> map=myTaskRegistrar.getScheduledTasks();

        return map;
    }

    @GetMapping("/getCustomMapper")
    @ApiOperation(value = "获取自定义mapper信息")
    public String getCustomMapper(){
        return otherMapper.getClass().getName()+"---------:"+otherMapper.toString();
    }

    @GetMapping("/getBeanTasks")
    @ApiOperation(value = "获取bean的任务信息")
    public List getBeanTasks(){
        ScheduledAnnotationBeanPostProcessor scheduledAnnotationBeanPostProcessor=(ScheduledAnnotationBeanPostProcessor)scheduledTaskHolder;
        return null;
    }

    @GetMapping("/urltoftp")
    @ApiOperation(value = "测试url文件传递到ftp")
    public ResultRespone test(String url){
        String file=url.substring(url.lastIndexOf("/")+1);
        String filename = filePathBean.getQuestionmark()+ IdWorker.getIdStr()+file.substring(file.lastIndexOf("."));
        System.out.println(filename);
        boolean b= FtpUtil.uploadFile2Ftp(url,filename);
        System.out.println(b);
//        ScheduledTask sc=new ScheduledTask();
//        Task task = sc.getTask();
//        FixedDelayTask fixedDelayTask=new FixedDelayTask();
//        fixedDelayTask.getInterval();
//        Runnable runnable = task.getRunnable();
//        ScheduledMethodRunnable scheduledMethodRunnable=new ScheduledMethodRunnable();
//        scheduledMethodRunnable.getMethod();
//        scheduledMethodRunnable.getTarget();
        return ResultRespone.success(b);
    }


}
