package com.tofly.dyrq.custom.controller;

import com.tofly.common.core.entity.ResultRespone;
import com.tofly.common.log.annotation.ToFlyAppLog;
import com.tofly.dyrq.custom.service.CustomAppFileService;
import com.tofly.dyrq.entity.AppFile;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import lombok.AllArgsConstructor;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
//移动端上传日志
@RestController
@AllArgsConstructor
@RequestMapping("/appfile")
@Api(tags = "APP文件参数表接口")
public class CustomAppFileController {
    private final CustomAppFileService customAppFileService;

    /**
     * 新增APP文件参数表
     *
     * @param appFile APP文件参数表
     * @return ResultRespone
     */
    @ToFlyAppLog(title = "新增APP文件参数表")
    @ApiOperation(value = "新增APP文件参数表")
    @PostMapping
    public ResultRespone save(HttpServletRequest servletRequest, AppFile appFile) {
        return ResultRespone.success(customAppFileService.save(servletRequest, appFile));
    }

    /**
     * 通过id批量删除APP文件参数表
     *
     * @param ids id
     * @return ResultRespone
     *//*
    @ToFlyAppLog(title = "通过id批量删除APP文件参数表")
    @ApiOperation(value = "通过ID批量删除APP文件参数表")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "ids", value = "批量删除，多个id以逗号隔开", required = true, dataType = "String")
    })
    @DeleteMapping("/deleteByIds")
    public ResultRespone removeById(String ids) {
        return ResultRespone.success(customAppFileService.removeByIds(ids));
    }*/

    /**
     * 查询最新的文件信息
     *
     * @return ResultRespone
     */
    @ToFlyAppLog(title = "查询最新的文件信息")
    @ApiOperation(value = "查询最新的文件信息")
    @GetMapping("/new")
    public ResultRespone getNew(){
        return ResultRespone.success(customAppFileService.getNew());
    }
}
