package com.tofly.dyrq.custom.controller;

import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.tofly.common.core.entity.ResultRespone;
import com.tofly.common.core.util.StringUtil;
import com.tofly.common.log.annotation.ToFlyAppLog;
import com.tofly.dyrq.custom.entity.CarUploadSearch;
import com.tofly.dyrq.custom.entity.DeviceUpLoadSearch;
import com.tofly.dyrq.custom.service.CustomDeviceUploadService;
import com.tofly.dyrq.entity.DeviceUpload;
import com.tofly.dyrq.service.DeviceUploadService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import lombok.AllArgsConstructor;
import org.springframework.web.bind.annotation.*;

import java.math.BigDecimal;

@RestController
@AllArgsConstructor
@RequestMapping("/deviceupload")
@Api(tags="巡检设备信息上传表接口")
public class CustomDeviceUploadController {
    private final DeviceUploadService deviceUploadService;
    private final CustomDeviceUploadService customDeviceUploadService;

    @ToFlyAppLog(title="新增巡检设备信息上传表" )
    @ApiOperation(value = "新增巡检设备信息上传表")
    @PostMapping
    public ResultRespone save(@RequestBody DeviceUpload deviceUpload) {
        if(deviceUpload.getCheckTime() == null){ResultRespone.failed("checkTime不能为空");}
        if(deviceUpload.getWorkState() == null){ResultRespone.failed("workState不能为空");}
        if(StringUtil.isEmpty(deviceUpload.getElectricity())){ResultRespone.failed("electricity不能为空");}
        if(deviceUpload.getGpsState() == null){ResultRespone.failed("gpsState不能为空");}
        if(deviceUpload.getGpsState().intValue() == 1) {
            if(deviceUpload.getGpsStar() == null){ResultRespone.failed("gpsStar不能为空");}
        }
        if(deviceUpload.getNetworkState() == null){ResultRespone.failed("networkState不能为空");}
        if (StringUtil.isEmpty(deviceUpload.getElectricity())){deviceUpload.setElectricity("0");}
      return ResultRespone.success(deviceUploadService.save(deviceUpload));
    }

    @GetMapping("/getPage" )
    @ApiOperation(value = "巡检上传表分页查询")
    public ResultRespone getDeviceUploadPage(Page page, @ModelAttribute DeviceUpload deviceUpload) {
      return ResultRespone.success(deviceUploadService.page(page, Wrappers.query(deviceUpload)));
    }

    @GetMapping("/mobile" )
    @ApiOperation(value = "巡检终端状态分页查询")
    public ResultRespone getPageByMobile(Page page, @ModelAttribute DeviceUpLoadSearch deviceUpLoadSearch) {
        return ResultRespone.success(customDeviceUploadService.getPageByMobile(page,deviceUpLoadSearch));
    }

    @GetMapping("/listCarWatch" )
    @ApiOperation(value = "车辆监控状态列表")
    public ResultRespone ListCarWatch(Page page, @ModelAttribute CarUploadSearch carUploadSearch) {
        return ResultRespone.success(customDeviceUploadService.listCarWatch(page,carUploadSearch));
    }

}
