/*
 * Author: wangjian
 * 生成controller
 */
package com.tofly.dyrq.custom.controller;

import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.tofly.common.core.entity.ResultRespone;
import com.tofly.common.log.annotation.ToFlyAppLog;
import com.tofly.common.oauth.util.SecurityUtils;
import com.tofly.dyrq.custom.entity.DevopHistory;
import com.tofly.dyrq.custom.service.CustomDevopsEquipmentService;
import com.tofly.dyrq.entity.DevopsEquipment;
import com.tofly.dyrq.mapper.DevopsEquipmentMapper;
import com.tofly.dyrq.service.DevopsEquipmentService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import lombok.AllArgsConstructor;
import org.springframework.stereotype.Controller;
import org.springframework.util.MultiValueMap;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;
import org.springframework.web.multipart.MultipartHttpServletRequest;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.net.URLEncoder;
import java.util.Arrays;
import java.util.List;
import java.util.Map;

/**
 * 管网运维部工具类设备清单录入表
 *
 * @author Zhangyu
 * @date Fri May 22 00:00:00 GMT+08:00 2020
 */
@Controller
@AllArgsConstructor
@RequestMapping("/devopsequipment")
@Api(tags="管网运维部工具类设备清单录入表接口")
public class CustomDevopsEquipmentController {
    private final CustomDevopsEquipmentService customDevopsEquipmentService;

    @ToFlyAppLog(title="通过Excel批量导入数据" )
    @ApiOperation(value = "通过Excel批量导入数据")
    @PostMapping(value = "/excelupload")
    public ResultRespone uploadBatchMenu(MultipartFile file){
        return ResultRespone.success(customDevopsEquipmentService.uploadExcel(file));
    }

    @ToFlyAppLog(title="通过Excel批量导出数据" )
    @ApiOperation(value = "通过Excel批量导出数据")
    @GetMapping("/download")
    public void download(HttpServletRequest request,HttpServletResponse response, String ids) throws IOException {
        String fileName = "资产(设备)台卡";
        response.reset();
        response.setCharacterEncoding("UTF-8");
        String userAgent = request.getHeader("User-Agent");
        if (userAgent.contains("MSIE") || userAgent.contains("Trident")) {
            // 针对IE或者以IE为内核的浏览器：
            fileName = URLEncoder.encode(fileName, "UTF-8");
        } else {
            // 非IE浏览器的处理：
            fileName = new String(fileName.getBytes("UTF-8"), "ISO-8859-1");
        }
        response.setContentType("application/octet-stream; charset=UTF-8");
        response.setHeader("Content-Disposition", String.format("attachment; filename=%s.xls", fileName));
        response.setHeader("content-type", "application/vnd.ms-excel");
        customDevopsEquipmentService.exportExcel(ids,response.getOutputStream(),fileName);
    }

    /**
     * 分页历史查询
     * @param page 分页对象
     * @return
     *//*
    @PostMapping("/pagenew")
    @ApiOperation(value = "分页历史查询")
    public ResultRespone getHistoryPage(Page page, @ModelAttribute DevopHistory devopHistory) {
        return ResultRespone.success(customDevopsEquipmentService.getHistory(page,devopHistory));
    }*/
}
