/*
 * Author: wangjian
 * 生成controller
 */
package com.tofly.dyrq.custom.controller;

import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.tofly.common.core.entity.ResultRespone;
import com.tofly.common.log.annotation.ToFlyAppLog;
import com.tofly.dyrq.custom.service.CustomEpmtStateService;
import com.tofly.dyrq.entity.EpmtState;
import com.tofly.dyrq.service.EpmtStateService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import lombok.AllArgsConstructor;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.net.URLEncoder;
import java.util.Arrays;

/**
 * 管网运维部设备状况表
 *
 * @author Zhangyu
 * @date Tue Dec 22 00:00:00 GMT+08:00 2020
 */
@RestController
@AllArgsConstructor
@RequestMapping("/epmtstate")
@Api(tags="管网运维部设备状况表接口")
public class CustomEpmtStateController {

    private final CustomEpmtStateService customEpmtStateService;

    @ToFlyAppLog(title="通过Excel批量导出数据" )
    @ApiOperation(value = "通过Excel批量导出数据")
    @GetMapping("/download")
    public void download(HttpServletRequest request, HttpServletResponse response, String ids) throws IOException {
        String fileName = "管网运维部设备状况表";
        response.reset();
        response.setCharacterEncoding("UTF-8");
        String userAgent = request.getHeader("User-Agent");
        if (userAgent.contains("MSIE") || userAgent.contains("Trident")) {
            // 针对IE或者以IE为内核的浏览器：
            fileName = URLEncoder.encode(fileName, "UTF-8");
        } else {
            // 非IE浏览器的处理：
            fileName = new String(fileName.getBytes("UTF-8"), "ISO-8859-1");
        }
        response.setContentType("application/octet-stream; charset=UTF-8");
        response.setHeader("Content-Disposition", String.format("attachment; filename=%s.xls", fileName));
        response.setHeader("content-type", "application/vnd.ms-excel");
        customEpmtStateService.exportExcel(ids,response.getOutputStream(),fileName);
    }
}
