/*
 * Author: wangjian
 * 生成controller
 */
package com.tofly.dyrq.custom.controller;

import com.tofly.common.core.entity.ResultRespone;
import com.tofly.common.log.annotation.ToFlyAppLog;
import com.tofly.common.oauth.util.SecurityUtils;
import com.tofly.dyrq.custom.service.CustomNormalEquipmentService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import lombok.AllArgsConstructor;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.multipart.MultipartFile;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.net.URLEncoder;

/**
 * 管网运维部一般设备表
 *
 * @author Zhangyu
 * @date Fri May 22 00:00:00 GMT+08:00 2020
 */
@Controller
@AllArgsConstructor
@RequestMapping("/normalequipment")
@Api(tags="管网运维部一般设备表接口")
public class CustomNormalEquipmentController {
    private final CustomNormalEquipmentService customNormalEquipmentService;

    @ToFlyAppLog(title="通过Excel批量导入数据" )
    @ApiOperation(value = "通过Excel批量导入数据")
    @PostMapping(value = "/excelupload")
    public ResultRespone uploadBatchMenu(MultipartFile file){
        return ResultRespone.success(customNormalEquipmentService.uploadExcel(file));
    }

    @ToFlyAppLog(title="通过Excel批量导出数据" )
    @ApiOperation(value = "通过Excel批量导出数据")
    @GetMapping("/download")
    public void download(HttpServletRequest request,HttpServletResponse response, String ids) throws IOException {
        String fileName = "一般(设备)台卡";
        response.reset();
        response.setCharacterEncoding("UTF-8");
        String userAgent = request.getHeader("User-Agent");
        if (userAgent.contains("MSIE") || userAgent.contains("Trident")) {
            // 针对IE或者以IE为内核的浏览器：
            fileName = URLEncoder.encode(fileName, "UTF-8");
        } else {
            // 非IE浏览器的处理：
            fileName = new String(fileName.getBytes("UTF-8"), "ISO-8859-1");
        }
        response.setContentType("application/octet-stream; charset=UTF-8");
        response.setHeader("Content-Disposition", String.format("attachment; filename=%s.xls", fileName));
        response.setHeader("content-type", "application/vnd.ms-excel");
        customNormalEquipmentService.exportExcel(ids,response.getOutputStream(),fileName);
    }
}
