package com.tofly.dyrq.custom.controller;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.tofly.common.core.entity.ResultRespone;
import com.tofly.dyrq.custom.entity.ConstructionSiteSearch;
import com.tofly.dyrq.custom.entity.CustomPlanDeviceQuery;
import com.tofly.dyrq.custom.entity.CustomPlanDeviceTypeQuery;
import com.tofly.dyrq.custom.service.CustomPlanDeviceService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import lombok.AllArgsConstructor;
import org.springframework.web.bind.annotation.*;

import java.util.List;
import java.util.Map;

/**
 * @author tuonbed
 * @date 2020/9/17  10:37
 */
@RestController
@AllArgsConstructor
@RequestMapping("/sbtzcx")
@Api(tags="设备台账查询")
public class CustomPlanDeviceController {

    private final CustomPlanDeviceService customPlanDeviceService;
    @ApiOperation(value = "设备类型统计")
    @GetMapping("/sblxtj")
    public ResultRespone getConstructionPage(Page page, @ModelAttribute CustomPlanDeviceQuery customPlanDeviceQuery) {
        return ResultRespone.success(customPlanDeviceService.sblxtj(page, customPlanDeviceQuery));
    }

    @ApiOperation(value = "根据设备统计")
    @PostMapping("/sbidtj")
    public ResultRespone sbidtj(Page page, @RequestBody CustomPlanDeviceTypeQuery customPlanDeviceTypeQuery) {
        return ResultRespone.success(customPlanDeviceService.sbidtj(page, customPlanDeviceTypeQuery));
    }

    @ApiOperation(value = "设备明细查询")
    @GetMapping("/getSbmx")
    public ResultRespone getSbmx(Page page, @ModelAttribute CustomPlanDeviceTypeQuery customPlanDeviceTypeQuery) {
        return ResultRespone.success(customPlanDeviceService.getSbmx(page, customPlanDeviceTypeQuery));
    }

}
