package com.tofly.dyrq.custom.controller;

import com.tofly.common.core.entity.ResultRespone;
import com.tofly.common.log.annotation.ToFlyAppLog;
import com.tofly.dyrq.custom.entity.PointList;
import com.tofly.dyrq.custom.entity.UpdatePoint;
import com.tofly.dyrq.custom.service.CustomPointService;
import io.swagger.annotations.ApiOperation;
import lombok.AllArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.web.bind.annotation.*;

import java.util.Map;

@RestController
@AllArgsConstructor
@Slf4j
public class CustomPointController {
    private CustomPointService customPointService;

    /**
     * 更新点到位或线所属点的到位状态
     *
     * @param
     * @return
     */
    @PostMapping("updatepointorpathisover")
    @ApiOperation(tags="巡检计划表接口",value = "更新点到位或线所属点的到位状态")
    @ToFlyAppLog(title="更新点到位或线所属点的到位状态")
    public ResultRespone updatePointIsover(@RequestBody PointList pointList) {
        Map<String,Long> tempIds = customPointService.updatePointOrPathIsover(pointList.getUpdatePointList());
        return tempIds.size() > 0 ? ResultRespone.success(tempIds) : ResultRespone.success("更新成功");
    }


}
