package com.tofly.dyrq.custom.controller;

import com.tofly.common.core.entity.ResultRespone;
import com.tofly.dyrq.custom.service.EquipmentPhotoService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import lombok.AllArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletRequest;

@RestController
@AllArgsConstructor
@RequestMapping("/equipmentphoto")
@Api(tags="设备照片上传接口")
@Slf4j
public class EquipmentPhotoController {
    private EquipmentPhotoService equipmentPhotoService;

    /**
     * 设备照片上传
     *
     * @param request
     * @return
     */
    @ApiOperation(value = "设备照片上传")
    @PostMapping
    public ResultRespone save(HttpServletRequest request){
        return ResultRespone.success(equipmentPhotoService.save(request));
    }

    @ApiOperation(value = "读取照片导入数据库")
    @GetMapping
    public ResultRespone getFiles(@RequestParam("path") String path){
        return ResultRespone.success(equipmentPhotoService.getFiles(path));
    }
}
