package com.tofly.dyrq.custom.controller;

import com.alibaba.fastjson.JSONArray;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.tofly.common.core.entity.ResultRespone;
import com.tofly.dyrq.custom.entity.ExcelParam;
import com.tofly.dyrq.custom.service.GisAboutService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import lombok.AllArgsConstructor;
import lombok.SneakyThrows;
import lombok.extern.slf4j.Slf4j;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.*;
import java.net.URLEncoder;
import java.util.Map;

/**
 * gis相关接口
 * @author tuonbed
 * @date 2020/3/30  9:43
 */
@RestController
@AllArgsConstructor
@RequestMapping("/Gis")
@Api(tags="Gis相关接口")
@Slf4j
public class GisAboutController {

    private final GisAboutService gisAboutService;

    //@ToFlyAppLog(title="导出数据" )
    @ApiOperation(value = "生成导出的数据文件")
    @PostMapping("/export")
    @SneakyThrows
    public ResultRespone excelout(@RequestBody ExcelParam excelParam, HttpServletRequest request, HttpServletResponse response){
       return ResultRespone.success(gisAboutService.createFile(excelParam)) ;
    }

    @ApiOperation(value = "返回查询的数据")
    @PostMapping("/exportList")
    @SneakyThrows
    public ResultRespone exceloutList(@RequestBody ExcelParam excelParam, HttpServletRequest request, HttpServletResponse response){
        Page page=new Page();
        JSONArray jsonArray=gisAboutService.exceloutList(excelParam);
        page.setRecords(jsonArray.toJavaList(Map.class));
        page.setSize(jsonArray.size());
        page.setTotal(jsonArray.size());
        return ResultRespone.success(page) ;
    }


//    @ApiOperation(value = "导出数据")
//    @GetMapping("/excelget")
//    @SneakyThrows
//    public void getexcelout(ExcelParam excelParam, HttpServletRequest request, HttpServletResponse response){
//        byte[] data = gisAboutService.getExcelByte(excelParam);
//        String filename=excelParam.getLayername();
//        response.reset();
//        response.setCharacterEncoding("UTF-8");
//        String userAgent = request.getHeader("User-Agent");
//        String formFileName;
//        if (userAgent.contains("MSIE") || userAgent.contains("Trident")) {
//            // 针对IE或者以IE为内核的浏览器：
//            formFileName = URLEncoder.encode(filename, "UTF-8");
//        } else {
//            // 非IE浏览器的处理：
//            formFileName = new String(filename.getBytes("UTF-8"), "ISO-8859-1");
//        }
//        response.setHeader("Content-Disposition", String.format("attachment; filename=%s.csv",formFileName));
//        response.addHeader("Content-Length", "" + data.length);
//        response.setContentType("application/octet-stream; charset=UTF-8");
//        response.setHeader("content-type", "application/octet-stream");
//        try{
//            IOUtil.write(response.getOutputStream(), Boolean.TRUE, data);
//        }catch (IOException e){
//            log.error(e.getMessage());
//            e.getMessage();
//        }
//    }


    @RequestMapping("/test")
    public void downLoad(HttpServletResponse response) throws UnsupportedEncodingException {
        String filename="aaaa.xlsx";
        String filePath = "D:" ;
        File file = new File(filePath + "/" + filename);
        if(file.exists()){
            response.setContentType("application/octet-stream");
            response.setHeader("content-type", "application/octet-stream");
            response.setHeader("Content-Disposition", "attachment;fileName=" + URLEncoder.encode(filename,"utf8"));
            byte[] buffer = new byte[1024];
            //输出流
            OutputStream os = null;
            try(FileInputStream fis= new FileInputStream(file);
                BufferedInputStream bis = new BufferedInputStream(fis);) {
                os = response.getOutputStream();
                int i = bis.read(buffer);
                while(i != -1){
                    os.write(buffer);
                    i = bis.read(buffer);
                }
            } catch (Exception e) {
                e.printStackTrace();
            }
        }
    }
}
