package com.tofly.dyrq.custom.entity;

import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import org.springframework.format.annotation.DateTimeFormat;

import java.util.Date;

@Data
public class ChildPlanSearch {
    /**
     * 计划开始日期
     */
    @ApiModelProperty(value = "计划开始日期[选填]yyyy-MM-dd HH:mm:ss")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss",timezone = "GMT+8")
    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm:ss")
    private Date childBeginDate;
    /**
     * 计划结束日期
     */
    @ApiModelProperty(value = "计划结束日期[选填]yyyy-MM-dd HH:mm:ss")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss",timezone = "GMT+8")
    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm:ss")
    private Date childEndDate;

    @ApiModelProperty(value = "公司唯一编码[选填]")
    private Long companyId;

    @ApiModelProperty(value = "巡检状态字符串[选填]用‘,’隔开  0：待审核，1：未开始，2：正在执行 3：已完成 4：超时未完成  5：申请转移  6：未提交 7：计划已转移")
    private String childPlanState;

    @ApiModelProperty(value = "用户唯一编码[选填]")
    private Long userId;

    @ApiModelProperty(value = "是否查询当天信息[选填]")
    private Boolean isToday;

    @ApiModelProperty(value = "子计划id[选填]")
    private Long childPlanId;

    @ApiModelProperty(value = "片区唯一编码")
    private Long regionId;
}
