/*
 * Author: wangjian
 * 生成entity
 */
package com.tofly.dyrq.custom.entity;

import com.baomidou.mybatisplus.annotation.*;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import com.tofly.common.core.constant.ToflySqlCondition;
import com.tofly.common.entity.CommonCode;
import java.math.BigDecimal;
import java.util.Date;
import com.fasterxml.jackson.annotation.JsonFormat;
import org.springframework.format.annotation.DateTimeFormat;

import java.util.List;
import java.util.stream.Collectors;


/**
 * GPS状态表
 *
 * @author pra
 * @date Mon Apr 13 00:00:00 CST 2020
 */
@Data
@EqualsAndHashCode(callSuper = true)
@TableName(value="TF_POINT_CONTENT")
@KeySequence("TF_POINT_CONTENT")
@ApiModel
public class PointContent extends Model<PointContent> {
    private static final long serialVersionUID = 1L;

        /**
     * 编号GUID
     */
        @TableId(value = "ID",type= IdType.INPUT)
        @ApiModelProperty(value = "编号GUID")
                private Long id;
                /**
     *  点位type（0未更新，1已更新）
     */
        @ApiModelProperty(value = "是否已经处理")        
                private Integer isHandle;
                /**
     * 点位type（1、point、2、path、3child）
     */
        @ApiModelProperty(value = "点位类型")
                private Integer jsonType;
        /**
         * 经度
         */
        @ApiModelProperty(value = "点位信息")
                private String jsonContent;
  
        
}
