package com.tofly.dyrq.custom.entity;

import com.baomidou.mybatisplus.annotation.FieldFill;
import com.baomidou.mybatisplus.annotation.TableField;
import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import org.springframework.format.annotation.DateTimeFormat;

import java.util.Date;

/**
 * @author pra
 * @date 2020/9/17 15:51
 * @description
 */
@Data
public class ReceiptMessageReault {
    @ApiModelProperty(value = "消息表主键")
    private Long messageId;

    @ApiModelProperty(value = "消息是否接收，0：未接收，1：已接收")
    private String flag;

    @ApiModelProperty(value = "消息接收时间")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss",timezone = "GMT+8")
    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm:ss")
    private Date recipientTime;

    @ApiModelProperty(value = "创建人")
    private Long createUser;
    @ApiModelProperty()
    private String createUserName;

    @ApiModelProperty(value = "创建时间")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss",timezone = "GMT+8")
    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm:ss")
    private Date createDate;

    @ApiModelProperty(value = "消息详情")
    private String message;

    @ApiModelProperty(value = "消息类型：0普通消息 1抢维修 2巡检 3工地 4隐患 5管网工单")
    private String type;

    private String receiptUserAvatar;

    private String createUserAvatar;

    @ApiModelProperty(value = "模块")
    private String module;
}
