package com.tofly.dyrq.custom.entity;

import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.tofly.dyrq.entity.ScadaRealdata;
import com.tofly.dyrq.entity.ScadapntsStations;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.math.BigDecimal;
import java.util.List;

/**
 * @author pra
 * @date 2020/11/24 10:48
 * @description
 */
//@JsonIgnoreProperties({"hibernateLazyInitializer","handler"})
    @Data
public class ScadaStationResult {
    /**
     * 站点编号
     */
    @ApiModelProperty(value = "站点编号")
    private String ptid;
    /**
     * 站点中文名
     */
    @ApiModelProperty(value = "站点中文名")
    private String ptname;
    /**
     * 横坐标或经度x
     */
    @ApiModelProperty(value = "横坐标或经度x")
    private BigDecimal x;
    /**
     * 纵坐标或纬度y
     */
    @ApiModelProperty(value = "纵坐标或纬度y")
    private BigDecimal y;
    /**
     * 站点scada实时数据
     */
    @ApiModelProperty(value = "站点scada实时数据")
    @JsonIgnoreProperties({"hibernateLazyInitializer","handler"})
    private List<ScadaRealdata> scadaRealdataResults;
}
