package com.tofly.dyrq.custom.entity;

import com.baomidou.mybatisplus.annotation.FieldFill;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.tofly.dyrq.entity.PlanChild;
import com.tofly.dyrq.entity.PlanTransfer;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import org.springframework.format.annotation.DateTimeFormat;

import java.math.BigDecimal;
import java.util.Date;

@Data
public class TransferQueryResut extends PlanTransfer {


    @TableField(exist = false)
    private Long childPlanId;

    /**
     * 主计划唯一编码
     */
    @ApiModelProperty(value = "主计划唯一编码")
    private Long mainPlanId;
    /**
     * 计划序号
     */
    @ApiModelProperty(value = "计划序号")
    private BigDecimal childNum;
    /**
     * 计划开始日期
     */
    @ApiModelProperty(value = "计划开始日期")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss",timezone = "GMT+8")
    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm:ss")
    private Date childBeginDate;
    /**
     * 计划结束日期
     */
    @ApiModelProperty(value = "计划结束日期")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss",timezone = "GMT+8")
    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm:ss")
    private Date childEndDate;
    /**
     * 巡检周期编码
     */
    @ApiModelProperty(value = "巡检周期编码")
    private Long periodId;
    @ApiModelProperty(hidden = true)
    @TableField(exist = false)
    private String preiodName;
    /**
     * 设备类型唯一编码
     */
    @ApiModelProperty(value = "设备类型唯一编码")
    private Long deviceTypeId;
    @ApiModelProperty(hidden = true)
    @TableField(exist = false)
    private String deviceTypeName;
    /**
     * 完成率
     */
    @ApiModelProperty(value = "完成率")
    private Double percent;
    /**
     * 最后一次修改日期
     */
    @ApiModelProperty(value = "最后一次修改日期")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss",timezone = "GMT+8")
    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm:ss")
    @TableField(value = "LAST_TIME",fill = FieldFill.INSERT_UPDATE)
    private Date lastTime;
    /**
     * 用户唯一编码
     */
    @ApiModelProperty(value = "用户唯一编码")
    @TableField(value = "USER_ID",fill = FieldFill.INSERT)
    private Long userId;
    @ApiModelProperty(hidden = true)
    @TableField(exist = false)
    private String userIdName;
    /**
     * 公司唯一编码
     */
    @ApiModelProperty(value = "公司唯一编码")
    private Long companyid;
    @ApiModelProperty(hidden = true)
    @TableField(exist = false)
    private String deptName;
    /**
     * 片区唯一编码
     */
    @ApiModelProperty(value = "片区唯一编码")
    private Long regionId;
    @ApiModelProperty(hidden = true)
    @TableField(exist = false)
    private String regionName;
    /**
     * 巡检状态 0：待审核，1：未开始，2：正在执行 3：已完成 4：超时未完成  5：申请转移  6：未提交 7：计划已转移
     */
    @ApiModelProperty(value = "巡检状态 0：待审核，1：未开始，2：正在执行 3：已完成 4：超时未完成  5：申请转移  6：未提交 7：计划已转移")
    private String childPlanState;
    @ApiModelProperty(hidden = true)
    @TableField(exist = false)
    private String chilePlanStateName;
    /**
     * 任务情况
     */
    @ApiModelProperty(value = "点完成情况")
    private BigDecimal isovertototal0;
    /**
     * 完成进度
     */
    @ApiModelProperty(value = "完成进度")
    private Double percent1;

    @ApiModelProperty(value = "巡检点数量")
    private Long pointNum;

    /**
     * 总共点线或者线长度
     */
    @ApiModelProperty(value = "总共点线或者线长度")
    private Double total;
    /**
     * 总共点线或者线数量
     */
    @ApiModelProperty(value = "总共点线或者线数量")
    private BigDecimal total1;

    /**
     * 点完成情况或线完成长度
     */
    @ApiModelProperty(value = "点完成情况或线完成长度")
    private Double isovertototal;
    /**
     * 点或者线地完成个数
     */
    @ApiModelProperty(value = "点或者线地完成个数")
    private BigDecimal isovertototal1;

    @ApiModelProperty(value = "计划预计完成率")
    private String planRate;

    @ApiModelProperty(value = "描述",hidden = true)
    @TableField(exist = false)
    private String description;

    @ApiModelProperty(value = "***巡检类型不为巡检点巡检线时(非巡检点和巡检线的情况),多个id以逗号隔开")
    @TableField(exist = false)
    private String objectIds;

    @ApiModelProperty(value = "计划详情")
    @TableField(exist = false)
    private String pointInfo;

}
