package com.tofly.dyrq.custom.entity;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONArray;
import com.baomidou.mybatisplus.annotation.TableField;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.tofly.dyrq.entity.TroublePipeinfo;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import org.springframework.format.annotation.DateTimeFormat;
import org.springframework.web.bind.annotation.RequestBody;

import java.math.BigDecimal;
import java.util.Date;
import java.util.List;
import java.util.Map;

@Data
public class TroubleSave {
    @ApiModelProperty(value = "主键ID")
    private Long id;

    @ApiModelProperty(value = "部门ID")
    private Long deptId;

    @ApiModelProperty(value = "隐患所属单位名称，造成隐患的责任单位")
    private String unitName;

    @ApiModelProperty(value = "隐患名称",required = true)
    private String troubleName;

    @ApiModelProperty(value = "隐患类别id")
    private Long troubleTypeId;

    @ApiModelProperty(value = "隐患级别id")
    private Long levelId;

    @ApiModelProperty(value = "地址",required = true)
    private String address;

    @ApiModelProperty(value = "隐患详情",required = true)
    private String troubleInfo;

    /*@ApiModelProperty(value = "隐患上报途径(0:非工作时间;1:工作时间现场上报;2:工作时间其他转入)",required = true)
    private String uploadType;*/

   /* @ApiModelProperty(value = "值班人员id[非工作日必填]")
    private Long ondutyUserid;*/

    /*@ApiModelProperty(value = "GIS班班长id[工作日其他隐患转入必填]")
    private Long gisUserid;*/

    @ApiModelProperty(value = "审核班组长")
    private Long undertakerUserid;

    @ApiModelProperty(value = "投影坐标位置x")
    private BigDecimal locationX;

    @ApiModelProperty(value = "投影坐标位置y")
    private BigDecimal locationY;


    @ApiModelProperty(value = "隐患发现人员[选填]")
    private Long findUserid;

    @ApiModelProperty(value = "发现时间[选填]")
    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm:ss")
    private Date findTime;

    @ApiModelProperty(value = "隐患上报备注[选填]")
    private String notes;

    @ApiModelProperty(value = "管线基本信息")
    private String pipeInfo;

    @ApiModelProperty(value = "设备基本信息")
    private String deviceInfo;

    @ApiModelProperty(value = "管道基本情况描述[选填]")
    private String pipeInfoDesc;

    @ApiModelProperty(value = "设备基本情况描述[选填]")
    private String deviceInfoDesc;

    /*@ApiModelProperty(value = "副部长用户id")
    private Long undersecretaryUserid;

    @ApiModelProperty(value = "部长用户id")
    private Long secretaryUserid;*/


    //后台处理参数
    @ApiModelProperty(value = "隐患编号,编号规则：dygas_gw_yh_2020041301",hidden = true)
    private String sid;

    @ApiModelProperty(value = "删除文件路径")
    @TableField(exist = false)
    private List<String> deleteFilePaths;

    @ApiModelProperty(value = "消息推送人员")
    private String sendUserIds;
}
