package com.tofly.dyrq.custom.entity;

import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.util.List;

@Data
public class TroubleSearch {
    @ApiModelProperty(value = "隐患名称")
    private String troubleName;
    @ApiModelProperty(value = "是否为隐患(0:不是隐患 1:常规隐患 2.存量隐患 3:抢维修)")
    private String state;
    @ApiModelProperty(value = "地址")
    private String address;
    @ApiModelProperty(value = "隐患上报途径(0:非工作时间;1:工作时间现场上报;2:工作时间其他转入)")
    private String uploadType;
    @ApiModelProperty(value = "(仅非工作时间,值班人员)事件类型:0:非隐患 1:一般隐患,2:重大隐患")
    private String handleState;
    @ApiModelProperty(value = "上报人")
    private Long reportUserId;
    @ApiModelProperty(value = "(非工作日)值班人员")
    private Long onDutyUserId;
    @ApiModelProperty(value = "GIS班班长")
    private Long gisUserId;
    @ApiModelProperty(value = "承办班班长(GIS班班长指定)")
    private Long undertakerUserId;
    @ApiModelProperty(value = "巡检人员(承办班班长指定)")
    private Long undertakerHandleUserId;
    @ApiModelProperty(value = "责任班班长(副部长指定)")
    private Long dutyUserId;
    @ApiModelProperty(value = "1.待值班人员勘察(非工作时间),2.待承办班班长审核(工作时间),3.待巡检人员现场核实(工作时间)," +
            "4.待副部长指派,5.转入抢维修,6.待责任班班长编制方案,7.隐患处理完成(副部长审核),8.待部长审核,9.待工单负责人执行," +
            "10.待副部长审核回报,11.隐患处理完成归档,12.部长审核未通过,13.副部长审核回报未通过,14.值班人员判断非隐患(非工作时间)")
    private Long processId;
    private Long processId2;
    @ApiModelProperty(value = "个人查询")
    private Long userId;
    @ApiModelProperty(value = "隐患ID")
    private Long id;

    @ApiModelProperty(value = "隐患工单责任人")
    private Long handleUserid;
    @ApiModelProperty(value = "隐患流程状态，多个状态以逗号隔开")
    private String processIds;
    @ApiModelProperty(hidden = true)
    private List<Long> processIdList;
    @ApiModelProperty(value = "部门ID")
    private Long deptId;
    private List<Long> deptUsers;

    @ApiModelProperty(value = "processIds")
    private Long teamUserId;
}
