package com.tofly.dyrq.custom.mapper;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.tofly.dyrq.custom.entity.*;
import com.tofly.dyrq.entity.RushRepairFile;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

import java.util.List;
import java.util.Map;

@Mapper
public interface CustomRushRepairMapper {
    CustomRushRepair getCustomRushRepairById(Long id);

    List<RushRepairResult> getAll(@Param("rushRepairSearch") RushRepairSearch rushRepairSearch);

    List<Map> pageByCondition(Page page, @Param("rushRepairSearch") RushRepairSearch rushRepairSearch);

    List<Map> getFilesName(Long id);

    List<Map> getVoice(Long id);

    List<Map> getEndFilesName(Long id);

    List<Map> getEndVoice(Long id);

    List<CustomRushRepairProcessManage> getProcess(Long id);

    List<Map> getProcessFiles(Long id);

    List<Map> getProcessVoice(Long id);

    List<Long> getIdByRole(Long id);

    List<CustomRushAudit> getAuditList(Long id);

    List<Map> getAuditFiles(Long id);

    Object getauditMindName(@Param("auditmind") String auditmind);

    List<Map> getFiles(@Param("rids") List rids);

    List<Map> getReportByTYpe(CustomRushRepairReportQuery customRushRepairReportQuery);

    List<Map> getReportByTime(CustomRushRepairReportQueryType customRushRepairReportQueryType);

    List<String> querySJByDay(CustomRushRepairReportQueryType customRushRepairReportQueryType);
    List<String> querySJByMonth(CustomRushRepairReportQueryType customRushRepairReportQueryType);
    List<String> querySJByYear(CustomRushRepairReportQueryType customRushRepairReportQueryType);
}
