package com.tofly.dyrq.custom.mapper;

import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.tofly.dyrq.custom.entity.CustomScada;
import com.tofly.dyrq.custom.entity.ScadaConfig;
import com.tofly.dyrq.custom.entity.ScadaRealdataResult;
import com.tofly.dyrq.custom.entity.ScadaStationResult;
import com.tofly.dyrq.entity.ScadaRealdata;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

import java.util.List;
import java.util.Map;

@Mapper
public interface CustomScadaMapper extends BaseMapper<CustomScada> {
    public List<Map> getStation(Page page, @Param("filter")String filter);
    public CustomScada getStationById(@Param("ptid")String ptid);
    public List<Map> getStationByList(List<String> list);
    public List<Map> getAlarmConfigByList(Page page,@Param("list") List<String> list);
    public List<Map> getAlarmInfo();

    int updateTag(@Param("scadaRealdata")ScadaRealdata scadaRealdata);
    int insertTag(@Param("scadaRealdata")ScadaRealdata scadaRealdata);

    List<ScadaStationResult> getRealData(@Param("searchText") String searchText,@Param("ptidList") List<String> ptidList);
    void updateConfig(@Param("scadaConfigs") List<ScadaConfig> scadaConfigs);
    void saveBatch(@Param("insertData") List<ScadaRealdata> insertData);
    void updateBatch(@Param("updateData") List<ScadaRealdata> updateData);
}
