package com.tofly.dyrq.custom.service;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.IService;
import com.tofly.dyrq.custom.entity.*;
import com.tofly.dyrq.entity.*;

import javax.servlet.http.HttpServletRequest;
import java.util.Map;

public interface CustomConstructionSiteService extends IService<ConstructionSite> {
     /**
      * 新增工地监护工单表(传入附件)
      *
      * @param servletRequest
      * @param constructionSite
      * @return
      */
     public boolean saveConstructionSite(HttpServletRequest servletRequest, ConstructionSite constructionSite);

     /**
      * 按条件分页查询
      *
      * @param page
      * @param constructionSiteSearch
      */
     public Page<Map> pageByCondition(Page page, ConstructionSiteSearch constructionSiteSearch);

     /**
      * 按条件分页查询(新)
      *
      * @param page
      * @param constructionSiteSearch
      */
     public Page<Map> pageByCondition2(Page page, ConstructionSiteSearch constructionSiteSearch);


     public Page<Map> getConstructionPageByUser(Page page, ConstructionSiteSearchUser constructionSiteSearchUser);

     /**
      * 根据传入id查询抢维修工单详情
      *
      * @param id
      * @return
      */
     public CustomConstructionSite getConstructionSiteById(Long id);

     /**
      * 根据传入id删除工地监护工单
      *
      * @param id
      * @return
      */
     public boolean removeById(Long id);

     /**
      * 工地监护审核派工
      *
      * @param constructionSiteDispatch
      * @return
      */
     public boolean saveConstructionSiteDispatch(ConstructionSiteDispatch constructionSiteDispatch);

     /**
      * 工地监护过程管理
      *
      * @param constructionProcess
      * @param servletRequest
      * @return
      */
     public boolean saveConstructionProcess(HttpServletRequest servletRequest, ConstructionProcess constructionProcess);

     /**
      * 工地监护审核施工结束
      *
      * @param servletRequest
      * @param constructionAuditEnd
      * @return
      */
     public boolean saveConstructionAuditEnd(HttpServletRequest servletRequest, ConstructionAuditEnd constructionAuditEnd);

}
