package com.tofly.dyrq.custom.service;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.tofly.dyrq.custom.entity.*;
import com.tofly.dyrq.entity.RushRepair;
import com.tofly.dyrq.entity.RushRepairAuditDispatch;
import com.tofly.dyrq.entity.RushRepairAuditEnd;
import com.tofly.dyrq.entity.RushRepairProcessManage;

import javax.servlet.http.HttpServletRequest;
import java.util.List;
import java.util.Map;

public interface CustomRushRepairService {
     /**
      * 新增抢维修工单表(传入附件)
      *
      * @param servletRequest
      * @param rushRepair
      * @return
      */
     public boolean saveRushRepair(HttpServletRequest servletRequest , RushRepair rushRepair);

     /**
      * 按条件分页查询
      *
      * @param page
      * @param rushRepairSearch
      */
     public Page<Map> pageByCondition(Page page, RushRepairSearch rushRepairSearch);

     /**
      * 按条件分页查询(新)
      *
      * @param page
      * @param rushRepairSearch
      */
     public Page<Map> pageByCondition2(Page page, RushRepairSearch rushRepairSearch);

     /**
      * 按条件分页查询(App新)
      *
      * @param page
      * @param rushRepairSearch
      *//*
     public Page<Map> pageByCondition3(Page page, RushRepairSearch rushRepairSearch);*/

     /**
      * 根据传入id查询抢维修工单详情
      *
      * @param id
      * @return
      */
     public CustomRushRepair getRushRepairById(Long id);

     /**
      * 根据传入id删除抢维修工单
      *
      * @param id
      * @return
      */
     public boolean removeById(Long id);

     /**
      * 抢维修审核派工
      *
      * @param rushRepairAuditDispatch
      * @return
      */
     public boolean saveRushRepairAuditDispatch(RushRepairAuditDispatch rushRepairAuditDispatch);

     /**
      * 抢维修过程管理
      *
      * @param rushRepairProcessManage
      * @param servletRequest
      * @return
      */
     public boolean saveRushRepairProcessManage(HttpServletRequest servletRequest, RushRepairProcessManage rushRepairProcessManage);

     /**
      * 抢维修审核施工结束
      *
      * @param servletRequest
      * @param rushRepairAuditEnd
      * @return
      */
     public boolean saveRushRepairAuditEnd(HttpServletRequest servletRequest, RushRepairAuditEnd rushRepairAuditEnd);

     /**
      * 个人查询
      *
      * @param page
      * @param rushRepairSearchUser
      */
     public Page<Map> getConstructionPageByUser(Page page, RushRepairSearchUser rushRepairSearchUser);

     public List<Map> getReportByTYpe(CustomRushRepairReportQuery customRushRepairReportQuery);

     public List<Map> getReportByTime(CustomRushRepairReportQueryType customRushRepairReportQueryType);

}
