package com.tofly.dyrq.custom.service;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.tofly.dyrq.custom.entity.CustomScada;
import com.tofly.dyrq.custom.entity.ScadaConfig;
import com.tofly.dyrq.custom.entity.ScadaStationResult;
import com.tofly.dyrq.entity.ScadaRealdata;
import com.tofly.dyrq.entity.ScadapntsDes;

import java.rmi.MarshalledObject;
import java.util.List;
import java.util.Map;

public interface CustomScadaService {
    public Page<Map> getStation(Page page, String filter);

    public CustomScada getStationById(String ptid);

    public List<Map> getStationByList(List<String> list);

    public Page<Map> getAlarmConfigByList(Page page, List<String> list);

    public List<Map> getAlarmInfo();

    Boolean updateByName(List<ScadapntsDes> list);

    /**
     * scada数据更新或者插入
     *
     * @param scadaRealdataList scada更新数据
     * @return
     */
    Boolean updateRealData(List<ScadaRealdata> scadaRealdataList);

    /**
     * scada实时数据分页
     *
     * @param searchText 参数编号和名称分页查询
     * @return
     */
    List<ScadaStationResult> getRealData(String searchText,String ptIds);

    /**
     *  批量报警配置
     * @param scadaConfigs 需要配置的参数及报警值
     * @return
     */
    Boolean updateConfig(List<ScadaConfig> scadaConfigs);
}
