package com.tofly.dyrq.custom.service;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.tofly.dyrq.custom.entity.*;
import org.apache.ibatis.annotations.Param;
import org.springframework.web.bind.annotation.RequestBody;

import javax.servlet.http.HttpServletRequest;
import java.util.List;
import java.util.Map;

public interface CustomTroubleService {
    /**
     * 根据条件查询隐患列表数据
     * @param page
     * @param troubleSearch
     * @return
     */
    Page<Map> getList(Page page, TroubleSearch troubleSearch);

    /**
     * 隐患信息上报
     * @param request
     * @param troubleSave
     * @return
     */
    Boolean save(HttpServletRequest request, TroubleSave troubleSave);

    /**
     * (非工作时间)值班人员现场勘查
     * @param request
     * @param troubleOndutyUpload
     * @return
     *//*
    Boolean ondutyUserCheck(HttpServletRequest request, TroubleOndutyUpload troubleOndutyUpload);

    *//**
     * (工作时间)承办班班长审核派工
     * @param undertakerCheck
     * @return
     *//*
    Boolean undertakerCheck(UndertakerCheck undertakerCheck);

    *//**
     *(工作时间)巡检人员现场核实
     * @param request
     * @param undertakerHandle
     * @return
     *//*
    Boolean undertakerHandle(HttpServletRequest request, UndertakerHandle undertakerHandle);*/

    /**
     * 班组长审核派工
     * @param undersecretaryCheck
     * @return
     */
    Boolean undersecretaryCheck(HttpServletRequest request, UndersecretaryCheck undersecretaryCheck);

    /**
     * 班组长/副部长/其他班组长编制方案
     * @param request
     * @param designSchema
     * @return
     */
    Boolean designSchema(HttpServletRequest request,DesignSchema designSchema);

    /**
     * 副部长审批隐患处理方案
     * @param secretaryCheck
     * @return
     */
    Boolean secretaryCheck(HttpServletRequest request,SecretaryCheck secretaryCheck);

    /**
     * 工单负责人处理回报
     * @param request
     * @param handleSchema
     * @return
     */
    Boolean handleSchema(HttpServletRequest request, HandleSchema handleSchema);

    /**
     * 副部长/班组长审核处理回报
     * @param handleCheck
     * @return
     */
    Boolean handleCheck(HttpServletRequest request,HandleCheck handleCheck);


    List<Map> lxtj(CustomRushRepairReportQuery customRushRepairReportQuery);

    List<Map> qsfx(CustomRushRepairReportQuery customRushRepairReportQuery);

    boolean updatePipeDevice(CustomTroubleUpdatePipe customTroubleUpdatePipe);

    Page<Map> getListNew(Page page, TroubleSearch troubleSearch);

    CustomTrouble getById(Long id);

}
