package com.tofly.dyrq.custom.service.impl;

import com.baomidou.mybatisplus.core.toolkit.IdWorker;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.tofly.common.core.util.FtpUtil;
import com.tofly.common.oauth.util.SecurityUtils;
import com.tofly.dyrq.config.FilePathBean;
import com.tofly.dyrq.custom.service.CustomAppFileService;
import com.tofly.dyrq.entity.AppFile;
import com.tofly.dyrq.service.AppFileService;
import lombok.AllArgsConstructor;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.util.MultiValueMap;
import org.springframework.web.multipart.MultipartFile;
import org.springframework.web.multipart.MultipartHttpServletRequest;

import javax.servlet.http.HttpServletRequest;
import java.io.File;
import java.util.Arrays;
import java.util.Date;
import java.util.List;

@Service
@AllArgsConstructor
public class CustomAppFileServiceImpl implements CustomAppFileService {
    private FilePathBean filePathBean;
    private AppFileService appFileService;

    @Override
    public boolean save(HttpServletRequest servletRequest, AppFile appFile) {
        MultiValueMap<String, MultipartFile> multiFileMap = ((MultipartHttpServletRequest) servletRequest).getMultiFileMap();
        if (multiFileMap != null) {
            multiFileMap.forEach((k, v) -> {
                String filePath = filePathBean.getAppfile() + IdWorker.getIdStr() + v.get(0).getOriginalFilename().substring(v.get(0).getOriginalFilename().lastIndexOf("."));
                boolean b = FtpUtil.uploadFile2Ftp(v.get(0), filePath);
                appFile.setFilePath(filePath);
                appFile.setFileName(v.get(0).getOriginalFilename());
            });
        }
        appFile.setCreatTime(new Date());
        appFile.setCreatUser(SecurityUtils.getUserId());
        appFileService.save(appFile);
        return true;
    }

    /*@Override
    public boolean removeByIds(String ids) {
        List<String> list = Arrays.asList(ids.split(","));
        List<AppFile> list1 = appFileService.list(Wrappers.<AppFile>lambdaQuery()
                .in(AppFile::getId, list));
        list1.forEach(k->{
            FtpUtil.deleteFile(k.getFilePath());
        });
        appFileService.remove(Wrappers.<AppFile>lambdaQuery()
                .in(AppFile::getId,list));
        return true;
    }*/

    @Override
    public AppFile getNew() {
        List<AppFile> list = appFileService.list(Wrappers.<AppFile>lambdaQuery()
                .orderByDesc(AppFile::getCreatTime));
        return list.get(0);
    }
}
