package com.tofly.dyrq.custom.service.impl;

import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.core.toolkit.IdWorker;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.tofly.common.core.util.BeanUtils;
import com.tofly.common.core.util.FtpUtil;
import com.tofly.common.core.util.StringUtil;
import com.tofly.common.mapper.ToflyCodeCommonMapper;
import com.tofly.common.oauth.exception.ToflyDeniedException;
import com.tofly.common.oauth.util.SecurityUtils;
import com.tofly.dyrq.config.FilePathBean;
import com.tofly.dyrq.custom.entity.*;
import com.tofly.dyrq.custom.mapper.CustomConstructionSiteMapper;
import com.tofly.dyrq.custom.service.CustomConstructionSiteService;
import com.tofly.dyrq.entity.*;
import com.tofly.dyrq.mapper.ConstructionSiteMapper;
import com.tofly.dyrq.service.*;
import lombok.AllArgsConstructor;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.util.MultiValueMap;
import org.springframework.web.multipart.MultipartFile;
import org.springframework.web.multipart.MultipartHttpServletRequest;

import javax.servlet.http.HttpServletRequest;
import java.util.*;
import java.util.stream.Collectors;

@Service
@AllArgsConstructor
public class CustomConstructionSiteServiceImpl extends ServiceImpl<ConstructionSiteMapper, ConstructionSite> implements CustomConstructionSiteService {
    private final FilePathBean filePathBean;
    private final ToflyCodeCommonMapper toflyCodeCommonMapper;
    private final ConstructionSiteMapper constructionSiteMapper;
    private final CustomConstructionSiteMapper customConstructionSiteMapper;
    private final ConstructionSiteService constructionSiteService;
    private final ConstructionProcessService constructionProcessService;
    private final ConstructionSiteFileService constructionSiteFileService;
    private final ConstructionAuditEndService constructionAuditEndService;
    private final ConstructionFiletositeService constructionFiletositeService;
    private final ConstructionFiletoauditService constructionFiletoauditService;
    private final ConstructionFiletoprocessService constructionFiletoprocessService;

    public List<ConstructionSiteFile> file(HttpServletRequest servletRequest) {
        MultiValueMap<String, MultipartFile> multipartFileMap = ((MultipartHttpServletRequest) servletRequest).getMultiFileMap();
        List<ConstructionSiteFile> list = new ArrayList<>();
        if (multipartFileMap.size() > 0) {
            multipartFileMap.forEach((k, v) -> {
                //web端所有文件
                if (k.contains("file")) {
                    v.forEach(f -> {
                        String filename = filePathBean.getConstructionsite() + IdWorker.getIdStr() + f.getOriginalFilename().substring(f.getOriginalFilename().lastIndexOf("."));
                        boolean b = FtpUtil.uploadFile2Ftp(f, filename);

                        ConstructionSiteFile constructionSiteFile = new ConstructionSiteFile();
                        constructionSiteFile.setPath(filename);
                        constructionSiteFile.setFileName(f.getOriginalFilename());
                        if (filename.toLowerCase().endsWith(".bmp")
                                || filename.toLowerCase().endsWith(".jpg")
                                || filename.toLowerCase().endsWith(".jpeg")
                                || filename.toLowerCase().endsWith(".gif")
                                || filename.toLowerCase().endsWith(".png")) {
                            constructionSiteFile.setFileType("0");
                        } else if (filename.toLowerCase().endsWith(".amr")) {
                            constructionSiteFile.setFileType("1");
                        } else {
                            constructionSiteFile.setFileType("3");
                        }
                        constructionSiteFileService.save(constructionSiteFile);
                        list.add(constructionSiteFile);
                    });
                }
                //移动端照片
                if (k.contains("photo")) {
                    v.forEach(f -> {
                        String filename = filePathBean.getConstructionsite() + IdWorker.getIdStr() + f.getOriginalFilename().substring(f.getOriginalFilename().lastIndexOf("."));
                        boolean b = FtpUtil.uploadFile2Ftp(f, filename);
                        ConstructionSiteFile constructionSiteFile = new ConstructionSiteFile();
                        constructionSiteFile.setPath(filename);
                        constructionSiteFile.setFileName(f.getOriginalFilename());
                        constructionSiteFile.setFileType("0");
                        constructionSiteFileService.save(constructionSiteFile);
                        list.add(constructionSiteFile);
                    });
                }
                //移动端语音
                if (k.contains("audio")) {
                    v.forEach(f -> {
                        String filename = filePathBean.getConstructionsite() + IdWorker.getIdStr() + f.getOriginalFilename().substring(f.getOriginalFilename().lastIndexOf("."));
                        boolean b = FtpUtil.uploadFile2Ftp(f, filename);
                        ConstructionSiteFile constructionSiteFile = new ConstructionSiteFile();
                        constructionSiteFile.setPath(filename);
                        constructionSiteFile.setFileName(f.getOriginalFilename());
                        constructionSiteFile.setFileType("1");
                        constructionSiteFileService.save(constructionSiteFile);
                        list.add(constructionSiteFile);
                    });
                }
                //移动端文件
                if (k.contains("other")) {
                    v.forEach(f -> {
                        String filename = filePathBean.getConstructionsite() + IdWorker.getIdStr() + f.getOriginalFilename().substring(f.getOriginalFilename().lastIndexOf("."));
                        boolean b = FtpUtil.uploadFile2Ftp(f, filename);
                        ConstructionSiteFile constructionSiteFile = new ConstructionSiteFile();
                        constructionSiteFile.setPath(filename);
                        constructionSiteFile.setFileName(f.getOriginalFilename());
                        constructionSiteFile.setFileType("3");
                        constructionSiteFileService.save(constructionSiteFile);
                        list.add(constructionSiteFile);
                    });
                }
            });
        }
        return list;
    }

    @Override
    @Transactional
    public boolean saveConstructionSite(HttpServletRequest servletRequest, ConstructionSite constructionSite) {
        if (constructionSite.getId() == null) {
            if (StringUtil.isEmpty(constructionSite.getSiteName())) {
                throw new ToflyDeniedException("工地名称地址不能为空");
            }
            if (StringUtil.isEmpty(constructionSite.getConstructionAddress())) {
                throw new ToflyDeniedException("施工地点不能为空");
            }
            if (constructionSite.getSiteType() == null) {
                throw new ToflyDeniedException("工地监护工单类型不能为空");
            }
            constructionSite.setCreatTime(new Date());
            constructionSite.setCreatUser(SecurityUtils.getUserId());
            constructionSiteService.save(constructionSite);
            for (ConstructionSiteFile constructionSiteFile : this.file(servletRequest)) {
                ConstructionFiletosite constructionFiletosite = new ConstructionFiletosite();
                constructionFiletosite.setWorkOrderId(constructionSite.getId());
                constructionFiletosite.setFileId(constructionSiteFile.getId());
                constructionFiletositeService.save(constructionFiletosite);
            }
        } else if (constructionSite.getId() != null) {
            String state = constructionSiteService.getById(constructionSite.getId()).getConstructionState();
            if(StringUtil.isNotEmpty(state) && Integer.parseInt(state) > 1){
                throw new ToflyDeniedException("工单已派工,无法再次修改");
            }
            constructionSiteService.updateById(constructionSite);
            if ( constructionSite.getDeleteFilePaths()!=null && constructionSite.getDeleteFilePaths().size() > 0) {
                List<ConstructionFiletosite> list = constructionFiletositeService.list(Wrappers.<ConstructionFiletosite>lambdaQuery()
                        .eq(ConstructionFiletosite::getWorkOrderId, constructionSite.getId()));
                List<Long> fileIds = new ArrayList<>();
                for (ConstructionFiletosite file : list) {
                    fileIds.add(file.getFileId());
                }
                List<ConstructionSiteFile> list2 = constructionSiteFileService.list(Wrappers.<ConstructionSiteFile>lambdaQuery()
                        .in(ConstructionSiteFile::getPath, constructionSite.getDeleteFilePaths()));
                List<Long> fileIds2 = new ArrayList<>();
                fileIds.forEach(k -> {
                    for (ConstructionSiteFile c : list2) {
                        if (c.getId().equals(k)) {
                            fileIds2.add(k);
                        }
                    }
                });
                /*List<ConstructionSiteFile> list1 = constructionSiteFileService.list(Wrappers.<ConstructionSiteFile>lambdaQuery()
                        .in(ConstructionSiteFile::getId, fileIds));*/
                /*list1.forEach(k -> {
                    FtpUtil.deleteFile(k);
                });*/
                List<String> list1 = constructionSite.getDeleteFilePaths();
                for (String path : list1) {
                    FtpUtil.deleteFile(path);
                }
                constructionFiletositeService.removeByIds(fileIds2);
                constructionSiteFileService.removeByIds(fileIds2);
            }
            if (!((MultipartHttpServletRequest) servletRequest).getMultiFileMap().isEmpty()) {
                for (ConstructionSiteFile constructionSiteFile : this.file(servletRequest)) {
                    ConstructionFiletosite constructionFiletosite = new ConstructionFiletosite();
                    constructionFiletosite.setWorkOrderId(constructionSite.getId());
                    constructionFiletosite.setFileId(constructionSiteFile.getId());
                    constructionFiletositeService.save(constructionFiletosite);
                }
            }
        }
        return true;
    }

    @Override
    public Page<Map> pageByCondition(Page page, ConstructionSiteSearch constructionSiteSearch) {
        List<Long> userIds = new ArrayList<>();
        if (StringUtil.isNotEmpty(constructionSiteSearch.getUserIds())) {
            String[] users = constructionSiteSearch.getUserIds().split(",");
            for (String user : users) {
                userIds.addAll(customConstructionSiteMapper.getIdByRole(Long.valueOf(user)));
            }
        }
        if (StringUtil.isNotEmpty(constructionSiteSearch.getUserIds()) && userIds.isEmpty()) {
            userIds.add(Long.MAX_VALUE);
        }
        if(StringUtil.isNotEmpty(constructionSiteSearch.getConstructionStates())){
            constructionSiteSearch.setConstructionStateList(Arrays.asList(
                    constructionSiteSearch.getConstructionStates().split(",")));
        }
        /*IPage result = constructionSiteService.pageMaps(page, Wrappers.<ConstructionSite>lambdaQuery()
                .like(StringUtil.isNotEmpty(constructionSiteSearch.getSiteName()), ConstructionSite::getSiteName, constructionSiteSearch.getSiteName())
                .eq(StringUtil.isNotEmpty(constructionSiteSearch.getSiteType()), ConstructionSite::getSiteType, constructionSiteSearch.getSiteType())
                .eq(StringUtil.isNotEmpty(constructionSiteSearch.getConstructionState()), ConstructionSite::getConstructionState, constructionSiteSearch.getConstructionState())
                .eq(constructionSiteSearch.getCreatUser() != null, ConstructionSite::getCreatUser, constructionSiteSearch.getCreatUser())
                .in(!userIds.isEmpty(), ConstructionSite::getId, userIds));*/
        Page<Map> result = page.setRecords(customConstructionSiteMapper.pageByCondition(page, constructionSiteSearch, userIds));
        //List<Map> records = result.getRecords();
        /*for (Map r : records) {
         *//*if (r.get("rushRepairResponsible") != null) {
                r.put("responsibleName", toflyCodeCommonMapper.getUserName(Long.parseLong(r.get("rushRepairResponsible").toString())));
            }
            if (r.get("dispatchUserId") != null) {
                r.put("dispatchUserName", toflyCodeCommonMapper.getUserName(Long.parseLong(r.get("dispatchUserId").toString())));
            } else {
                r.put("dispatchUserName", null);
            }
            if (r.get("constructionPerson") != null) {
                r.put("constructionPersonName", toflyCodeCommonMapper.getUserName(Long.parseLong(r.get("constructionPerson").toString())));
            } else {
                r.put("constructionPersonName", null);
            }
            if (r.get("siteType") != null) {
                r.put("siteTypeName", constructionSiteMapper.getsiteTypeName(r.get("siteType").toString()));
            } else {
                r.put("siteTypeName", null);
            }
            if (r.get("constructionState") != null) {
                r.put("constructionStateName", constructionSiteMapper.getconstructionStateName(r.get("constructionState").toString()));
            } else {
                r.put("constructionStateName", null);
            }*//*
            r.put("files", customConstructionSiteMapper.getFilesName(Long.parseLong(r.get("id").toString())));
            r.put("voice", customConstructionSiteMapper.getVoice(Long.parseLong(r.get("id").toString())));
            //r.put("endFiles", customConstructionSiteMapper.getEndFilesName(Long.parseLong(r.get("id").toString())));
            r.put("endVoice", customConstructionSiteMapper.getEndVoice(Long.parseLong(r.get("id").toString())));
            List<CustomConstructionProcess> processManages = customConstructionSiteMapper.getProcess(Long.parseLong(r.get("id").toString()));
            for (CustomConstructionProcess p : processManages) {
                p.setProcessFiles(customConstructionSiteMapper.getProcessFiles(p.getId()));
                p.setProcessVoice(customConstructionSiteMapper.getProcessVoice(p.getId()));
            }
            r.put("processManages", processManages);

            List<CustomConStructionAudit> auditList = customConstructionSiteMapper.getAuditList(Long.parseLong(r.get("id").toString()));
            for (CustomConStructionAudit a : auditList) {
                a.setAuditEndFiles(customConstructionSiteMapper.getAuditFiles(a.getId()));
            }
            r.put("auditList", auditList);
        }*/

        return result;
    }

    @Override
    public Page<Map> pageByCondition2(Page page, ConstructionSiteSearch constructionSiteSearch) {
        List<Long> userIds = new ArrayList<>();
        if (StringUtil.isNotEmpty(constructionSiteSearch.getUserIds())) {
            String[] users = constructionSiteSearch.getUserIds().split(",");
            for (String user : users) {
                userIds.addAll(customConstructionSiteMapper.getIdByRole(Long.valueOf(user)));
            }
        }
        if (StringUtil.isNotEmpty(constructionSiteSearch.getUserIds()) && userIds.isEmpty()) {
            userIds.add(Long.MAX_VALUE);
        }
        if(StringUtil.isNotEmpty(constructionSiteSearch.getConstructionStates())){
            constructionSiteSearch.setConstructionStateList(Arrays.asList(
                    constructionSiteSearch.getConstructionStates().split(",")));
        }
        Page<Map> result = page.setRecords(customConstructionSiteMapper.pageByCondition2(page, constructionSiteSearch, userIds));
        return result;
    }

    @Override
    public Page<Map> getConstructionPageByUser(Page page, ConstructionSiteSearchUser constructionSiteSearchUser) {
        constructionSiteSearchUser.setUserId(SecurityUtils.getUserId());
        List<CustomConstructionSite> list = customConstructionSiteMapper.pageByConditionByUser(page, constructionSiteSearchUser);
        return page.setRecords(list);
    }

    @Override
    public CustomConstructionSite getConstructionSiteById(Long id) {
        CustomConstructionSite customConstructionSite = customConstructionSiteMapper.getConstructionSiteById(id);
        return customConstructionSite;
    }

    /*@Override
    public CustomRushRepair getRushRepairById(Long id) {
        return null;
    }*/

    @Override
    @Transactional
    public boolean removeById(Long id) {
        List<ConstructionFiletosite> list = constructionFiletositeService.list(Wrappers.<ConstructionFiletosite>lambdaQuery()
                .eq(ConstructionFiletosite::getWorkOrderId, id));
        List<Long> fileIds = new ArrayList<>();
        for (ConstructionFiletosite file : list) {
            fileIds.add(file.getFileId());
        }
        if (!fileIds.isEmpty()) {
            List<ConstructionSiteFile> list1 = constructionSiteFileService.list(Wrappers.<ConstructionSiteFile>lambdaQuery()
                    .in(ConstructionSiteFile::getId, fileIds));
            list1.forEach(k -> {
                FtpUtil.deleteFile(k.getPath());
            });
            constructionSiteFileService.removeByIds(fileIds);
            constructionFiletositeService.removeByIds(fileIds);
        }
        constructionSiteService.removeById(id);
        return true;
    }

    @Override
    public boolean saveConstructionSiteDispatch(ConstructionSiteDispatch constructionSiteDispatch) {
        return false;
    }

    @Override
    @Transactional
    public boolean saveConstructionProcess(HttpServletRequest servletRequest, ConstructionProcess constructionProcess) {
        constructionProcess.setManageDate(new Date());
        constructionProcessService.save(constructionProcess);

        if (!((MultipartHttpServletRequest) servletRequest).getMultiFileMap().isEmpty()) {
            for (ConstructionSiteFile constructionSiteFile : this.file(servletRequest)) {
                ConstructionFiletoprocess constructionFiletoprocess = new ConstructionFiletoprocess();
                constructionFiletoprocess.setFileId(constructionSiteFile.getId());
                constructionFiletoprocess.setProcessManageId(constructionProcess.getId());
                constructionFiletoprocessService.save(constructionFiletoprocess);
            }
        }
        return true;
    }

    @Override
    @Transactional
    public boolean saveConstructionAuditEnd(HttpServletRequest servletRequest, ConstructionAuditEnd constructionAuditEnd) {
        constructionAuditEnd.setAuditTime(new Date());
        constructionAuditEnd.setAuditor(SecurityUtils.getUserId());
        constructionAuditEndService.save(constructionAuditEnd);
        if (!((MultipartHttpServletRequest) servletRequest).getMultiFileMap().isEmpty()) {
            for (ConstructionSiteFile constructionSiteFile : this.file(servletRequest)) {
                ConstructionFiletoaudit constructionFiletoaudit = new ConstructionFiletoaudit();
                constructionFiletoaudit.setFileId(constructionSiteFile.getId());
                constructionFiletoaudit.setAuditEndId(constructionAuditEnd.getId());
                constructionFiletoauditService.save(constructionFiletoaudit);
            }
        }
        //20200703wjmodify,更新状态时，这里写得有问题，
//        if ("0".equals(StringUtil.isNotEmpty(constructionAuditEnd.getAuditmind()))) {
//            constructionSiteService.update(Wrappers.<ConstructionSite>lambdaUpdate()
//                    .eq(ConstructionSite::getId, constructionAuditEnd.getWorkOrderId())
//                    .set(ConstructionSite::getConstructionState, "5"));
//        } else if ("1".equals(StringUtil.isNotEmpty(constructionAuditEnd.getAuditmind()))) {
//            constructionSiteService.update(Wrappers.<ConstructionSite>lambdaUpdate()
//                    .eq(ConstructionSite::getId, constructionAuditEnd.getWorkOrderId())
//                    .set(ConstructionSite::getConstructionState, "4"));
//        }
        if ("0".equals(constructionAuditEnd.getAuditmind())) {
            constructionSiteService.update(Wrappers.<ConstructionSite>lambdaUpdate()
                    .eq(ConstructionSite::getId, constructionAuditEnd.getWorkOrderId())
                    .set(ConstructionSite::getConstructionState, "5"));
        } else if ("1".equals(constructionAuditEnd.getAuditmind())) {
            constructionSiteService.update(Wrappers.<ConstructionSite>lambdaUpdate()
                    .eq(ConstructionSite::getId, constructionAuditEnd.getWorkOrderId())
                    .set(ConstructionSite::getConstructionState, "4"));
        }
        return true;
    }
}
