package com.tofly.dyrq.custom.service.impl;

import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.tofly.common.oauth.exception.ToflyDeniedException;
import com.tofly.dyrq.custom.entity.CarUploadSearch;
import com.tofly.dyrq.custom.entity.DeviceUpLoadSearch;
import com.tofly.dyrq.custom.entity.DeviceUploadMobile;
import com.tofly.dyrq.custom.mapper.CustomDeviceUploadMapper;
import com.tofly.dyrq.custom.service.CustomDeviceUploadService;
import com.tofly.dyrq.entity.Plan;
import com.tofly.dyrq.entity.TfPdaSign;
import com.tofly.dyrq.service.PlanService;
import lombok.AllArgsConstructor;
import org.springframework.stereotype.Service;

import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.Date;
import java.util.List;
import java.util.Map;

@Service
@AllArgsConstructor
public class CustomDeviceUploadServiceImpl implements CustomDeviceUploadService {
    private final PlanService planService;
    private final CustomDeviceUploadMapper customDeviceUploadMapper;

    @Override
    public Page<Map> getPageByMobile(Page page, DeviceUpLoadSearch deviceUpLoadSearch) {
        if (deviceUpLoadSearch.getDeptId() == 0){
            throw new ToflyDeniedException("请上传部门ID");
        }
        if (deviceUpLoadSearch.getSearchDate() != null){
            throw new ToflyDeniedException("请上传查询日期");
        }
        Long deptId = deviceUpLoadSearch.getDeptId();
        String startTime = deviceUpLoadSearch.getSearchDate().toString() + "0:00:00";
        String endTime = deviceUpLoadSearch.getSearchDate().toString() + "23:59:59";

        return page.setRecords(customDeviceUploadMapper.getPageByMobile(page,deptId,startTime,endTime));
    }

    @Override
    public Page<Map> listCarWatch(Page page, CarUploadSearch carUploadSearch) {
        Long deptId = carUploadSearch.getDeptId();
        Calendar cal = Calendar.getInstance();
        if (carUploadSearch.getDate() != null) {
            cal.setTime(carUploadSearch.getDate());
        }
        cal.set(Calendar.HOUR_OF_DAY, 0);
        cal.set(Calendar.MINUTE, 0);
        cal.set(Calendar.SECOND, 0);
        Date startDate = cal.getTime();
        cal.set(Calendar.HOUR_OF_DAY, 23);
        cal.set(Calendar.MINUTE, 59);
        cal.set(Calendar.SECOND, 59);
        Date endDate = cal.getTime();
        Long carId = carUploadSearch.getCarId();
        return page.setRecords(customDeviceUploadMapper.listCarWatch(page,carId,deptId,startDate,endDate));
    }
}
















