package com.tofly.dyrq.custom.service.impl;

import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.tofly.dyrq.custom.service.CustomEpmtStateService;
import com.tofly.dyrq.entity.EpmtState;
import com.tofly.dyrq.service.EpmtStateService;
import lombok.AllArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.apache.poi.hssf.usermodel.*;
import org.apache.poi.ss.usermodel.*;
import org.apache.poi.ss.util.CellRangeAddress;
import org.springframework.stereotype.Service;

import java.io.IOException;
import java.io.OutputStream;
import java.math.BigDecimal;
import java.math.RoundingMode;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

@Service
@AllArgsConstructor
@Slf4j
public class CustomEpmtStateServiceImpl implements CustomEpmtStateService {
    private EpmtStateService epmtStateService;

    @Override
    public void exportExcel(String ids,OutputStream out, String fileName) {
        List<Long> idList = new ArrayList<>();
        Arrays.asList(ids.split(",")).forEach(k -> {
            idList.add(Long.parseLong(k));
        });
        List<EpmtState> list = epmtStateService.list(Wrappers.<EpmtState>lambdaQuery().in(!idList.isEmpty(), EpmtState::getId, idList));
        HSSFWorkbook wb = new HSSFWorkbook();
        HSSFCellStyle cs = wb.createCellStyle();
        cs.setAlignment(HorizontalAlignment.CENTER);
        cs.setVerticalAlignment(VerticalAlignment.CENTER);
        cs.setBorderBottom(BorderStyle.THIN);
        cs.setBorderLeft(BorderStyle.THIN);
        cs.setBorderRight(BorderStyle.THIN);
        cs.setBorderTop(BorderStyle.THIN);
        cs.setWrapText(true);
        HSSFFont font = wb.createFont();
        font.setFontHeightInPoints((short) 14);
        cs.setFont(font);
        try {
            for (int i = 0; i < list.size(); i++) {
                HSSFSheet sheet = wb.createSheet("sheet" + (i + 1));
                HSSFRow row = sheet.createRow(0);
                row.setHeight((short) 1000);
                Cell cell1 = row.createCell(0);
                cell1.setCellValue("管网运维部设备状况表(" + (i + 1) + ")");
                HSSFCellStyle cs1 = wb.createCellStyle();
                cs1.setAlignment(HorizontalAlignment.CENTER);
                cs1.setVerticalAlignment(VerticalAlignment.CENTER);
                HSSFFont f = wb.createFont();
                f.setFontHeightInPoints((short) 20);
                cs1.setFont(f);
                cell1.setCellStyle(cs1);
                CellRangeAddress region = new CellRangeAddress(0, 0, 0, 5);
                sheet.addMergedRegion(region);
                HSSFRow row1 = sheet.createRow(1);
                row1.setHeight((short) 1200);
                Cell cell2 = row1.createCell(0);
                cell2.setCellValue("项目");
                cell2.setCellStyle(cs);
                Cell cell3 = row1.createCell(1);
                cell3.setCellStyle(cs);
                if (list.get(i).getName() != null) {
                    cell3.setCellValue(list.get(i).getName());
                }
                HSSFCellStyle cs2 = wb.createCellStyle();
                cs2.setBorderTop(BorderStyle.THIN);
                Cell cell43 = row1.createCell(2);
                cell43.setCellStyle(cs2);
                Cell cell44 = row1.createCell(3);
                cell44.setCellStyle(cs2);
                Cell cell45 = row1.createCell(4);
                cell45.setCellStyle(cs2);
                Cell cell4 = row1.createCell(5);
                cell4.setCellValue("备注");
                cell4.setCellStyle(cs);
                CellRangeAddress region1 = new CellRangeAddress(1, 1, 1, 4);
                sheet.addMergedRegion(region1);
                HSSFRow row2 = sheet.createRow(2);
                row2.setHeight((short) 1300);
                Cell cell5 = row2.createCell(0);
                cell5.setCellStyle(cs);
                cell5.setCellValue("设备状况");
                Cell cell6 = row2.createCell(1);
                cell6.setCellStyle(cs);
                cell6.setCellValue("在用设备台数");
                Cell cell7 = row2.createCell(2);
                cell7.setCellStyle(cs);
                cell7.setCellValue("备用设备台数");
                Cell cell8 = row2.createCell(3);
                cell8.setCellValue("设备总台数");
                cell8.setCellStyle(cs);
                Cell cell35 = row2.createCell(4);
                cell35.setCellStyle(cs);
                Cell cell9 = row2.createCell(5);
                cell9.setCellStyle(cs);
                if (list.get(i).getStateNote() != null) {
                    cell9.setCellValue(list.get(i).getStateNote());
                }
                HSSFRow row3 = sheet.createRow(3);
                row3.setHeight((short) 1400);
                HSSFCellStyle cs3 = wb.createCellStyle();
                cs3.setBorderLeft(BorderStyle.THIN);
                Cell cell46 = row3.createCell(0);
                cell46.setCellStyle(cs3);
                Cell cell10 = row3.createCell(1);
                cell10.setCellStyle(cs);
                if (list.get(i).getInUse() != null) {
                    cell10.setCellValue(list.get(i).getInUse());
                } else {
                    cell10.setCellValue(0);
                }
                Cell cell11 = row3.createCell(2);
                cell11.setCellStyle(cs);
                if (list.get(i).getSpare() != null) {
                    cell11.setCellValue(list.get(i).getSpare());
                } else {
                    cell11.setCellValue(0);
                }
                Cell cell12 = row3.createCell(3);
                cell12.setCellStyle(cs);
                if (list.get(i).getTotal() != null) {
                    cell12.setCellValue(list.get(i).getTotal());
                } else {
                    cell12.setCellValue(0);
                }
                Cell cell36 = row3.createCell(4);
                cell36.setCellStyle(cs);
                HSSFCellStyle cs4 = wb.createCellStyle();
                cs4.setBorderRight(BorderStyle.THIN);
                Cell cell49 = row3.createCell(5);
                cell49.setCellStyle(cs4);
                HSSFRow row4 = sheet.createRow(4);
                row4.setHeight((short) 1300);
                Cell cell47 = row4.createCell(0);
                cell47.setCellStyle(cs3);
                Cell cell13 = row4.createCell(1);
                cell13.setCellStyle(cs);
                cell13.setCellValue("完好设备台数");
                Cell cell14 = row4.createCell(2);
                cell14.setCellStyle(cs);
                cell14.setCellValue("设备完好率");
                Cell cell37 = row4.createCell(3);
                cell37.setCellStyle(cs);
                Cell cell38 = row4.createCell(4);
                cell38.setCellStyle(cs);
                Cell cell50 = row4.createCell(5);
                cell50.setCellStyle(cs4);
                HSSFRow row5 = sheet.createRow(5);
                row5.setHeight((short) 1400);
                Cell cell48 = row5.createCell(0);
                cell48.setCellStyle(cs3);
                Cell cell15 = row5.createCell(1);
                cell15.setCellStyle(cs);
                if (list.get(i).getIntact() != null) {
                    cell15.setCellValue(list.get(i).getIntact());
                } else {
                    cell15.setCellValue(0);
                }
                Cell cell16 = row5.createCell(2);
                cell16.setCellStyle(cs);
                if (list.get(i).getIntact() != null && list.get(i).getTotal() != null) {
                    double d = new BigDecimal(list.get(i).getIntact()).divide(new BigDecimal(list.get(i).getTotal()),4, RoundingMode.CEILING).doubleValue();
                    cell16.setCellValue((d * 100) + "%");
                }
                Cell cell39 = row5.createCell(3);
                cell39.setCellStyle(cs);
                Cell cell40 = row5.createCell(4);
                cell40.setCellStyle(cs);
                Cell cell51 = row5.createCell(5);
                cell51.setCellStyle(cs4);
                CellRangeAddress region2 = new CellRangeAddress(2,5,0,0);
                CellRangeAddress region3 = new CellRangeAddress(2,5,5,5);
                sheet.addMergedRegion(region2);
                sheet.addMergedRegion(region3);
                HSSFRow row6 = sheet.createRow(6);
                row6.setHeight((short) 1300);
                Cell cell17 = row6.createCell(0);
                cell17.setCellStyle(cs);
                cell17.setCellValue("设备变动情况");
                Cell cell18 = row6.createCell(1);
                cell18.setCellStyle(cs);
                cell18.setCellValue("新购设备台数");
                Cell cell19 = row6.createCell(2);
                cell19.setCellStyle(cs);
                cell19.setCellValue("移入设备台数");
                Cell cell20 = row6.createCell(3);
                cell20.setCellStyle(cs);
                cell20.setCellValue("移出设备台数");
                Cell cell21 = row6.createCell(4);
                cell21.setCellStyle(cs);
                cell21.setCellValue("报废设备台数");
                Cell cell22 = row6.createCell(5);
                cell22.setCellStyle(cs);
                if (list.get(i).getChangeNote() != null) {
                    cell22.setCellValue(list.get(i).getChangeNote());
                }
                HSSFRow row7 = sheet.createRow(7);
                row7.setHeight((short) 1400);
                Cell cell52 = row7.createCell(0);
                cell52.setCellStyle(cs3);
                Cell cell23 = row7.createCell(1);
                cell23.setCellStyle(cs);
                if (list.get(i).getNewly() != null) {
                    cell23.setCellValue(list.get(i).getNewly());
                } else {
                    cell23.setCellValue(0);
                }
                Cell cell24 = row7.createCell(2);
                cell24.setCellStyle(cs);
                if (list.get(i).getMoveIn() != null) {
                    cell24.setCellValue(list.get(i).getMoveIn());
                } else {
                    cell24.setCellValue(0);
                }
                Cell cell25 = row7.createCell(3);
                cell25.setCellStyle(cs);
                if (list.get(i).getMoveOut() != null) {
                    cell25.setCellValue(list.get(i).getMoveOut());
                } else {
                    cell25.setCellValue(0);
                }
                Cell cell26 = row7.createCell(4);
                cell26.setCellStyle(cs);
                if (list.get(i).getScrap() != null) {
                    cell26.setCellValue(list.get(i).getScrap());
                } else {
                    cell26.setCellValue(0);
                }
                Cell cell53 = row7.createCell(5);
                cell53.setCellStyle(cs4);
                CellRangeAddress region4 = new CellRangeAddress(6,7,0,0);
                CellRangeAddress region5 = new CellRangeAddress(6,7,5,5);
                sheet.addMergedRegion(region4);
                sheet.addMergedRegion(region5);
                HSSFRow row8 = sheet.createRow(8);
                row8.setHeight((short) 1300);
                Cell cell27 = row8.createCell(0);
                cell27.setCellStyle(cs);
                cell27.setCellValue("设备维修情况");
                Cell cell28 = row8.createCell(1);
                cell28.setCellStyle(cs);
                cell28.setCellValue("计划维修台数");
                Cell cell29 = row8.createCell(2);
                cell29.setCellStyle(cs);
                cell29.setCellValue("实际维修台数");
                Cell cell30 = row8.createCell(3);
                cell30.setCellStyle(cs);
                cell30.setCellValue("完成率");
                Cell cell41 = row8.createCell(4);
                cell41.setCellStyle(cs);
                Cell cell31 = row8.createCell(5);
                cell31.setCellStyle(cs);
                if (list.get(i).getRepairNote() != null) {
                    cell31.setCellValue(list.get(i).getRepairNote());
                }
                HSSFRow row9 = sheet.createRow(9);
                row9.setHeight((short) 1400);
                HSSFCellStyle cs5 = wb.createCellStyle();
                cs5.setBorderLeft(BorderStyle.THIN);
                cs5.setBorderBottom(BorderStyle.THIN);
                Cell cell54 = row9.createCell(0);
                cell54.setCellStyle(cs5);
                Cell cell32 = row9.createCell(1);
                cell32.setCellStyle(cs);
                if(list.get(i).getPlanRepair()!=null){
                    cell32.setCellValue(list.get(i).getPlanRepair());
                } else {
                    cell32.setCellValue(0);
                }
                Cell cell33 = row9.createCell(2);
                cell33.setCellStyle(cs);
                if(list.get(i).getActualRepair()!=null){
                    cell33.setCellValue(list.get(i).getActualRepair());
                } else {
                    cell33.setCellValue(0);
                }
                Cell cell34 = row9.createCell(3);
                cell34.setCellStyle(cs);
                if(list.get(i).getPlanRepair()!=null && list.get(i).getActualRepair()!=null){
                    double d = new BigDecimal(list.get(i).getActualRepair()).divide(new BigDecimal(list.get(i).getPlanRepair()),4, RoundingMode.CEILING).doubleValue();
                    cell34.setCellValue((d*100)+"%");
                }
                Cell cell42 = row9.createCell(4);
                cell42.setCellStyle(cs);
                HSSFCellStyle cs6 = wb.createCellStyle();
                cs6.setBorderBottom(BorderStyle.THIN);
                cs6.setBorderRight(BorderStyle.THIN);
                Cell cell55 = row9.createCell(5);
                cell55.setCellStyle(cs6);
                CellRangeAddress region6 = new CellRangeAddress(8,9,0,0);
                CellRangeAddress region7 = new CellRangeAddress(8,9,5,5);
                sheet.addMergedRegion(region6);
                sheet.addMergedRegion(region7);
                sheet.setColumnWidth(1,3000);
                sheet.setColumnWidth(2,3000);
                sheet.setColumnWidth(3,3000);
                sheet.setColumnWidth(4,3000);
                sheet.setColumnWidth(5,8000);
            }
            wb.write(out);
        } catch (Exception e) {
            log.error("导出Excel异常{}", e.getMessage());
        } finally {
            try {
                wb.close();
            } catch (IOException e1) {
                e1.printStackTrace();
            }
            if (out != null) {
                try {
                    out.close();
                } catch (IOException e1) {
                    e1.printStackTrace();
                }
            }
        }
    }
}
