package com.tofly.dyrq.custom.service.impl;

import com.tofly.common.oauth.util.SecurityUtils;
import com.tofly.dyrq.custom.service.CustomKeyEmptTypeService;
import com.tofly.dyrq.custom.service.CustomNormalEmptTypeService;
import com.tofly.dyrq.entity.KeyEmptType;
import com.tofly.dyrq.entity.NormalEmptType;
import com.tofly.dyrq.service.KeyEmptTypeService;
import com.tofly.dyrq.service.NormalEmptTypeService;
import lombok.AllArgsConstructor;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.Date;


@Service
@AllArgsConstructor
public class CustomKeyEmptTypeServiceImpl implements CustomKeyEmptTypeService {
    private KeyEmptTypeService keyEmptTypeService;

    @Override
    @Transactional
    public boolean save(KeyEmptType keyEmptType) {
        keyEmptType.setCreatUser(SecurityUtils.getUserId());
        keyEmptType.setCreatTime(new Date());
        keyEmptTypeService.save(keyEmptType);
        return true;
    }

    @Override
    @Transactional
    public boolean updateById(KeyEmptType keyEmptType) {
        keyEmptType.setUpdateTime(new Date());
        keyEmptTypeService.updateById(keyEmptType);
        return true;
    }
}
