package com.tofly.dyrq.custom.service.impl;

import com.alibaba.fastjson.JSONArray;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.core.toolkit.IdWorker;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.fasterxml.jackson.databind.jsonFormatVisitors.JsonIntegerFormatVisitor;
import com.tofly.common.core.constant.SecurityConstants;
import com.tofly.common.core.entity.ResultRespone;
import com.tofly.common.core.util.Date8Util;
import com.tofly.common.core.util.DateUtil;
import com.tofly.common.core.util.FtpUtil;
import com.tofly.common.core.util.StringUtil;
import com.tofly.common.mapper.ToflyCodeCommonMapper;
import com.tofly.common.oauth.exception.ToflyDeniedException;
import com.tofly.common.oauth.util.SecurityUtils;
import com.tofly.dyrq.custom.entity.*;
import com.tofly.dyrq.custom.mapper.CustomMaintenanceMapper;
import com.tofly.dyrq.custom.service.BaseInfoService;
import com.tofly.dyrq.custom.service.CustomMaintenanceService;
import com.tofly.dyrq.custom.service.CustomPointService;
import com.tofly.dyrq.custom.service.GisAboutService;
import com.tofly.dyrq.entity.*;
import com.tofly.dyrq.config.FilePathBean;
import com.tofly.dyrq.service.*;
import lombok.AllArgsConstructor;
import org.apache.commons.lang.StringUtils;
import org.springframework.data.redis.core.ValueOperations;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.util.MultiValueMap;
import org.springframework.web.multipart.MultipartFile;
import org.springframework.web.multipart.MultipartHttpServletRequest;

import javax.servlet.http.HttpServletRequest;

import java.text.SimpleDateFormat;
import java.util.*;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;
import java.util.stream.Collectors;

@AllArgsConstructor
@Service
public class CustomMaintenanceServiceImpl implements CustomMaintenanceService {
    private final MaintenanceService maintenanceService;
    private final MaintenanceContentService maintenanceContentService;
    private final MaintenanceDeviceService maintenanceDeviceService;
    private final MaintenanceMenuService maintenanceMenuService;
    private final MaintenanceDeviceConService maintenanceDeviceConService;
    private final MaintenanceFileService maintenanceFileService;
    private final MaintenanceDeviceFileService maintenanceDeviceFileService;
    private final FilePathBean filePathBean;
    private final CustomMaintenanceMapper customMaintenanceMapper;
    private final ToflyCodeCommonMapper toflyCodeCommonMapper;
    private final BaseInfoService baseInfoService;
    private final PlanPointTempService planPointTempService;
    private final SysDeviceTypeService sysDeviceTypeService;
    private final GisAboutService gisAboutService;
    private final CustomPointService customPointService;
    
    
    private final ValueOperations<String, String> valueOperations;

    @Override
    public IPage getMaintenancePage(Page page, MaintenanceSearch maintenanceSearch) {
        return page.setRecords(customMaintenanceMapper.getMaintenancePage(page, maintenanceSearch));
        //查询主记录
//        IPage result = maintenanceService.pageMaps(page, Wrappers.<Maintenance>lambdaQuery()
//                .in(maintenanceSearch.getIds() != null, Maintenance::getId, maintenanceSearch.getIds())
////                .eq(maintenanceSearch.getRegion() != null, Maintenance::getRegion, maintenanceSearch.getRegion())
//                .ge(maintenanceSearch.getStartDate() != null, Maintenance::getCheckEndDate, maintenanceSearch.getStartDate())
//                .le(maintenanceSearch.getEndDate() != null, Maintenance::getCheckBeginDate, maintenanceSearch.getEndDate())
//                .eq(maintenanceSearch.getChildPlanId() != null, Maintenance::getChildPlanId, maintenanceSearch.getChildPlanId())
//                .eq(maintenanceSearch.getPlanTempPointId() != null, Maintenance::getPlanTempPointId, maintenanceSearch.getPlanTempPointId())
//                .eq(maintenanceSearch.getCreateUser() != null, Maintenance::getCreateUser, maintenanceSearch.getCreateUser())
//        );
//        List<Map> records = result.getRecords();
//        //查询记录关联的检查内容及详情
//        for (Map i : records) {
//            i.put("userName", i.get("userid") != null ? toflyCodeCommonMapper.getUserName(Long.parseLong(i.get("userid").toString())) : "");
//            i.put("userDeptId", i.get("userid") != null ? toflyCodeCommonMapper.getDeptName(Long.parseLong(i.get("userid").toString())) : "");
//            i.put("checkUserName", i.get("checkUser") != null ? toflyCodeCommonMapper.getUserName(Long.parseLong(i.get("checkUser").toString())) : "");
//            i.put("createUserName", i.get("createUser") != null ? toflyCodeCommonMapper.getUserName(Long.parseLong(i.get("createUser").toString())) : "");
//            Long recordId = Long.parseLong(i.get("id").toString());
//            List<Map<String, Object>> list = maintenanceContentService.listMaps(Wrappers.<MaintenanceContent>lambdaQuery()
//                    .eq(MaintenanceContent::getRecordId, recordId)
//                    .select(MaintenanceContent::getMenuId, MaintenanceContent::getNote));
//            for (Map j : list) {
//                Long menuId = j.get("menuId") != null ? Long.parseLong(j.get("menuId").toString()) : 0;
//                MaintenanceMenu maintenanceMenu = menuId != null ? maintenanceMenuService.getById(menuId) : null;
//                if (maintenanceMenu == null) {
//                    throw new ToflyDeniedException("检查内容菜单不存在该项检查内容");
//                }
//                j.put("parentId", maintenanceMenu.getParentId());
//                j.put("name", maintenanceMenu.getName());
//            }
//            i.put("content", list);
//            //添加文件
//            MaintenanceFile maintenanceFile = new MaintenanceFile();
//            maintenanceFile.setMaintenanceId(recordId);
//            List<MaintenanceFile> files = maintenanceFileService.list(Wrappers.query(maintenanceFile));
//            List<Map> fileStream = files.stream().map(f -> {
//                HashMap hm = new HashMap();
//                hm.put("fileName", f.getFileName());
//                hm.put("filePath", f.getFilePath());
//                return hm;
//            }).collect(Collectors.toList());
//            i.put("files", fileStream);
//        }
//        result.setRecords(records);
//        return result;
    }

    @Transactional
    @Override
    public Boolean addMaintenance(HttpServletRequest request, AddMaintenance addMaintenance) {
    	SimpleDateFormat sdf = new SimpleDateFormat("yyMMddHHmmssSSSSSSS");
    	
        Long childPlanId = addMaintenance.getChildPlanId();
        if(null!=childPlanId) {
        	  valueOperations.set("child_" + Long.parseLong(sdf.format(new Date())), String.valueOf(childPlanId)); 
        }
        
      
        
        Long pointId = addMaintenance.getPlanTempPointId();
        //判断该计划中该点是否已上传
//        Maintenance one = maintenanceService.getOne(Wrappers.<Maintenance>lambdaQuery().eq(Maintenance::getChildPlanId, childPlanId)
//                .eq(Maintenance::getPlanTempPointId, pointId));
//        if (one != null) {
//            throw new ToflyDeniedException("当前计划该设备记录已上传");
//        }

        Date now = Date8Util.getCurrentDate();
        //更新计划的点
        planPointTempService.update(Wrappers.<PlanPointTemp>lambdaUpdate()
                .eq(PlanPointTemp::getChildPlanId, childPlanId)
                .eq(PlanPointTemp::getPointId, pointId)
                .set(PlanPointTemp::getIsover, "1")
                .set(PlanPointTemp::getState, "1")
                .set(PlanPointTemp::getOverDate, now)
                .set(PlanPointTemp::getCheckState, '1')
                .set(PlanPointTemp::getCheckDate, now));

        //保存记录表
        maintenanceService.save(addMaintenance);
        Long recordId = addMaintenance.getId();
        if (addMaintenance.getContent() == null || addMaintenance.getContent().size() == 0) {
            throw new ToflyDeniedException("检查内容不能为空");
        }
        //保存记录关联的检查内容
        addMaintenance.getContent().forEach(content -> {
            if (content.getParentId() == null) {
                throw new ToflyDeniedException("检查设施不能为空");
            }
            //记录设备信息和备注
            MaintenanceContent maintenanceContent = new MaintenanceContent();
            maintenanceContent.setRecordId(recordId);
            maintenanceContent.setMenuId(content.getParentId());
            maintenanceContent.setNote(content.getNote());
            maintenanceContentService.save(maintenanceContent);
            //存储子检查内容
            if (StringUtil.isNotEmpty(content.getMenuIds())) {
                for (Long id : content.getMenuIds()) {
                    MaintenanceContent maintenanceContent2 = new MaintenanceContent();
                    maintenanceContent2.setRecordId(recordId);
                    maintenanceContent2.setMenuId(Long.valueOf(id));
                    maintenanceContentService.save(maintenanceContent2);
                }
            }
        });
        //更新点到位情况

        //遍历请求中key包含photo的所有文件，包括photo1，photo2中的多个文件
        MultiValueMap<String, MultipartFile> multiFileMap = ((MultipartHttpServletRequest) request).getMultiFileMap();
        multiFileMap.forEach((k, v) -> {
            //保存照片
            v.forEach(file -> {
                String fileName = file.getOriginalFilename();
                String filePath = filePathBean.getMaintenance() + IdWorker.getIdStr() + file.getOriginalFilename().substring(file.getOriginalFilename().lastIndexOf("."));
                boolean b = FtpUtil.uploadFile2Ftp(file, filePath);
                if (b) {
                    MaintenanceFile maintenanceFile = new MaintenanceFile();
                    maintenanceFile.setFilePath(filePath);
                    maintenanceFile.setFileName(fileName);
                    maintenanceFile.setMaintenanceId(addMaintenance.getId());
                    maintenanceFileService.save(maintenanceFile);
                }
            });
        });
        return true;
    }

    @Override
    @Transactional
    public Boolean putMaintenance(HttpServletRequest request, AddMaintenance addMaintenance) {
        //更新主记录
        maintenanceService.updateById(addMaintenance);
        //更新关联表 删除原关联并添加
        Long recordId = addMaintenance.getId();
        maintenanceContentService.remove(Wrappers.<MaintenanceContent>lambdaQuery().eq(MaintenanceContent::getRecordId, recordId));
        //保存记录关联的检查内容
        if(addMaintenance.getContent() != null) {
            addMaintenance.getContent().forEach(content -> {
                //记录设备信息和备注
                MaintenanceContent maintenanceContent = new MaintenanceContent();
                maintenanceContent.setRecordId(recordId);
                maintenanceContent.setMenuId(content.getParentId());
                maintenanceContent.setNote(content.getNote());
                maintenanceContentService.save(maintenanceContent);
                //存储子检查内容
//            List menuIds = Arrays.asList(content.getMenuIds().split(","));
                content.getMenuIds().forEach(id -> {
                    MaintenanceContent maintenanceContent2 = new MaintenanceContent();
                    maintenanceContent2.setRecordId(recordId);
                    maintenanceContent2.setMenuId((Long) id);
                    maintenanceContentService.save(maintenanceContent2);
                });
            });
        }
        //清除文件
        List<MaintenanceFile> files = maintenanceFileService.list(Wrappers.<MaintenanceFile>lambdaQuery().eq(MaintenanceFile::getMaintenanceId, recordId));
        files.forEach(file -> {
            Boolean b = FtpUtil.deleteFile(file.getFilePath());
        });
        //清除原文件记录
        maintenanceFileService.remove(Wrappers.<MaintenanceFile>lambdaQuery().eq(MaintenanceFile::getMaintenanceId, recordId));
        //遍历请求中key包含photo的所有文件，包括photo1，photo2中的多个文件
        MultiValueMap<String, MultipartFile> multiFileMap = ((MultipartHttpServletRequest) request).getMultiFileMap();
        multiFileMap.forEach((k, v) -> {
            //保存照片
            v.forEach(file -> {
                String fileName = file.getOriginalFilename();
                String filePath = filePathBean.getMaintenance() + IdWorker.getIdStr() + file.getOriginalFilename().substring(file.getOriginalFilename().lastIndexOf("."));
                boolean b = FtpUtil.uploadFile2Ftp(file, filePath);
                if (b) {
                    MaintenanceFile maintenanceFile = new MaintenanceFile();
                    maintenanceFile.setFilePath(filePath);
                    maintenanceFile.setFileName(fileName);
                    maintenanceFile.setMaintenanceId(addMaintenance.getId());
                    maintenanceFileService.save(maintenanceFile);
                }
            });
        });
        return true;
    }

    @Override
    public IPage getMaintenanceDevicePage(Page page, MaintenanceDeviceSearch maintenanceDeviceSearch) {
        return page.setRecords(customMaintenanceMapper.getMaintenanceDevicePage(page, maintenanceDeviceSearch));
//        //查询主记录
//        IPage result = maintenanceDeviceService.pageMaps(page, Wrappers.<MaintenanceDevice>lambdaQuery()
//                .in(maintenanceDeviceSearch.getIds() != null, MaintenanceDevice::getId, maintenanceDeviceSearch.getIds())
//                .ge(maintenanceDeviceSearch.getStartDate() != null, MaintenanceDevice::getCreateDate, maintenanceDeviceSearch.getStartDate())
//                .le(maintenanceDeviceSearch.getEndDate() != null, MaintenanceDevice::getCreateDate, maintenanceDeviceSearch.getEndDate())
//                .eq(maintenanceDeviceSearch.getChildPlanId() != null, MaintenanceDevice::getChildPlanId, maintenanceDeviceSearch.getChildPlanId())
//                .eq(maintenanceDeviceSearch.getPlanTempPointId() != null, MaintenanceDevice::getPlanTempPointId, maintenanceDeviceSearch.getPlanTempPointId())
//                .eq(maintenanceDeviceSearch.getCreateUser() != null, MaintenanceDevice::getCreateUser, maintenanceDeviceSearch.getCreateUser()));
//        List<Map> records = result.getRecords();
//        //查询记录关联的检查内容及详情
//        for (Map i : records) {
//            i.put("maintainUserName", i.get("maintainUser") != null ? toflyCodeCommonMapper.getUserName(Long.parseLong(i.get("maintainUser").toString())) : "");
//            i.put("checkUserName", i.get("checkUser") != null ? toflyCodeCommonMapper.getUserName(Long.parseLong(i.get("checkUser").toString())) : "");
//            i.put("createUserName", i.get("createUser") != null ? toflyCodeCommonMapper.getUserName(Long.parseLong(i.get("createUser").toString())) : "");
//            i.put("deviceUserName", i.get("deviceUser") != null ? toflyCodeCommonMapper.getUserName(Long.parseLong(i.get("deviceUser").toString())) : "");
//            i.put("repairUserName", i.get("repairUser") != null ? toflyCodeCommonMapper.getUserName(Long.parseLong(i.get("repairUser").toString())) : "");
//            i.put("useUserName", i.get("useUser") != null ? toflyCodeCommonMapper.getUserName(Long.parseLong(i.get("useUser").toString())) : "");
//            //添加设备操作人部门
//            i.put("deviceUserDeptId", i.get("deviceUser") != null ? toflyCodeCommonMapper.getDeptName(Long.parseLong(i.get("deviceUser").toString())) : null);
//            Long recordId = Long.parseLong(i.get("id").toString());
//            MaintenanceDeviceCon maintenanceDeviceCon = new MaintenanceDeviceCon();
//            maintenanceDeviceCon.setDeviceRecordId(recordId);
//            List<MaintenanceDeviceCon> list = maintenanceDeviceConService.list(Wrappers.query(maintenanceDeviceCon));
//            List<Long> list1 = list.stream().map(m -> {
//                Long typeId = m.getTypeId();
//                return typeId;
//            }).collect(Collectors.toList());
//            i.put("content", list1);
//            //添加文件
//            MaintenanceDeviceFile maintenanceDeviceFile = new MaintenanceDeviceFile();
//            maintenanceDeviceFile.setMaintenanceDeviceId(recordId);
//            List<MaintenanceDeviceFile> files = maintenanceDeviceFileService.list(Wrappers.query(maintenanceDeviceFile));
//            List<Map> fileStream = files.stream().map(f -> {
//                HashMap hm = new HashMap();
//                hm.put("fileName", f.getFileName());
//                hm.put("filePath", f.getFilePath());
//                return hm;
//            }).collect(Collectors.toList());
//            i.put("files", fileStream);
//        }
//        result.setRecords(records);
//        return result;
    }

    @Transactional
    @Override
    public Boolean addMaintenanceDevice(HttpServletRequest request, AddMaintenanceDevice addMaintenanceDevice) {
//        if (addMaintenanceDevice.getChildPlanId() == null) {
//            throw new ToflyDeniedException("巡检计划id不能为空");
//        }
//        if (addMaintenanceDevice.getPlanTempPointId() == null) {
//            throw new ToflyDeniedException("巡检计划临时点ID");
//        }
    	
    	SimpleDateFormat sdf = new SimpleDateFormat("yyMMddHHmmssSSSSSSS");
        Long childPlanId = addMaintenanceDevice.getChildPlanId();
        if(null!=childPlanId) {
        	  valueOperations.set("child_" + Long.parseLong(sdf.format(new Date())), String.valueOf(childPlanId)); 
        }
        
    	
       
        Long pointId = addMaintenanceDevice.getPlanTempPointId();
        //判断是否该计划该点存在
//        PlanPointTemp pointTemp = planPointTempService.getOne(Wrappers.<PlanPointTemp>lambdaQuery()
//                .eq(PlanPointTemp::getChildPlanId, childPlanId)
//                .eq(PlanPointTemp::getPointId, pointId));
//        if (pointTemp == null) {
//            throw new ToflyDeniedException("该计划不存在该点信息");
//        }
        //判断该计划中该点是否已上传
//        MaintenanceDevice one = maintenanceDeviceService.getOne(Wrappers.<MaintenanceDevice>lambdaQuery()
//                .eq(MaintenanceDevice::getChildPlanId, childPlanId)
//                .eq(MaintenanceDevice::getPlanTempPointId, pointId));
//        if (one != null) {
//            throw new ToflyDeniedException("当前计划该设备记录已上传");
//        }
        Date now = Date8Util.getCurrentDate();
        //更新计划的点
        planPointTempService.update(Wrappers.<PlanPointTemp>lambdaUpdate()
                .eq(PlanPointTemp::getChildPlanId, childPlanId)
                .eq(PlanPointTemp::getPointId, pointId)
                .set(PlanPointTemp::getIsover, "1")
                .set(PlanPointTemp::getState, "1")
                .set(PlanPointTemp::getOverDate, now)
                .set(PlanPointTemp::getCheckState, '1')
                .set(PlanPointTemp::getCheckDate, now));

        //根据巡检计划id和点sid查询gis服务，获取竣工日期，设备参数，型号
        Map param = new HashMap();
        param.put("ckey", "pipe1");
        ResultRespone resultRespone = baseInfoService.getSourcePage(param);
        if (resultRespone.getCode() != 1) {
            throw new ToflyDeniedException("gis服务地址获取失败");
        }
        //获取计划点对应的layerId
        SysDeviceType sysDeviceType = sysDeviceTypeService.getOne(Wrappers.<SysDeviceType>lambdaQuery()
                .select(SysDeviceType::getContactLayerId)
                .apply("point_type_id =\n" +
                                "(select device_type_id from TF_plan_point_temp pt where pt.child_plan_id ={0} and pt.point_id = {1} )"
                        , childPlanId, pointId));
        String layerId = sysDeviceType.getContactLayerId();
        Map result = (Map) resultRespone.getResult();
        List<Map> records = (List) result.get("records");
        String gisUrl = "";
        if (records != null && records.size() > 0) {
            gisUrl = records.get(0).get("cval").toString() + "/" + layerId + "/query";
        }

        //Gis查询
        ExcelParam excelParam = new ExcelParam();
        excelParam.setGeometry("1");
        excelParam.setObjectids(pointId.toString());
        excelParam.setLayerurl(gisUrl);
        excelParam.setOutfields("SID,OBJECTID,CODE,GASDATE,FINISHDATE,MATERIAL,SPEC,DIAMETER");
        JSONArray geo = gisAboutService.exceloutList(excelParam);
        //保存使用年限，设备参数，型号
        if(geo.size() >0){
            String material = geo.getJSONObject(0).getJSONObject("attributes").getString("MATERIAL");
            Integer dimameter = geo.getJSONObject(0).getJSONObject("attributes").getInteger("DIAMETER");
            String type = geo.getJSONObject(0).getJSONObject("attributes").getString("SPEC");
            addMaintenanceDevice.setType(type);
            addMaintenanceDevice.setTechParam("材质:" + (material == null ? "无" : material) + " 管径:" + (dimameter == null ? "无" : dimameter.toString()));
            Date gasDate = geo.getJSONObject(0).getJSONObject("attributes").getDate("GASDATE");
            Integer differentYear = null;
            if (gasDate != null) {
                differentYear = getDifferentYear(gasDate);
            }
            addMaintenanceDevice.setUsedYears(differentYear == null ? null : differentYear.shortValue());
        }
//        String material = geo.getJSONObject(0).getJSONObject("attributes").getString("MATERIAL");
//        Integer dimameter = geo.getJSONObject(0).getJSONObject("attributes").getInteger("DIAMETER");
//        String type = geo.getJSONObject(0).getJSONObject("attributes").getString("SPEC");
//        addMaintenanceDevice.setType(type);
//        addMaintenanceDevice.setTechParam("材质:" + (material == null ? "无" : material) + " 管径:" + (dimameter == null ? "无" : dimameter.toString()));
//        Date gasDate = geo.getJSONObject(0).getJSONObject("attributes").getDate("GASDATE");
//        Integer differentYear = null;
//        if (gasDate != null) {
//            differentYear = getDifferentYear(gasDate);
//        }
//        addMaintenanceDevice.setUsedYears(differentYear == null ? null : differentYear.shortValue());
        //保存登记表 保养人，保养时间
        addMaintenanceDevice.setMaintainUser(SecurityUtils.getUserId());
        addMaintenanceDevice.setMaintainDate(Date8Util.getCurrentDate());
        addMaintenanceDevice.setSecurity("严格按照相关要求和部门《燃气管网附属设备设施维护保养制度》执行");
        maintenanceDeviceService.save(addMaintenanceDevice);
        Long recordId = addMaintenanceDevice.getId();
        //保存记录关联的保养内容
        if(addMaintenanceDevice.getContent() != null) {
            addMaintenanceDevice.getContent().stream().forEach(content -> {
                MaintenanceDeviceCon maintenanceDeviceCon = new MaintenanceDeviceCon();
                maintenanceDeviceCon.setDeviceRecordId(recordId);
                maintenanceDeviceCon.setTypeId(content);
                maintenanceDeviceConService.save(maintenanceDeviceCon);
            });
        }

        //遍历请求中key包含photo的所有文件，包括photo1，photo2中的多个文件
        MultiValueMap<String, MultipartFile> multiFileMap = ((MultipartHttpServletRequest) request).getMultiFileMap();
        multiFileMap.forEach((k, v) -> {
            //保存照片
            v.forEach(file -> {
                String fileName = file.getOriginalFilename();
                String filePath = filePathBean.getMaintenanceDevice() + IdWorker.getIdStr() + file.getOriginalFilename().substring(file.getOriginalFilename().lastIndexOf("."));
                boolean b = FtpUtil.uploadFile2Ftp(file, filePath);
                if (b) {
                    MaintenanceDeviceFile maintenanceDeviceFile = new MaintenanceDeviceFile();
                    maintenanceDeviceFile.setFilePath(filePath);
                    maintenanceDeviceFile.setFileName(fileName);
                    maintenanceDeviceFile.setMaintenanceDeviceId(addMaintenanceDevice.getId());
                    maintenanceDeviceFileService.save(maintenanceDeviceFile);
                }
            });
        });
        return true;
    }

    @Override
    public Boolean putMaintenanceDevice(HttpServletRequest request, AddMaintenanceDevice addMaintenanceDevice) {
        //更新主记录
        maintenanceDeviceService.updateById(addMaintenanceDevice);
        //更新关联表 删除原关联并添加
        Long recordId = addMaintenanceDevice.getId();
        maintenanceDeviceConService.remove(Wrappers.<MaintenanceDeviceCon>lambdaQuery().eq(MaintenanceDeviceCon::getDeviceRecordId, recordId));
        //保存记录关联的检查内容
        if (addMaintenanceDevice.getContent() != null){
            addMaintenanceDevice.getContent().forEach(content -> {
                MaintenanceDeviceCon maintenanceDeviceCon = new MaintenanceDeviceCon();
                maintenanceDeviceCon.setDeviceRecordId(recordId);
                maintenanceDeviceCon.setTypeId(content);
                maintenanceDeviceConService.save(maintenanceDeviceCon);
            });
        }
        //清除文件
        List<MaintenanceDeviceFile> files = maintenanceDeviceFileService.list(Wrappers.<MaintenanceDeviceFile>lambdaQuery().eq(MaintenanceDeviceFile::getMaintenanceDeviceId, recordId));
        files.forEach(file -> {
            Boolean b = FtpUtil.deleteFile(file.getFilePath());
        });
        //清除原文件记录
        maintenanceDeviceFileService.remove(Wrappers.<MaintenanceDeviceFile>lambdaQuery().eq(MaintenanceDeviceFile::getMaintenanceDeviceId, recordId));
        //遍历请求中key包含photo的所有文件，包括photo1，photo2中的多个文件
        MultiValueMap<String, MultipartFile> multiFileMap = ((MultipartHttpServletRequest) request).getMultiFileMap();
        multiFileMap.forEach((k, v) -> {
            //保存照片
            v.forEach(file -> {
                String fileName = file.getOriginalFilename();
                String filePath = filePathBean.getMaintenanceDevice() + IdWorker.getIdStr() + file.getOriginalFilename().substring(file.getOriginalFilename().lastIndexOf("."));
                boolean b = FtpUtil.uploadFile2Ftp(file, filePath);
                if (b) {
                    MaintenanceDeviceFile maintenanceDeviceFile = new MaintenanceDeviceFile();
                    maintenanceDeviceFile.setFilePath(filePath);
                    maintenanceDeviceFile.setFileName(fileName);
                    maintenanceDeviceFile.setMaintenanceDeviceId(addMaintenanceDevice.getId());
                    maintenanceDeviceFileService.save(maintenanceDeviceFile);
                }
            });
        });
        return true;
    }

    private int getDifferentYear(Date before) {
        Calendar calendar1 = Calendar.getInstance();
        calendar1.setTime(before);
        Calendar calendar2 = Calendar.getInstance();
        return calendar2.get(Calendar.YEAR) - calendar1.get(Calendar.YEAR);
    }

    private int getDifferentMonth(Date before) {
        Calendar calendar1 = Calendar.getInstance();
        calendar1.setTime(before);
        Calendar calendar2 = Calendar.getInstance();
        return calendar2.get(Calendar.MONTH) - calendar1.get(Calendar.MONTH);
    }
}
