package com.tofly.dyrq.custom.service.impl;

import com.tofly.common.oauth.util.SecurityUtils;
import com.tofly.dyrq.custom.service.CustomNormalEmptTypeService;
import com.tofly.dyrq.entity.NormalEmptType;
import com.tofly.dyrq.service.NormalEmptTypeService;
import lombok.AllArgsConstructor;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.Date;

@Service
@AllArgsConstructor
public class CustomNormalEmptTypeServiceImpl implements CustomNormalEmptTypeService {
    private NormalEmptTypeService normalEmptTypeService;

    @Override
    @Transactional
    public boolean save(NormalEmptType normalEmptType) {
        normalEmptType.setCreatUser(SecurityUtils.getUserId());
        normalEmptType.setCreatTime(new Date());
        normalEmptTypeService.save(normalEmptType);
        return true;
    }

    @Override
    @Transactional
    public boolean updateById(NormalEmptType normalEmptType) {
        normalEmptType.setUpdateTime(new Date());
        normalEmptTypeService.updateById(normalEmptType);
        return true;
    }
}
