package com.tofly.dyrq.custom.service.impl;

import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.tofly.common.core.util.StringUtil;
import com.tofly.dyrq.custom.entity.CustomPlanDeviceQuery;
import com.tofly.dyrq.custom.entity.CustomPlanDeviceTypeQuery;
import com.tofly.dyrq.custom.mapper.CustomPlanDeviceMapper;
import com.tofly.dyrq.custom.service.CustomPlanDeviceService;
import lombok.AllArgsConstructor;
import org.springframework.stereotype.Service;

import java.util.Arrays;
import java.util.List;
import java.util.Map;

/**
 * @author tuonbed
 * @date 2020/9/17  10:34
 */
@Service
@AllArgsConstructor
public class CustomPlanDeviceServiceImpl implements CustomPlanDeviceService {

    private final CustomPlanDeviceMapper customPlanDeviceMapper;
    @Override
    public IPage sblxtj(Page page, CustomPlanDeviceQuery customPlanDeviceQuery) {
        return page.setRecords(customPlanDeviceMapper.sblxtj(page,customPlanDeviceQuery));
    }

    @Override
    public IPage sbidtj(Page page, CustomPlanDeviceTypeQuery customPlanDeviceTypeQuery) {
        String sbids = customPlanDeviceTypeQuery.getSbids();
        if(StringUtil.isNotEmpty(sbids)){
            customPlanDeviceTypeQuery.setSbidList(Arrays.asList(sbids.split(",")));
        }
        return page.setRecords(customPlanDeviceMapper.sbidtj(page,customPlanDeviceTypeQuery));
    }

    @Override
    public IPage getSbmx(Page page, CustomPlanDeviceTypeQuery customPlanDeviceTypeQuery) {
        String sbids = customPlanDeviceTypeQuery.getSbids();
        if(StringUtil.isNotEmpty(sbids)){
            customPlanDeviceTypeQuery.setSbidList(Arrays.asList(sbids.split(",")));
        }
        return page.setRecords(customPlanDeviceMapper.getSbmx(page,customPlanDeviceTypeQuery));
    }
}
