package com.tofly.dyrq.custom.service.impl;

import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.core.toolkit.IdWorker;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.tofly.common.core.util.Date8Util;
import com.tofly.common.core.util.DateUtil;
import com.tofly.common.core.util.FtpUtil;
import com.tofly.common.core.util.StringUtil;
import com.tofly.common.mapper.ToflyCodeCommonMapper;
import com.tofly.common.oauth.exception.ToflyDeniedException;
import com.tofly.common.oauth.util.SecurityUtils;
import com.tofly.dyrq.config.FilePathBean;
import com.tofly.dyrq.custom.entity.*;
import com.tofly.dyrq.custom.mapper.CustomRushRepairMapper;
import com.tofly.dyrq.custom.mapper.OtherMapper;
import com.tofly.dyrq.custom.service.CustomMessageService;
import com.tofly.dyrq.custom.service.CustomRushRepairService;
import com.tofly.dyrq.entity.*;
import com.tofly.dyrq.mapper.RushRepairMapper;
import com.tofly.dyrq.service.*;
import lombok.AllArgsConstructor;
import lombok.SneakyThrows;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.util.MultiValueMap;
import org.springframework.web.multipart.MultipartFile;
import org.springframework.web.multipart.MultipartHttpServletRequest;

import javax.servlet.http.HttpServletRequest;
import java.math.BigDecimal;
import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.util.*;
import java.util.stream.Collectors;

/**
 * 抢维修工单表
 *
 * @author Zhangyu
 * @date Tue Jun 16 00:00:00 GMT+08:00 2020
 */


@Service
@AllArgsConstructor
@Transactional
public class CustomRushRepairServiceImpl implements CustomRushRepairService {

    private final FilePathBean filePathBean;
    private final RushRepairService rushRepairService;
    private final RushRepairFileService rushRepairFileService;
    private final RushRepairMapper rushRepairMapper;
    private final ToflyCodeCommonMapper toflyCodeCommonMapper;
    private final CustomRushRepairMapper customRushRepairMapper;
    private final RushRepairAuditEndService rushRepairAuditEndService;
    private final RushRepairFiletoauditService rushRepairFiletoauditService;
    private final RushRepairFiletorepairService rushRepairFiletorepairService;
    private final RushRepairFiletoprocessService rushRepairFiletoprocessService;
    private final RushRepairAuditDispatchService rushRepairAuditDispatchService;
    private final RushRepairProcessManageService rushRepairProcessManageService;
    private final CustomMessageService customMessageService;

    private final OtherMapper otherMapper;

    public static final Map<String, String> workOrderType = new HashMap() {{
        put("0", "内部工单");
        put("1", "外部转接");
    }};
    public static final Map<String, String> workOrderState = new HashMap() {{
        put("0", "待派工");
        put("1", "派工未通过");
        put("2", "待处理");
        put("3", "待审核");
        put("4", "审核未通过");
        put("5", "归档");
    }};

    public static final Map<Object, String> typeName = new HashMap() {{
        put("0", "内部工单");
        put("1", "外部转移");
    }};

    public List<RushRepairFile> file(HttpServletRequest servletRequest) {
        MultiValueMap<String, MultipartFile> multipartFileMap = ((MultipartHttpServletRequest) servletRequest).getMultiFileMap();
        List<RushRepairFile> list = new ArrayList<>();
        if (multipartFileMap != null) {
            multipartFileMap.forEach((k, v) -> {
                //web端所有文件
                if (k.contains("file")) {
                    v.forEach(f -> {
                        String filename = filePathBean.getRushrepair() + IdWorker.getIdStr() + f.getOriginalFilename().substring(f.getOriginalFilename().lastIndexOf("."));
                        boolean b = FtpUtil.uploadFile2Ftp(f, filename);

                        RushRepairFile rushRepairFile = new RushRepairFile();
                        rushRepairFile.setPath(filename);
                        rushRepairFile.setFileName(f.getOriginalFilename());
                        if (filename.toLowerCase().endsWith(".bmp")
                                || filename.toLowerCase().endsWith(".jpg")
                                || filename.toLowerCase().endsWith(".jpeg")
                                || filename.toLowerCase().endsWith(".gif")
                                || filename.toLowerCase().endsWith(".png")) {
                            rushRepairFile.setFileType("0");
                        } else if (filename.toLowerCase().endsWith(".amr")) {
                            rushRepairFile.setFileType("1");
                        } else {
                            rushRepairFile.setFileType("2");
                        }
                        rushRepairFileService.save(rushRepairFile);
                        list.add(rushRepairFile);
                    });
                }
                //移动端照片
                if (k.contains("photo")) {
                    v.forEach(f -> {
                        String filename = filePathBean.getRushrepair() + IdWorker.getIdStr() + f.getOriginalFilename().substring(f.getOriginalFilename().lastIndexOf("."));
                        boolean b = FtpUtil.uploadFile2Ftp(f, filename);
                        RushRepairFile rushRepairFile = new RushRepairFile();
                        rushRepairFile.setPath(filename);
                        rushRepairFile.setFileName(f.getOriginalFilename());
                        rushRepairFile.setFileType("0");
                        rushRepairFileService.save(rushRepairFile);
                        list.add(rushRepairFile);
                    });
                }
                //移动端语音
                if (k.contains("audio")) {
                    v.forEach(f -> {
                        String filename = filePathBean.getRushrepair() + IdWorker.getIdStr() + f.getOriginalFilename().substring(f.getOriginalFilename().lastIndexOf("."));
                        boolean b = FtpUtil.uploadFile2Ftp(f, filename);
                        RushRepairFile rushRepairFile = new RushRepairFile();
                        rushRepairFile.setPath(filename);
                        rushRepairFile.setFileName(f.getOriginalFilename());
                        rushRepairFile.setFileType("1");
                        rushRepairFileService.save(rushRepairFile);
                        list.add(rushRepairFile);
                    });
                }
                //移动端文件
                if (k.contains("other")) {
                    v.forEach(f -> {
                        String filename = filePathBean.getRushrepair() + IdWorker.getIdStr() + f.getOriginalFilename().substring(f.getOriginalFilename().lastIndexOf("."));
                        boolean b = FtpUtil.uploadFile2Ftp(f, filename);
                        RushRepairFile rushRepairFile = new RushRepairFile();
                        rushRepairFile.setPath(filename);
                        rushRepairFile.setFileName(f.getOriginalFilename());
                        rushRepairFile.setFileType("2");
                        rushRepairFileService.save(rushRepairFile);
                        list.add(rushRepairFile);
                    });
                }
            });
        }
        return list;
    }

    @Override
    public boolean saveRushRepair(HttpServletRequest servletRequest, RushRepair rushRepair) {
        if (rushRepair.getId() == null) {
            if (StringUtil.isEmpty(rushRepair.getAddress())) {
                throw new ToflyDeniedException("抢维修地址不能为空");
            }
            if (StringUtil.isEmpty(rushRepair.getWorkOrderSource())) {
                throw new ToflyDeniedException("抢维修工单来源不能为空");
            }
            if (StringUtil.isEmpty(rushRepair.getWorkOrderType())) {
                throw new ToflyDeniedException("抢维修工单类型不能为空");
            }
            if (rushRepair.getDeleteFilePaths() != null) {
                rushRepair.getDeleteFilePaths().forEach(path -> {

                });
            }
            //rushRepair.setRushRepairResponsible(SecurityUtils.getUserId());
            rushRepair.setCreatTime(new Date());
            rushRepair.setCreatUser(SecurityUtils.getUserId());
            rushRepairService.save(rushRepair);
            for (RushRepairFile rushRepairFile : this.file(servletRequest)) {
                RushRepairFiletorepair rushRepairFiletorepair = new RushRepairFiletorepair();
                rushRepairFiletorepair.setWorkOrderId(rushRepair.getId());
                rushRepairFiletorepair.setFileId(rushRepairFile.getId());
                rushRepairFiletorepairService.save(rushRepairFiletorepair);
            }
        } else if (rushRepair.getId() != null) {
            String state = rushRepairService.getById(rushRepair.getId()).getWorkOrderState();
            if (StringUtil.isNotEmpty(state) && Integer.parseInt(state) > 1) {
                throw new ToflyDeniedException("工单已派工,无法再次修改");
            }
            rushRepairService.updateById(rushRepair);
            if (rushRepair.getDeleteFilePaths() != null && rushRepair.getDeleteFilePaths().size() > 0) {
                List<RushRepairFiletorepair> list = rushRepairFiletorepairService.list(Wrappers.<RushRepairFiletorepair>lambdaQuery()
                        .eq(RushRepairFiletorepair::getWorkOrderId, rushRepair.getId()));
                List<Long> fileIds = new ArrayList<>();
                for (RushRepairFiletorepair file : list) {
                    fileIds.add(file.getFileId());
                }
                List<RushRepairFile> list2 = rushRepairFileService.list(Wrappers.<RushRepairFile>lambdaQuery()
                        .in(RushRepairFile::getPath, rushRepair.getDeleteFilePaths()));
                List<Long> fileIds2 = new ArrayList<>();
                fileIds.forEach(k -> {
                    for (RushRepairFile r : list2) {
                        if (r.getId().equals(k)) {
                            fileIds2.add(k);
                        }
                    }
                });
                /*List<RushRepairFile> list1 = rushRepairFileService.list(Wrappers.<rushRepairFileService>lambdaQuery()
                        .in(rushRepairFileService::getId, fileIds));*/
                /*list1.forEach(k -> {
                    FtpUtil.deleteFile(k);
                });*/
                List<String> list1 = rushRepair.getDeleteFilePaths();
                for (String path : list1) {
                    FtpUtil.deleteFile(path);
                }
                rushRepairFiletorepairService.removeByIds(fileIds2);
                rushRepairFileService.removeByIds(fileIds2);
            }
            if (!((MultipartHttpServletRequest) servletRequest).getMultiFileMap().isEmpty()) {
                for (RushRepairFile rushRepairFile : this.file(servletRequest)) {
                    RushRepairFiletorepair rushRepairFiletorepair = new RushRepairFiletorepair();
                    rushRepairFiletorepair.setWorkOrderId(rushRepair.getId());
                    rushRepairFiletorepair.setFileId(rushRepairFile.getId());
                    rushRepairFiletorepairService.save(rushRepairFiletorepair);
                }
            }
        }
        if (rushRepair.getDispatchUserId() != null) {
            customMessageService.sendMessage(rushRepair.getDispatchUserId().toString(), "您有一条待派工抢维修工单信息", "1","");
        }
        return true;
    }

    @Override
    public Page<Map> pageByCondition(Page page, RushRepairSearch rushRepairSearch) {
        List<Map> records = pageBase(page,rushRepairSearch);

        //handlerList(records);
        List<Map> userList = otherMapper.getUsers();
        List<Map> deptList = otherMapper.getDepts();
        Map<Object, String> userMap = userList.stream().collect(Collectors.toMap(m -> m.get("id"), v -> (String) v.get("name")));
        Map<Object, String> deptMap = deptList.stream().collect(Collectors.toMap(m -> m.get("id"), v -> (String) v.get("name")));
        records.forEach(r -> {
            if (r.get("rushRepairResponsible") != null) {
                r.put("responsibleName", userMap.get(r.get("rushRepairResponsible")));
            }
            if (r.get("department") != null) {
                r.put("departmentName", deptMap.get(r.get("department")));
            }
            if (r.get("rushRepairPersons") != null) {
                String[] rushRepairPersons = r.get("rushRepairPersons").toString().split(",");
                StringBuilder stringBuilder = new StringBuilder();
                for (String id : rushRepairPersons) {
                    stringBuilder.append(userMap.get(new BigDecimal(id))).append(",");
                }
                r.put("rushRepairPersonsName", stringBuilder.substring(0, stringBuilder.length() - 1));
            }
            r.put("dispatchUserName", userMap.get(r.get("dispatchUserId")));
            r.put("workOrderTypeName", workOrderType.get(r.get("workOrderType")));
            r.put("workOrderStateName", workOrderState.get(r.get("workOrderState")));
        });
//        for (Map r : records) {
//            if (r.get("rushRepairResponsible") != null) {
//                r.put("responsibleName", toflyCodeCommonMapper.getUserName(Long.parseLong(r.get("rushRepairResponsible").toString())));
//            }
//            if (r.get("rushRepairPersons") != null) {
//                String[] rushRepairPersons = r.get("rushRepairPersons").toString().split(",");
//                StringBuffer rushRepairPersonsName = new StringBuffer();
//                for (int i = 0; i < rushRepairPersons.length; i++) {
//                    if (i < rushRepairPersons.length - 1) {
//                        rushRepairPersonsName.append(toflyCodeCommonMapper.getUserName(Long.parseLong(rushRepairPersons[i])) + ",");
//                    } else {
//                        rushRepairPersonsName.append(toflyCodeCommonMapper.getUserName(Long.parseLong(rushRepairPersons[i])));
//                    }
//                }
//                r.put("rushRepairPersonsName", rushRepairPersonsName);
//            }
//            if (r.get("dispatchUserId") != null) {
//                r.put("dispatchUserName", toflyCodeCommonMapper.getUserName(Long.parseLong(r.get("dispatchUserId").toString())));
//            } else {
//                r.put("dispatchUserName", null);
//            }
//            if (r.get("workOrderType") != null) {
//                r.put("workOrderTypeName", rushRepairMapper.getworkOrderTypeName(r.get("workOrderType").toString()));
//            } else {
//                r.put("workOrderTypeName", null);
//            }
//            if (r.get("workOrderState") != null) {
//                r.put("workOrderStateName", rushRepairMapper.getworkOrderStateName(r.get("workOrderState").toString()));
//            } else {
//                r.put("workOrderStateName", null);
//            }
//            r.put("files", customRushRepairMapper.getFilesName(Long.parseLong(r.get("id").toString())));
//            r.put("voice", customRushRepairMapper.getVoice(Long.parseLong(r.get("id").toString())));
//            //r.put("endFiles", customRushRepairMapper.getEndFilesName(Long.parseLong(r.get("id").toString())));
//            r.put("endVoice", customRushRepairMapper.getEndVoice(Long.parseLong(r.get("id").toString())));
//            List<CustomRushRepairProcessManage> processManages = customRushRepairMapper.getProcess(Long.parseLong(r.get("id").toString()));
//            for (CustomRushRepairProcessManage p : processManages) {
//                p.setProcessFiles(customRushRepairMapper.getProcessFiles(p.getId()));
//                p.setProcessVoice(customRushRepairMapper.getProcessVoice(p.getId()));
//            }
//            r.put("processManages", processManages);
//            List<CustomRushAudit> auditList = customRushRepairMapper.getAuditList(Long.parseLong(r.get("id").toString()));
//            for (CustomRushAudit a : auditList) {
//                a.setAuditEndFiles(customRushRepairMapper.getAuditFiles(a.getId()));
//            }
//            r.put("auditList", auditList);
//        }

        return page.setRecords(records);
    }

    @Override
    public Page<Map> pageByCondition2(Page page, RushRepairSearch rushRepairSearch) {
        List<Map> records = pageBase(page,rushRepairSearch);
        handlerList(records);
        return page.setRecords(records);
    }

    /*@Override
    public Page<Map> pageByCondition3(Page page, RushRepairSearch rushRepairSearch) {
        List<Map> records = pageBase(page,rushRepairSearch);
        List<Map> userList = otherMapper.getUsers();
        List<Map> deptList = otherMapper.getDepts();
        Map<Object, String> userMap = userList.stream().collect(Collectors.toMap(m -> m.get("id"), v -> (String) v.get("name")));
        Map<Object, String> deptMap = deptList.stream().collect(Collectors.toMap(m -> m.get("id"), v -> (String) v.get("name")));
        List<Object> rids = records.stream().map(m -> m.get("id")).collect(Collectors.toList());
        List<Map> files = customRushRepairMapper.getFiles(rids);

        List<Map<String, Object>> process = rushRepairProcessManageService.listMaps(Wrappers.<RushRepairProcessManage>lambdaQuery()
                .in(RushRepairProcessManage::getWorkOrderId, rids).orderByAsc(RushRepairProcessManage::getManageDate));
        process.stream().forEach(pro -> {
            pro.put("processFiles", files.stream()
                    .filter(m -> ("3".equals(m.get("lx"))) && (pro.get("id").equals(m.get("mxid")) && ("0".equals(m.get("fileType")) || "2".equals(m.get("fileType")))))
                    .map(m -> {
                        Map map = new HashMap();
                        map.put("path", m.get("path"));
                        map.put("fileName", m.get("fileName"));
                        return map;
                    }).collect(Collectors.toList())
            );
            pro.put("processVoice", files.stream()
                    .filter(m -> ("3".equals(m.get("lx"))) && (pro.get("id").equals(m.get("mxid")) && ("1".equals(m.get("fileType")))))
                    .map(m -> {
                        Map map = new HashMap();
                        map.put("path", m.get("path"));
                        map.put("fileName", m.get("fileName"));
                        return map;
                    }).collect(Collectors.toList())
            );
        });
        records.forEach(r -> {
            if (r.get("rushRepairResponsible") != null) {
                r.put("responsibleName", userMap.get(r.get("rushRepairResponsible")));
            }
            if (r.get("department") != null) {
                r.put("departmentName", deptMap.get(r.get("department")));
            }
            if (r.get("rushRepairPersons") != null) {
                String[] rushRepairPersons = r.get("rushRepairPersons").toString().split(",");
                StringBuilder stringBuilder = new StringBuilder();
                for (String id : rushRepairPersons) {
                    stringBuilder.append(userMap.get(new BigDecimal(id))).append(",");
                }
                r.put("rushRepairPersonsName", stringBuilder.substring(0, stringBuilder.length() - 1));
            }
            r.put("dispatchUserName", userMap.get(r.get("dispatchUserId")));
            r.put("workOrderTypeName", workOrderType.get(r.get("workOrderType")));
            r.put("workOrderStateName", workOrderState.get(r.get("workOrderState")));
            r.put("processManages", process.stream().filter(pro -> (r.get("id").equals(pro.get("workOrderId")))).collect(Collectors.toList()));
        });
        return page.setRecords(records);
    }*/

    @Override
    public CustomRushRepair getRushRepairById(Long id) {
        CustomRushRepair customRushRepair = customRushRepairMapper.getCustomRushRepairById(id);
        /*List<Long> fileIds = new ArrayList<>();
        List<String> photo = new ArrayList<>();
        List<String> audio = new ArrayList<>();
        List<String> files = new ArrayList<>();

        for (RushRepairFiletorepair fr : rushRepairFiletorepairService.list(Wrappers.<RushRepairFiletorepair>lambdaQuery()
                .eq(RushRepairFiletorepair::getWorkOrderId, id))) {
            fileIds.add(fr.getFileId());
        }
        List<Long> auditList = new ArrayList<>();
        rushRepairAuditEndService.list(Wrappers.<RushRepairAuditEnd>lambdaQuery()
                .eq(RushRepairAuditEnd::getWorkOrderId, id)).forEach(k -> {
            auditList.add(k.getId());
        });
        if (auditList.size() > 0) {
            for (RushRepairFiletoaudit fa : rushRepairFiletoauditService.list(Wrappers.<RushRepairFiletoaudit>lambdaQuery()
                    .in(RushRepairFiletoaudit::getAuditEndId, auditList))) {
                fileIds.add(fa.getFileId());
            }
        }
        List<Long> processList = new ArrayList<>();
        rushRepairProcessManageService.list(Wrappers.<RushRepairProcessManage>lambdaQuery()
                .eq(RushRepairProcessManage::getWorkOrderId, id)).forEach(k -> {
            processList.add(k.getId());
        });
        if (processList.size() > 0) {
            for (RushRepairFiletoprocess fp : rushRepairFiletoprocessService.list(Wrappers.<RushRepairFiletoprocess>lambdaQuery()
                    .in(RushRepairFiletoprocess::getProcessManageId, processList))) {
                fileIds.add(fp.getFileId());
            }
        }
        if (fileIds.size() > 0) {
            rushRepairFileService.list(Wrappers.<RushRepairFile>lambdaQuery()
                    .in(RushRepairFile::getId, fileIds)).forEach(rf -> {
                if ("0".equals(rf.getFileType().trim())) {
                    photo.add(rf.getFileName());
                } else if ("1".equals(rf.getFileType().trim())) {
                    audio.add(rf.getFileName());
                } else if ("2".equals(rf.getFileType().trim())) {
                    files.add(rf.getFileName());
                }
            });
        }
        customRushRepair.setPhoto(photo);
        customRushRepair.setAudio(audio);
        customRushRepair.setFiles(files);*/
        List<Map> userList = otherMapper.getUsers();
        Map<Object, String> userMap = userList.stream().collect(Collectors.toMap(m -> m.get("id"), v -> (String) v.get("name")));
        if (StringUtil.isNotEmpty(customRushRepair.getRushRepairPersons())) {
            String[] rushRepairPersons = customRushRepair.getRushRepairPersons().split(",");
            StringBuilder sb = new StringBuilder();
            for (String userId : rushRepairPersons) {
                sb.append(userMap.get(new BigDecimal(userId))).append(",");
            }
            customRushRepair.setRushRepairPersonsName(sb.substring(0,sb.length()-1));
        }
        return customRushRepair;
    }

    @Override
    public boolean removeById(Long id) {
        List<RushRepairFiletorepair> list = rushRepairFiletorepairService.list(Wrappers.<RushRepairFiletorepair>lambdaQuery()
                .eq(RushRepairFiletorepair::getWorkOrderId, id));
        List<Long> fileIds = new ArrayList<>();
        for (RushRepairFiletorepair file : list) {
            fileIds.add(file.getFileId());
        }
        if (!fileIds.isEmpty()) {
            List<RushRepairFile> list1 = rushRepairFileService.list(Wrappers.<RushRepairFile>lambdaQuery()
                    .in(RushRepairFile::getId, fileIds));
            list1.forEach(k -> {
                FtpUtil.deleteFile(k.getPath());
            });
            rushRepairFileService.removeByIds(fileIds);
            rushRepairFiletorepairService.removeByIds(fileIds);
        }
        rushRepairService.removeById(id);
        return true;
    }

    @Override
    public boolean saveRushRepairAuditDispatch(RushRepairAuditDispatch rushRepairAuditDispatch) {
        //rushRepairAuditDispatch.setAuditTime(new Date());
        rushRepairAuditDispatch.setAuditor(SecurityUtils.getUserId());
        rushRepairAuditDispatchService.save(rushRepairAuditDispatch);
        if ("0".equals(rushRepairAuditDispatch.getAuditmind())) {
            RushRepair rushRepair = new RushRepair();
            rushRepair.setId(rushRepairAuditDispatch.getWorkOrderId());
            rushRepair.setDispatchUserId(SecurityUtils.getUserId());
            rushRepair.setDispatchDate(new Date());
            rushRepair.setWorkOrderState("2");
            rushRepairService.updateById(rushRepair);
        } else if ("1".equals(rushRepairAuditDispatch.getAuditmind())) {
            rushRepairService.update(Wrappers.<RushRepair>lambdaUpdate()
                    .eq(RushRepair::getId, rushRepairAuditDispatch.getWorkOrderId())
                    .set(RushRepair::getWorkOrderType, "1"));
        }
        return true;
    }

    @Override
    public boolean saveRushRepairProcessManage(HttpServletRequest servletRequest, RushRepairProcessManage rushRepairProcessManage) {
        rushRepairProcessManage.setManageDate(new Date());
        rushRepairProcessManageService.save(rushRepairProcessManage);

        if (!((MultipartHttpServletRequest) servletRequest).getMultiFileMap().isEmpty()) {
            for (RushRepairFile rushRepairFile : this.file(servletRequest)) {
                RushRepairFiletoprocess rushRepairFiletoprocess = new RushRepairFiletoprocess();
                rushRepairFiletoprocess.setFileId(rushRepairFile.getId());
                rushRepairFiletoprocess.setProcessManageId(rushRepairProcessManage.getId());
                rushRepairFiletoprocessService.save(rushRepairFiletoprocess);
            }
        }
        return true;
    }

    @Override
    public boolean saveRushRepairAuditEnd(HttpServletRequest servletRequest, RushRepairAuditEnd rushRepairAuditEnd) {
        rushRepairAuditEnd.setAuditTime(new Date());
        rushRepairAuditEnd.setAuditor(SecurityUtils.getUserId());
        rushRepairAuditEndService.save(rushRepairAuditEnd);
        if (!((MultipartHttpServletRequest) servletRequest).getMultiFileMap().isEmpty()) {
            for (RushRepairFile rushRepairFile : this.file(servletRequest)) {
                RushRepairFiletoaudit rushRepairFiletoaudit = new RushRepairFiletoaudit();
                rushRepairFiletoaudit.setFileId(rushRepairFile.getId());
                rushRepairFiletoaudit.setAuditEndId(rushRepairAuditEnd.getId());
                rushRepairFiletoauditService.save(rushRepairFiletoaudit);
            }
        }
        if ("0".equals(rushRepairAuditEnd.getAuditmind())) {
            rushRepairService.update(Wrappers.<RushRepair>lambdaUpdate()
                    .eq(RushRepair::getId, rushRepairAuditEnd.getWorkOrderId())
                    .set(RushRepair::getWorkOrderState, "5"));
        } else if ("1".equals(rushRepairAuditEnd.getAuditmind())) {
            rushRepairService.update(Wrappers.<RushRepair>lambdaUpdate()
                    .eq(RushRepair::getId, rushRepairAuditEnd.getWorkOrderId())
                    .set(RushRepair::getWorkOrderState, "4"));
        }
        return true;
    }

    @Override
    public Page<Map> getConstructionPageByUser(Page page, RushRepairSearchUser rushRepairSearchUser) {
        Long userid = SecurityUtils.getUserId();
        IPage result = rushRepairService.pageMaps(page, Wrappers.<RushRepair>lambdaQuery()
                .eq(StringUtil.isNotEmpty(rushRepairSearchUser.getWorkOrderType()), RushRepair::getWorkOrderType, rushRepairSearchUser.getWorkOrderType())
                .eq(StringUtil.isNotEmpty(rushRepairSearchUser.getWorkOrderId()), RushRepair::getWorkOrderId, rushRepairSearchUser.getWorkOrderId())
                .eq(StringUtil.isNotEmpty(rushRepairSearchUser.getWorkOrderState()), RushRepair::getWorkOrderState, rushRepairSearchUser.getWorkOrderState())
                .and(wrapper1 -> wrapper1.eq(RushRepair::getRushRepairResponsible, userid)
                        .or(wrapper -> wrapper.eq(RushRepair::getDispatchUserId, userid))
                        .or(wrapper2 -> wrapper2.eq(RushRepair::getCreatUser, userid))
                        .like(StringUtil.isNotEmpty(rushRepairSearchUser.getAddress()), RushRepair::getAddress, rushRepairSearchUser.getAddress())));
        List<Map> records = result.getRecords();
        handlerList(records);
        return page.setRecords(records);
    }

    @Override
    public List<Map> getReportByTYpe(CustomRushRepairReportQuery customRushRepairReportQuery) {
        return customRushRepairMapper.getReportByTYpe(customRushRepairReportQuery);
    }

    @Override
    public List<Map> getReportByTime(CustomRushRepairReportQueryType customRushRepairReportQueryType) {
        String reportType = customRushRepairReportQueryType.getReportType();
        String type = "";
        List<String> sjList = null;
        switch (reportType) {
            case "1":
                type = "to_char(creat_time，'yyyy-MM-dd')";
                sjList = customRushRepairMapper.querySJByDay(customRushRepairReportQueryType);
                break;
            case "2":
                type = "to_char(creat_time，'yyyy-MM')";
                sjList = customRushRepairMapper.querySJByMonth(customRushRepairReportQueryType);
                break;
            case "3":
                type = "to_char(creat_time，'yyyy')";
                sjList = customRushRepairMapper.querySJByYear(customRushRepairReportQueryType);
                break;
            default:
                type = null;
        }
        customRushRepairReportQueryType.setReportType(type);
        List<Map> reportByTime = customRushRepairMapper.getReportByTime(customRushRepairReportQueryType);
        List<String> collect = reportByTime.stream().map(m -> m.get("workOrderType") + "-" + m.get("sj")).collect(Collectors.toList());

        List<Object> workOrderType = reportByTime.stream().map(m -> m.get("workOrderType")).distinct().collect(Collectors.toList());

        Map map;
        for (String sj : sjList) {
            for (Object o : workOrderType) {
                if (!collect.contains(o + "-" + sj)) {
                    map = new HashMap();
                    map.put("sj", sj);
                    map.put("workOrderType", o);
                    map.put("workOrderTypeName", typeName.get(o));
                    map.put("cunt", 0);
                    reportByTime.add(map);
                }
            }
        }
        ;
//        reportByTime.sort(Comparator.comparing(m->(String)m.get("workOrderType")+m.get("sj")));
//        Map<Object, List<Map>> collect1 = reportByTime.stream().sorted(Comparator.comparing(m -> (String) m.get("workOrderType") + m.get("sj")))
//                .collect(Collectors.groupingBy(m -> m.get("workOrderTypeName")));
        List<Map> list = new ArrayList();
        for (Object o : workOrderType) {
            map = new HashMap();
            map.put("trouble_type_name", typeName.get(o));
            map.put("info", reportByTime.stream().filter(m -> o.equals(m.get("workOrderType")))
                    .sorted(Comparator.comparing(m -> (String) m.get("sj"))).collect(Collectors.toList()));
            list.add(map);
        }

        return list;
    }


    private void handlerList(List<Map> records) {
        if (records == null || records.size() == 0) {
            return;
        }
        List<Map> userList = otherMapper.getUsers();
        Map<Object, String> userMap = userList.stream().collect(Collectors.toMap(m -> m.get("id"), v -> (String) v.get("name")));
        List<Object> rids = records.stream().map(m -> m.get("id")).collect(Collectors.toList());

        List<Map> files = customRushRepairMapper.getFiles(rids);

        List<Map<String, Object>> process = rushRepairProcessManageService.listMaps(Wrappers.<RushRepairProcessManage>lambdaQuery()
                .in(RushRepairProcessManage::getWorkOrderId, rids).orderByAsc(RushRepairProcessManage::getManageDate));
        process.stream().forEach(pro -> {
            pro.put("processFiles", files.stream()
                    .filter(m -> ("3".equals(m.get("lx"))) && (pro.get("id").equals(m.get("mxid")) && ("0".equals(m.get("fileType")) || "2".equals(m.get("fileType")))))
                    .map(m -> {
                        Map map = new HashMap();
                        map.put("path", m.get("path"));
                        map.put("fileName", m.get("fileName"));
                        return map;
                    }).collect(Collectors.toList())
            );
            pro.put("processVoice", files.stream()
                    .filter(m -> ("3".equals(m.get("lx"))) && (pro.get("id").equals(m.get("mxid")) && ("1".equals(m.get("fileType")))))
                    .map(m -> {
                        Map map = new HashMap();
                        map.put("path", m.get("path"));
                        map.put("fileName", m.get("fileName"));
                        return map;
                    }).collect(Collectors.toList())
            );
        });
//        List<Map<String, Object>> endList = rushRepairAuditEndService.listMaps(Wrappers.<RushRepairAuditEnd>lambdaQuery()
//                .in(RushRepairAuditEnd::getWorkOrderId, rids));

//        List<CustomRushAudit> endList = customRushRepairMapper.getAuditList(null);
        List<Map<String, Object>> endList = rushRepairAuditEndService.listMaps(Wrappers.<RushRepairAuditEnd>query()
                .select("TF_RUSH_REPAIR_AUDIT_END.*", "decode(AUDITMIND,'0','通过','1','不通过') as auditmindName",
                        "(select real_name from tf_smpn_user_x where id=TF_RUSH_REPAIR_AUDIT_END.AUDITOR) as auditorName"
                )
                .in("work_order_id", rids).orderByAsc("AUDIT_TIME"));
        endList.stream().forEach(end -> {
            end.put("auditEndFiles", files.stream()
                    //end.setAuditEndFiles(files.stream()
                    .filter(m -> ("2".equals(m.get("lx"))) && (end.get("id").equals(m.get("mxid")) && ("0".equals(m.get("fileType")) || "2".equals(m.get("fileType")))))
                    .map(m -> {
                        Map map = new HashMap();
                        map.put("path", m.get("path"));
                        map.put("fileName", m.get("fileName"));
                        return map;
                    }).collect(Collectors.toList()));
        });


        records.forEach(r -> {
            if (r.get("rushRepairResponsible") != null) {
                r.put("responsibleName", userMap.get(r.get("rushRepairResponsible")));
            }
            if (r.get("rushRepairPersons") != null) {
                String[] rushRepairPersons = r.get("rushRepairPersons").toString().split(",");
                StringBuilder stringBuilder = new StringBuilder();
                for (String id : rushRepairPersons) {
                    stringBuilder.append(userMap.get(new BigDecimal(id))).append(",");
                }
                r.put("rushRepairPersonsName", stringBuilder.substring(0, stringBuilder.length() - 1));
            }
            r.put("dispatchUserName", userMap.get(r.get("dispatchUserId")));
            r.put("workOrderTypeName", workOrderType.get(r.get("workOrderType")));
            r.put("workOrderStateName", workOrderState.get(r.get("workOrderState")));
            r.put("files", files.stream()
                    .filter(m -> (r.get("id").equals(m.get("workOrderId"))) && ("1".equals(m.get("lx")) && ("0".equals(m.get("fileType")) || "2".equals(m.get("fileType")))))
                    .map(m -> {
                        Map map = new HashMap();
                        map.put("path", m.get("path"));
                        map.put("fileName", m.get("fileName"));
                        return map;
                    }).collect(Collectors.toList())
            );
            r.put("voice", files.stream()
                    .filter(m -> (r.get("id").equals(m.get("workOrderId"))) && ("1".equals(m.get("lx")) && ("1".equals(m.get("fileType")))))
                    .map(m -> {
                        Map map = new HashMap();
                        map.put("path", m.get("path"));
                        map.put("fileName", m.get("fileName"));
                        return map;
                    }).collect(Collectors.toList())
            );

            r.put("endVoice", files.stream()
                    .filter(m -> (r.get("id").equals(m.get("workOrderId"))) && ("2".equals(m.get("lx")) && ("1".equals(m.get("fileType")))))
                    .map(m -> {
                        Map map = new HashMap();
                        map.put("path", m.get("path"));
                        map.put("fileName", m.get("fileName"));
                        return map;
                    }).collect(Collectors.toList())
            );
            r.put("processManages", process.stream().filter(pro -> (r.get("id").equals(pro.get("workOrderId")))).collect(Collectors.toList()));
//            r.put("auditList",endList.stream().filter(pro->((BigDecimal)r.get("id")).longValue()==(pro.getWorkOrderId())).collect(Collectors.toList()));
            r.put("auditList", endList.stream().filter(pro -> (r.get("id")).equals(pro.get("workOrderId"))).collect(Collectors.toList()));
        });
    }

    private List<Map> pageBase(Page page,RushRepairSearch rushRepairSearch){
        List<Long> userIds = new ArrayList<>();
        if (StringUtil.isNotEmpty(rushRepairSearch.getUserIds())) {
            String[] users = rushRepairSearch.getUserIds().split(",");
            for (String u : users) {
                userIds.addAll(customRushRepairMapper.getIdByRole(Long.valueOf(u)));
            }
            Set<String> temp = new HashSet<>();
            for (String user : users) {
                temp.add(user);
            }
            List<RushRepair> repairList = rushRepairService.list();
            repairList.forEach(k -> {
                if (StringUtil.isNotEmpty(k.getRushRepairPersons())) {
                    String[] rp = k.getRushRepairPersons().split(",");
                    for (String r : rp) {
                        if (temp.add(r)) {
                            temp.remove(r);
                        } else if (!temp.add(r)) {
                            userIds.add(k.getId());
                        }
                    }
                }
            });
        }
        if (StringUtil.isNotEmpty(rushRepairSearch.getUserIds()) && userIds.isEmpty()) {
            userIds.add(Long.MAX_VALUE);
        }

        IPage result = rushRepairService.pageMaps(page, Wrappers.<RushRepair>lambdaQuery()
                .eq(StringUtil.isNotEmpty(rushRepairSearch.getWorkOrderType()), RushRepair::getWorkOrderType, rushRepairSearch.getWorkOrderType())
                .eq(StringUtil.isNotEmpty(rushRepairSearch.getWorkOrderId()), RushRepair::getWorkOrderId, rushRepairSearch.getWorkOrderId())
                .eq(StringUtil.isNotEmpty(rushRepairSearch.getWorkOrderState()), RushRepair::getWorkOrderState, rushRepairSearch.getWorkOrderState())
                .eq(rushRepairSearch.getCreatUser() != null, RushRepair::getCreatUser, rushRepairSearch.getCreatUser())
                .eq(rushRepairSearch.getDispatchUserId() != null, RushRepair::getDispatchUserId, rushRepairSearch.getDispatchUserId())
                .eq(rushRepairSearch.getRushRepairResponsible() != null, RushRepair::getRushRepairResponsible, rushRepairSearch.getRushRepairResponsible())
                .in(StringUtil.isNotEmpty(rushRepairSearch.getWorkOrderStates()), RushRepair::getWorkOrderState,
                        StringUtil.isNotEmpty(rushRepairSearch.getWorkOrderStates()) ?
                                Arrays.asList(rushRepairSearch.getWorkOrderStates().split(",")) : null)
                .in(!userIds.isEmpty(), RushRepair::getId, userIds)
                .like(StringUtil.isNotEmpty(rushRepairSearch.getAdsOrIdOrSocOrDesc()),RushRepair::getAddress, rushRepairSearch.getAdsOrIdOrSocOrDesc())
                .or().like(StringUtil.isNotEmpty(rushRepairSearch.getAdsOrIdOrSocOrDesc()),RushRepair::getWorkOrderId,rushRepairSearch.getAdsOrIdOrSocOrDesc())
                .or().like(StringUtil.isNotEmpty(rushRepairSearch.getAdsOrIdOrSocOrDesc()),RushRepair::getWorkOrderSource,rushRepairSearch.getAdsOrIdOrSocOrDesc())
                .or().like(StringUtil.isNotEmpty(rushRepairSearch.getAdsOrIdOrSocOrDesc()),RushRepair::getDescription,rushRepairSearch.getAdsOrIdOrSocOrDesc())
                .orderByDesc(RushRepair::getCreatTime));
        List<Map> records = result.getRecords();
        return records;
    }

}
