package com.tofly.dyrq.custom.service.impl;

import com.tofly.common.oauth.util.SecurityUtils;
import com.tofly.dyrq.custom.service.CustomKeyEmptTypeService;
import com.tofly.dyrq.custom.service.CustomSpecialEmptTypeService;
import com.tofly.dyrq.entity.KeyEmptType;
import com.tofly.dyrq.entity.SpecialEmptType;
import com.tofly.dyrq.service.KeyEmptTypeService;
import com.tofly.dyrq.service.SpecialEmptTypeService;
import lombok.AllArgsConstructor;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.Date;

@Service
@AllArgsConstructor
public class CustomSpecialEmptTypeServiceImpl implements CustomSpecialEmptTypeService {
    private SpecialEmptTypeService specialEmptTypeService;

    @Override
    @Transactional
    public boolean save(SpecialEmptType specialEmptType) {
        specialEmptType.setCreatUser(SecurityUtils.getUserId());
        specialEmptType.setCreatTime(new Date());
        specialEmptTypeService.save(specialEmptType);
        return true;
    }

    @Override
    @Transactional
    public boolean updateById(SpecialEmptType specialEmptType) {
        specialEmptType.setUpdateTime(new Date());
        specialEmptTypeService.updateById(specialEmptType);
        return true;
    }
}
