package com.tofly.dyrq.custom.service.impl;

import com.tofly.common.core.util.FtpUtil;
import com.tofly.common.core.util.StringUtil;
import com.tofly.dyrq.config.FilePathBean;
import com.tofly.dyrq.custom.entity.*;
import com.tofly.dyrq.custom.mapper.EquipmentPhotoMapper;
import com.tofly.dyrq.custom.service.EquipmentPhotoService;
import lombok.AllArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.util.MultiValueMap;
import org.springframework.web.multipart.MultipartFile;
import org.springframework.web.multipart.MultipartHttpServletRequest;

import javax.servlet.http.HttpServletRequest;
import java.io.File;
import java.util.*;
import java.util.stream.Collectors;

@Service
@AllArgsConstructor
@Slf4j
public class EquipmentPhotoServiceImpl implements EquipmentPhotoService {
    private EquipmentPhotoMapper equipmentPhotoMapper;
    private FilePathBean filePathBean;

    @Override
    @Transactional
    public Boolean save(HttpServletRequest request) {
        MultiValueMap<String, MultipartFile> files = ((MultipartHttpServletRequest) request).getMultiFileMap();
        List<Gasmeter> gasmters = equipmentPhotoMapper.getGasmeterSid();
        List<Booster> boosters = equipmentPhotoMapper.getBoosterSid();
        List<Fitting> fittings = equipmentPhotoMapper.getFittingSid();
        List<Valve> valves = equipmentPhotoMapper.getValveSid();
        List<Yjbh> yjbhs = equipmentPhotoMapper.getYjbhSid();
        List<Gasmeter> gasmeters2 = new ArrayList<>();
        List<Booster> boosters2 = new ArrayList<>();
        List<MultipartFile> files1 = new ArrayList<>();
        List<Fitting> fittings2 = new ArrayList<>();
        List<Valve> valves2 = new ArrayList<>();
        List<Yjbh> yjbhs2 = new ArrayList<>();
        files.forEach((k, v) -> {
            v.forEach(file -> {
                if (k.contains("file")) {
                    files1.add(file);
                }
            });
        });
        if (files1 != null && !files1.isEmpty()) {
            files1.forEach(k -> {
                String fileSid = k.getOriginalFilename().substring(0, k.getOriginalFilename().lastIndexOf("."));
                for (Gasmeter gasmeter : gasmters) {
                    if (gasmeter != null) {
                        if (fileSid.contains(gasmeter.getOldno())) {
                            String filePath = filePathBean.getEquipmentfile() + k.getOriginalFilename();
                            boolean b = FtpUtil.uploadFile2Ftp(k, filePath);
                            if (b) {
                                StringBuilder remark = new StringBuilder();
                                if (StringUtil.isNotEmpty(gasmeter.getPictures())) {
                                    if (!gasmeter.getPictures().contains(filePath)) {
                                        remark.append(gasmeter.getPictures()).append(",").append(filePath);
                                    } else {
                                        remark.append(gasmeter.getPictures());
                                    }
                                } else {
                                    remark.append(filePath);
                                }
                                gasmeter.setPictures(remark.toString());
                                gasmeters2.add(gasmeter);
                            }
                        }
                    }
                }
                for (Booster booster : boosters) {
                    if (booster != null) {
                        if (fileSid.contains(booster.getOldno())) {
                            String filePath = filePathBean.getEquipmentfile() + k.getOriginalFilename();
                            boolean b = FtpUtil.uploadFile2Ftp(k, filePath);
                            if (b) {
                                StringBuilder remark = new StringBuilder();
                                if (StringUtil.isNotEmpty(booster.getPictures())) {
                                    if (!booster.getPictures().contains(filePath)) {
                                        remark.append(booster.getPictures()).append(",").append(filePath);
                                    } else {
                                        remark.append(booster.getPictures());
                                    }
                                } else {
                                    remark.append(filePath);
                                }
                                booster.setPictures(remark.toString());
                                boosters2.add(booster);
                            }
                        }
                    }
                }
                for (Fitting fitting : fittings) {
                    if (fitting != null) {
                        if (fileSid.contains(fitting.getOldno())) {
                            String filePath = filePathBean.getEquipmentfile() + k.getOriginalFilename();
                            boolean b = FtpUtil.uploadFile2Ftp(k, filePath);
                            if (b) {
                                StringBuilder remark = new StringBuilder();
                                if (StringUtil.isNotEmpty(fitting.getPictures())) {
                                    if (!fitting.getPictures().contains(filePath)) {
                                        remark.append(fitting.getPictures()).append(",").append(filePath);
                                    } else {
                                        remark.append(fitting.getPictures());
                                    }
                                } else {
                                    remark.append(filePath);
                                }
                                fitting.setPictures(remark.toString());
                                fittings2.add(fitting);
                            }
                        }
                    }
                }
                for (Valve valve : valves) {
                    if (valve != null) {
                        if (fileSid.contains(valve.getOldno())) {
                            String filePath = filePathBean.getEquipmentfile() + k.getOriginalFilename();
                            boolean b = FtpUtil.uploadFile2Ftp(k, filePath);
                            if (b) {
                                StringBuilder remark = new StringBuilder();
                                if (StringUtil.isNotEmpty(valve.getPictures())) {
                                    if (!valve.getPictures().contains(filePath)) {
                                        remark.append(valve.getPictures()).append(",").append(filePath);
                                    } else {
                                        remark.append(valve.getPictures());
                                    }
                                } else {
                                    remark.append(filePath);
                                }
                                valve.setPictures(remark.toString());
                                valves2.add(valve);
                            }
                        }
                    }
                }
                for (Yjbh yjbh : yjbhs) {
                    if (yjbh != null) {
                        if (fileSid.contains(yjbh.getOldno())) {
                            String filePath = filePathBean.getEquipmentfile() + k.getOriginalFilename();
                            boolean b = FtpUtil.uploadFile2Ftp(k, filePath);
                            if (b) {
                                StringBuilder remark = new StringBuilder();
                                if (StringUtil.isNotEmpty(yjbh.getPictures())) {
                                    if (!yjbh.getPictures().contains(filePath)) {
                                        remark.append(yjbh.getPictures()).append(",").append(filePath);
                                    } else {
                                        remark.append(yjbh.getPictures());
                                    }
                                } else {
                                    remark.append(filePath);
                                }
                                yjbh.setPictures(remark.toString());
                                yjbhs2.add(yjbh);
                            }
                        }
                    }
                }
            });
        }
        Map<String, List<Booster>> boosterMap = boosters2.stream().collect(Collectors.groupingBy(Booster::getOldno));
        List<Booster> updateBooster = new ArrayList<>();
        boosterMap.forEach((m, v) -> {
            Booster bs = v.stream().sorted(Comparator.comparing(Booster::getPictures).reversed()).findFirst().orElse(null);
            updateBooster.add(bs);
        });
        Map<String, List<Gasmeter>> gasmeterMap = gasmeters2.stream().collect(Collectors.groupingBy(Gasmeter::getOldno));
        List<Gasmeter> updateGasmeter = new ArrayList<>();
        gasmeterMap.forEach((m, v) -> {
            Gasmeter gs = v.stream().sorted(Comparator.comparing(Gasmeter::getPictures).reversed()).findFirst().orElse(null);
            updateGasmeter.add(gs);
        });
        Map<String, List<Fitting>> fittingMap = fittings2.stream().collect(Collectors.groupingBy(Fitting::getOldno));
        List<Fitting> updateFitting = new ArrayList<>();
        fittingMap.forEach((m, v) -> {
            Fitting ft = v.stream().sorted(Comparator.comparing(Fitting::getPictures).reversed()).findFirst().orElse(null);
            updateFitting.add(ft);
        });
        Map<String, List<Valve>> valveMap = valves2.stream().collect(Collectors.groupingBy(Valve::getOldno));
        List<Valve> updateValve = new ArrayList<>();
        valveMap.forEach((m, v) -> {
            Valve va = v.stream().sorted(Comparator.comparing(Valve::getPictures).reversed()).findFirst().orElse(null);
            updateValve.add(va);
        });
        Map<String, List<Yjbh>> yjbhMap = yjbhs2.stream().collect(Collectors.groupingBy(Yjbh::getOldno));
        List<Yjbh> updateYjbh = new ArrayList<>();
        yjbhMap.forEach((m, v) -> {
            Yjbh yb = v.stream().sorted(Comparator.comparing(Yjbh::getPictures).reversed()).findFirst().orElse(null);
            updateYjbh.add(yb);
        });
        if (updateBooster.size() > 0) {
            equipmentPhotoMapper.updateBooster(updateBooster);
        }
        if (updateGasmeter.size() > 0) {
            equipmentPhotoMapper.updateGasmeter(updateGasmeter);
        }
        if (updateFitting.size() > 0) {
            equipmentPhotoMapper.updateFitting(updateFitting);
        }
        if (updateValve.size() > 0) {
            equipmentPhotoMapper.updateValve(updateValve);
        }
        if (updateYjbh.size() > 0) {
            equipmentPhotoMapper.updateYjbh(updateYjbh);
        }
        return true;
    }

    @Override
    @Transactional
    public Boolean getFiles(String path) {
        List<Gasmeter> gasmters = equipmentPhotoMapper.getGasmeterSid();
        List<Booster> boosters = equipmentPhotoMapper.getBoosterSid();
        List<Fitting> fittings = equipmentPhotoMapper.getFittingSid();
        List<Valve> valves = equipmentPhotoMapper.getValveSid();
        List<Yjbh> yjbhs = equipmentPhotoMapper.getYjbhSid();
        List<Gasmeter> gasmeters2 = new ArrayList<>();
        List<Booster> boosters2 = new ArrayList<>();
        List<Fitting> fittings2 = new ArrayList<>();
        List<Valve> valves2 = new ArrayList<>();
        List<Yjbh> yjbhs2 = new ArrayList<>();
        List<String> fileNames = new ArrayList<>();
        files(path, fileNames);
        for (String s : fileNames) {
            String filePath = filePathBean.getEquipmentfile() + s;
            for (Gasmeter gasmeter : gasmters) {
                if (gasmeter != null) {
                    if (s.contains(gasmeter.getOldno())) {
                        StringBuilder remark = new StringBuilder();
                        if (StringUtil.isNotEmpty(gasmeter.getPictures())) {
                            if (!gasmeter.getPictures().contains(filePath)) {
                                remark.append(gasmeter.getPictures()).append(",").append(filePath);
                            } else {
                                remark.append(gasmeter.getPictures());
                            }
                        } else {
                            remark.append(filePath);
                        }
                        gasmeter.setPictures(remark.toString());
                        gasmeters2.add(gasmeter);
                    }
                }
            }
            for (Booster booster : boosters) {
                if (booster != null) {
                    if (s.contains(booster.getOldno())) {
                        StringBuilder remark = new StringBuilder();
                        if (StringUtil.isNotEmpty(booster.getPictures())) {
                            if (!booster.getPictures().contains(filePath)) {
                                remark.append(booster.getPictures()).append(",").append(filePath);
                            } else {
                                remark.append(booster.getPictures());
                            }
                        } else {
                            remark.append(filePath);
                        }
                        booster.setPictures(remark.toString());
                        boosters2.add(booster);
                    }
                }
            }
            for (Fitting fitting : fittings) {
                if (fitting != null) {
                    if (s.contains(fitting.getOldno())) {
                        StringBuilder remark = new StringBuilder();
                        if (StringUtil.isNotEmpty(fitting.getPictures())) {
                            if (!fitting.getPictures().contains(filePath)) {
                                remark.append(fitting.getPictures()).append(",").append(filePath);
                            } else {
                                remark.append(fitting.getPictures());
                            }
                        } else {
                            remark.append(filePath);
                        }
                        fitting.setPictures(remark.toString());
                        fittings2.add(fitting);
                    }
                }
            }
            for (Valve valve : valves) {
                if (valve != null) {
                    if (s.contains(valve.getOldno())) {
                        StringBuilder remark = new StringBuilder();
                        if (StringUtil.isNotEmpty(valve.getPictures())) {
                            if (!valve.getPictures().contains(filePath)) {
                                remark.append(valve.getPictures()).append(",").append(filePath);
                            } else {
                                remark.append(valve.getPictures());
                            }
                        } else {
                            remark.append(filePath);
                        }
                        valve.setPictures(remark.toString());
                        valves2.add(valve);
                    }
                }
            }
            for (Yjbh yjbh : yjbhs) {
                if (yjbh != null) {
                    if (s.contains(yjbh.getOldno())) {
                        StringBuilder remark = new StringBuilder();
                        if (StringUtil.isNotEmpty(yjbh.getPictures())) {
                            if (!yjbh.getPictures().contains(filePath)) {
                                remark.append(yjbh.getPictures()).append(",").append(filePath);
                            } else {
                                remark.append(yjbh.getPictures());
                            }
                        } else {
                            remark.append(filePath);
                        }
                        yjbh.setPictures(remark.toString());
                        yjbhs2.add(yjbh);
                    }
                }
            }
        }
        Map<String, List<Booster>> boosterMap = boosters2.stream().collect(Collectors.groupingBy(Booster::getOldno));
        List<Booster> updateBooster = new ArrayList<>();
        boosterMap.forEach((m, v) -> {
            Booster bs = v.stream().sorted(Comparator.comparing(Booster::getPictures).reversed()).findFirst().orElse(null);
            updateBooster.add(bs);
        });
        Map<String, List<Gasmeter>> gasmeterMap = gasmeters2.stream().collect(Collectors.groupingBy(Gasmeter::getOldno));
        List<Gasmeter> updateGasmeter = new ArrayList<>();
        gasmeterMap.forEach((m, v) -> {
            Gasmeter gs = v.stream().sorted(Comparator.comparing(Gasmeter::getPictures).reversed()).findFirst().orElse(null);
            updateGasmeter.add(gs);
        });
        Map<String, List<Fitting>> fittingMap = fittings2.stream().collect(Collectors.groupingBy(Fitting::getOldno));
        List<Fitting> updateFitting = new ArrayList<>();
        fittingMap.forEach((m, v) -> {
            Fitting ft = v.stream().sorted(Comparator.comparing(Fitting::getPictures).reversed()).findFirst().orElse(null);
            updateFitting.add(ft);
        });
        Map<String, List<Valve>> valveMap = valves2.stream().collect(Collectors.groupingBy(Valve::getOldno));
        List<Valve> updateValve = new ArrayList<>();
        valveMap.forEach((m, v) -> {
            Valve va = v.stream().sorted(Comparator.comparing(Valve::getPictures).reversed()).findFirst().orElse(null);
            updateValve.add(va);
        });
        Map<String, List<Yjbh>> yjbhMap = yjbhs2.stream().collect(Collectors.groupingBy(Yjbh::getOldno));
        List<Yjbh> updateYjbh = new ArrayList<>();
        yjbhMap.forEach((m, v) -> {
            Yjbh yb = v.stream().sorted(Comparator.comparing(Yjbh::getPictures).reversed()).findFirst().orElse(null);
            updateYjbh.add(yb);
        });
        if (updateBooster.size() > 0) {
            equipmentPhotoMapper.updateBooster(updateBooster);
        }
        if (updateGasmeter.size() > 0) {
            equipmentPhotoMapper.updateGasmeter(updateGasmeter);
        }
        if (updateFitting.size() > 0) {
            equipmentPhotoMapper.updateFitting(updateFitting);
        }
        if (updateValve.size() > 0) {
            equipmentPhotoMapper.updateValve(updateValve);
        }
        if (updateYjbh.size() > 0) {
            equipmentPhotoMapper.updateYjbh(updateYjbh);
        }
        return true;
    }

    private List<String> files(String path, List<String> fileNames) {
        File file = new File(path);
        File[] array = file.listFiles();
        assert array != null;
        for (File f : array) {
            if (f.isFile()) {
                fileNames.add(f.getName());
            } else if (f.isDirectory()) {
                files(f.getPath(), fileNames);
            }
        }
        return fileNames;
    }


}
