package com.tofly.dyrq.custom.service.impl;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.baomidou.mybatisplus.core.toolkit.IdWorker;
import com.tofly.common.core.util.HttpURL;
import com.tofly.common.core.util.StringUtil;
import com.tofly.common.core.util.io.ExcelUtil;
import com.tofly.dyrq.config.ComConstans;
import com.tofly.dyrq.custom.entity.ExcelParam;
import com.tofly.dyrq.custom.service.GisAboutService;
import lombok.SneakyThrows;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;

import java.math.BigDecimal;
import java.text.SimpleDateFormat;
import java.util.*;
import java.util.stream.Collectors;

/**
 * @author tuonbed
 * @date 2020/3/30  10:06
 */
@Service
@Slf4j
public class GisAboutServiceImpl implements GisAboutService {

    @Override
    @SneakyThrows
    public String createFile(ExcelParam excelParam) {
        List<String[]> ids= StringUtil.stringSplittoList(excelParam.getObjectids(),",", ComConstans.REQUEST_MAXCOUNT);
        List<List<Object>> list=new ArrayList();
        List<Object> head=new ArrayList<>();
        Map<String,Object> headMap=new LinkedHashMap<>();
        ids.stream().forEach(id->{
            String param="objectids="+StringUtil.join(id,",")+"&outfields="+excelParam.getOutfields()+
                    "&returnGeometry="+ComConstans.REQUEST_GEM+"&f="+ComConstans.REQUEST_FORMAT;
            try{
                String countent= HttpURL.getContent(excelParam.getLayerurl()+"?"+param,"");
                JSONObject jsonObject = JSONObject.parseObject(countent);
                JSONArray features = jsonObject.getJSONArray("features");

                //给表头及数据按照请求字段顺序排序
                List<String> orderFileds = Arrays.asList(excelParam.getOutfields().split(","));

                if(head.size()==0){
                    headMap.putAll(JSONObject.parseObject(jsonObject.getString("fieldAliases"), LinkedHashMap.class));

//                    head.addAll(headMap.values().stream().collect(Collectors.toList()));
                }
                //确定表头顺序
                for (String orderFiled : orderFileds) {
                    head.add(headMap.get(orderFiled));
                }
                for(int i=0;i<features.size();i++){
                    Map<String,Object> m = JSONObject.parseObject(features.getJSONObject(i).getString("attributes"), LinkedHashMap.class);
                    List<Object> list1=new ArrayList<>();
                    for (int j = 0;j<orderFileds.size();j++){
                        String filedName = orderFileds.get(j);
//                    headMap.keySet().stream().forEach(k->{
                        //将时间戳转换为日期
                        Object v = m.get(filedName);
                        Boolean b = v instanceof Long;
                        if (v != null && b && (((String)headMap.get(filedName)).indexOf("日期")>-1 || ((String)headMap.get(filedName)).indexOf("时间")>-1)){
                            String format = "yyyy-MM-dd HH:mm:ss";
                            Date date = new Date((Long) v);
                            SimpleDateFormat sdf = new SimpleDateFormat(format);
                            String toDate = sdf.format(date);
                            list1.add(toDate);
                        }else {
                            list1.add(v == null?"":v);
                        }
                    };
                    list.add(list1);
                }
            }catch (Exception e){
                log.error(e.getMessage());
            }

        });
        String fileName=IdWorker.getIdStr()+excelParam.getLayername()+".csv";
        ExcelUtil.createCSVFile(head,list,fileName);
        return fileName;
    }

    @Override
    public JSONArray exceloutList(ExcelParam excelParam) {
        List<String[]> ids= StringUtil.stringSplittoList(excelParam.getObjectids(),",", ComConstans.REQUEST_MAXCOUNT);
        JSONArray list=new JSONArray();
        ids.stream().forEach(id->{
            String param="objectids="+StringUtil.join(id,",")+"&outfields="+excelParam.getOutfields()+
                    "&returnGeometry="+"1".equals(excelParam.getGeometry())+"&f="+ComConstans.REQUEST_FORMAT;
            try{
                String countent= HttpURL.getContent(excelParam.getLayerurl()+"?"+param,"");
                JSONObject jsonObject = JSONObject.parseObject(countent);
                JSONArray features = jsonObject.getJSONArray("features");

                list.addAll(features);
            }catch (Exception e){
                log.error(e.getMessage());
            }
        });
        return list;
    }


}
