package com.tofly.dyrq.dto;

import com.tofly.dyrq.annotations.JpaDTO;
import lombok.Data;

import javax.persistence.Entity;
import javax.persistence.Id;
import java.math.BigDecimal;

/**
 * @program: tofly-dyrq
 * @description: 巡检报表 按照公司查询 周/月/年报自定义查询对象
 * @author: Sumer
 * @create: 2020-09-09 13:42
 */
@JpaDTO
@Data
@Entity
public class InspectionReportCompanyStatisticDTO {

    @Id

    /**
     * 公司Id
     */
    private String companyId;

    /**
     * 公司名称
     */
    private String companyName;

    /**
     * 用户id
     */
    private String userId;

    /**
     * 用户姓名
     */
    private String userName;

    /**
     * 巡检时长,秒数
     */
    private Double totalTime;

    /**
     * 巡检里程
     */
    private Double totalDistance;

    /**
     * 巡检平均时速
     */
    private Double totalAverage;

    /**
     * 有效耗时
     */
    private Double totalValidTime;
    /**
     * 有效距离
     */

    private Double totalValidDistance;
    /**
     * 有效时速
     */

    private Double totalValidAverage;
    /**
     * 发现隐患数
     */

    private Integer troubleNum;
    /**
     * 工地发现数
     */

    private Integer buildingSitefinded;
    /**
     * 计划巡检点个数
     */

    private BigDecimal pointinplan;
    /**
     * 实际巡检点个数
     */

    private BigDecimal pointPatroled;
    /**
     * 计划巡检线长度
     */

    private BigDecimal pathinplan;
    /**
     * 实际巡检线长度
     */

    private BigDecimal pathpatroled;
    /**
     * 计划巡检设备个数
     */

    private BigDecimal equipmentsInPlan;
    /**
     * 实际巡检设备个数
     */

    private BigDecimal equipmentsPatroled;
}