package com.tofly.dyrq.dto;

import com.tofly.dyrq.annotations.JpaDTO;
import lombok.Data;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import java.util.Date;

/**
 * @program: tofly-dyrq
 * @description: 巡检报表计划自定义查询对象
 * @author: Sumer
 * @create: 2020-09-08 11:51
 */
@JpaDTO
@Data
@Entity
public class InspectionReportPlanDTO {
    @Id

    /**
     * 计划唯一编码 (同旧CHILD_PLAN_ID)
     */
    @Column(name="ID")
    private Long id;

    /**
     * 用户id
     */
    @Column(name="USER_ID")
    private Long userId;

    /**
     * 完成进度
     */
    @Column(name="PERCENT1")
    private Double percent1;

    /**
     * 计划开始日期
     */
    @Column(name="CHILD_BEGIN_DATE")
    private Date childBeginDate;

    /**
     * 计划结束日期
     */
    @Column(name="CHILD_END_DATE")
    private Date childEndDate;

    /**
     * 巡检点类型唯一编码
     */
    @Column(name="DEVICE_TYPE_ID")
    private Long deviceTypeId;

    /**
     * 巡检周期类型名称
     */
    @Column(name="PERIOD_NAME")
    private String periodName;

    /**
     * 巡检类型配置名称
     */
    @Column(name="NAME")
    private String deviceTypeName;

    /**
     * 0：巡检点 1：巡检线
     */
    @Column(name="TYPE")
    private String type;

    /**
     * 区域名称
     */
    @Column(name="REGIONNAME")
    private String regionName;
}