package com.tofly.dyrq.dto;


import com.tofly.dyrq.annotations.JpaDTO;
import lombok.Data;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import java.math.BigDecimal;
import java.util.Date;

/**
 * @program: tofly-dyrq
 * @description: 巡检报表点自定义查询对象
 * @author: Sumer
 * @create: 2020-09-08 13:46
 */
@JpaDTO
@Data
@Entity
public class InspectionReportPointDTO {
    @Id

    /**
     * 巡检是否到位 0：未到位 1：已到位
     */
    @Column(name="ISOVER")
    private String isover;

    /**
     * 用户唯一编码
     */
    @Column(name="USER_ID")
    private Long userId;

    /**
     * 子计划唯一编码
     */
    @Column(name="CHILD_PLAN_ID")
    private Long childPlanId;

    /**
     * 到位时间
     */
    @Column(name="OVER_DATE")
    private Date overDate;

    /**
     * 到位速度
     */
    @Column(name="GPS_SPEED")
    private BigDecimal gpsSpeed;

    @Column(name="CODE")
    private String code;

    /**
     * 0:正在处理 1：处理结束
     */
    @Column(name="STATE")
    private String state;

    /**
     * 计划开始日期
     */
    @Column(name="CHILD_BEGIN_DATE")
    private Date childBeginDate;

    /**
     * 计划结束日期
     */
    @Column(name="CHILD_END_DATE")
    private Date childEndDate;
}