/*
 * Author: wangjian
 * 生成entity
 */
package com.tofly.dyrq.entity;

import com.baomidou.mybatisplus.annotation.*;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import org.springframework.format.annotation.DateTimeFormat;

import java.util.Date;


/**
 * app版本发布
 *
 * @author wangjian
 * @date Tue Apr 07 00:00:00 CST 2020
 */
@Data
@EqualsAndHashCode(callSuper = true)
@TableName(value="TF_APP_VERSION",resultMap = "appVersionMap")
@KeySequence("TF_APP_VERSION")
@ApiModel
public class AppVersion extends Model<AppVersion> {
    private static final long serialVersionUID = 1L;

        /**
     * 主键
     */
        @TableId(value = "ID",type= IdType.INPUT)
        @ApiModelProperty(value = "主键")
                private Long id;
            /**
     * appOS
     */
        @ApiModelProperty(value = "appOS")
                private String os;
            /**
     * 版本号
     */
        @ApiModelProperty(value = "版本号")
                private String version;
            /**
     * 副版本号
     */
        @ApiModelProperty(value = "副版本号")
                private String versionSub;
            /**
     * 发布时间
     */
        @ApiModelProperty(value = "发布时间")
        @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss",timezone = "GMT+8")
    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm:ss")
                private Date publishtime;
            /**
     * 下载更新地址
     */
        @ApiModelProperty(value = "下载更新地址")
                private String downurl;
            /**
     * 更新说明
     */
        @ApiModelProperty(value = "更新说明")
                private String notes;
            /**
     * 创建时间
     */
        @ApiModelProperty(value = "创建时间")
        @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss",timezone = "GMT+8")
    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm:ss")
            @TableField(value = "CREATE_TIME",fill = FieldFill.INSERT)
            private Date createTime;
            /**
     * 删除状态 0：未删除 1：已删除
     */
        @ApiModelProperty(value = "删除状态 0：未删除 1：已删除")
                private String delState;

    /**
     * 创建人
     */
    @ApiModelProperty(value = "创建人")
    private Long createUser;

    @TableLogic
    private String delFlag;

    @ApiModelProperty(value = "文件名")
    private String fileName;

}
