/*
 * Author: wangjian
 * 生成entity
 */
package com.tofly.dyrq.entity;

import com.baomidou.mybatisplus.annotation.*;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import com.tofly.common.core.constant.ToflySqlCondition;
import com.tofly.common.entity.CommonCode;

import java.util.List;
import java.util.stream.Collectors;


/**
 * 工地监护文件表
 *
 * @author Zhangyu
 * @date Sun Jun 28 00:00:00 GMT+08:00 2020
 */
@Data
@EqualsAndHashCode(callSuper = true)
@TableName(value="TF_CONSTRUCTION_SITE_FILE",resultMap = "constructionSiteFileMap")
@KeySequence("TF_CONSTRUCTION_SITE_FILE")
@ApiModel
public class ConstructionSiteFile extends Model<ConstructionSiteFile> {
    private static final long serialVersionUID = 1L;

        /**
     * 工地监护文件表主键ID
     */
        @TableId(value = "ID",type= IdType.INPUT)
            @ApiModelProperty(value = "工地监护文件表主键ID")
                private Long id;
                /**
     * 文件地址
     */
            @ApiModelProperty(value = "文件地址")
                private String path;
                /**
     * 文件名
     */
            @ApiModelProperty(value = "文件名")
                private String fileName;
                /**
     * 文件类型:  0:照片 ,1:语音 ,2:保护或整改通知书 ,3:其他
     */
            @ApiModelProperty(value = "文件类型:  0:照片 ,1:语音 ,2:保护或整改通知书 ,3:其他")
                private String fileType;
        @ApiModelProperty(hidden = true)
    private String fileTypeName;
                /**
     * 删除标记
     */
            @TableLogic
        @ApiModelProperty(value = "删除标记")
                private String delFlag;
            
}
