/*
 * Author: wangjian
 * 生成entity
 */
package com.tofly.dyrq.entity;

import com.baomidou.mybatisplus.annotation.*;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import com.tofly.common.core.constant.ToflySqlCondition;
import com.tofly.common.entity.CommonCode;
import java.util.Date;
import com.fasterxml.jackson.annotation.JsonFormat;
import org.springframework.format.annotation.DateTimeFormat;

import java.util.List;
import java.util.stream.Collectors;


/**
 * 工地监护类型表
 *
 * @author pra
 * @date Mon Aug 31 00:00:00 CST 2020
 */
@Data
@EqualsAndHashCode(callSuper = true)
@TableName(value="TF_CONSTRUCTION_TYPE",resultMap = "constructionTypeMap")
@KeySequence("TF_CONSTRUCTION_TYPE")
@ApiModel
public class ConstructionType extends Model<ConstructionType> {
    private static final long serialVersionUID = 1L;

        /**
     * 主键ID
     */
        @TableId(value = "ID",type= IdType.INPUT)
            @ApiModelProperty(value = "主键ID")
                private Long id;
                /**
     * 类型名称
     */
            @ApiModelProperty(value = "类型名称")
                private String name;
                /**
     * 备注
     */
            @ApiModelProperty(value = "备注")
                private String note;
                /**
     * 创建人
     */
            @ApiModelProperty(value = "创建人")
            @TableField(value = "CREATE_USER",fill = FieldFill.INSERT)
            private Long createUser;
            @ApiModelProperty(hidden = true)
    private String createUserName;
            /**
     * 创建时间
     */
            @ApiModelProperty(value = "创建时间")
        @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss",timezone = "GMT+8")
    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm:ss")
            @TableField(value = "CREATE_TIME",fill = FieldFill.INSERT)
            private Date createTime;

    @TableLogic
    private String delFlag;
}
