/*
 * Author: wangjian
 * 生成entity
 */
package com.tofly.dyrq.entity;

import com.baomidou.mybatisplus.annotation.*;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import com.tofly.common.core.constant.ToflySqlCondition;
import com.tofly.common.entity.CommonCode;

import java.util.List;
import java.util.stream.Collectors;


/**
 * 管网运维部设备状况表
 *
 * @author Zhangyu
 * @date Tue Dec 22 00:00:00 GMT+08:00 2020
 */
@Data
@EqualsAndHashCode(callSuper = true)
@TableName(value="TF_EPMT_STATE",resultMap = "epmtStateMap")
@KeySequence("TF_EPMT_STATE")
@ApiModel
public class EpmtState extends Model<EpmtState> {
    private static final long serialVersionUID = 1L;

        /**
     * 主键
     */
        @TableId(value = "ID",type= IdType.INPUT)
            @ApiModelProperty(value = "主键")
                private Long id;
                /**
     * 项目名称
     */
            @ApiModelProperty(value = "项目名称")
                private String name;
                /**
     * 在用设备台数
     */
            @ApiModelProperty(value = "在用设备台数")
                private Long inUse;
                /**
     * 备用设备台数
     */
            @ApiModelProperty(value = "备用设备台数")
                private Long spare;
                /**
     * 设备总台数
     */
            @ApiModelProperty(value = "设备总台数")
                private Long total;
                /**
     * 完好设备台数
     */
            @ApiModelProperty(value = "完好设备台数")
                private Long intact;
                /**
     * 新购设备台数
     */
            @ApiModelProperty(value = "新购设备台数")
                private Long newly;
                /**
     * 移入设备台数
     */
            @ApiModelProperty(value = "移入设备台数")
                private Long moveIn;
                /**
     * 移出设备台数
     */
            @ApiModelProperty(value = "移出设备台数")
                private Long moveOut;
                /**
     * 报废设备台数
     */
            @ApiModelProperty(value = "报废设备台数")
                private Long scrap;
                /**
     * 计划维修台数
     */
            @ApiModelProperty(value = "计划维修台数")
                private Long planRepair;
                /**
     * 实际维修台数
     */
            @ApiModelProperty(value = "实际维修台数")
                private Long actualRepair;
                /**
     * 设备状况备注
     */
            @ApiModelProperty(value = "设备状况备注")
                private String stateNote;
                /**
     * 设备变动状况备注
     */
            @ApiModelProperty(value = "设备变动状况备注")
                private String changeNote;
                /**
     * 设备维修状况备注
     */
            @ApiModelProperty(value = "设备维修状况备注")
                private String repairNote;
                /**
     * 删除标记
     */
            @TableLogic
        @ApiModelProperty(value = "删除标记")
                private String delFlag;
            
}
