/*
 * Author: wangjian
 * 生成entity
 */
package com.tofly.dyrq.entity;

import com.baomidou.mybatisplus.annotation.*;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import org.springframework.format.annotation.DateTimeFormat;

import java.math.BigDecimal;
import java.util.Date;


/**
 * 地理书签信息表
 *
 * @author wangjian
 * @date Wed Mar 25 00:00:00 CST 2020
 */
@Data
@EqualsAndHashCode(callSuper = true)
@TableName(value="TF_WEB_GEOBOOKMARK",resultMap = "geobookmarkMap")
@KeySequence("TF_WEB_GEOBOOKMARK")
@ApiModel
public class Geobookmark extends Model<Geobookmark> {
    private static final long serialVersionUID = 1L;

        /**
     * 编号
     */
        @TableId(value = "ID",type= IdType.INPUT)
        @ApiModelProperty(value = "编号")
                private Long id;
            /**
     * 书签名称
     */
        @ApiModelProperty(value = "书签名称")
                private String markname;
            /**
     * 书签备注
     */
        @ApiModelProperty(value = "书签备注")
                private String remark;
            /**
     * x最小值
     */
        @ApiModelProperty(value = "x最小值")
                private BigDecimal xmin;
            /**
     * x最大值
     */
        @ApiModelProperty(value = "x最大值")
                private BigDecimal xmax;
            /**
     * y最小值
     */
        @ApiModelProperty(value = "y最小值")
                private BigDecimal ymin;
            /**
     * y最大值
     */
        @ApiModelProperty(value = "y最大值")
                private BigDecimal ymax;
            /**
     * 创建者编号
     */
        @ApiModelProperty(value = "创建者编号")
            @TableField(value = "CREATORID",fill = FieldFill.INSERT)
            private Long creatorid;
            /**
     * 创建日期
     */
        @ApiModelProperty(value = "创建日期")
        @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss",timezone = "GMT+8")
    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm:ss")
            @TableField(value = "CREATEDATE",fill = FieldFill.INSERT)
            private Date createdate;

    @TableLogic
    private String delFlag;
        
}
