/*
 * Author: wangjian
 * 生成entity
 */
package com.tofly.dyrq.entity;

import com.baomidou.mybatisplus.annotation.*;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import org.springframework.format.annotation.DateTimeFormat;

import java.util.Date;


/**
 * 巡检片区表
 *
 * @author wangjian
 * @date Tue Apr 07 00:00:00 CST 2020
 */
@Data
@EqualsAndHashCode(callSuper = true)
@TableName(value="TF_GPS_REGION",resultMap = "gpsRegionMap")
@KeySequence("TF_GPS_REGION")
@ApiModel
public class GpsRegion extends Model<GpsRegion> {
    private static final long serialVersionUID = 1L;

        /**
     * 区域id
     */
        @TableId(value = "ID",type= IdType.INPUT)
        @ApiModelProperty(value = "区域id")
                private Long id;
            /**
     * 区域名称
     */
        @ApiModelProperty(value = "区域名称")
                private String regionname;
            /**
     * 区域几何坐标
     */
        @ApiModelProperty(value = "区域几何坐标")
                private String geometry;
            /**
     * 区域位置
     */
        @ApiModelProperty(value = "区域位置")
                private String address;
            /**
     * 区域备注
     */
        @ApiModelProperty(value = "区域备注")
                private String notes;
            /**
     * 更新时间
     */
        @ApiModelProperty(value = "更新时间")
        @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss",timezone = "GMT+8")
    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm:ss")
                private Date updatetime;
            /**
     * 更新用户id
     */
        @ApiModelProperty(value = "更新用户id")
                private String updateUserid;
            /**
     * 更新人员	
     */
        @ApiModelProperty(value = "更新人员	")
                private String updateUsername;
            /**
     * 所属公司ID
     */
        @ApiModelProperty(value = "所属公司ID")
                private String companyid;
            /**
     * 管线长度
     */
        @ApiModelProperty(value = "管线长度")
                private String pipeLength;
            /**
     * 管线数量
     */
        @ApiModelProperty(value = "管线数量")
                private String pipeNum;
            /**
     * 创建人
     */
        @ApiModelProperty(value = "创建人")
            @TableField(value = "CREATE_USER",fill = FieldFill.INSERT)
            private Long createUser;

    @ApiModelProperty(hidden = true)
        private String createUserName;
            /**
     * 创建时间
     */
        @ApiModelProperty(value = "创建时间")
        @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss",timezone = "GMT+8")
    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm:ss")
            @TableField(value = "CREATE_DATE",fill = FieldFill.INSERT)
            private Date createDate;

    @ApiModelProperty(hidden = true)
        private Integer pointNum;
    @ApiModelProperty(hidden = true)
        private Integer lineNum;
    @ApiModelProperty(hidden = true)
        private Integer troubleNum;
    @ApiModelProperty(hidden = true)
        private String isPlan;

    @TableLogic
    private String delFlag;
}
