/*
 * Author: wangjian
 * 生成entity
 */
package com.tofly.dyrq.entity;

import com.baomidou.mybatisplus.annotation.*;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import com.tofly.common.core.constant.ToflySqlCondition;
import com.tofly.common.entity.CommonCode;

import java.math.BigDecimal;
import java.util.Date;
import com.fasterxml.jackson.annotation.JsonFormat;
import org.springframework.format.annotation.DateTimeFormat;

import java.util.List;
import java.util.stream.Collectors;


/**
 * 调压站及楼栋调压箱巡护记录表
 *
 * @author admin
 * @date Fri Jun 05 00:00:00 CST 2020
 */
@Data
@EqualsAndHashCode(callSuper = true)
@TableName(value="TF_MAINTENANCE",resultMap = "maintenanceMap")
@KeySequence("TF_MAINTENANCE")
@ApiModel
public class Maintenance extends Model<Maintenance> {
    private static final long serialVersionUID = 1L;

        /**
     * 唯一编码
     */
        @TableId(value = "ID",type= IdType.INPUT)
            @ApiModelProperty(value = "唯一编码")
                private Long id;
                /**
     * 用气片区
     */
            @ApiModelProperty(value = "用气片区")
                private String region;
                /**
     * 设施编号
     */
            @ApiModelProperty(value = "设施编号")
                private Long deviceId;
                /**
     * 检查起始时间
     */
            @ApiModelProperty(value = "检查时间")
        @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss",timezone = "GMT+8")
    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm:ss")
                private Date checkDate;
            
            @ApiModelProperty(value = "检查状态")
                    private Integer checkState;
            
            
            @ApiModelProperty(value = "检查起始时间")
            @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss",timezone = "GMT+8")
        @DateTimeFormat(pattern="yyyy-MM-dd HH:mm:ss")
                    private Date checkBeginDate;
            
            
                /**
     * 检查结束时间
     */
            @ApiModelProperty(value = "检查结束时间")
        @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss",timezone = "GMT+8")
    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm:ss")
                private Date checkEndDate;
                /**
     * 地址
     */
            @ApiModelProperty(value = "地址")
                private String address;
                /**
     * 记录创建人
     */
            @ApiModelProperty(value = "记录创建人")
            @TableField(value = "CREATE_USER",fill = FieldFill.INSERT)
            private Long createUser;
            @ApiModelProperty(hidden = true)
    private String createUserName;
            /**
     * 创建时间
     */
            @ApiModelProperty(value = "创建时间")
        @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss",timezone = "GMT+8")
    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm:ss")
            @TableField(value = "CREATE_DATE",fill = FieldFill.INSERT)
            private Date createDate;
                /**
     * 巡检员
     */
            @ApiModelProperty(value = "巡护员")
                private Long userid;
    @ApiModelProperty(hidden = true)
    @TableField(exist = false)
    private String useridName;
                /**
     * 审核人
     */
            @ApiModelProperty(value = "审核人")
                private Long checkUser;
    @ApiModelProperty(hidden = true)
    @TableField(exist = false)
    private String checkUserName;

    @ApiModelProperty(value = "巡检子计划ID")
    private Long childPlanId;

    @ApiModelProperty(value = "巡检计划临时点(point_id)")
    private Long planTempPointId;

    @ApiModelProperty(value = "平面坐标 X")
    private BigDecimal x;

    @ApiModelProperty(value = "平面坐标 Y")
    private BigDecimal y;
            
}
