/*
 * Author: wangjian
 * 生成entity
 */
package com.tofly.dyrq.entity;

import com.baomidou.mybatisplus.annotation.*;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import com.tofly.common.core.constant.ToflySqlCondition;
import com.tofly.common.entity.CommonCode;
import java.util.Date;
import com.fasterxml.jackson.annotation.JsonFormat;
import org.springframework.format.annotation.DateTimeFormat;

import java.util.List;
import java.util.stream.Collectors;


/**
 * 消息推送表
 *
 * @author admin
 * @date Tue Jun 16 00:00:00 CST 2020
 */
@Data
@EqualsAndHashCode(callSuper = true)
@TableName(value="TF_MESSAGE",resultMap = "messageMap")
@KeySequence("TF_MESSAGE")
@ApiModel
public class Message extends Model<Message> {
    private static final long serialVersionUID = 1L;

    /**
     * 唯一编码
     */
    @TableId(value = "ID",type= IdType.INPUT)
    @ApiModelProperty(value = "唯一编码")
    private Long id;
    /**
     * 创建人
     */
    @ApiModelProperty(value = "创建人")
    @TableField(value = "CREATE_USER",fill = FieldFill.INSERT)
    private Long createUser;
    @ApiModelProperty(hidden = true)
    private String createUserName;
    /**
     * 创建时间
     */
    @ApiModelProperty(value = "创建时间")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss",timezone = "GMT+8")
    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm:ss")
    @TableField(value = "CREATE_DATE",fill = FieldFill.INSERT)
    private Date createDate;
    /**
     * 消息主题
     */
    @ApiModelProperty(value = "消息主题")
    private String topic;
    /**
     * 消息详情
     */
    @ApiModelProperty(value = "消息详情")
    private String message;
    /**
     * $column.comments
     */
    @TableLogic
    @ApiModelProperty(value = "$column.comments")
    private String delFlag;

    @ApiModelProperty(value = "回复的原消息ID")
    private Long replyId;

    @ApiModelProperty(value = "消息类型：0普通消息 1抢维修 2巡检 3工地 4隐患 5管网工单")
    private String type;

    @ApiModelProperty(value = "模块")
    private String module;
}
