/*
 * Author: wangjian
 * 生成entity
 */
package com.tofly.dyrq.entity;

import com.baomidou.mybatisplus.annotation.*;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import com.tofly.common.core.annotation.Excel;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import com.tofly.common.core.constant.ToflySqlCondition;
import com.tofly.common.entity.CommonCode;

import java.math.BigDecimal;
import java.util.Date;

import com.fasterxml.jackson.annotation.JsonFormat;
import org.springframework.format.annotation.DateTimeFormat;

import java.util.List;
import java.util.stream.Collectors;


/**
 * 管网运维部一般设备表
 *
 * @author Zhangyu
 * @date Tue Dec 15 00:00:00 GMT+08:00 2020
 */
@Data
@EqualsAndHashCode(callSuper = true)
@TableName(value = "TF_NORMAL_EQUIPMENT", resultMap = "normalEquipmentMap")
@KeySequence("TF_NORMAL_EQUIPMENT")
@ApiModel
public class NormalEquipment extends Model<NormalEquipment> {
    private static final long serialVersionUID = 1L;

    /**
     * ID,主键
     */
    @TableId(value = "ID", type = IdType.INPUT)
    @ApiModelProperty(value = "ID,主键")
    private Long id;
    /**
     * 台卡编号
     */
    @ApiModelProperty(value = "台卡编号")
    @Excel(name = "台卡编号")
    private BigDecimal cardNumber;
    /**
     * 财务编号
     */
    @ApiModelProperty(value = "财务编号")
    @Excel(name = "财务编号")
    private String financialNumber;
    /**
     * 自编号
     */
    @ApiModelProperty(value = "自编号")
    @Excel(name = "自编号")
    private String ownNumber;
    /**
     * 设备类型
     */
    @ApiModelProperty(value = "设备类型")
    @Excel(name = "设备类型")
    private String epmtType;
    @ApiModelProperty(hidden = true)
    private String epmtTypeName;
    /**
     * 设备名称
     */
    @ApiModelProperty(value = "设备名称")
    @Excel(name = "设备名称")
    private String equipmentName;
    /**
     * 制造单位
     */
    @ApiModelProperty(value = "制造单位")
    @Excel(name = "制造单位")
    private String manufacturer;
    /**
     * 出厂日期
     */
    @ApiModelProperty(value = "出厂日期")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    @Excel(name = "出厂日期", dateFormat = "yyyy.MM.dd")
    private Date manufacturerDate;
    /**
     * 出厂编号
     */
    @ApiModelProperty(value = "出厂编号")
    @Excel(name = "出厂编号")
    private String manufacturerNumber;
    /**
     * 型号及规格
     */
    @ApiModelProperty(value = "型号及规格")
    @Excel(name = "型号及规格")
    private String typeSpecification;
    /**
     * 总重
     */
    @ApiModelProperty(value = "总重")
    @Excel(name = "总重")
    private Double totalWeight;
    /**
     * 原值(元)
     */
    @ApiModelProperty(value = "原值(元)")
    @Excel(name = "原值(元)")
    private Double originalValue;
    /**
     * 主要技术性能-项目1
     */
    @ApiModelProperty(value = "主要技术性能-项目1")
    @Excel(name = "项目1")
    private String project1;
    /**
     * 主要技术性能-性能参数1
     */
    @ApiModelProperty(value = "主要技术性能-性能参数1")
    @Excel(name = "性能参数1")
    private String performanceParam1;
    /**
     * 主要技术性能-项目2
     */
    @ApiModelProperty(value = "主要技术性能-项目2")
    @Excel(name = "项目2")
    private String project2;
    /**
     * 主要技术性能-性能参数2
     */
    @ApiModelProperty(value = "主要技术性能-性能参数2")
    @Excel(name = "性能参数2")
    private String performanceParam2;
    /**
     * 主要技术性能-项目3
     */
    @ApiModelProperty(value = "主要技术性能-项目3")
    @Excel(name = "项目3")
    private String project3;
    /**
     * 主要技术性能-性能参数3
     */
    @ApiModelProperty(value = "主要技术性能-性能参数3")
    @Excel(name = "性能参数3")
    private String performanceParam3;
    /**
     * 主要技术性能-项目4
     */
    @ApiModelProperty(value = "主要技术性能-项目4")
    @Excel(name = "项目4")
    private String project4;
    /**
     * 主要技术性能-性能参数4
     */
    @ApiModelProperty(value = "主要技术性能-性能参数4")
    @Excel(name = "性能参数4")
    private String performanceParam4;
    /**
     * 主要技术性能-项目5
     */
    @ApiModelProperty(value = "主要技术性能-项目5")
    @Excel(name = "项目5")
    private String project5;
    /**
     * 主要技术性能-性能参数5
     */
    @ApiModelProperty(value = "主要技术性能-性能参数5")
    @Excel(name = "性能参数5")
    private String performanceParam5;
    /**
     * 备注1
     */
    @ApiModelProperty(value = "备注1")
    @Excel(name = "备注1")
    private String note;
    /**
     * 装箱单
     */
    @ApiModelProperty(value = "装箱单")
    @Excel(name = "装箱单")
    private BigDecimal packingList;
    /**
     * 总装图
     */
    @ApiModelProperty(value = "总装图")
    @Excel(name = "总装图")
    private BigDecimal assemblyDrawing;
    /**
     * 合格证与等级
     */
    @ApiModelProperty(value = "合格证与等级")
    @Excel(name = "合格证与等级")
    private BigDecimal certificateGrade;
    /**
     * 易碎件图
     */
    @ApiModelProperty(value = "易碎件图")
    @Excel(name = "易碎件图")
    private BigDecimal quickWearPartDrawing;
    /**
     * 使用说明书-本
     */
    @ApiModelProperty(value = "使用说明书-本")
    @Excel(name = "使用说明书-本")
    private BigDecimal manualCopy;
    /**
     * 使用说明书-页
     */
    @ApiModelProperty(value = "使用说明书-页")
    @Excel(name = "使用说明书-页")
    private BigDecimal manualPage;
    /**
     * 其他资料
     */
    @ApiModelProperty(value = "其他资料")
    @Excel(name = "其他资料")
    private BigDecimal otherMaterials;
    /**
     * 安装单位
     */
    @ApiModelProperty(value = "安装单位")
    @Excel(name = "安装单位")
    private String installUnit;
    /**
     * 安装地点
     */
    @ApiModelProperty(value = "安装地点")
    @Excel(name = "安装地点")
    private String installPlace;
    /**
     * 设备状况  0:在用 , 1:待报废
     */
    @ApiModelProperty(value = "设备状况  0:在用 , 1:待报废")
    @Excel(name = "设备状况", readConverterExp = "0=在用,1=待报废")
    private String equipmentState;
    @ApiModelProperty(hidden = true)
    private String equipmentStateName;
    /**
     * 安装日期
     */
    @ApiModelProperty(value = "安装日期")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    @Excel(name = "安装日期", dateFormat = "yyyy.MM.dd")
    private Date installDate;
    /**
     * 负责人
     */
    @ApiModelProperty(value = "负责人")
    @Excel(name = "负责人")
    private String responsiblePerson;
    /**
     * 建卡日期
     */
    @ApiModelProperty(value = "建卡日期")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    @Excel(name = "建卡日期", dateFormat = "yyyy.MM.dd")
    private Date createCardDate;
    /**
     * 启用日期
     */
    @ApiModelProperty(value = "启用日期")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    @Excel(name = "启用日期", dateFormat = "yyyy.MM.dd")
    private Date introductionDate;
    /**
     * 来源与转移  0:新增 , 1:转移 , 2:待转移
     */
    @ApiModelProperty(value = "来源与转移  0:新增 , 1:转移 , 2:待转移")
    @Excel(name = "来源与转移", readConverterExp = "0=新增,1=转移,2=待转移")
    private String sourceTransfer;
    @ApiModelProperty(hidden = true)
    private String sourceTransferName;
    /**
     * 备注2
     */
    @ApiModelProperty(value = "备注2")
    @Excel(name = "备注2")
    private String remarks;
    /**
     * 更新日期
     */
    @ApiModelProperty(value = "更新日期")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    @Excel(name = "更新日期", dateFormat = "yyyy.MM.dd")
    private Date updateDate;
    /**
     * 使用部门
     */
    @ApiModelProperty(value = "使用部门")
    @Excel(name = "使用部门")
    private String dept;
    /**
     * 删除标记
     */
    @TableLogic
    @ApiModelProperty(value = "删除标记")
    private String delFlag;
}
