/*
 * Author: wangjian
 * 生成entity
 */
package com.tofly.dyrq.entity;

import com.baomidou.mybatisplus.annotation.*;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.tofly.common.core.constant.OracleCondition;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import org.apache.ibatis.type.JdbcType;
import org.springframework.format.annotation.DateTimeFormat;

import java.math.BigDecimal;
import java.util.Date;


/**
 * 巡检移动设备
 *
 * @author wangjian
 * @date Wed Apr 01 00:00:00 CST 2020
 */
@Data
@EqualsAndHashCode(callSuper = true)
@TableName(value="TF_PDA_DEVICE",resultMap = "pdaDeviceMap")
@KeySequence("TF_PDA_DEVICE")
@ApiModel
public class PdaDevice extends Model<PdaDevice> {
    private static final long serialVersionUID = 1L;

        /**
     * 设备编码
     */
        @TableId(value = "ID",type= IdType.INPUT)
        @ApiModelProperty(value = "设备编码")
                private Long id;
        @ApiModelProperty(hidden = true)
    private String sfbd;

            /**
     * 设备编码
     */
        @ApiModelProperty(value = "设备编码")
                private String uim;
            /**
     * IMEI码
     */
        @ApiModelProperty(value = "IMEI码")
                private String imei;
            /**
     * 电话号码
     */
        @ApiModelProperty(value = "电话号码")
                private String mobile;
            /**
     * 设备名称
     */
        @ApiModelProperty(value = "设备名称")
        @TableField(condition = OracleCondition.LIKE)
                private String padname;
            /**
     * 设备品牌
     */
        @ApiModelProperty(value = "设备品牌")
                private String brand;
            /**
     * 设备型号
     */
        @ApiModelProperty(value = "设备型号")
                private String model;
            /**
     * 设备注释
     */
        @ApiModelProperty(value = "设备注释")
                private String note;
            /**
     * 购置日期
     */
        @ApiModelProperty(value = "购置日期")
        @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss",timezone = "GMT+8")
    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm:ss")
                private Date buydate;
            /**
     * os系统
     */
        @ApiModelProperty(value = "os系统")
                private String appos;
            /**
     * app版本号
     */
        @ApiModelProperty(value = "app版本号")
                private String appversion;
            /**
     * app发布日期
     */
        @ApiModelProperty(value = "app发布日期")
        @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss",timezone = "GMT+8")
    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm:ss")
                private Date appversionReleasetime;
            /**
     * 设备更新时间
     */
        @ApiModelProperty(value = "设备更新时间")
        @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss",timezone = "GMT+8")
    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm:ss")
                private Date appversionUpdatetime;
            /**
     * 设备状态
     */
        @ApiModelProperty(value = "设备状态")
                private BigDecimal state;
            /**
     * 所属公司
     */
            @TableField(updateStrategy = FieldStrategy.IGNORED,jdbcType = JdbcType.NUMERIC)
        @ApiModelProperty(value = "所属公司")
                private Long companyid;
            /**
     * 0:B端 1：M端
     */
        @ApiModelProperty(value = "注册方式: 0:WEB端 1:手机端")
                private BigDecimal registerType;
    @ApiModelProperty(hidden = true)
    private String registerTypeName;
            /**
     * android版本号
     */
        @ApiModelProperty(value = "android版本号")
                private String androidVersion;
            /**
     * 设备类型 0：设备机 1;备用机
     */
        @ApiModelProperty(value = "设备类型 0:备用机 1:正式机")
                private BigDecimal type;
    @ApiModelProperty(hidden = true)
    private String typeName;
            /**
     * 公司名
     */

            @TableField(updateStrategy = FieldStrategy.IGNORED,jdbcType = JdbcType.VARCHAR)
            @ApiModelProperty(value = "公司名")
                private String companyName;
            /**
     * $column.comments
     */
        @ApiModelProperty(value = "$column.comments")
                private BigDecimal sid;
            /**
     * 创建时间
     */
        @ApiModelProperty(value = "创建时间")
        @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss",timezone = "GMT+8")
    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm:ss")
            @TableField(value = "CREATE_TIME",fill = FieldFill.INSERT)
            private Date createTime;

    @TableLogic
    private String delFlag;
        
}
