/*
 * Author: wangjian
 * 生成entity
 */
package com.tofly.dyrq.entity;

import com.baomidou.mybatisplus.annotation.*;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import org.springframework.format.annotation.DateTimeFormat;

import java.util.Date;


/**
 * 巡检人员与移动设备关联表
 *
 * @author wangjian
 * @date Tue Mar 31 00:00:00 CST 2020
 */
@Data
@EqualsAndHashCode(callSuper = true)
@TableName(value="TF_PDA_USER_DEVICE",resultMap = "pdaUserDeviceMap")
@KeySequence("TF_PDA_USER_DEVICE")
@ApiModel
public class PdaUserDevice extends Model<PdaUserDevice> {
    private static final long serialVersionUID = 1L;

        /**
     * 绑定用户id
     */
        @ApiModelProperty(value = "绑定用户id")
            @TableField(value = "USER_ID",fill = FieldFill.INSERT)
            private Long userId;
            /**
     * 绑定移动设备id
     */
        @ApiModelProperty(value = "绑定移动设备id")
                private Long deviceId;
            /**
     * 巡检类型 0：人巡 1：车巡
     */
        @ApiModelProperty(value = "巡检类型 0：人巡 1：车巡")
                private String xjtype;
            /**
     * 创建时间
     */
        @ApiModelProperty(value = "创建时间")
        @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss",timezone = "GMT+8")
    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm:ss")
            @TableField(value = "CREATE_TIME",fill = FieldFill.INSERT)
            private Date createTime;
            /**
     * 唯一标识id
     */
        @TableId(value = "ID",type= IdType.INPUT)
        @ApiModelProperty(value = "唯一标识id")
                private Long id;

    @TableLogic
    private String delFlag;
        
}
