/*
 * Author: wangjian
 * 生成entity
 */
package com.tofly.dyrq.entity;

import com.baomidou.mybatisplus.annotation.*;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import com.tofly.common.core.constant.ToflySqlCondition;
import com.tofly.common.entity.CommonCode;

import java.math.BigDecimal;
import java.util.Date;

import com.fasterxml.jackson.annotation.JsonFormat;
import org.springframework.format.annotation.DateTimeFormat;

import java.util.List;
import java.util.stream.Collectors;


/**
 * 巡检计划表
 *
 * @author wangjian
 * @date Fri Apr 17 00:00:00 CST 2020
 */
@Data
@EqualsAndHashCode(callSuper = true)
@TableName(value = "TF_PLAN", resultMap = "planMap")
@KeySequence("TF_PLAN")
@ApiModel
public class Plan extends Model<Plan> {
    private static final long serialVersionUID = 1L;

    /**
     * $column.comments
     */
    @ApiModelProperty(value = "$column.comments")
    @TableLogic
    private String delFlag;
    /**
     * 巡检计划编码
     */
    @TableId(value = "ID", type = IdType.INPUT)
    @ApiModelProperty(value = "巡检计划编码")
    private Long id;
    /**
     * 巡检片区编码
     */
    @ApiModelProperty(value = "巡检片区编码")
    private Long regionId;
    @ApiModelProperty(hidden = true)
    @TableField(exist = false)
    private String regionName;
    /**
     * 被安排用户编码
     */
    @ApiModelProperty(value = "被安排用户编码")
    @TableField(value = "USER_ID", fill = FieldFill.INSERT)
    private Long userId;
    @ApiModelProperty(hidden = true)
    @TableField(exist = false)
    private String userIdName;
    /**
     * 巡检周期编码
     */
    @ApiModelProperty(value = "巡检周期编码")
    private Long periodId;
    @ApiModelProperty(hidden = true)
    @TableField(exist = false)
    private String preiodName;
    /**
     * 设备类型唯一编码
     */
    @ApiModelProperty(value = "设备类型唯一编码")
    private Long deviceTypeId;
    @ApiModelProperty(hidden = true)
    @TableField(exist = false)
    private String deviceTypeName;
    /**
     * 是否发现隐患
     */
    @ApiModelProperty(value = "是否发现隐患")
    private String isFindTrouble;
    /**
     * 巡检状态 0：待审核，1：未开始，2：正在执行 3：已完成 4：超时未完成  5：申请转移  6：未提交 7：计划已转移
     */
    @ApiModelProperty(value = "巡检状态 0：待审核，1：未开始，2：正在执行 3：已完成 4：超时未完成  5：申请转移  6：未提交 7：计划已转移")
    private String planState;
    @ApiModelProperty(hidden = true)
    @TableField(exist = false)
    private String PlanStateName;
    /**
     * 巡检计划开始时间
     */
    @ApiModelProperty(value = "巡检计划开始时间")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date planBegindate;
    /**
     * 巡检计划结束时间
     */
    @ApiModelProperty(value = "巡检计划结束时间")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date planEnddate;
    /**
     * 自定义间隔天数
     */
    @ApiModelProperty(value = "自定义间隔天数,默认为0,period_id为1时，此项必填")
    private BigDecimal intervalDays;
    /**
     * 描述
     */
    @ApiModelProperty(value = "描述")
    private String description;
    /**
     * 创建用户
     */
    @ApiModelProperty(value = "创建用户")
    @TableField(value = "CREATE_USER", fill = FieldFill.INSERT)
    private Long createUser;
    @ApiModelProperty(hidden = true)
    @TableField(exist = false)
    private String createUserName;
    /**
     * 创建日期
     */
    @ApiModelProperty(value = "创建日期")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    @TableField(value = "CREATE_TIME", fill = FieldFill.INSERT)
    private Date createTime;
    /**
     * 所属公司为一编码
     */
    @ApiModelProperty(value = "所属公司为一编码")
    private Long companyid;
    @ApiModelProperty(hidden = true)
    @TableField(exist = false)
    private String deptName;
    /**
     * 最后一次修改时间
     */
    @ApiModelProperty(value = "最后一次修改时间")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    @TableField(value = "LAST_TIME",fill = FieldFill.INSERT_UPDATE)
    private Date lastTime;
    /**
     * 0:待审核 1:通过 2:未通过
     */
    @ApiModelProperty(value = "0:待审核 1:通过 2:未通过")
    private String isvalid;
    @ApiModelProperty(hidden = true)
    @TableField(exist = false)
    private String isvalidName;
    /**
     * 审核备注
     */
    @ApiModelProperty(value = "审核备注")
    private String checkNote;
    /**
     * 审核时间
     */
    @ApiModelProperty(value = "审核时间")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date checkTime;
    /**
     * 审核人
     */
    @ApiModelProperty(value = "审核人")
    private Long checkUser;
    /**
     * 计划详情
     */
    @ApiModelProperty(value = "计划详情")
    private String pointInfo;
    /**
     * 用户是否阅读 0：未读 1：已读
     */
    @ApiModelProperty(value = "用户是否阅读 0：未读 1：已读")
    private String isread;
    @ApiModelProperty(hidden = true)
    @TableField(exist = false)
    private String isreadName;
    /**
     * 0：人巡 1：车巡
     */
    @ApiModelProperty(value = "0：人巡 1：车巡 ")
    private String planMode;
    @ApiModelProperty(hidden = true)
    @TableField(exist = false)
    private String modeName;

    /**
     * Objectids
     */
    @ApiModelProperty(value = "***巡检类型不为巡检点巡检线时(非巡检点和巡检线的情况),多个id以逗号隔开")
    private String objectIds;

 }
