/*
 * Author: wangjian
 * 生成entity
 */
package com.tofly.dyrq.entity;

import com.baomidou.mybatisplus.annotation.*;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import org.springframework.format.annotation.DateTimeFormat;

import java.math.BigDecimal;
import java.util.Date;


/**
 * 巡检点记录表
 *
 * @author wangjian
 * @date Fri Apr 17 00:00:00 CST 2020
 */
@Data
@EqualsAndHashCode(callSuper = true)
@TableName(value="TF_PLAN_POINT_TEMP",resultMap = "planPointTempMap")
@KeySequence("TF_PLAN_POINT_TEMP")
@ApiModel
public class PlanPointTemp extends Model<PlanPointTemp> {
    private static final long serialVersionUID = 1L;

        /**
     * $column.comments
     */
        @ApiModelProperty(value = "$column.comments")
//        @TableLogic
                private String delFlag;
                /**
     * 临时表唯一编码
     */
        @TableId(value = "ID",type= IdType.INPUT)
        @ApiModelProperty(value = "临时表唯一编码")
                private Long id;
                /**
     * 巡检计划唯一编码
     */
        @ApiModelProperty(value = "巡检计划唯一编码")
                private Long planId;
                /**
     * 计划对应点
     */
        @ApiModelProperty(value = "计划对应点")
                private Long pointId;
                /**
     * 巡检是否到位 0：未到位 1：已到位
     */
        @ApiModelProperty(value = "巡检是否到位 0：未到位 1：已到位")
                private String isover;
        @ApiModelProperty(hidden = true)
        @TableField(exist = false)
    private String isoverName;
                /**
     * 子计划唯一编码
     */
        @ApiModelProperty(value = "子计划唯一编码")
                private Long childPlanId;
                /**
     * 用户唯一编码
     */
        @ApiModelProperty(value = "用户唯一编码")
            @TableField(value = "USER_ID",fill = FieldFill.INSERT)
            private Long userId;
            @ApiModelProperty(hidden = true)
            @TableField(exist = false)
    private String userIdName;
            /**
     * 公司唯一编码
     */
        @ApiModelProperty(value = "公司唯一编码")
                private Long companyid;
                /**
     * 片区唯一编码
     */
        @ApiModelProperty(value = "片区唯一编码")
                private Long regionId;
                /**
     * 巡检类型唯一编码
     */
        @ApiModelProperty(value = "巡检类型唯一编码")
                private Long deviceTypeId;
        @ApiModelProperty(hidden = true)
        @TableField(exist = false)
    private String deviceTypeName;
                /**
     * 巡检周期唯一编码
     */
        @ApiModelProperty(value = "巡检周期唯一编码")
                private Long periodId;
        @ApiModelProperty(hidden = true)
        @TableField(exist = false)
    private String preiodName;
                /**
     * 巡检点几何坐标
     */
        @ApiModelProperty(value = "巡检点几何坐标")
                private String geometry;
                /**
     * $column.comments
     */
        @ApiModelProperty(value = "$column.comments")
                private String name;
                /**
     * $column.comments
     */
        @ApiModelProperty(value = "$column.comments")
                private String address;
                /**
     * $column.comments
     */
        @ApiModelProperty(value = "$column.comments")
                private String regionname;
                /**
     * 纬度
     */
        @ApiModelProperty(value = "纬度")
                private BigDecimal lat;
                /**
     * 精度
     */
        @ApiModelProperty(value = "精度")
                private BigDecimal lng;
                /**
     * 0:正在处理 1：处理结束
     */
        @ApiModelProperty(value = "0:正在处理 1：处理结束")
                private String state;
        @ApiModelProperty(hidden = true)
        @TableField(exist = false)
    private String stateName;
                /**
     * 隐患唯一编码
     */
        @ApiModelProperty(value = "隐患唯一编码")
                private Long troubleId;
                /**
     * 到位时间
     */
        @ApiModelProperty(value = "到位时间")
        @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss",timezone = "GMT+8")
    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm:ss")
                private Date overDate;
                /**
     * 线到位情况
     */
        @ApiModelProperty(value = "线到位情况")
                private BigDecimal pathIsover;
                /**
     * 巡检过程中上传备注信息
     */
        @ApiModelProperty(value = "巡检过程中上传备注信息")
                private String notes;
                /**
     * $column.comments
     */
        @ApiModelProperty(value = "$column.comments")
                private String code;
                /**
     * $column.comments
     */
        @ApiModelProperty(value = "$column.comments")
                private String content;
                /**
     * 到位速度
     */
        @ApiModelProperty(value = "到位速度")
                private BigDecimal gpsSpeed;
                /**
     * 管线长度
     */
        @ApiModelProperty(value = "管线长度")
                private String pipeLength;

    /**
     * 设备检查时间（点状设备）
     */
    @ApiModelProperty(value = "设备检查时间（点状设备）")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date checkDate;
    /**
     * 设备检查状态0:未检查 1:已检查（点状设备）
     */
    @ApiModelProperty(value = "设备检查状态0:未检查 1:已检查（点状设备）")
    private String checkState;
    
    
  
    @ApiModelProperty(value = "到位时间")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss",timezone = "GMT+8")
    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm:ss")
    private Date createDate;
    
    
    
}
