/*
 * Author: wangjian
 * 生成entity
 */
package com.tofly.dyrq.entity;

import com.baomidou.mybatisplus.annotation.*;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import org.springframework.format.annotation.DateTimeFormat;

import java.util.Date;


/**
 * 巡检类型配置表
 *
 * @author wangjian
 * @date Mon Apr 20 00:00:00 CST 2020
 */
@Data
@EqualsAndHashCode(callSuper = true)
@TableName(value="TF_PLAN_POINT_TYPE",resultMap = "planPointTypeMap")
@KeySequence("TF_PLAN_POINT_TYPE")
@ApiModel
public class PlanPointType extends Model<PlanPointType> {
    private static final long serialVersionUID = 1L;

        /**
     * $column.comments
     */
            @TableLogic
        @ApiModelProperty(value = "$column.comments")
                private String delFlag;
                /**
     * 唯一标识id
     */
        @TableId(value = "ID",type= IdType.INPUT)
            @ApiModelProperty(value = "唯一标识id")
                private Long id;
                /**
     * 名称
     */
            @ApiModelProperty(value = "名称")
                private String name;
                /**
     * 备注
     */
            @ApiModelProperty(value = "备注")
                private String note;
                /**
     * 0：巡检点 1：巡检线
     */
            @ApiModelProperty(value = "0：巡检点 1：巡检线")
                private String type;
        @ApiModelProperty(hidden = true)
    private String typeName;
                /**
     * 创建人
     */
            @ApiModelProperty(value = "创建人")
            @TableField(value = "CREATE_USER",fill = FieldFill.INSERT)
            private Long createUser;
            @ApiModelProperty(hidden = true)
    private String createUserName;
            /**
     * 创建时间
     */
            @ApiModelProperty(value = "创建时间")
        @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss",timezone = "GMT+8")
    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm:ss")
            @TableField(value = "CREATE_TIME",fill = FieldFill.INSERT)
            private Date createTime;
                /**
     * 0:可以删除 1：禁止删除
     */
            @ApiModelProperty(value = "0:可以删除 1：禁止删除")
                private String forbidDelete;
        @ApiModelProperty(hidden = true)
    private String forbidDeleteName;
                /**
     * 巡检类型 0：巡检点 1：巡检线 2：巡检设备
     */
            @ApiModelProperty(value = "巡检类型 0：巡检点 1：巡检线 2：巡检设备")
                private String level2;
        @ApiModelProperty(hidden = true)
    private String level2Name;
                /**
     * 巡检模式 0：人巡 1：车巡
     */
            @ApiModelProperty(value = "巡检模式 0：人巡 1：车巡")
                private String planMode;
        @ApiModelProperty(hidden = true)
    private String planModeName;
            
}
