/*
 * Author: wangjian
 * 生成entity
 */
package com.tofly.dyrq.entity;

import com.baomidou.mybatisplus.annotation.*;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import com.tofly.common.core.constant.ToflySqlCondition;
import com.tofly.common.entity.CommonCode;
import java.math.BigDecimal;
import java.util.Date;
import com.fasterxml.jackson.annotation.JsonFormat;
import org.springframework.format.annotation.DateTimeFormat;

import java.util.List;
import java.util.stream.Collectors;


/**
 * 计划转移记录表
 *
 * @author pangrongan
 * @date Wed May 13 00:00:00 CST 2020
 */
@Data
@EqualsAndHashCode(callSuper = true)
@TableName(value="TF_PLAN_TRANSFER",resultMap = "planTransferMap")
@KeySequence("TF_PLAN_TRANSFER")
@ApiModel
public class PlanTransfer extends Model<PlanTransfer> {
    private static final long serialVersionUID = 1L;

        /**
     * $column.comments
     */
            @TableLogic
        @ApiModelProperty(value = "$column.comments")
                private String delFlag;
                /**
     * 主键值
     */
        @TableId(value = "ID",type= IdType.INPUT)
            @ApiModelProperty(value = "主键值")
                private Long id;
                /**
     * 计划唯一编码
     */
            @ApiModelProperty(value = "计划唯一编码")
                private String planId;
                /**
     * 审核状态：2：待审核  0：不同意  1：同意
     */
            @ApiModelProperty(value = "审核状态：2：待审核  0：不同意  1：同意")
                private short checkState;
        @ApiModelProperty(hidden = true)
        @TableField(exist = false)
    private String checkStateName;
                /**
     * 审核时间
     */
            @ApiModelProperty(value = "审核时间")
        @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss",timezone = "GMT+8")
    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm:ss")
                private Date checkTime;
                /**
     * 审核人
     */
            @ApiModelProperty(value = "审核人")
                private Long checkUser;
    @ApiModelProperty(hidden = true)
    @TableField(exist = false)
    private String checkUserName;
                /**
     * 审核备注
     */
            @ApiModelProperty(value = "审核备注")
                private String checkNote;
                /**
     * 申请人
     */
            @ApiModelProperty(value = "申请人")
                private Long applyUserid;
    @ApiModelProperty(hidden = true)
    @TableField(exist = false)
    private String applyUseridName;
                /**
     * 申请时间
     */
            @ApiModelProperty(value = "申请时间")
        @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss",timezone = "GMT+8")
    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm:ss")
                private Date applyTime;
                /**
     * $column.comments
     */
            @ApiModelProperty(value = "$column.comments")
        @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss",timezone = "GMT+8")
    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm:ss")
            @TableField(value = "CREATE_TIME",fill = FieldFill.INSERT)
            private Date createTime;
                /**
     * 指派用户唯一编码
     */
            @ApiModelProperty(value = "指派用户唯一编码")
                private Long replaceUserid;
    @ApiModelProperty(hidden = true)
    @TableField(exist = false)
    private String replaceUseridName;

                /**
     * $column.comments
     */
                private BigDecimal sid;
                /**
     * $column.comments
     */
            @ApiModelProperty(value = "子计划ID")
                private Long childPlanId;

        @ApiModelProperty(value = "申请备注")
        private String applyNote;
            
}
