/*
 * Author: wangjian
 * 生成entity
 */
package com.tofly.dyrq.entity;

import com.baomidou.mybatisplus.annotation.*;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import com.tofly.common.core.constant.ToflySqlCondition;
import com.tofly.common.entity.CommonCode;
import org.apache.ibatis.type.JdbcType;

import java.util.List;
import java.util.stream.Collectors;


/**
 * 二维码信息表
 *
 * @author Zhangyu
 * @date Mon May 11 00:00:00 GMT+08:00 2020
 */
@Data
@EqualsAndHashCode(callSuper = true)
@TableName(value="TF_QRCODE",resultMap = "qrcodeMap")
@KeySequence("TF_QRCODE")
@ApiModel
public class Qrcode extends Model<Qrcode> {
    private static final long serialVersionUID = 1L;

        /**
     * 主键ID
     */
        @TableId(value = "ID",type= IdType.INPUT)
            @ApiModelProperty(value = "主键ID")
                private Long id;
                /**
     * 标题
     */
            @ApiModelProperty(value = "标题")
                private String title;
                /**
     * 末尾备注信息
     */
            @ApiModelProperty(value = "末尾备注信息")
                private String prefixMsg;
                /**
     * 传入二维码图片
     */
    //@TableField(updateStrategy = FieldStrategy.IGNORED ,value = "logo", jdbcType = JdbcType.VARCHAR)
            @ApiModelProperty(value = "传入二维码图片,不传图片修改时 属性变为null字段为空")
                private String logo;
                /**
     * 二维码尺寸
     */
            @ApiModelProperty(value = "二维码尺寸")
                private Integer qrSize;
                /**
     * 删除标记
     */
            @TableLogic
        @ApiModelProperty(value = "删除标记")
                private String delFlag;
}
