/*
 * Author: wangjian
 * 生成entity
 */
package com.tofly.dyrq.entity;

import com.baomidou.mybatisplus.annotation.*;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import org.springframework.format.annotation.DateTimeFormat;

import java.math.BigDecimal;
import java.util.Date;


/**
 * 疑问标识信息表
 *
 * @author wangjian
 * @date Wed Mar 25 00:00:00 CST 2020
 */
@Data
@EqualsAndHashCode(callSuper = true)
@TableName(value="TF_WEB_QUESTIONMARK",resultMap = "questionmarkMap")
@KeySequence("TF_WEB_QUESTIONMARK")
@ApiModel
public class Questionmark extends Model<Questionmark> {
    private static final long serialVersionUID = 1L;

        /**
     * 编号
     */
        @TableId(value = "ID",type= IdType.INPUT)
        @ApiModelProperty(value = "编号")
                private Long id;
            /**
     * 草图位置横坐标
     */
        @ApiModelProperty(value = "草图位置横坐标")
                private BigDecimal x;
            /**
     * 草图位置纵坐标
     */
        @ApiModelProperty(value = "草图位置纵坐标")
                private BigDecimal y;
            /**
     * 标题
     */
        @ApiModelProperty(value = "标题")
                private String caption;
            /**
     * 草图图片编号
     */
        @ApiModelProperty(value = "草图图片编号")
                private String fileid;
            /**
     * 创建者编号
     */
        @ApiModelProperty(value = "创建者编号")
            @TableField(value = "CREATORID",fill = FieldFill.INSERT)
            private Long creatorid;
            /**
     * 创建日期
     */
        @ApiModelProperty(value = "创建日期")
        @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss",timezone = "GMT+8")
    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm:ss")
            @TableField(value = "CREATEDATE",fill = FieldFill.INSERT)
            private Date createdate;
            /**
     * 坐标系编号
     */
        @ApiModelProperty(value = "坐标系编号")
                private Integer wkid;
            /**
     * 草图位置经度
     */
        @ApiModelProperty(value = "草图位置经度")
                private BigDecimal longitude;
            /**
     * 草图位置维度
     */
        @ApiModelProperty(value = "草图位置维度")
                private BigDecimal latitude;
            /**
     * 地图比例尺
     */
        @ApiModelProperty(value = "地图比例尺")
                private BigDecimal scale;
            /**
     * 创建者登录名
     */
        @ApiModelProperty(value = "创建者登录名")
                private String username;
            /**
     * 处理状态（1-已处理、0-未处理）
     */
        @ApiModelProperty(value = "处理状态（1-已处理、0-未处理）")
                private String status;
            /**
     * 处理人(登录名)
     */
        @ApiModelProperty(value = "处理人(登录名)")
                private String handleUsername;
            /**
     * 处理人(登录名)
     */
        @ApiModelProperty(value = "处理人(登录名)")
                private String handleRealname;
            /**
     * 处理日期
     */
        @ApiModelProperty(value = "处理日期")
        @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss",timezone = "GMT+8")
    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm:ss")
                private Date handledate;
            /**
     * 内容
     */
        @ApiModelProperty(value = "内容")
                private String content;

    @TableLogic
    private String delFlag;
        
}
