/*
 * Author: wangjian
 * 生成entity
 */
package com.tofly.dyrq.entity;

import com.baomidou.mybatisplus.annotation.*;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import com.tofly.common.core.constant.ToflySqlCondition;
import com.tofly.common.entity.CommonCode;
import java.math.BigDecimal;
import java.util.Date;
import com.fasterxml.jackson.annotation.JsonFormat;
import org.springframework.format.annotation.DateTimeFormat;

import java.util.List;
import java.util.stream.Collectors;


/**
 * 抢维修工单表
 *
 * @author Zhangyu
 * @date Tue Jun 16 00:00:00 GMT+08:00 2020
 */
@Data
@EqualsAndHashCode(callSuper = true)
@TableName(value="TF_RUSH_REPAIR",resultMap = "rushRepairMap")
@KeySequence("TF_RUSH_REPAIR")
@ApiModel
public class RushRepair extends Model<RushRepair> {
    private static final long serialVersionUID = 1L;

        /**
     * 抢维修工单主键
     */
        @TableId(value = "ID",type= IdType.INPUT)
            @ApiModelProperty(value = "抢维修工单主键")
                private Long id;
                /**
     * 工单编号
     */
            @ApiModelProperty(value = "工单编号")
                private String workOrderId;
                /**
     * 工单类型 0:内部工单 , 1:外部转接
     */
            @ApiModelProperty(value = "工单类型 0:内部工单 , 1:外部转接")
                private String workOrderType;
        @ApiModelProperty(hidden = true)
    private String workOrderTypeName;
                /**
     * 工单来源
     */
            @ApiModelProperty(value = "工单来源")
                private String workOrderSource;
                /**
     * 派工人ID编号
     */
            @ApiModelProperty(value = "派工人ID编号")
                private Long dispatchUserId;
    @ApiModelProperty(hidden = true)
    private String dispatchUserName;
                /**
     * 派工时间
     */
            @ApiModelProperty(value = "派工时间")
        @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss",timezone = "GMT+8")
    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm:ss")
                private Date dispatchDate;
                /**
     * 地址
     */
            @ApiModelProperty(value = "地址")
                private String address;
                /**
     * 联系人
     */
            @ApiModelProperty(value = "联系人")
                private String contact;
                /**
     * 联系电话
     */
            @ApiModelProperty(value = "联系电话")
                private String contactPhone;
                /**
     * 抢修责任人(工单接受及上报人)
     */
            @ApiModelProperty(value = "抢修责任人(工单接受及上报人)")
                private Long rushRepairResponsible;
    @ApiModelProperty(hidden = true)
    private String responsibleName;
                /**
     * 多人名称，由抢修责任人登记
     */
            @ApiModelProperty(value = "参与抢修人员(多人名称，由抢修责任人登记,以\",\"隔开)")
                private String rushRepairPersons;
                /**
     * 坐标X
     */
            @ApiModelProperty(value = "坐标X")
                private BigDecimal x;
                /**
     * 坐标Y
     */
            @ApiModelProperty(value = "坐标Y")
                private BigDecimal y;
                /**
     * 介绍
     */
            @ApiModelProperty(value = "介绍")
                private String introduction;
                /**
     * 详情描述
     */
            @ApiModelProperty(value = "详情描述")
                private String description;
                /**
     * 备注
     */
            @ApiModelProperty(value = "备注")
                private String note;
    /**
     * 记录人(工单创建人)
     */
    @ApiModelProperty(value = "记录人(工单创建人)")
    private Long creatUser;
    @ApiModelProperty(hidden = true)
    private String creatUserName;
    /**
     * 工单创建时间
     */
    @ApiModelProperty(value = "工单创建时间")
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss",timezone = "GMT+8")
    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm:ss")
    private Date creatTime;
                /**
     * 删除标记
     */
            @TableLogic
        @ApiModelProperty(value = "删除标记")
                private String delFlag;
                /**
     * 工单状态  工单状态  0:待派工 , 1:派工未通过, 2:待处理 , 3:待审核 , 4:审核未通过, 5:归档
     */
            @ApiModelProperty(value = "工单状态  工单状态  0:待派工 , 1:派工未通过, 2:待处理 , 3:待审核 , 4:审核未通过, 5:归档")
                private String workOrderState;
        @ApiModelProperty(hidden = true)
    private String workOrderStateName;

    @ApiModelProperty(value = "抢险人部门")
    private Long department;
    @ApiModelProperty(hidden = true)
    private String departmentName;

    @ApiModelProperty(value = "删除文件路径")
    @TableField(exist = false)
    private List<String> deleteFilePaths;
            
}
