/*
 * Author: wangjian
 * 生成entity
 */
package com.tofly.dyrq.entity;

import com.baomidou.mybatisplus.annotation.*;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import com.tofly.common.core.constant.ToflySqlCondition;
import com.tofly.common.entity.CommonCode;
import java.util.Date;
import com.fasterxml.jackson.annotation.JsonFormat;
import org.springframework.format.annotation.DateTimeFormat;

import java.util.List;
import java.util.stream.Collectors;


/**
 * 抢维修审核派工表
 *
 * @author Zhangyu
 * @date Tue Jun 16 00:00:00 GMT+08:00 2020
 */
@Data
@EqualsAndHashCode(callSuper = true)
@TableName(value="TF_RUSH_REPAIR_AUDIT_DISPATCH",resultMap = "rushRepairAuditDispatchMap")
@KeySequence("TF_RUSH_REPAIR_AUDIT_DISPATCH")
@ApiModel
public class RushRepairAuditDispatch extends Model<RushRepairAuditDispatch> {
    private static final long serialVersionUID = 1L;

        /**
     * 抢维修审核派工表主键
     */
        @TableId(value = "ID",type= IdType.INPUT)
            @ApiModelProperty(value = "抢维修审核派工表主键")
                private Long id;
                /**
     * 审核人
     */
            @ApiModelProperty(value = "审核人")
                private Long auditor;
                /**
     * 0:通过 , 1: 不通过
     */
            @ApiModelProperty(value = "0:通过 , 1: 不通过")
                private String auditmind;
        @ApiModelProperty(hidden = true)
    private String auditMindName;
                /**
     * 审核详情描述
     */
            @ApiModelProperty(value = "审核详情描述")
                private String auditDescription;
                /**
     * 审核时间
     */
            @ApiModelProperty(value = "审核时间")
        @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss",timezone = "GMT+8")
    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm:ss")
                private Date auditTime;
                /**
     * 抢维修工单ID
     */
            @ApiModelProperty(value = "抢维修工单ID")
                private Long workOrderId;
                /**
     * 删除标记
     */
            @TableLogic
        @ApiModelProperty(value = "删除标记")
                private String delFlag;
            
}
