/*
 * Author: wangjian
 * 生成entity
 */
package com.tofly.dyrq.entity;

import com.baomidou.mybatisplus.annotation.*;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import com.tofly.common.core.constant.ToflySqlCondition;
import com.tofly.common.entity.CommonCode;

import java.util.List;
import java.util.stream.Collectors;


/**
 * 抢维修文件管理表
 *
 * @author Zhangyu
 * @date Mon Jun 22 00:00:00 GMT+08:00 2020
 */
@Data
@EqualsAndHashCode(callSuper = true)
@TableName(value="TF_RUSH_REPAIR_FILE",resultMap = "rushRepairFileMap")
@KeySequence("TF_RUSH_REPAIR_FILE")
@ApiModel
public class RushRepairFile extends Model<RushRepairFile> {
    private static final long serialVersionUID = 1L;

        /**
     * 抢维修文件管理表主键
     */
        @TableId(value = "ID",type= IdType.INPUT)
            @ApiModelProperty(value = "抢维修文件管理表主键")
                private Long id;
                /**
     * 文件地址
     */
            @ApiModelProperty(value = "文件地址")
                private String path;
                /**
     * 文件类型: 0:照片 1:语音 2:其他
     */
            @ApiModelProperty(value = "文件类型: 0:照片 1:语音 2:其他")
                private String fileType;
        @ApiModelProperty(hidden = true)
    private String fileTypeName;
                /**
     * 删除标记
     */
            @TableLogic
        @ApiModelProperty(value = "删除标记")
                private String delFlag;
                /**
     * 文件名
     */
            @ApiModelProperty(value = "文件名")
                private String fileName;
            
}
