/*
 * Author: wangjian
 * 生成entity
 */
package com.tofly.dyrq.entity;

import com.baomidou.mybatisplus.annotation.*;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import com.tofly.common.core.constant.ToflySqlCondition;
import com.tofly.common.entity.CommonCode;
import java.math.BigDecimal;
import java.util.Date;
import com.fasterxml.jackson.annotation.JsonFormat;
import org.springframework.format.annotation.DateTimeFormat;

import java.util.List;
import java.util.stream.Collectors;


/**
 * 抢维修过程管理表
 *
 * @author Zhangyu
 * @date Tue Jun 16 00:00:00 GMT+08:00 2020
 */
@Data
@EqualsAndHashCode(callSuper = true)
@TableName(value="TF_RUSH_REPAIR_PROCESS_MANAGE",resultMap = "rushRepairProcessManageMap")
@KeySequence("TF_RUSH_REPAIR_PROCESS_MANAGE")
@ApiModel
public class RushRepairProcessManage extends Model<RushRepairProcessManage> {
    private static final long serialVersionUID = 1L;

        /**
     * 抢维修过程管理表主键
     */
        @TableId(value = "ID",type= IdType.INPUT)
            @ApiModelProperty(value = "抢维修过程管理表主键")
                private Long id;
                /**
     * 过程更新描述
     */
            @ApiModelProperty(value = "过程更新描述")
                private String description;
                /**
     * 过程更新时间
     */
            @ApiModelProperty(value = "过程更新时间")
        @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss",timezone = "GMT+8")
    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm:ss")
                private Date manageDate;
                /**
     * 删除标记
     */
            @TableLogic
        @ApiModelProperty(value = "删除标记")
                private String delFlag;
                /**
     * 抢维修工单ID
     */
            @ApiModelProperty(value = "抢维修工单ID")
                private Long workOrderId;
                /**
     * 过程管理坐标X
     */
            @ApiModelProperty(value = "过程管理坐标X")
                private BigDecimal x;
                /**
     * 过程管理坐标Y
     */
            @ApiModelProperty(value = "过程管理坐标Y")
                private BigDecimal y;
            
}
