/*
 * Author: wangjian
 * 生成entity
 */
package com.tofly.dyrq.entity;

import com.baomidou.mybatisplus.annotation.*;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import com.tofly.common.core.constant.ToflySqlCondition;
import com.tofly.common.entity.CommonCode;
import java.math.BigDecimal;
import java.util.Date;
import com.fasterxml.jackson.annotation.JsonFormat;
import org.springframework.format.annotation.DateTimeFormat;

import java.util.List;
import java.util.stream.Collectors;


/**
 * 4.1.28	SCADA报警记录表
 *
 * @author admin
 * @date Tue Apr 14 00:00:00 CST 2020
 */
@Data
@EqualsAndHashCode(callSuper = true)
@TableName(value="SCADA_ALARMRECORD",resultMap = "scadaAlarmrecordMap")
@KeySequence("SCADA_ALARMRECORD")
@ApiModel
public class ScadaAlarmrecord extends Model<ScadaAlarmrecord> {
    private static final long serialVersionUID = 1L;

        /**
     * $column.comments
     */
        @TableId(value = "DEL_FLAG",type= IdType.INPUT)
        @ApiModelProperty(value = "$column.comments")
                private String delFlag;
                /**
     * 变量名
     */
        @ApiModelProperty(value = "变量名")
                private String valname;
                /**
     * 报警时间
     */
        @ApiModelProperty(value = "报警时间")
        @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss",timezone = "GMT+8")
    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm:ss")
                private Date alarmtime;
                /**
     * 报警消息
     */
        @ApiModelProperty(value = "报警消息")
                private String content;
                /**
     * 监测值
     */
        @ApiModelProperty(value = "监测值")
                private BigDecimal value;
                /**
     * 报警阀值
     */
        @ApiModelProperty(value = "报警阀值")
                private BigDecimal mvalue;
                /**
     * 备注
     */
        @ApiModelProperty(value = "备注")
                private String remark;
                /**
     * 是否可用（1-可用，0-不可用）
     */
        @ApiModelProperty(value = "是否可用（1-可用，0-不可用）")
                private String enable;
                /**
     * 检查日期
     */
        @ApiModelProperty(value = "检查日期")
        @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss",timezone = "GMT+8")
    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm:ss")
                private Date checktime;
            
}
