/*
 * Author: wangjian
 * 生成entity
 */
package com.tofly.dyrq.entity;

import com.baomidou.mybatisplus.annotation.*;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import com.tofly.common.core.constant.ToflySqlCondition;
import com.tofly.common.entity.CommonCode;

import java.math.BigDecimal;
import java.util.Date;

import com.fasterxml.jackson.annotation.JsonFormat;
import org.springframework.format.annotation.DateTimeFormat;

import java.util.List;
import java.util.stream.Collectors;


/**
 * scada实时数据同步表
 *
 * @author pra
 * @date Fri Nov 20 00:00:00 CST 2020
 */
@Data
@EqualsAndHashCode(callSuper = true)
@TableName(value = "SCADA_REALDATA", resultMap = "scadaRealdataMap")
@KeySequence("SCADA_REALDATA")
@ApiModel
public class ScadaRealdata extends Model<ScadaRealdata> {
    private static final long serialVersionUID = 1L;

    /**
     * $column.comments
     */
    @ApiModelProperty(value = "$column.comments")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date time;
    /**
     * $column.comments
     */
    @ApiModelProperty(value = "参数编号")
    private String tag;
    /**
     * $column.comments
     */
    @ApiModelProperty(value = "参数值")
    private BigDecimal tagValue;
    /**
     * $column.comments
     */
    @ApiModelProperty(value = "参数名称")
    private String tagExplain;
    /**
     * $column.comments
     */
    @ApiModelProperty(value = "参数单位")
    private String ue;

    @ApiModelProperty(value = "报警最大值")
    private BigDecimal maxval;

    @ApiModelProperty(value = "报警最小值")
    private BigDecimal minval;

}
