/*
 * Author: wangjian
 * 生成entity
 */
package com.tofly.dyrq.entity;

import com.baomidou.mybatisplus.annotation.*;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import com.tofly.common.core.constant.ToflySqlCondition;
import com.tofly.common.entity.CommonCode;
import java.math.BigDecimal;

import java.util.List;
import java.util.stream.Collectors;


/**
 * scada参数描述信息(中文描述，单位)
 *
 * @author admin
 * @date Thu Apr 23 00:00:00 CST 2020
 */
@Data
@EqualsAndHashCode(callSuper = true)
@TableName(value="SCADAPNTS_DES",resultMap = "scadapntsDesMap")
@KeySequence("SCADAPNTS_DES")
@ApiModel
public class ScadapntsDes extends Model<ScadapntsDes> {
    private static final long serialVersionUID = 1L;

    /**
     * $column.comments
     */
    @ApiModelProperty(value = "参数类型(0-模拟量,1-状态量,2-脉冲量,3-其他)")
    private Short paratype;
    /**
     * 编号
     */
    @TableId(value = "PTNUM",type= IdType.INPUT)
    @ApiModelProperty(value = "编号")
    private BigDecimal ptnum;
    /**
     * 参数变量名
     */
    @ApiModelProperty(value = "参数变量名")
    private String name;
    /**
     * 参数描述
     */
    @ApiModelProperty(value = "参数描述")
    private String description;
    /**
     * 参数单位
     */
    @ApiModelProperty(value = "参数单位")
    private String unit;
    /**
     * 报警阀值上限
     */
    @ApiModelProperty(value = "报警阀值上限")
    private BigDecimal maxval;
    /**
     * 报警阀值下限
     */
    @ApiModelProperty(value = "报警阀值下限")
    private BigDecimal minval;

}
