/*
 * Author: wangjian
 * 生成entity
 */
package com.tofly.dyrq.entity;

import com.baomidou.mybatisplus.annotation.*;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import com.tofly.common.core.constant.ToflySqlCondition;
import com.tofly.common.entity.CommonCode;
import java.util.Date;
import com.fasterxml.jackson.annotation.JsonFormat;
import org.springframework.format.annotation.DateTimeFormat;

import java.util.List;
import java.util.stream.Collectors;


/**
 * 特种设备类型表
 *
 * @author Zhangyu
 * @date Tue Dec 15 00:00:00 GMT+08:00 2020
 */
@Data
@EqualsAndHashCode(callSuper = true)
@TableName(value="TF_SPECIAL_EMPT_TYPE",resultMap = "specialEmptTypeMap")
@KeySequence("TF_SPECIAL_EMPT_TYPE")
@ApiModel
public class SpecialEmptType extends Model<SpecialEmptType> {
    private static final long serialVersionUID = 1L;

        /**
     * 主键
     */
        @TableId(value = "ID",type= IdType.INPUT)
            @ApiModelProperty(value = "主键")
                private Long id;
                /**
     * 特种设备类型名称
     */
            @ApiModelProperty(value = "特种设备类型名称")
                private String name;
                /**
     * 创建人
     */
            @ApiModelProperty(value = "创建人")
                private Long creatUser;
            @ApiModelProperty(hidden = true)
            private String creatUserName;
                /**
     * 创建时间
     */
            @ApiModelProperty(value = "创建时间")
        @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss",timezone = "GMT+8")
    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm:ss")
                private Date creatTime;
                /**
     * 修改时间
     */
            @ApiModelProperty(value = "修改时间")
        @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss",timezone = "GMT+8")
    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm:ss")
            private Date updateTime;
                /**
     * 删除标记
     */
            @TableLogic
        @ApiModelProperty(value = "删除标记")
                private String delFlag;
                /**
     * 备注
     */
            @ApiModelProperty(value = "备注")
                private String note;


}
