/*
 * Author: wangjian
 * 生成entity
 */
package com.tofly.dyrq.entity;

import com.baomidou.mybatisplus.annotation.*;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import com.tofly.common.core.constant.ToflySqlCondition;
import com.tofly.common.entity.CommonCode;
import java.util.Date;
import com.fasterxml.jackson.annotation.JsonFormat;
import org.springframework.format.annotation.DateTimeFormat;

import java.util.List;
import java.util.stream.Collectors;


/**
 * 系统配置表
 *
 * @author wangjian
 * @date Tue Apr 07 00:00:00 CST 2020
 */
@Data
@EqualsAndHashCode(callSuper = true)
@TableName(value="TF_SYS_CONFIG",resultMap = "sysConfigMap")
@KeySequence("TF_SYS_CONFIG")
@ApiModel
public class SysConfig extends Model<SysConfig> {
    private static final long serialVersionUID = 1L;

        /**
     * $column.comments
     */
        @ApiModelProperty(value = "$column.comments")
            @TableField(value = "CREATE_USER",fill = FieldFill.INSERT)
            private Long createUser;
            /**
     * 主键值
     */
        @TableId(value = "ID",type= IdType.INPUT)
        @ApiModelProperty(value = "主键值")
                private Long id;
            /**
     * 键值
     */
        @ApiModelProperty(value = "键值")
                private String key;
            /**
     * 值(或子类的KEY)
     */
        @ApiModelProperty(value = "值(或子类的KEY)")
                private String value;
            /**
     * 创建时间
     */
        @ApiModelProperty(value = "创建时间")
        @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss",timezone = "GMT+8")
    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm:ss")
            @TableField(value = "CREATE_TIME",fill = FieldFill.INSERT)
            private Date createTime;
            /**
     * 备注
     */
        @ApiModelProperty(value = "备注")
                private String notes;
            /**
     * 开始日期
     */
        @ApiModelProperty(value = "开始日期")
        @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss",timezone = "GMT+8")
    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm:ss")
                private Date startDate;
            /**
     * 结束日期
     */
        @ApiModelProperty(value = "结束日期")
        @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss",timezone = "GMT+8")
    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm:ss")
                private Date endDate;
            /**
     * 0:可以删除 1：禁止删除
     */
        @ApiModelProperty(value = "0:可以删除 1：禁止删除")
                private String forbidDelete;
        @ApiModelProperty(hidden = true)
    private String forbinDeleteName;

            /**
     * 图片名称
     */
        @ApiModelProperty(value = "图片名称")
                private String icon;
            /**
     * 图片路径
     */
        @ApiModelProperty(value = "图片路径")
                private String iconPath;
            /**
     * 0:禁止 1：可以
     */
        @ApiModelProperty(value = "0:禁止 1：可以")
                private String parentable;
        @ApiModelProperty(hidden = true)
    private String parentableName;

            /**
     * $column.comments
     */
        @ApiModelProperty(value = "$column.comments")
                private String keyen;

    @TableLogic
    private String delFlag;
        
}
