/*
 * Author: wangjian
 * 生成entity
 */
package com.tofly.dyrq.entity;

import com.baomidou.mybatisplus.annotation.*;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import com.tofly.common.core.constant.ToflySqlCondition;
import com.tofly.common.entity.CommonCode;
import java.math.BigDecimal;
import java.util.Date;
import com.fasterxml.jackson.annotation.JsonFormat;
import org.springframework.format.annotation.DateTimeFormat;

import java.util.List;
import java.util.stream.Collectors;


/**
 * 附件\图片\上传表
 *
 * @author wangjian
 * @date Tue Apr 28 00:00:00 CST 2020
 */
@Data
@EqualsAndHashCode(callSuper = true)
@TableName(value="TF_SYS_UPLOAD_FILE",resultMap = "sysUploadFileMap")
@KeySequence("TF_SYS_UPLOAD_FILE")
@ApiModel
public class SysUploadFile extends Model<SysUploadFile> {
    private static final long serialVersionUID = 1L;

        /**
     * $column.comments
     */
            @TableLogic
        @ApiModelProperty(value = "$column.comments")
                private String delFlag;
                /**
     * 主键GUID
     */
        @TableId(value = "ID",type= IdType.INPUT)
            @ApiModelProperty(value = "主键GUID")
                private Long id;
                /**
     * 复合关联表table主键ID
     */
            @ApiModelProperty(value = "复合关联表table主键ID")
                private Long tableid;
                /**
     * 复合关联表table名
     */
            @ApiModelProperty(value = "复合关联表table名")
                private String tablename;
                /**
     * 附件类型
     */
            @ApiModelProperty(value = "附件类型")
                private String filetype;
                /**
     * 文件注释,用于特殊分类标记
     */
            @ApiModelProperty(value = "文件注释,用于特殊分类标记")
                private String filenote;
                /**
     * 文件相对存放路径(包含文件名)
     */
            @ApiModelProperty(value = "文件相对存放路径(包含文件名)")
                private String filename;
                /**
     * 文件大小
     */
            @ApiModelProperty(value = "文件大小")
                private BigDecimal filelength;
                /**
     * 上传时间
     */
            @ApiModelProperty(value = "上传时间")
        @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss",timezone = "GMT+8")
    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm:ss")
                private Date uploadTime;
                /**
     * 上传人员id
     */
            @ApiModelProperty(value = "上传人员id")
                private Long uploadUserid;
                /**
     * 上传人员
     */
            @ApiModelProperty(value = "上传人员")
                private String uploadUsername;
                /**
     * 上传设备id
     */
            @ApiModelProperty(value = "上传设备id")
                private String uploadEquid;
                /**
     * 上传注释
     */
            @ApiModelProperty(value = "上传注释")
                private String uploadNote;
                /**
     * 所属公司id
     */
            @ApiModelProperty(value = "所属公司id")
                private Long companyid;
                /**
     * 音频长度
     */
            @ApiModelProperty(value = "音频长度")
                private String audiolength;
                /**
     * 0:未做ftp处理 1：已做ftp处理
     */
            @ApiModelProperty(value = "0:未做ftp处理 1：已做ftp处理")
                private BigDecimal ftpState;
                /**
     * 文件路径
     */
            @ApiModelProperty(value = "文件路径")
                private String path;
                /**
     * 缩略图名字
     */
            @ApiModelProperty(value = "缩略图名字")
                private String thumbName;
                /**
     * 缩略图路径
     */
            @ApiModelProperty(value = "缩略图路径")
                private String thumbPath;
                /**
     * 上传实际时间
     */
            @ApiModelProperty(value = "上传实际时间")
        @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss",timezone = "GMT+8")
    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm:ss")
                private Date checkTime;
                /**
     * 原文件名字
     */
            @ApiModelProperty(value = "原文件名字")
                private String originalName;
            
}
