/*
 * Author: wangjian
 * 生成entity
 */
package com.tofly.dyrq.entity;

import com.baomidou.mybatisplus.annotation.*;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import com.tofly.common.core.constant.ToflySqlCondition;
import com.tofly.common.entity.CommonCode;
import java.math.BigDecimal;
import java.util.Date;
import com.fasterxml.jackson.annotation.JsonFormat;
import org.springframework.format.annotation.DateTimeFormat;

import java.util.List;
import java.util.stream.Collectors;


/**
 * 上报信息表
 *
 * @author admin
 * @date Tue Mar 31 00:00:00 CST 2020
 */
@Data
@EqualsAndHashCode(callSuper = true)
@TableName(value="TF_PDA_SUBMITINFO",resultMap = "tfPdaSubmitinfoMap")
@KeySequence("TF_PDA_SUBMITINFO")
@ApiModel
public class TfPdaSubmitinfo extends Model<TfPdaSubmitinfo> {
    private static final long serialVersionUID = 1L;

        /**
     * 编号
     */
        @TableId(value = "ID",type= IdType.INPUT)
        @ApiModelProperty(value = "编号")
                private String id;
            /**
     * 标题
     */
        @ApiModelProperty(value = "标题")
                private String caption;
            /**
     * 上报内容
     */
        @ApiModelProperty(value = "上报内容")
                private String content;
            /**
     * 上报地址
     */
        @ApiModelProperty(value = "上报地址")
                private String address;
            /**
     * 上报人编号
     */
        @ApiModelProperty(value = "上报人编号")
                private String userid;
            /**
     * 投影坐标x
     */
        @ApiModelProperty(value = "投影坐标x")
                private BigDecimal x;
            /**
     * 投影坐标y
     */
        @ApiModelProperty(value = "投影坐标y")
                private BigDecimal y;
            /**
     * 目的点经度
     */
        @ApiModelProperty(value = "目的点经度")
                private BigDecimal longitude;
            /**
     * 目的点维度
     */
        @ApiModelProperty(value = "目的点维度")
                private BigDecimal latitude;
            /**
     * 上报日期
     */
        @ApiModelProperty(value = "上报日期")
        @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss",timezone = "GMT+8")
    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm:ss")
                private Date submitdate;
            /**
     * 上报人真实姓名
     */
        @ApiModelProperty(value = "上报人真实姓名")
                private String realname;

    @ApiModelProperty(value = "标题，上报人模糊查询")
    @TableField(exist = false)
    private String filter;

    @ApiModelProperty(value = "起始时间")
    @TableField(exist = false)
    private String startDate;

    @ApiModelProperty(value = "结束时间")
    @TableField(exist = false)
    private String endDate;

    @TableLogic
    private String delFlag;

}
