/*
 * Author: wangjian
 * 生成entity
 */
package com.tofly.dyrq.entity;

import com.baomidou.mybatisplus.annotation.*;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import org.springframework.format.annotation.DateTimeFormat;

import java.math.BigDecimal;
import java.util.Date;


/**
 * 工单记录表
 *
 * @author admin
 * @date Mon Mar 30 00:00:00 CST 2020
 */
@Data
@EqualsAndHashCode(callSuper = true)
@TableName(value="TF_PDA_TASK",resultMap = "tfPdaTaskMap")
@KeySequence("TF_PDA_TASK")
@ApiModel
public class TfPdaTask extends Model<TfPdaTask> {
    private static final long serialVersionUID = 1L;

        /**
     * 编号
     */
        @TableId(value = "ID",type= IdType.INPUT)
        @ApiModelProperty(value = "编号")
                private Long id;
            /**
     * 标题
     */
        @ApiModelProperty(value = "标题")
                private String caption;
            /**
     * 任务内容
     */
        @ApiModelProperty(value = "任务内容")
                private String content;
            /**
     * 目的点投影坐标x
     */
        @ApiModelProperty(value = "目的点投影坐标x")
                private BigDecimal x;
            /**
     * 目的点投影坐标y
     */
        @ApiModelProperty(value = "目的点投影坐标y")
                private BigDecimal y;
            /**
     * 坐标系编号
     */
        @ApiModelProperty(value = "坐标系编号")
                private Integer wkid;
            /**
     * 目的点经度
     */
        @ApiModelProperty(value = "目的点经度")
                private BigDecimal longitude;
            /**
     * 目的点维度
     */
        @ApiModelProperty(value = "目的点维度")
                private BigDecimal latitude;
            /**
     * 目的点地址
     */
        @ApiModelProperty(value = "目的点地址")
                private String address;
            /**
     * 接单人编号
     */
        @ApiModelProperty(value = "接单人编号")
                private Long userid;
            /**
     * 计划完工时间
     */
        @ApiModelProperty(value = "计划完工时间")
        @JsonFormat(pattern="yyyy-MM-dd",timezone = "GMT+8")
    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm:ss")
                private Date planFinishDate;
            /**
     * 派工人编号
     */
        @ApiModelProperty(value = "派工人编号")
                private Long dispatchUserid;
            /**
     * 派工日期
     */
        @ApiModelProperty(value = "派工日期")
        @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss",timezone = "GMT+8")
    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm:ss")
                private Date dispatchDate;
            /**
     * 任务状态
     */
        @ApiModelProperty(value = "任务状态,0为未处理，1为已处理，2为已取消")
                private Integer taskStatus;
            /**
     * 接单人真实姓名
     */
        @ApiModelProperty(value = "接单人真实姓名")
                private String realname;
            /**
     * 派单人真实姓名
     */
        @ApiModelProperty(value = "派单人真实姓名")
                private String dispatchRealname;
            /**
     * 工单流水号yyyyMMddHH24MIss+4位随机数
     */
        @ApiModelProperty(value = "工单流水号yyyyMMddHH24MIss+4位随机数")
                private String taskbh;


//    @ApiModelProperty(value = "标题,接单人模糊查询")
//    @TableField(exist = false)
//    private String filter;
//
//    @ApiModelProperty(value = "起始时间")
//    @TableField(exist = false)
//    private String startDate;
//
//    @ApiModelProperty(value = "结束时间")
//    @TableField(exist = false)
//    private String endDate;
//
//    @TableField(exist = false)
//    private String handleRecord;
//
//    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss",timezone = "GMT+8")
//    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm:ss")
//    @TableField(exist = false)
//    private Date finishDate;
//
//    @TableField(exist = false)
//    private List<String> fileids;

    @TableLogic
    private String delFlag;

}
