/*
 * Author: wangjian
 * 生成entity
 */
package com.tofly.dyrq.entity;

import com.alibaba.druid.sql.visitor.functions.Lpad;
import com.baomidou.mybatisplus.annotation.*;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import com.tofly.common.core.constant.ToflySqlCondition;
import com.tofly.common.entity.CommonCode;
import java.math.BigDecimal;
import java.util.Date;
import com.fasterxml.jackson.annotation.JsonFormat;
import org.springframework.format.annotation.DateTimeFormat;

import java.util.List;
import java.util.stream.Collectors;


/**
 * 巡检系统用户
 *
 * @author admin
 * @date Tue Mar 31 00:00:00 CST 2020
 */
@Data
@EqualsAndHashCode(callSuper = true)
@TableName(value="TF_PDA_USER",resultMap = "tfPdaUserMap")
@KeySequence("TF_PDA_USER")
@ApiModel
public class TfPdaUser extends Model<TfPdaUser> {
    private static final long serialVersionUID = 1L;

        /**
     * 主键GUID
     */
        @TableId(value = "USERID",type= IdType.INPUT)
        @ApiModelProperty(value = "主键GUID")
                private Long userid;
            /**
     * 登录账号
     */
        @ApiModelProperty(value = "登录账号")
                private String loginid;
            /**
     * 用户名
     */
        @ApiModelProperty(value = "用户名")
                private String username;
            /**
     * 登录密码(加密)
     */
        @ApiModelProperty(value = "登录密码(加密)")
                private String password;
            /**
     * 移动设备ID
     */
        @ApiModelProperty(value = "移动设备ID")
                private Long pdaid;
            /**
     * 巡检类型 0：人巡 1：车巡
     */
        @ApiModelProperty(value = "巡检类型 0：人巡 1：车巡")
                private BigDecimal patrolType;
            /**
     * 移动电话
     */
        @ApiModelProperty(value = "移动电话")
                private String mobile;
            /**
     * 是否在线
     */
        @ApiModelProperty(value = "是否在线")
                private BigDecimal onlineState;
            /**
     * 所属公司(预留)
     */
        @ApiModelProperty(value = "所属公司(预留)")
                private String companyid;
            /**
     * 所属组织部门
     */
        @ApiModelProperty(value = "所属组织部门")
                private String depid;
            /**
     * 头像图片地址
     */
        @ApiModelProperty(value = "头像图片地址")
                private String avatar;
            /**
     * 用户状态  0：启用 1：停用 2：未绑定
     */
        @ApiModelProperty(value = "用户状态  0：启用 1：停用 2：未绑定")
                private BigDecimal state;
            /**
     * 最近登录日期
     */
        @ApiModelProperty(value = "最近登录日期")
        @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss",timezone = "GMT+8")
    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm:ss")
                private Date logintime;
            /**
     * API访问令牌
     */
        @ApiModelProperty(value = "API访问令牌")
                private String token;
            /**
     * 角色ID
     */
        @ApiModelProperty(value = "角色ID")
                private String roleid;
            /**
     * 纬度
     */
        @ApiModelProperty(value = "纬度")
                private BigDecimal lat;
            /**
     * 经度
     */
        @ApiModelProperty(value = "经度")
                private BigDecimal lng;
            /**
     * 最后一次更新日期
     */
        @ApiModelProperty(value = "最后一次更新日期")
        @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss",timezone = "GMT+8")
    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm:ss")
                private Date posttime;
            /**
     * $column.comments
     */
        @ApiModelProperty(value = "$column.comments")
                private BigDecimal ftpState;
            /**
     * 设备最后一次更新日期
     */
        @ApiModelProperty(value = "设备最后一次更新日期")
        @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss",timezone = "GMT+8")
    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm:ss")
                private Date devicePosttime;
            /**
     * 头像地址
     */
        @ApiModelProperty(value = "头像地址")
                private String path;
            /**
     * $column.comments
     */
        @ApiModelProperty(value = "$column.comments")
                private BigDecimal sid;
            /**
     * 公司名称
     */
        @ApiModelProperty(value = "公司名称")
                private String companyName;
            /**
     * $column.comments
     */
        @ApiModelProperty(value = "$column.comments")
                private String depname;
    @TableLogic
    private String delFlag;
}
