/*
 * Author: wangjian
 * 生成entity
 */
package com.tofly.dyrq.entity;

import com.baomidou.mybatisplus.annotation.*;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import org.springframework.format.annotation.DateTimeFormat;

import java.util.Date;


/**
 * 用户状态记录表
 *
 * @author admin
 * @date Fri Apr 03 00:00:00 CST 2020
 */
@Data
@EqualsAndHashCode(callSuper = true)
@TableName(value="TF_USER_STATUS",resultMap = "tfUserStatusMap")
@KeySequence("TF_USER_STATUS")
@ApiModel
public class TfUserStatus extends Model<TfUserStatus> {
    private static final long serialVersionUID = 1L;

        /**
     * 编号
     */
        @TableId(value = "ID",type= IdType.INPUT)
        @ApiModelProperty(value = "编号")
                private Long id;
            /**
     * 用户编号
     */
        @ApiModelProperty(value = "用户编号")
                private String userid;
            /**
     * 用户认证token
     */
        @ApiModelProperty(value = "用户认证token")
                private String usertoken;
            /**
     * 系统编号
     */
        @ApiModelProperty(value = "系统编号")
                private String appid;
            /**
     * 在线状态
     */
        @ApiModelProperty(value = "在线状态")
                private String onlineStatus;
            /**
     * 上次操作时间
     */
        @ApiModelProperty(value = "上次操作时间")
        @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss",timezone = "GMT+8")
    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm:ss")
                private Date lastoperation;
            /**
     * 客户端ip
     */
        @ApiModelProperty(value = "客户端ip")
                private String clientip;
    @TableLogic
    private String delFlag;
}
