/*
 * Author: wangjian
 * 生成entity
 */
package com.tofly.dyrq.entity;

import com.baomidou.mybatisplus.annotation.*;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import com.tofly.common.core.constant.ToflySqlCondition;
import com.tofly.common.entity.CommonCode;

import java.math.BigDecimal;
import java.util.Date;

import com.fasterxml.jackson.annotation.JsonFormat;
import org.springframework.format.annotation.DateTimeFormat;


/**
 * 隐患上报表
 *
 * @author Zhangyu
 * @date Wed Jul 29 00:00:00 GMT+08:00 2020
 */
@Data
@EqualsAndHashCode(callSuper = true)
@TableName(value = "TF_TROUBLE", resultMap = "troubleMap")
@KeySequence("TF_TROUBLE")
@ApiModel
public class Trouble extends Model<Trouble> {
    private static final long serialVersionUID = 1L;

    /**
     * 承办班班长审核时间
     */
    @ApiModelProperty(value = "承办班班长审核时间")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date undertakerCheckTime;
    /**
     * 主键
     */
    @TableId(value = "ID", type = IdType.INPUT)
    @ApiModelProperty(value = "主键")
    private Long id;
    /**
     * 隐患唯一编码
     */
    @ApiModelProperty(value = "隐患唯一编码")
    private String sid;
    /**
     * (非工作日)值班人员id
     */
    @ApiModelProperty(value = "(非工作日)值班人员id")
    private Long onDutyUserId;
    @ApiModelProperty(hidden = true)
    private String onDutyUserName;
    /**
     * 巡检设备id
     */
    @ApiModelProperty(value = "巡检设备id")
    private Long padId;
    /**
     * 隐患类型ID
     */
    @ApiModelProperty(value = "隐患类型ID")
    private Long troubleTypeId;
            @ApiModelProperty(hidden = true)
            private String troubleTypeName;
    /**
     * 隐患备注
     */
    @ApiModelProperty(value = "隐患备注")
    private String notes;
    /**
     * 是否为隐患(0:不是隐患 1:常规隐患 2.存量隐患 3:抢维修)
     */
    @ApiModelProperty(value = "是否为隐患(0:不是隐患 1:常规隐患 2.存量隐患 3:抢维修)")
    private String state;
    @ApiModelProperty(hidden = true)
    private String stateName;
    /**
     * 转换位置x
     */
    @ApiModelProperty(value = "转换位置x")
    private BigDecimal locationX;
    /**
     * 转换位置y
     */
    @ApiModelProperty(value = "转换位置y")
    private BigDecimal locationY;
    /**
     * GPS经度
     */
    @ApiModelProperty(value = "GPS经度")
    private BigDecimal locationLongitude;
    /**
     * GPS纬度
     */
    @ApiModelProperty(value = "GPS纬度")
    private BigDecimal locationLatitude;
    /**
     * 地址
     */
    @ApiModelProperty(value = "地址")
    private String address;
    /**
     * 发现时间
     */
    @ApiModelProperty(value = "发现时间")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date findTime;
    /**
     * 巡检区域编码
     */
    @ApiModelProperty(value = "巡检区域编码")
    private Long regionId;
    /**
     * 工单处理完成时间
     */
           /* @ApiModelProperty(value = "工单处理完成时间")
        @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss",timezone = "GMT+8")
    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm:ss")
                private Date handleTime;*/
    /**
     * 隐患所属图层ID
     */
    @ApiModelProperty(value = "隐患所属图层ID")
    private Long layerId;
    /**
     * 处理状态0:正在处理 1:处理完成
     */
    @ApiModelProperty(value = "处理状态0:正在处理 1:处理完成")
    private String handleState;
    @ApiModelProperty(hidden = true)
    private String handleStateName;
    /**
     * 隐患所属图层名称
     */
    @ApiModelProperty(value = "隐患所属图层名称")
    private String layerName;
    /**
     * 隐患所属单位名称，造成隐患的责任单位
     */
    @ApiModelProperty(value = "隐患所属单位名称，造成隐患的责任单位")
    private String unitName;
    /**
     * 隐患级别
     */
    @ApiModelProperty(value = "隐患级别")
    private Long levelId;
    @ApiModelProperty(hidden = true)
    private String levelName;
    /**
     * 隐患设备名称
     */
    @ApiModelProperty(value = "隐患设备名称")
    private String equId;
    /**
     * 部门ID
     */
    @ApiModelProperty(value = "部门ID")
    private Long deptId;
    @ApiModelProperty(hidden = true)
    private String deptName;
    /**
     * 管线基本情况描述
     */
    @ApiModelProperty(value = "管线基本情况描述")
    private String pipeInfoDesc;
    /**
     * 设备基本情况描述
     */
    @ApiModelProperty(value = "设备基本情况描述")
    private String deviceInfoDesc;
    /**
     * 上报人
     */
    @ApiModelProperty(value = "上报人")
    private Long reportUserId;
    @ApiModelProperty(hidden = true)
    private String reportUserName;
    /**
     * 上报时间
     */
    @ApiModelProperty(value = "上报时间")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date reportTime;
    /**
     * 隐患流程唯一编码
     */
    @ApiModelProperty(value = "隐患流程唯一编码")
    private Long processId;
    @ApiModelProperty(hidden = true)
    private String processName;
    /**
     * 签到位置是否正常 0:gps获取 1：手动获取
     */
    @ApiModelProperty(value = "签到位置是否正常 0:gps获取 1：手动获取")
    private String flag;
    @ApiModelProperty(hidden = true)
    private String flagName;
    /**
     * 隐患名称
     */
    @ApiModelProperty(value = "隐患名称")
    private String troubleName;
    /**
     * (值班人员)事件类型:0:非隐患 1:一般隐患,2::重大隐患
     */
    @ApiModelProperty(value = "(仅非工作时间,值班人员)事件类型")
    private Long eventType;
    @ApiModelProperty(hidden = true)
    private String eventTypeName;
    /**
     * 隐患详情
     */
    @ApiModelProperty(value = "隐患详情")
    private String troubleInfo;
    /**
     * 副部长用户id
     */
    @ApiModelProperty(value = "副部长用户id")
    private Long undersecretaryUserId;
    @ApiModelProperty(hidden = true)
    private String undersecretaryUserName;
    /**
     * 班组长审核时间
     */
    @ApiModelProperty(value = "副部长审核时间")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date undersecretaryCheckTime;
    /**
     * (值班人员)临时处理方案
     */
    @ApiModelProperty(value = "(值班人员)临时处理方案")
    private String tempHandleProject;
    /**
     * (值班人员)临时处理结果
     */
    @ApiModelProperty(value = "(值班人员)临时处理结果")
    private String tempHandleResult;
    /**
     * 其他班组长
     */
    @ApiModelProperty(value = "其他班组长")
    private Long maintainerUserId;
    @ApiModelProperty(hidden = true)
    private String maintainerUserName;
    /**
     * 隐患上报途径(0:非工作时间;1:工作时间现场上报;2:工作时间其他转入)
     */
    @ApiModelProperty(value = "隐患上报途径(0:非工作时间;1:工作时间现场上报;2:工作时间其他转入)")
    private String uploadType;
    @ApiModelProperty(hidden = true)
    private String uploadTypeName;
    /**
     * 删除标记
     */
    @TableLogic
    @ApiModelProperty(value = "删除标记")
    private String delFlag;
    /**
     * 承办班班长(审核隐患上报)
     */
    @ApiModelProperty(value = "承办班班长(审核隐患上报)")
    private Long undertakerUserId;
    @ApiModelProperty(hidden = true)
    private String undertakerUserName;
    /**
     * (承办班班长指定)巡检人员
     */
    @ApiModelProperty(value = "(承办班班长指定)巡检人员")
    private Long undertakerHandleUserId;
    @ApiModelProperty(hidden = true)
    private String undertakerHandleUserName;
    /**
     * 承办班班长审核意见
     */
    @ApiModelProperty(value = "承办班班长审核意见")
    private String undertakerCheckNotes;
    /**
     * (承办班班长指定)巡检处理情况
     */
    @ApiModelProperty(value = "(承办班班长指定)巡检处理情况")
    private String undertakerHandleNotes;
    /**
     * 方案编制人(班组长)
     */
    @ApiModelProperty(value = "方案编制人(班组长)")
    private Long dutyUserId;
    @ApiModelProperty(hidden = true)
    private String dutyUserName;
    /* *//**
     * 协同处理人员
     *//*
            @ApiModelProperty(value = "协同处理人员")
                private String coprocessor;
                *//**
     * 整改方案说明
     *//*
            @ApiModelProperty(value = "整改方案说明")
                private String dutyPlanNote;
                *//**
     * 责任班班长派发时间
     *//*
            @ApiModelProperty(value = "责任班班长派发时间")
        @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss",timezone = "GMT+8")
    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm:ss")
                private Date dutyCheckTime;*/
    /**
     * 资金来源
     */
    @ApiModelProperty(value = "资金来源")
    private String source;
    /* *//**
     * 工单处理责任人
     *//*
            @ApiModelProperty(value = "工单处理责任人")
                private Long handleUserId;
            @ApiModelProperty(hidden = true)
            private String handleUserName;
                */
    /**
     * 技术总监
     */
    @ApiModelProperty(value = "技术总监")
    private Long director;
    @ApiModelProperty(hidden = true)
    private String directorName;
    /**
     * 工单处理结果
     */
           /* @ApiModelProperty(value = "工单处理结果")
                private String handleNote;*/
    /**
     * 隐患类别(对象+泄漏、破损、串压、进水、截止等)
     */
    @ApiModelProperty(value = "隐患类别(对象+泄漏、破损、串压、进水、截止等)")
    private String troubleType;
    /**
     * 隐患发现人员id
     */
    @ApiModelProperty(value = "隐患发现人员id")
    private Long findUserId;
    @ApiModelProperty(hidden = true)
    private String findUserName;
    /**
     * GIS班班长
     */
    @ApiModelProperty(value = "GIS班班长")
    private Long gisUserId;
    @ApiModelProperty(hidden = true)
    private String gisUserName;
    /**
     * (承办班班长指定)巡检处理时间
     */
    @ApiModelProperty(value = "(承办班班长指定)巡检处理时间")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date undertakerHandleTime;
    /**
     * 班组长审核备注
     */
    @ApiModelProperty(value = "班组长审核备注")
    private String  undersecretaryCheckNotes;
}
