/*
 * Author: wangjian
 * 生成entity
 */
package com.tofly.dyrq.entity;

import com.baomidou.mybatisplus.annotation.*;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import com.tofly.common.core.constant.ToflySqlCondition;
import com.tofly.common.entity.CommonCode;

import java.util.Date;

import com.fasterxml.jackson.annotation.JsonFormat;
import org.springframework.format.annotation.DateTimeFormat;

import java.util.List;
import java.util.stream.Collectors;


/**
 * 隐患部长审核方案表
 *
 * @author Zhangyu
 * @date Wed Aug 05 00:00:00 GMT+08:00 2020
 */
@Data
@EqualsAndHashCode(callSuper = true)
@TableName(value = "TF_TROUBLE_AUDIT_SCHEME", resultMap = "troubleAuditSchemeMap")
@KeySequence("TF_TROUBLE_AUDIT_SCHEME")
@ApiModel
public class TroubleAuditScheme extends Model<TroubleAuditScheme> {
    private static final long serialVersionUID = 1L;

    /**
     * 主键ID
     */
    @TableId(value = "ID", type = IdType.INPUT)
    @ApiModelProperty(value = "主键ID")
    private Long id;
    /**
     * 审核人ID(部长)
     */
    @ApiModelProperty(value = "审核人ID(部长)")
    private Long auditorSecretary;
    @ApiModelProperty(hidden = true)
    private String auditorSecretaryName;
    /**
     * 审核意见  0:通过 , 1:不通过
     */
    @ApiModelProperty(value = "审核意见  0:通过 , 1:不通过")
    private String auditmind;
    @ApiModelProperty(hidden = true)
    private String auditMindName;
    /**
     * 审核描述
     */
    @ApiModelProperty(value = "审核描述")
    private String auditDescription;
    /**
     * 隐患工单ID
     */
    @ApiModelProperty(value = "隐患工单ID")
    private Long workOrderId;
    /**
     * 审核时间
     */
    @ApiModelProperty(value = "审核时间")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date auditTime;
    /**
     * 删除标记
     */
    @TableLogic
    @ApiModelProperty(value = "删除标记")
    private String delFlag;
    /**
     * 隐患工单责任人
     */
    @ApiModelProperty(value = "隐患工单责任人")
    private Long handleUserId;
    @ApiModelProperty(hidden = true)
    private String handleUserName;
    /**
     * 协同处理人员 以','隔开
     */
    @ApiModelProperty(value = "协同处理人员 以','隔开")
    private String coprocessor;
    /**
     * 协同处理人员姓名 以','隔开
     */
    @ApiModelProperty(value = "协同处理人员姓名 以','隔开")
    private String coprocessorName;
    /**
     * 整改方案说明
     */
    @ApiModelProperty(value = "整改方案说明")
    private String dutyPlanNote;
    /**
     * 方案制定时间
     */
    @ApiModelProperty(value = "方案制定时间")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date dutyCheckTime;

}
