/*
 * Author: wangjian
 * 生成entity
 */
package com.tofly.dyrq.entity;

import com.baomidou.mybatisplus.annotation.*;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import com.tofly.common.core.constant.ToflySqlCondition;
import com.tofly.common.entity.CommonCode;

import java.util.List;
import java.util.stream.Collectors;


/**
 * 隐患类别
 *
 * @author wangjian
 * @date Fri Apr 03 00:00:00 CST 2020
 */
@Data
@EqualsAndHashCode(callSuper = true)
@TableName(value="TF_TROUBLE_CATEGORY",resultMap = "troubleCategoryMap")
@KeySequence("TF_TROUBLE_CATEGORY")
@ApiModel
public class TroubleCategory extends Model<TroubleCategory> {
    private static final long serialVersionUID = 1L;

        /**
     * 主键值
     */
        @TableId(value = "ID",type= IdType.INPUT)
        @ApiModelProperty(value = "主键值")
                private Long id;
            /**
     * 隐患级别编码
     */
        @ApiModelProperty(value = "隐患级别编码")
                private Long levelid;
        @ApiModelProperty(hidden = true)
    private String levelName;

            /**
     * 安全隐患内容
     */
        @ApiModelProperty(value = "安全隐患内容")
                @TableField(condition = ToflySqlCondition.LIKE)
        private String content;
            /**
     * 隐患类型唯一编码
     */
        @ApiModelProperty(value = "隐患类型唯一编码")
                private Long troubleTypeId;
        @ApiModelProperty(hidden = true)
    private String troubleTypeName;

            /**
     * 设备类型唯一编码
     */
        @ApiModelProperty(value = "设备类型唯一编码")
                private Long sysDeviceTypeId;
        @ApiModelProperty(hidden = true)
    private String sysDeviceTypeName;
    @TableLogic
    private String delFlag;
        
}
