/*
 * Author: wangjian
 * 生成entity
 */
package com.tofly.dyrq.entity;

import com.baomidou.mybatisplus.annotation.*;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import com.tofly.common.core.constant.ToflySqlCondition;
import com.tofly.common.entity.CommonCode;
import java.util.Date;
import com.fasterxml.jackson.annotation.JsonFormat;
import org.springframework.format.annotation.DateTimeFormat;

import java.util.List;
import java.util.stream.Collectors;


/**
 * 隐患流程记录表
 *
 * @author admin
 * @date Thu Mar 11 00:00:00 GMT+08:00 2021
 */
@Data
@EqualsAndHashCode(callSuper = true)
@TableName(value="TF_TROUBLE_CHECK",resultMap = "troubleCheckMap")
@KeySequence("TF_TROUBLE_CHECK")
@ApiModel
public class TroubleCheck extends Model<TroubleCheck> {
    private static final long serialVersionUID = 1L;

        /**
     * 隐患ID
     */
            @ApiModelProperty(value = "隐患ID")
                private Long troubleId;
                /**
     * 流程ID
     */
            @ApiModelProperty(value = "流程ID")
                private Long processId;
                /**
     * 记录时间
     */
            @ApiModelProperty(value = "记录时间")
        @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss",timezone = "GMT+8")
    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm:ss")
                private Date noteTime;
                /**
     * 删除标记
     */
            @TableLogic
        @ApiModelProperty(value = "删除标记")
                private String delFlag;
                /**
     * 主键
     */
        @TableId(value = "ID",type= IdType.INPUT)
            @ApiModelProperty(value = "主键")
                private Long id;
            
}
