/*
 * Author: wangjian
 * 生成entity
 */
package com.tofly.dyrq.entity;

import com.baomidou.mybatisplus.annotation.*;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import com.tofly.common.core.constant.ToflySqlCondition;
import com.tofly.common.entity.CommonCode;

import java.math.BigDecimal;

import java.util.List;
import java.util.stream.Collectors;


/**
 * 隐患上报设备基本信息表
 *
 * @author Zhangyu
 * @date Wed Aug 05 00:00:00 GMT+08:00 2020
 */
@Data
@EqualsAndHashCode(callSuper = true)
@TableName(value = "TF_TROUBLE_DEVICEINFO", resultMap = "troubleDeviceinfoMap")
@KeySequence("TF_TROUBLE_DEVICEINFO")
@ApiModel
public class TroubleDeviceinfo extends Model<TroubleDeviceinfo> {
    private static final long serialVersionUID = 1L;

    /**
     * 图形
     */
    @ApiModelProperty(value = "图形")
    private String geometry;
    /**
     * 主键ID
     */
    @TableId(value = "ID", type = IdType.INPUT)
    @ApiModelProperty(value = "主键ID")
    private Long id;
    /**
     * 唯一编码
     */
    @ApiModelProperty(value = "唯一编码")
    private String sid;
    /**
     * 特征
     */
    @ApiModelProperty(value = "特征")
    private String name;
    /**
     * 设备地址
     */
    @ApiModelProperty(value = "设备地址")
    private String address;
    /**
     * 材质
     */
    @ApiModelProperty(value = "材质")
    private String material;
    /**
     * 管径
     */
    @ApiModelProperty(value = "管径")
    private BigDecimal pipeDiameter;
    /**
     * 埋深
     */
    @ApiModelProperty(value = "埋深")
    private BigDecimal depth;
    /**
     * 高程
     */
    @ApiModelProperty(value = "高程")
    private BigDecimal altitude;
    /**
     * X坐标
     */
    @ApiModelProperty(value = "X坐标")
    private BigDecimal x;
    /**
     * Y坐标
     */
    @ApiModelProperty(value = "Y坐标")
    private BigDecimal y;
    /**
     * 删除标记
     */
    @TableLogic
    @ApiModelProperty(value = "删除标记")
    private String delFlag;
    /**
     * 隐患ID
     */
    @ApiModelProperty(value = "隐患ID")
    private Long troubleId;
    /**
     * 图层ID
     */
    @ApiModelProperty(value = "图层ID")
    private Long layerId;
    /**
     * 图层名称
     */
    @ApiModelProperty(value = "图层名称")
    private String layerName;

}
