/*
 * Author: wangjian
 * 生成entity
 */
package com.tofly.dyrq.entity;

import com.baomidou.mybatisplus.annotation.*;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import com.tofly.common.core.constant.ToflySqlCondition;
import com.tofly.common.entity.CommonCode;
import java.util.Date;
import com.fasterxml.jackson.annotation.JsonFormat;
import org.springframework.format.annotation.DateTimeFormat;


/**
 * 隐患事件级别表
 *
 * @author admin
 * @date Sat Jul 17 00:00:00 CST 2202
 */
@Data
@EqualsAndHashCode(callSuper = true)
@TableName(value="TF_TROUBLE_ENENT_TYPE",resultMap = "troubleEnentTypeMap")
@KeySequence("TF_TROUBLE_ENENT_TYPE")
@ApiModel
public class TroubleEnentType extends Model<TroubleEnentType> {
    private static final long serialVersionUID = 1L;

        /**
     * 唯一标识编号
     */
        @TableId(value = "ID",type= IdType.INPUT)
            @ApiModelProperty(value = "唯一标识编号")
                private Long id;
                /**
     * 事件类型分类名称
     */
            @ApiModelProperty(value = "事件类型分类名称")
                private String name;
                /**
     * 备注
     */
            @ApiModelProperty(value = "备注")
                private String notes;
                /**
     * 创建人
     */
            @ApiModelProperty(value = "创建人")
                private Long createUserid;
                /**
     * 创建时间
     */
            @ApiModelProperty(value = "创建时间")
        @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss",timezone = "GMT+8")
    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm:ss")
            @TableField(value = "CREATE_TIME",fill = FieldFill.INSERT)
            private Date createTime;
                /**
     * $column.comments
     */
            @TableLogic
        @ApiModelProperty(value = "$column.comments")
                private String delFlag;
    @ApiModelProperty(value = "是否为隐患，0 不是隐患，1 是隐患")
            private String isTrouble;
            
}
