/*
 * Author: wangjian
 * 生成entity
 */
package com.tofly.dyrq.entity;

import com.baomidou.mybatisplus.annotation.*;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import com.tofly.common.core.constant.ToflySqlCondition;
import com.tofly.common.entity.CommonCode;

import java.util.List;
import java.util.stream.Collectors;


/**
 * 隐患上报附件表
 *
 * @author Zhangyu
 * @date Tue Aug 04 00:00:00 GMT+08:00 2020
 */
@Data
@EqualsAndHashCode(callSuper = true)
@TableName(value="TF_TROUBLE_FILE",resultMap = "troubleFileMap")
@KeySequence("TF_TROUBLE_FILE")
@ApiModel
public class TroubleFile extends Model<TroubleFile> {
    private static final long serialVersionUID = 1L;

        /**
     * 审核方案附件
     */
            @ApiModelProperty(value = "审核方案附件")
                private Long auditSchemeId;
                /**
     * 审核处理结果附件
     */
            @ApiModelProperty(value = "审核处理结果附件")
                private Long auditEndId;
                /**
     * 主键id
     */
        @TableId(value = "ID",type= IdType.INPUT)
            @ApiModelProperty(value = "主键id")
                private Long id;
                /**
     * 隐患ID
     */
            @ApiModelProperty(value = "隐患ID")
                private Long troubleId;
                /**
     * 文件路径
     */
            @ApiModelProperty(value = "文件路径")
                private String filePath;
                /**
     * 删除标记
     */
            @TableLogic
        @ApiModelProperty(value = "删除标记")
                private String delFlag;
                /**
     * 文件类型(0:照片,1:语音,2:其他,3:整改工程决算书,4:隐患整改通知书,5:管道保护通知书,6:整改方案文件)
     */
            @ApiModelProperty(value = "文件类型(0:照片,1:语音,2:其他,3:整改工程决算书,4:隐患整改通知书,5:管道保护通知书,6:整改方案文件)")
                private String fileType;
                /**
     * 隐患流程ID
     */
            @ApiModelProperty(value = "隐患流程ID")
                private Long processId;
                /**
     * 文件名称
     */
            @ApiModelProperty(value = "文件名称")
                private String fileName;
            
}
