/*
 * Author: wangjian
 * 生成entity
 */
package com.tofly.dyrq.entity;

import com.baomidou.mybatisplus.annotation.*;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import com.tofly.common.core.constant.ToflySqlCondition;
import com.tofly.common.entity.CommonCode;
import java.util.Date;
import com.fasterxml.jackson.annotation.JsonFormat;
import org.springframework.format.annotation.DateTimeFormat;

import java.util.List;
import java.util.stream.Collectors;


/**
 * 隐患级别
 *
 * @author wangjian
 * @date Fri Apr 03 00:00:00 CST 2020
 */
@Data
@EqualsAndHashCode(callSuper = true)
@TableName(value="TF_TROUBLE_LEVEL",resultMap = "troubleLevelMap")
@KeySequence("TF_TROUBLE_LEVEL")
@ApiModel
public class TroubleLevel extends Model<TroubleLevel> {
    private static final long serialVersionUID = 1L;

        /**
     * ID
     */
        @TableId(value = "ID",type= IdType.INPUT)
        @ApiModelProperty(value = "ID")
                private Long id;
            /**
     * 级别名称
     */
        @ApiModelProperty(value = "级别名称")
                @TableField(condition = ToflySqlCondition.LIKE)
        private String name;
            /**
     * 级别描述
     */
        @ApiModelProperty(value = "级别描述")
                private String notes;
            /**
     * 级别分组
     */
        @ApiModelProperty(value = "级别分组")
                private String category;
            /**
     * 是否审核定级 0：不需要审核 1：需要审核
     */
        @ApiModelProperty(value = "是否审核定级 0：不需要审核 1：需要审核")
                private String ischeck;
        @ApiModelProperty(hidden = true)
    private String ischeckName;

            /**
     * 是否需要提交到隐患系统 0：不需要 1：需要
     */
        @ApiModelProperty(value = "是否需要提交到隐患系统 0：不需要 1：需要")
                private String issubmit;
        @ApiModelProperty(hidden = true)
    private String issubmitName;

            /**
     * $column.comments
     */
        @ApiModelProperty(value = "$column.comments")
                private String version;
            /**
     * $column.comments
     */
        @ApiModelProperty(value = "$column.comments")
                private String createUserid;
            /**
     * $column.comments
     */
        @ApiModelProperty(value = "$column.comments")
        @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss",timezone = "GMT+8")
    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm:ss")
            @TableField(value = "CREATE_TIME",fill = FieldFill.INSERT)
            private Date createTime;
    @TableLogic
    private String delFlag;
}
