/*
 * Author: wangjian
 * 生成entity
 */
package com.tofly.dyrq.entity;

import com.baomidou.mybatisplus.annotation.*;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import com.tofly.common.core.constant.ToflySqlCondition;
import com.tofly.common.entity.CommonCode;
import java.math.BigDecimal;
import java.util.Date;
import com.fasterxml.jackson.annotation.JsonFormat;
import org.springframework.format.annotation.DateTimeFormat;

import java.util.List;
import java.util.stream.Collectors;


/**
 * 隐患分类
 *
 * @author wangjian
 * @date Fri Apr 03 00:00:00 CST 2020
 */
@Data
@EqualsAndHashCode(callSuper = true)
@TableName(value="TF_TROUBLE_TYPE",resultMap = "troubleTypeMap")
@KeySequence("TF_TROUBLE_TYPE")
@ApiModel
public class TroubleType extends Model<TroubleType> {
    private static final long serialVersionUID = 1L;

        /**
     * 唯一标识编号
     */
        @TableId(value = "ID",type= IdType.INPUT)
        @ApiModelProperty(value = "唯一标识编号")
                private Long id;
            /**
     * 隐患分类名称
     */
        @ApiModelProperty(value = "隐患分类名称")
                @TableField(condition = ToflySqlCondition.LIKE)
        private String name;
            /**
     * 隐患分类备注
     */
        @ApiModelProperty(value = "隐患分类备注")
                private String notes;
            /**
     * 创建人
     */
        @ApiModelProperty(value = "创建人")
                private Long createUserid;
            /**
     * 创建时间
     */
        @ApiModelProperty(value = "创建时间")
        @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss",timezone = "GMT+8")
    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm:ss")
            @TableField(value = "CREATE_TIME",fill = FieldFill.INSERT)
            private Date createTime;
            /**
     * 版本号
     */
        @ApiModelProperty(value = "版本号")
                private String version;
            /**
     * 删除状态
     */
        @ApiModelProperty(value = "删除状态")
                private BigDecimal delState;
    @TableLogic
    private String delFlag;
}
