/*
 * Author: wangjian
 * 生成entity
 */
package com.tofly.dyrq.entity;

import com.baomidou.mybatisplus.annotation.*;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import com.tofly.common.core.constant.ToflySqlCondition;
import com.tofly.common.entity.CommonCode;
import java.math.BigDecimal;
import java.util.Date;
import com.fasterxml.jackson.annotation.JsonFormat;
import org.springframework.format.annotation.DateTimeFormat;

import java.util.List;
import java.util.stream.Collectors;


/**
 * 上传照片
 *
 * @author wangjian
 * @date Wed Apr 29 00:00:00 CST 2020
 */
@Data
@EqualsAndHashCode(callSuper = true)
@TableName(value="TF_UPLOAD_PHOTO",resultMap = "uploadPhotoMap")
@KeySequence("TF_UPLOAD_PHOTO")
@ApiModel
public class UploadPhoto extends Model<UploadPhoto> {
    private static final long serialVersionUID = 1L;

        /**
     * $column.comments
     */
            @TableLogic
        @ApiModelProperty(value = "$column.comments")
                private String delFlag;
                /**
     * ID,主键
     */
        @TableId(value = "ID",type= IdType.INPUT)
            @ApiModelProperty(value = "ID,主键")
                private Long id;
                /**
     * 设备类型
     */
            @ApiModelProperty(value = "设备类型")
                private Long equid;
        @ApiModelProperty(hidden = true)
    private String deviceName;
                /**
     * 描述
     */
            @ApiModelProperty(value = "描述")
                private String description;
                /**
     * 创建时间
     */
            @ApiModelProperty(value = "创建时间")
        @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss",timezone = "GMT+8")
    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm:ss")
            @TableField(value = "CREATE_TIME",fill = FieldFill.INSERT)
            private Date createTime;
                /**
     * 所属公司id
     */
            @ApiModelProperty(value = "所属公司id")
                private Long companyid;
        @ApiModelProperty(hidden = true)
    private String deptName;
                /**
     * 上传用户唯一编码
     */
            @ApiModelProperty(value = "上传用户唯一编码")
                private Long uploadUserid;
        @ApiModelProperty(hidden = true)
    private String uploadUserName;
                /**
     * 纬度
     */
            @ApiModelProperty(value = "纬度")
                private BigDecimal lat;
                /**
     * 经度
     */
            @ApiModelProperty(value = "经度")
                private BigDecimal lng;
                /**
     * 地址
     */
            @ApiModelProperty(value = "地址")
                private String address;
                /**
     * 上传实际时间
     */
            @ApiModelProperty(value = "上传实际时间")
        @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss",timezone = "GMT+8")
    @DateTimeFormat(pattern="yyyy-MM-dd HH:mm:ss")
                private Date actualTime;
                /**
     * 照片类型唯一编码
     */
            @ApiModelProperty(value = "照片类型唯一编码")
                private Long pictypeid;
        @ApiModelProperty(hidden = true)
    private String pictypeName;
                /**
     * 签到位置是否正常 0:gps获取 1：手动获取
     */
            @ApiModelProperty(value = "签到位置是否正常 0:gps获取 1：手动获取")
                private String flag;
        @ApiModelProperty(hidden = true)
    private String flagName;
            
}
