/*
 * Author: wangjian
 * 生成entity
 */
package com.tofly.dyrq.entity;

import com.baomidou.mybatisplus.annotation.*;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;

import java.math.BigDecimal;


/**
 * 预警分析参数配置表
 *
 * @author wangjian
 * @date Wed Apr 08 00:00:00 CST 2020
 */
@Data
@EqualsAndHashCode(callSuper = true)
@TableName(value="TF_WEB_WARNINGCONFIG",resultMap = "webWarningconfigMap")
@KeySequence("TF_WEB_WARNINGCONFIG")
@ApiModel
public class WebWarningconfig extends Model<WebWarningconfig> {
    private static final long serialVersionUID = 1L;

        /**
     * 编号
     */
        @TableId(value = "ID",type= IdType.INPUT)
        @ApiModelProperty(value = "编号")
                private Long id;
            /**
     * 要素类名
     */
        @ApiModelProperty(value = "要素类名")
                private String layername;
            /**
     * 要素类别名
     */
        @ApiModelProperty(value = "要素类别名")
                private String layeralias;
            /**
     * 域值编号
     */
        @ApiModelProperty(value = "域值编号")
                private String domainkey;
            /**
     * 域值
     */
        @ApiModelProperty(value = "域值")
                private String domainvalue;
            /**
     * 维修次数阀值
     */
        @ApiModelProperty(value = "维修次数阀值")
                private BigDecimal repairnumber;
            /**
     * 服务年限阀值-年
     */
        @ApiModelProperty(value = "服务年限阀值-年")
                private BigDecimal serviceyear;
            /**
     * 服务年限阀值-月
     */
        @ApiModelProperty(value = "服务年限阀值-月")
                private BigDecimal servicemonth;
            /**
     * 分类字段
     */
        @ApiModelProperty(value = "分类字段")
                private String field;
            /**
     * 分类字段别名
     */
        @ApiModelProperty(value = "分类字段别名")
                private String fieldalias;
            /**
     * 创建人编号
     */
        @ApiModelProperty(value = "创建人编号")
            @TableField(value = "CREATE_USER",fill = FieldFill.INSERT)
            private Long createUser;
            /**
     * 创建人所属单位代码
     */
        @ApiModelProperty(value = "创建人所属单位代码")
                private String managementcode;
    @TableLogic
    private String delFlag;
}
