package com.tofly.dyrq.repository;


import com.tofly.dyrq.entity.GpsDayCalculate;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Query;
import org.springframework.stereotype.Repository;

import java.util.Date;
import java.util.List;

/**
 * @program: tofly-dyrq
 * @description: 累计计算轨迹
 * @author: Sumer
 * @create: 2020-08-27 10:57
 */
@Repository
public interface GpsDayCalculateRepository extends JpaRepository<GpsDayCalculate, Long> {

    /**
     * 获取当前用户时间范围数据
     * @param userid 用户id
     * @param sDate 开始时间
     * @param eDate 结束时间
     * @return
     */
    @Query(value =  "SELECT * FROM TF_GPS_DAY_CALCULATE t " +
                    "WHERE t.USERID = ?1 AND t.PLAN_DATE >= ?2 AND t.PLAN_DATE <= ?3 ",nativeQuery = true)
    List<GpsDayCalculate> getGpsDayCalculateList(Long userid , Date sDate,Date eDate);
}