package com.tofly.dyrq.repository;


import com.tofly.dyrq.dto.InspectionReportPlanDTO;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Query;
import org.springframework.stereotype.Repository;

import java.util.Date;
import java.util.List;

@Repository
public interface InspectionReportPlanRepository extends JpaRepository<InspectionReportPlanDTO,Long> {

    /**
     * 获取当前时间范围对应巡检类型的计划相关信息
     * @param sDate
     * @param eDate
     * @return
     */
    @Query(value =  "SELECT a.ID,a.USER_ID,a.PERCENT1,a.CHILD_BEGIN_DATE,a.CHILD_END_DATE,a.DEVICE_TYPE_ID,e.PERIOD_NAME,b.NAME ,b.TYPE ,d.REGIONNAME  " +
                    "FROM TF_PLAN_CHILD a JOIN TF_PLAN_POINT_TYPE b ON  a.DEVICE_TYPE_ID = b.ID " +
                    "JOIN TF_GPS_REGION d ON a.REGION_ID = d.ID JOIN TF_PLAN_PERIOD_TYPE e ON a.PERIOD_ID = e.ID " +
                    "WHERE a.CHILD_BEGIN_DATE >= ?1 AND a.CHILD_BEGIN_DATE <= ?2 AND b.TYPE = 0",nativeQuery = true )
    List<InspectionReportPlanDTO> getPlans(Date sDate , Date eDate);
}
