package com.tofly.dyrq.repository;


import com.tofly.dyrq.dto.InspectionReportPointDTO;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Query;
import org.springframework.stereotype.Repository;

import java.util.Date;
import java.util.List;

@Repository
public interface InspectionReportPointRepository extends JpaRepository<InspectionReportPointDTO,Long> {
    /**
     * 获取当前时间范围的点相关信息
     *
     * @param sDate
     * @param eDate
     * @return
     */
    @Query(value =  "SELECT a.ISOVER ,a.USER_ID ,a.CHILD_PLAN_ID ,a.OVER_DATE ,a.GPS_SPEED ,a.CODE ,a.STATE ,b.CHILD_BEGIN_DATE ,b.CHILD_END_DATE  " +
                    "FROM TF_PLAN_POINT_TEMP a JOIN TF_PLAN_CHILD b ON a.CHILD_PLAN_ID = b.ID " +
                    "WHERE b.CHILD_BEGIN_DATE >= ?1 AND b.CHILD_BEGIN_DATE <= ?2",nativeQuery = true)
    List<InspectionReportPointDTO> getPoints(Date sDate , Date eDate);
}
