package com.tofly.dyrq.service;


import com.tofly.dyrq.vo.DailyPlanStaticsVO;
import com.tofly.dyrq.vo.StaticModelPlanResultVO;

import java.util.Date;
import java.util.List;
import java.util.Map;

/**
 * 巡检报表服务
 */
public interface InspectionReportService {
    /**
     * 巡检(日 OR 月)报处理
     * @param departmentId  所属组织部门
     * @param userId        用户id
     * @param searchDate    巡检日期
     * @param timeType      日期类型
     * @return map结果对象
     */
    List<DailyPlanStaticsVO> disposeDailyPlanStatics(String departmentId, String userId, String searchDate, String timeType);

    /**
     * 巡检(日 OR 月)报 统计数据处理
     * @param departmentId      所属组织部门
     * @param beginPlanDate     开始日期
     * @param endPlanDate       结束日期
     * @return
     */
    List<StaticModelPlanResultVO> disposeStaticPlan(String departmentId , String beginPlanDate, String endPlanDate);
}
