/*
 * Author: wangjian
 * 生成ServiceImpl
 */
package com.tofly.dyrq.service.impl;

import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.tofly.common.core.util.StringUtil;
import com.tofly.common.oauth.exception.ToflyDeniedException;
import com.tofly.dyrq.entity.GpsRegion;
import com.tofly.dyrq.entity.PlanPoint;
import com.tofly.dyrq.mapper.GpsRegionMapper;
import com.tofly.dyrq.service.GpsRegionService;
import com.tofly.dyrq.service.PlanPointService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.Arrays;
import java.util.Collection;
import java.util.List;
import java.util.stream.Collectors;

/**
 * 巡检片区表
 *
 * @author wangjian
 * @date Tue Apr 07 00:00:00 CST 2020
 */
@Service("gpsRegionService")
public class GpsRegionServiceImpl extends ServiceImpl<GpsRegionMapper, GpsRegion> implements GpsRegionService {

    @Autowired
    private PlanPointService planPointService;

    @Override
    public String isPlan(Long regionId) {
        return baseMapper.getIsPlan(regionId);
    }

    @Override
    public Integer getTroubleNum(Long regionId) {

        return baseMapper.getTroubleNum(regionId);
    }

    @Override
    @Transactional
    public boolean deleteById(long regionId) {
        String isPlan=this.isPlan(regionId);
        if("1".equals(isPlan)){
            throw new ToflyDeniedException("存在着计划，不允许删除");
        }
        Integer integer=this.getTroubleNum(regionId);
        if(integer.intValue()>0){
            throw new ToflyDeniedException("存在着隐患点，不允许删除");
        }
        planPointService.remove(Wrappers.<PlanPoint>lambdaQuery()
        .eq(PlanPoint::getRegionId,regionId));
        return this.removeById(regionId);
    }

    @Override
    @Transactional
    public boolean deleteByIds(String ids) {
        List idList= Arrays.asList(ids.split(","));
//        Collection<GpsRegion> collection = this.listByIds(idList);
//        String msg= collection.stream().filter(gp -> "1".equals(gp.getIsPlan()))
//                .map(GpsRegion::getRegionname).collect(Collectors.joining(","));
//        if(StringUtil.isNotEmpty(msg)){
//            throw new ToflyDeniedException("存在着计划不允许删除的数据"+msg);
//        }
//        msg= collection.stream().filter(gp -> gp.getTroubleNum().intValue()>0)
//                .map(GpsRegion::getRegionname).collect(Collectors.joining(","));
//        if(StringUtil.isNotEmpty(msg)){
//            throw new ToflyDeniedException("存在着隐患点不允许删除的数据"+msg);
//        }
//        planPointService.remove(Wrappers.<PlanPoint>lambdaQuery()
//        .in(PlanPoint::getRegionId,idList));
        return this.removeByIds(idList);
    }
}
