/*
 * Author: wangjian
 * 生成ServiceImpl
 */
package com.tofly.dyrq.service.impl;

import com.baomidou.mybatisplus.core.toolkit.IdWorker;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.tofly.common.core.util.FtpUtil;
import com.tofly.dyrq.config.FilePathBean;
import com.tofly.dyrq.entity.MsLog;
import com.tofly.dyrq.service.MsLogService;
import com.tofly.dyrq.service.PlanPointService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import com.tofly.dyrq.mapper.MsLogMapper;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.util.MultiValueMap;
import org.springframework.web.multipart.MultipartFile;
import org.springframework.web.multipart.MultipartHttpServletRequest;

import javax.servlet.http.HttpServletRequest;
import java.util.concurrent.atomic.AtomicInteger;

/**
 * 表
 *
 * @author pra
 * @date Fri Sep 04 00:00:00 CST 2020
 */

@Service("msLogService")
public class MsLogServiceImpl extends ServiceImpl<MsLogMapper, MsLog> implements MsLogService {

    @Autowired
    private FilePathBean filePathBean;

    @Override
    @Transactional
    public Boolean saveMsLog(HttpServletRequest request, MsLog msLog) {
        //遍历请求中key包含的所有文件
        AtomicInteger count = new AtomicInteger(0);
        MultiValueMap<String, MultipartFile> multiFileMap = ((MultipartHttpServletRequest) request).getMultiFileMap();
        multiFileMap.forEach((k, v) -> {
            //保存照片
            v.forEach(file -> {
                String fileName = file.getOriginalFilename();
                String filePath = filePathBean.getMsLog() + IdWorker.getIdStr() + file.getOriginalFilename().substring(file.getOriginalFilename().lastIndexOf("."));
                boolean b = FtpUtil.uploadFile2Ftp(file, filePath);
                if (b) {
                    msLog.setPath(filePath);
                    msLog.setFileName(fileName);
                    this.save(msLog);
                    count.set(count.get() + 1);
                }
            });
        });
        if (count.get() > 0){
            return false;
        }
        return true;
    }
}
