package com.tofly.dyrq.util;

import com.tofly.base.api.entity.Log;
import com.tofly.base.api.feign.BaseLogService;
import com.tofly.common.core.constant.SecurityConstants;
import com.tofly.common.log.event.SysLogEvent;
import com.tofly.dyrq.custom.mapper.CustomPlanMapper;
import com.tofly.dyrq.service.PlanPointTempService;
import com.tofly.dyrq.service.TfPlanPathTempService;
import lombok.AllArgsConstructor;
import org.springframework.context.ApplicationListener;
import org.springframework.context.event.EventListener;
import org.springframework.core.annotation.Order;
import org.springframework.core.env.Environment;
import org.springframework.scheduling.annotation.Async;
import org.springframework.stereotype.Component;

/**
 * @author tuonbed
 * @date 2020/9/22  10:46
 */
@AllArgsConstructor
@Component
public class PlanDetailEventListener implements ApplicationListener<PlanDetailEvent> {
    private final CustomPlanMapper customPlanMapper;

    @Override
    @Async
    public void onApplicationEvent(PlanDetailEvent event) {
        customPlanMapper.insertBacthPointTemp(event.getPointTempList());
        customPlanMapper.insertBacthPathTemp(event.getPathTempList());
//        planPathTempService.removeById(event.getPathMaxId());
//        planPointTempService.removeById(event.getPointMaxId());
    }
}
