package com.tofly.dyrq.vo;

import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.math.BigDecimal;
import java.util.Date;

/**
 * @program: tofly-dyrq
 * @description: 巡检报表日/月报表基础数据前端返回对象
 * @author: Sumer
 * @create: 2020-09-08 14:55
 */
@Data
public class DailyPlanStaticsBasisVO {
    /**
     * 用户唯一编码
     */
    @ApiModelProperty(value = "用户唯一编码")
    private String userId;
    /**
     * 用户名称
     */
    @ApiModelProperty(value = "用户名称")
    private String userName;
    /**
     * 所属组织部门编码
     */
    @ApiModelProperty(value = "所属组织部门编码")
    private String departmentId;
    /**
     * 所属组织部门名称
     */
    @ApiModelProperty(value = "所属组织部门名称")
    private String depName;
    /**
     * 巡检里程
     */
    @ApiModelProperty(value = "巡检里程")
    private BigDecimal planTotalDistance;
    /**
     * 巡检时长,秒数
     */
    @ApiModelProperty(value = "巡检时长,秒数")
    private BigDecimal planTotalTime;
    /**
     * 巡检平均时速
     */
    @ApiModelProperty(value = "巡检平均时速")
    private BigDecimal planTotalAverage;
    /**
     * 有效里程
     */
    @ApiModelProperty(value = "有效里程")
    private BigDecimal totalValidDistance;
    /**
     * 有效耗时
     */
    @ApiModelProperty(value = "有效耗时")
    private BigDecimal totalValidTime;
    /**
     * 有效时速
     */
    @ApiModelProperty(value = "有效时速")
    private BigDecimal totalValidAverage;
    /**
     * 完成进度
     */
    @ApiModelProperty(value = "完成进度")
    private BigDecimal totalPercent;
    /**
     * 巡检日期
     */
    @ApiModelProperty(value = "巡检日期")
    private String patrolDate;
    /**
     * 签到时间段
     */
    @ApiModelProperty(value = "签到时间段")
    private String patrolDateRange;
}