package com.tofly.dyrq.vo;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.math.BigDecimal;

/**
 * @program: tofly-dyrq
 * @description:
 * @author: Sumer
 * @create: 2020-09-14 14:10
 */
@Data
@ApiModel(description= "巡检统计数据返回对象")
public class StaticModelPlanResultVO {

    /**
     * 公司名称
     */
    @ApiModelProperty(value = "公司名称")
    private String companyName;

    /**
     * 用户名称
     */
    @ApiModelProperty(value = "用户名称")
    private String userName;

    /**
     * 巡检时长,秒数
     */
    @ApiModelProperty(value = "巡检时长,秒数")
    private BigDecimal totalTime;

    /**
     * 巡检里程
     */
    @ApiModelProperty(value = "巡检里程")
    private BigDecimal totalDistance;

    /**
     * 有效耗时
     */
    @ApiModelProperty(value = "有效耗时")
    private BigDecimal totalValidTime;

    /**
     * 有效里程
     */
    @ApiModelProperty(value = "有效里程")
    private BigDecimal totalValidDistance;

    /**
     * 有效时速
     */
    @ApiModelProperty(value = "有效时速")
    private BigDecimal totalValidAverage;

    /**
     * 发现隐患数
     */
    @ApiModelProperty(value = "发现隐患数")
    private BigDecimal troubleNum;

    /**
     * 实际巡检设备个数
     */
    @ApiModelProperty(value = "实际巡检设备个数")
    private BigDecimal equipmentsPatroled;

    /**
     * 实际巡检点个数
     */
    @ApiModelProperty(value = "实际巡检点个数")
    private BigDecimal pointPatroled;

    /**
     * 实际巡检线长度
     */
    @ApiModelProperty(value = "实际巡检线长度")
    private BigDecimal pathPatroled;

    /**
     * 巡检点完成率
     */
    @ApiModelProperty(value = "巡检点完成率")
    private BigDecimal pointPercent;

    /**
     * 巡检线完成率
     */
    @ApiModelProperty(value = "巡检线完成率")
    private BigDecimal pathPercent;

    /**
     * 公司Id
     */
    @ApiModelProperty(value = "公司Id")
    private String companyId;

    /**
     * 用户Id
     */
    @ApiModelProperty(value = "用户Id")
    private String userId;


    /**
     * 工地发现个数
     */
    @ApiModelProperty(value = "工地发现个数")
    private BigDecimal buildingSiteFinded;

    /**
     * 巡检管线完成率
     */
    @ApiModelProperty(value = "巡检管线完成率")
    private BigDecimal pipelinePercent;

    /**
     * 巡检平均时速
     */
    @ApiModelProperty(value = "巡检平均时速")
    private BigDecimal totalAverage;

    /**
     * 计划巡检设备个数
     */
    @ApiModelProperty(value = "计划巡检设备个数")
    private BigDecimal equipmentsInPlan;

    /**
     * 巡检设备个数完成率
     */
    @ApiModelProperty(value = "巡检设备个数完成率")
    private BigDecimal equipmentsPercent;

    /**
     * 计划巡检点个数
     */
    @ApiModelProperty(value = "计划巡检点个数")
    private BigDecimal pointInPlan;

    /**
     * 计划巡检线长度
     */
    @ApiModelProperty(value = "计划巡检线长度")
    private BigDecimal pathInPlan;


}